/**
 * vis-graph3d
 * https://visjs.github.io/vis-graph3d/
 *
 * Create interactive, animated 3d graphs. Surfaces, lines, dots and block styling out of the box.
 *
 * @version 6.0.1
 * @date    2020-12-16T19:57:33.652Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).vis=t.vis||{})}(this,(function(t){"use strict";var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function n(t,e){return t(e={exports:{}},e.exports),e.exports}function r(t){return t&&t.default||t}var i=function(t){return t&&t.Math==Math&&t},o=i("object"==typeof globalThis&&globalThis)||i("object"==typeof window&&window)||i("object"==typeof self&&self)||i("object"==typeof e&&e)||function(){return this}()||Function("return this")(),a=function(t){try{return!!t()}catch(t){return!0}},s=!a((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),u={}.propertyIsEnumerable,l=Object.getOwnPropertyDescriptor,c={f:l&&!u.call({1:2},1)?function(t){var e=l(this,t);return!!e&&e.enumerable}:u},h=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},f={}.toString,d=function(t){return f.call(t).slice(8,-1)},p="".split,v=a((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==d(t)?p.call(t,""):Object(t)}:Object,y=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},g=function(t){return v(y(t))},m=function(t){return"object"==typeof t?null!==t:"function"==typeof t},b=function(t,e){if(!m(t))return t;var n,r;if(e&&"function"==typeof(n=t.toString)&&!m(r=n.call(t)))return r;if("function"==typeof(n=t.valueOf)&&!m(r=n.call(t)))return r;if(!e&&"function"==typeof(n=t.toString)&&!m(r=n.call(t)))return r;throw TypeError("Can't convert object to primitive value")},w={}.hasOwnProperty,_=function(t,e){return w.call(t,e)},x=o.document,S=m(x)&&m(x.createElement),T=function(t){return S?x.createElement(t):{}},E=!s&&!a((function(){return 7!=Object.defineProperty(T("div"),"a",{get:function(){return 7}}).a})),A=Object.getOwnPropertyDescriptor,O={f:s?A:function(t,e){if(t=g(t),e=b(e,!0),E)try{return A(t,e)}catch(t){}if(_(t,e))return h(!c.f.call(t,e),t[e])}},k=/#|\.prototype\./,C=function(t,e){var n=P[L(t)];return n==M||n!=D&&("function"==typeof e?a(e):!!e)},L=C.normalize=function(t){return String(t).replace(k,".").toLowerCase()},P=C.data={},D=C.NATIVE="N",M=C.POLYFILL="P",R=C,I={},j=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},z=function(t,e,n){if(j(t),void 0===e)return t;switch(n){case 0:return function(){return t.call(e)};case 1:return function(n){return t.call(e,n)};case 2:return function(n,r){return t.call(e,n,r)};case 3:return function(n,r,i){return t.call(e,n,r,i)}}return function(){return t.apply(e,arguments)}},N=function(t){if(!m(t))throw TypeError(String(t)+" is not an object");return t},F=Object.defineProperty,B={f:s?F:function(t,e,n){if(N(t),e=b(e,!0),N(n),E)try{return F(t,e,n)}catch(t){}if("get"in n||"set"in n)throw TypeError("Accessors not supported");return"value"in n&&(t[e]=n.value),t}},W=s?function(t,e,n){return B.f(t,e,h(1,n))}:function(t,e,n){return t[e]=n,t},Y=O.f,G=function(t){var e=function(e,n,r){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,n)}return new t(e,n,r)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},V=function(t,e){var n,r,i,a,s,u,l,c,h=t.target,f=t.global,d=t.stat,p=t.proto,v=f?o:d?o[h]:(o[h]||{}).prototype,y=f?I:I[h]||(I[h]={}),g=y.prototype;for(i in e)n=!R(f?i:h+(d?".":"#")+i,t.forced)&&v&&_(v,i),s=y[i],n&&(u=t.noTargetGet?(c=Y(v,i))&&c.value:v[i]),a=n&&u?u:e[i],n&&typeof s==typeof a||(l=t.bind&&n?z(a,o):t.wrap&&n?G(a):p&&"function"==typeof a?z(Function.call,a):a,(t.sham||a&&a.sham||s&&s.sham)&&W(l,"sham",!0),y[i]=l,p&&(_(I,r=h+"Prototype")||W(I,r,{}),I[r][i]=a,t.real&&g&&!g[i]&&W(g,i,a)))};V({target:"Object",stat:!0,forced:!s,sham:!s},{defineProperty:B.f});var X=n((function(t){var e=I.Object,n=t.exports=function(t,n,r){return e.defineProperty(t,n,r)};e.defineProperty.sham&&(n.sham=!0)})),U=X,Z=Math.ceil,H=Math.floor,q=function(t){return isNaN(t=+t)?0:(t>0?H:Z)(t)},$=Math.min,Q=function(t){return t>0?$(q(t),9007199254740991):0},K=Math.max,J=Math.min,tt=function(t,e){var n=q(t);return n<0?K(n+e,0):J(n,e)},et=function(t){return function(e,n,r){var i,o=g(e),a=Q(o.length),s=tt(r,a);if(t&&n!=n){for(;a>s;)if((i=o[s++])!=i)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===n)return t||s||0;return!t&&-1}},nt={includes:et(!0),indexOf:et(!1)},rt={},it=nt.indexOf,ot=function(t,e){var n,r=g(t),i=0,o=[];for(n in r)!_(rt,n)&&_(r,n)&&o.push(n);for(;e.length>i;)_(r,n=e[i++])&&(~it(o,n)||o.push(n));return o},at=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],st=Object.keys||function(t){return ot(t,at)},ut=s?Object.defineProperties:function(t,e){N(t);for(var n,r=st(e),i=r.length,o=0;i>o;)B.f(t,n=r[o++],e[n]);return t};V({target:"Object",stat:!0,forced:!s,sham:!s},{defineProperties:ut});var lt=n((function(t){var e=I.Object,n=t.exports=function(t,n){return e.defineProperties(t,n)};e.defineProperties.sham&&(n.sham=!0)})),ct=function(t){return"function"==typeof t?t:void 0},ht=function(t,e){return arguments.length<2?ct(I[t])||ct(o[t]):I[t]&&I[t][e]||o[t]&&o[t][e]},ft=at.concat("length","prototype"),dt={f:Object.getOwnPropertyNames||function(t){return ot(t,ft)}},pt={f:Object.getOwnPropertySymbols},vt=ht("Reflect","ownKeys")||function(t){var e=dt.f(N(t)),n=pt.f;return n?e.concat(n(t)):e},yt=function(t,e,n){var r=b(e);r in t?B.f(t,r,h(0,n)):t[r]=n};V({target:"Object",stat:!0,sham:!s},{getOwnPropertyDescriptors:function(t){for(var e,n,r=g(t),i=O.f,o=vt(r),a={},s=0;o.length>s;)void 0!==(n=i(r,e=o[s++]))&&yt(a,e,n);return a}});var gt=I.Object.getOwnPropertyDescriptors,mt=O.f,bt=a((function(){mt(1)}));V({target:"Object",stat:!0,forced:!s||bt,sham:!s},{getOwnPropertyDescriptor:function(t,e){return mt(g(t),e)}});var wt,_t=n((function(t){var e=I.Object,n=t.exports=function(t,n){return e.getOwnPropertyDescriptor(t,n)};e.getOwnPropertyDescriptor.sham&&(n.sham=!0)})),xt=!!Object.getOwnPropertySymbols&&!a((function(){return!String(Symbol())})),St=xt&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Tt=Array.isArray||function(t){return"Array"==d(t)},Et=function(t){return Object(y(t))},At=ht("document","documentElement"),Ot="__core-js_shared__",kt=o[Ot]||function(t,e){try{W(o,t,e)}catch(n){o[t]=e}return e}(Ot,{}),Ct=n((function(t){(t.exports=function(t,e){return kt[t]||(kt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.8.1",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),Lt=0,Pt=Math.random(),Dt=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++Lt+Pt).toString(36)},Mt=Ct("keys"),Rt=function(t){return Mt[t]||(Mt[t]=Dt(t))},It=Rt("IE_PROTO"),jt=function(){},zt=function(t){return"<script>"+t+"</"+"script>"},Nt=function(){try{wt=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;Nt=wt?function(t){t.write(zt("")),t.close();var e=t.parentWindow.Object;return t=null,e}(wt):((e=T("iframe")).style.display="none",At.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(zt("document.F=Object")),t.close(),t.F);for(var n=at.length;n--;)delete Nt.prototype[at[n]];return Nt()};rt[It]=!0;var Ft=Object.create||function(t,e){var n;return null!==t?(jt.prototype=N(t),n=new jt,jt.prototype=null,n[It]=t):n=Nt(),void 0===e?n:ut(n,e)},Bt=dt.f,Wt={}.toString,Yt="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],Gt={f:function(t){return Yt&&"[object Window]"==Wt.call(t)?function(t){try{return Bt(t)}catch(t){return Yt.slice()}}(t):Bt(g(t))}},Vt=function(t,e,n,r){r&&r.enumerable?t[e]=n:W(t,e,n)},Xt=Ct("wks"),Ut=o.Symbol,Zt=St?Ut:Ut&&Ut.withoutSetter||Dt,Ht=function(t){return _(Xt,t)||(xt&&_(Ut,t)?Xt[t]=Ut[t]:Xt[t]=Zt("Symbol."+t)),Xt[t]},qt={f:Ht},$t=B.f,Qt=function(t){var e=I.Symbol||(I.Symbol={});_(e,t)||$t(e,t,{value:qt.f(t)})},Kt={};Kt[Ht("toStringTag")]="z";var Jt="[object z]"===String(Kt),te=Ht("toStringTag"),ee="Arguments"==d(function(){return arguments}()),ne=Jt?d:function(t){var e,n,r;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(n=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),te))?n:ee?d(e):"Object"==(r=d(e))&&"function"==typeof e.callee?"Arguments":r},re=Jt?{}.toString:function(){return"[object "+ne(this)+"]"},ie=B.f,oe=Ht("toStringTag"),ae=function(t,e,n,r){if(t){var i=n?t:t.prototype;_(i,oe)||ie(i,oe,{configurable:!0,value:e}),r&&!Jt&&W(i,"toString",re)}},se=Function.toString;"function"!=typeof kt.inspectSource&&(kt.inspectSource=function(t){return se.call(t)});var ue,le,ce,he=kt.inspectSource,fe=o.WeakMap,de="function"==typeof fe&&/native code/.test(he(fe)),pe=o.WeakMap;if(de){var ve=kt.state||(kt.state=new pe),ye=ve.get,ge=ve.has,me=ve.set;ue=function(t,e){return e.facade=t,me.call(ve,t,e),e},le=function(t){return ye.call(ve,t)||{}},ce=function(t){return ge.call(ve,t)}}else{var be=Rt("state");rt[be]=!0,ue=function(t,e){return e.facade=t,W(t,be,e),e},le=function(t){return _(t,be)?t[be]:{}},ce=function(t){return _(t,be)}}var we={set:ue,get:le,has:ce,enforce:function(t){return ce(t)?le(t):ue(t,{})},getterFor:function(t){return function(e){var n;if(!m(e)||(n=le(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return n}}},_e=Ht("species"),xe=function(t,e){var n;return Tt(t)&&("function"!=typeof(n=t.constructor)||n!==Array&&!Tt(n.prototype)?m(n)&&null===(n=n[_e])&&(n=void 0):n=void 0),new(void 0===n?Array:n)(0===e?0:e)},Se=[].push,Te=function(t){var e=1==t,n=2==t,r=3==t,i=4==t,o=6==t,a=7==t,s=5==t||o;return function(u,l,c,h){for(var f,d,p=Et(u),y=v(p),g=z(l,c,3),m=Q(y.length),b=0,w=h||xe,_=e?w(u,m):n||a?w(u,0):void 0;m>b;b++)if((s||b in y)&&(d=g(f=y[b],b,p),t))if(e)_[b]=d;else if(d)switch(t){case 3:return!0;case 5:return f;case 6:return b;case 2:Se.call(_,f)}else switch(t){case 4:return!1;case 7:Se.call(_,f)}return o?-1:r||i?i:_}},Ee={forEach:Te(0),map:Te(1),filter:Te(2),some:Te(3),every:Te(4),find:Te(5),findIndex:Te(6),filterOut:Te(7)},Ae=Ee.forEach,Oe=Rt("hidden"),ke="Symbol",Ce=Ht("toPrimitive"),Le=we.set,Pe=we.getterFor(ke),De=Object.prototype,Me=o.Symbol,Re=ht("JSON","stringify"),Ie=O.f,je=B.f,ze=Gt.f,Ne=c.f,Fe=Ct("symbols"),Be=Ct("op-symbols"),We=Ct("string-to-symbol-registry"),Ye=Ct("symbol-to-string-registry"),Ge=Ct("wks"),Ve=o.QObject,Xe=!Ve||!Ve.prototype||!Ve.prototype.findChild,Ue=s&&a((function(){return 7!=Ft(je({},"a",{get:function(){return je(this,"a",{value:7}).a}})).a}))?function(t,e,n){var r=Ie(De,e);r&&delete De[e],je(t,e,n),r&&t!==De&&je(De,e,r)}:je,Ze=function(t,e){var n=Fe[t]=Ft(Me.prototype);return Le(n,{type:ke,tag:t,description:e}),s||(n.description=e),n},He=St?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof Me},qe=function(t,e,n){t===De&&qe(Be,e,n),N(t);var r=b(e,!0);return N(n),_(Fe,r)?(n.enumerable?(_(t,Oe)&&t[Oe][r]&&(t[Oe][r]=!1),n=Ft(n,{enumerable:h(0,!1)})):(_(t,Oe)||je(t,Oe,h(1,{})),t[Oe][r]=!0),Ue(t,r,n)):je(t,r,n)},$e=function(t,e){N(t);var n=g(e),r=st(n).concat(tn(n));return Ae(r,(function(e){s&&!Qe.call(n,e)||qe(t,e,n[e])})),t},Qe=function(t){var e=b(t,!0),n=Ne.call(this,e);return!(this===De&&_(Fe,e)&&!_(Be,e))&&(!(n||!_(this,e)||!_(Fe,e)||_(this,Oe)&&this[Oe][e])||n)},Ke=function(t,e){var n=g(t),r=b(e,!0);if(n!==De||!_(Fe,r)||_(Be,r)){var i=Ie(n,r);return!i||!_(Fe,r)||_(n,Oe)&&n[Oe][r]||(i.enumerable=!0),i}},Je=function(t){var e=ze(g(t)),n=[];return Ae(e,(function(t){_(Fe,t)||_(rt,t)||n.push(t)})),n},tn=function(t){var e=t===De,n=ze(e?Be:g(t)),r=[];return Ae(n,(function(t){!_(Fe,t)||e&&!_(De,t)||r.push(Fe[t])})),r};if(xt||(Vt((Me=function(){if(this instanceof Me)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=Dt(t),n=function(t){this===De&&n.call(Be,t),_(this,Oe)&&_(this[Oe],e)&&(this[Oe][e]=!1),Ue(this,e,h(1,t))};return s&&Xe&&Ue(De,e,{configurable:!0,set:n}),Ze(e,t)}).prototype,"toString",(function(){return Pe(this).tag})),Vt(Me,"withoutSetter",(function(t){return Ze(Dt(t),t)})),c.f=Qe,B.f=qe,O.f=Ke,dt.f=Gt.f=Je,pt.f=tn,qt.f=function(t){return Ze(Ht(t),t)},s&&je(Me.prototype,"description",{configurable:!0,get:function(){return Pe(this).description}})),V({global:!0,wrap:!0,forced:!xt,sham:!xt},{Symbol:Me}),Ae(st(Ge),(function(t){Qt(t)})),V({target:ke,stat:!0,forced:!xt},{for:function(t){var e=String(t);if(_(We,e))return We[e];var n=Me(e);return We[e]=n,Ye[n]=e,n},keyFor:function(t){if(!He(t))throw TypeError(t+" is not a symbol");if(_(Ye,t))return Ye[t]},useSetter:function(){Xe=!0},useSimple:function(){Xe=!1}}),V({target:"Object",stat:!0,forced:!xt,sham:!s},{create:function(t,e){return void 0===e?Ft(t):$e(Ft(t),e)},defineProperty:qe,defineProperties:$e,getOwnPropertyDescriptor:Ke}),V({target:"Object",stat:!0,forced:!xt},{getOwnPropertyNames:Je,getOwnPropertySymbols:tn}),V({target:"Object",stat:!0,forced:a((function(){pt.f(1)}))},{getOwnPropertySymbols:function(t){return pt.f(Et(t))}}),Re){var en=!xt||a((function(){var t=Me();return"[null]"!=Re([t])||"{}"!=Re({a:t})||"{}"!=Re(Object(t))}));V({target:"JSON",stat:!0,forced:en},{stringify:function(t,e,n){for(var r,i=[t],o=1;arguments.length>o;)i.push(arguments[o++]);if(r=e,(m(e)||void 0!==t)&&!He(t))return Tt(e)||(e=function(t,e){if("function"==typeof r&&(e=r.call(this,t,e)),!He(e))return e}),i[1]=e,Re.apply(null,i)}})}Me.prototype[Ce]||W(Me.prototype,Ce,Me.prototype.valueOf),ae(Me,ke),rt[Oe]=!0;var nn,rn,on,an=I.Object.getOwnPropertySymbols,sn={},un=!a((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),ln=Rt("IE_PROTO"),cn=Object.prototype,hn=un?Object.getPrototypeOf:function(t){return t=Et(t),_(t,ln)?t[ln]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?cn:null},fn=(Ht("iterator"),!1);[].keys&&("next"in(on=[].keys())?(rn=hn(hn(on)))!==Object.prototype&&(nn=rn):fn=!0),null==nn&&(nn={});var dn={IteratorPrototype:nn,BUGGY_SAFARI_ITERATORS:fn},pn=dn.IteratorPrototype,vn=function(){return this},yn=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,n={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(n,[]),e=n instanceof Array}catch(t){}return function(n,r){return N(n),function(t){if(!m(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(r),e?t.call(n,r):n.__proto__=r,n}}():void 0),gn=dn.IteratorPrototype,mn=dn.BUGGY_SAFARI_ITERATORS,bn=Ht("iterator"),wn="keys",_n="values",xn="entries",Sn=function(){return this},Tn=function(t,e,n,r,i,o,a){!function(t,e,n){var r=e+" Iterator";t.prototype=Ft(pn,{next:h(1,n)}),ae(t,r,!1,!0),sn[r]=vn}(n,e,r);var s,u,l,c=function(t){if(t===i&&y)return y;if(!mn&&t in p)return p[t];switch(t){case wn:case _n:case xn:return function(){return new n(this,t)}}return function(){return new n(this)}},f=e+" Iterator",d=!1,p=t.prototype,v=p[bn]||p["@@iterator"]||i&&p[i],y=!mn&&v||c(i),g="Array"==e&&p.entries||v;if(g&&(s=hn(g.call(new t)),gn!==Object.prototype&&s.next&&(ae(s,f,!0,!0),sn[f]=Sn)),i==_n&&v&&v.name!==_n&&(d=!0,y=function(){return v.call(this)}),a&&p[bn]!==y&&W(p,bn,y),sn[e]=y,i)if(u={values:c(_n),keys:o?y:c(wn),entries:c(xn)},a)for(l in u)(mn||d||!(l in p))&&Vt(p,l,u[l]);else V({target:e,proto:!0,forced:mn||d},u);return u},En="Array Iterator",An=we.set,On=we.getterFor(En);Tn(Array,"Array",(function(t,e){An(this,{type:En,target:g(t),index:0,kind:e})}),(function(){var t=On(this),e=t.target,n=t.kind,r=t.index++;return!e||r>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==n?{value:r,done:!1}:"values"==n?{value:e[r],done:!1}:{value:[r,e[r]],done:!1}}),"values");sn.Arguments=sn.Array;var kn=Ht("toStringTag");for(var Cn in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var Ln=o[Cn],Pn=Ln&&Ln.prototype;Pn&&ne(Pn)!==kn&&W(Pn,kn,Cn),sn[Cn]=sn.Array}var Dn=function(t){return function(e,n){var r,i,o=String(y(e)),a=q(n),s=o.length;return a<0||a>=s?t?"":void 0:(r=o.charCodeAt(a))<55296||r>56319||a+1===s||(i=o.charCodeAt(a+1))<56320||i>57343?t?o.charAt(a):r:t?o.slice(a,a+2):i-56320+(r-55296<<10)+65536}},Mn={codeAt:Dn(!1),charAt:Dn(!0)}.charAt,Rn="String Iterator",In=we.set,jn=we.getterFor(Rn);Tn(String,"String",(function(t){In(this,{type:Rn,string:String(t),index:0})}),(function(){var t,e=jn(this),n=e.string,r=e.index;return r>=n.length?{value:void 0,done:!0}:(t=Mn(n,r),e.index+=t.length,{value:t,done:!1})}));var zn=Ht("iterator"),Nn=function(t){if(null!=t)return t[zn]||t["@@iterator"]||sn[ne(t)]},Fn=function(t){var e=Nn(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return N(e.call(t))},Bn=Nn,Wn=function(t){var e=t.return;if(void 0!==e)return N(e.call(t)).value},Yn=function(t,e,n,r){try{return r?e(N(n)[0],n[1]):e(n)}catch(e){throw Wn(t),e}},Gn=Ht("iterator"),Vn=Array.prototype,Xn=function(t){return void 0!==t&&(sn.Array===t||Vn[Gn]===t)},Un=Ht("iterator"),Zn=!1;try{var Hn=0,qn={next:function(){return{done:!!Hn++}},return:function(){Zn=!0}};qn[Un]=function(){return this},Array.from(qn,(function(){throw 2}))}catch(t){}var $n=!function(t,e){if(!e&&!Zn)return!1;var n=!1;try{var r={};r[Un]=function(){return{next:function(){return{done:n=!0}}}},t(r)}catch(t){}return n}((function(t){Array.from(t)}));V({target:"Array",stat:!0,forced:$n},{from:function(t){var e,n,r,i,o,a,s=Et(t),u="function"==typeof this?this:Array,l=arguments.length,c=l>1?arguments[1]:void 0,h=void 0!==c,f=Nn(s),d=0;if(h&&(c=z(c,l>2?arguments[2]:void 0,2)),null==f||u==Array&&Xn(f))for(n=new u(e=Q(s.length));e>d;d++)a=h?c(s[d],d):s[d],yt(n,d,a);else for(o=(i=f.call(s)).next,n=new u;!(r=o.call(i)).done;d++)a=h?Yn(i,c,[r.value,d],!0):r.value,yt(n,d,a);return n.length=d,n}});var Qn=I.Array.from,Kn=Qn;V({target:"Object",stat:!0,sham:!s},{create:Ft});var Jn=I.Object,tr=function(t,e){return Jn.create(t,e)},er=tr,nr=X;var rr,ir=function(t,e,n){return e in t?nr(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}):t[e]=n,t},or="\t\n\v\f\r                　\u2028\u2029\ufeff",ar="["+or+"]",sr=RegExp("^"+ar+ar+"*"),ur=RegExp(ar+ar+"*$"),lr=function(t){return function(e){var n=String(y(e));return 1&t&&(n=n.replace(sr,"")),2&t&&(n=n.replace(ur,"")),n}},cr={start:lr(1),end:lr(2),trim:lr(3)},hr=cr.trim;V({target:"String",proto:!0,forced:(rr="trim",a((function(){return!!or[rr]()||"​᠎"!="​᠎"[rr]()||or[rr].name!==rr})))},{trim:function(){return hr(this)}});var fr=function(t){return I[t+"Prototype"]},dr=fr("String").trim,pr=String.prototype,vr=function(t){var e=t.trim;return"string"==typeof t||t===pr||t instanceof String&&e===pr.trim?dr:e},yr=function(t,e){var n=[][t];return!!n&&a((function(){n.call(null,e||function(){throw 1},1)}))},gr=Object.defineProperty,mr={},br=function(t){throw t},wr=function(t,e){if(_(mr,t))return mr[t];e||(e={});var n=[][t],r=!!_(e,"ACCESSORS")&&e.ACCESSORS,i=_(e,0)?e[0]:br,o=_(e,1)?e[1]:void 0;return mr[t]=!!n&&!a((function(){if(r&&!s)return!0;var t={length:-1};r?gr(t,1,{enumerable:!0,get:br}):t[1]=1,n.call(t,i,o)}))},_r=Ee.forEach,xr=yr("forEach"),Sr=wr("forEach"),Tr=xr&&Sr?[].forEach:function(t){return _r(this,t,arguments.length>1?arguments[1]:void 0)};V({target:"Array",proto:!0,forced:[].forEach!=Tr},{forEach:Tr});var Er=fr("Array").forEach,Ar=Array.prototype,Or={DOMTokenList:!0,NodeList:!0},kr=function(t){var e=t.forEach;return t===Ar||t instanceof Array&&e===Ar.forEach||Or.hasOwnProperty(ne(t))?Er:e},Cr=cr.trim,Lr=o.parseInt,Pr=/^[+-]?0[Xx]/,Dr=8!==Lr(or+"08")||22!==Lr(or+"0x16")?function(t,e){var n=Cr(String(t));return Lr(n,e>>>0||(Pr.test(n)?16:10))}:Lr;V({global:!0,forced:parseInt!=Dr},{parseInt:Dr});var Mr=I.parseInt,Rr=c.f,Ir=function(t){return function(e){for(var n,r=g(e),i=st(r),o=i.length,a=0,u=[];o>a;)n=i[a++],s&&!Rr.call(r,n)||u.push(t?[n,r[n]]:r[n]);return u}},jr={entries:Ir(!0),values:Ir(!1)}.values;V({target:"Object",stat:!0},{values:function(t){return jr(t)}});var zr,Nr,Fr=I.Object.values,Br=ht("navigator","userAgent")||"",Wr=o.process,Yr=Wr&&Wr.versions,Gr=Yr&&Yr.v8;Gr?Nr=(zr=Gr.split("."))[0]+zr[1]:Br&&(!(zr=Br.match(/Edge\/(\d+)/))||zr[1]>=74)&&(zr=Br.match(/Chrome\/(\d+)/))&&(Nr=zr[1]);var Vr=Nr&&+Nr,Xr=Ht("species"),Ur=function(t){return Vr>=51||!a((function(){var e=[];return(e.constructor={})[Xr]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Zr=Ee.filter,Hr=Ur("filter"),qr=wr("filter");V({target:"Array",proto:!0,forced:!Hr||!qr},{filter:function(t){return Zr(this,t,arguments.length>1?arguments[1]:void 0)}});var $r=fr("Array").filter,Qr=Array.prototype,Kr=function(t){var e=t.filter;return t===Qr||t instanceof Array&&e===Qr.filter?$r:e},Jr=a((function(){hn(1)}));V({target:"Object",stat:!0,forced:Jr,sham:!un},{getPrototypeOf:function(t){return hn(Et(t))}});var ti=I.Object.getPrototypeOf,ei=ti,ni=nt.indexOf,ri=[].indexOf,ii=!!ri&&1/[1].indexOf(1,-0)<0,oi=yr("indexOf"),ai=wr("indexOf",{ACCESSORS:!0,1:0});V({target:"Array",proto:!0,forced:ii||!oi||!ai},{indexOf:function(t){return ii?ri.apply(this,arguments)||0:ni(this,t,arguments.length>1?arguments[1]:void 0)}});var si=fr("Array").indexOf,ui=Array.prototype,li=function(t){var e=t.indexOf;return t===ui||t instanceof Array&&e===ui.indexOf?si:e},ci=Object.assign,hi=Object.defineProperty,fi=!ci||a((function(){if(s&&1!==ci({b:1},ci(hi({},"a",{enumerable:!0,get:function(){hi(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},n=Symbol(),r="abcdefghijklmnopqrst";return t[n]=7,r.split("").forEach((function(t){e[t]=t})),7!=ci({},t)[n]||st(ci({},e)).join("")!=r}))?function(t,e){for(var n=Et(t),r=arguments.length,i=1,o=pt.f,a=c.f;r>i;)for(var u,l=v(arguments[i++]),h=o?st(l).concat(o(l)):st(l),f=h.length,d=0;f>d;)u=h[d++],s&&!a.call(l,u)||(n[u]=l[u]);return n}:ci;V({target:"Object",stat:!0,forced:Object.assign!==fi},{assign:fi});var di=I.Object.assign;V({target:"Array",stat:!0},{isArray:Tt});var pi=I.Array.isArray,vi=pi;var yi=function(t){if(vi(t))return t},gi=Ht("iterator"),mi=function(t){var e=Object(t);return void 0!==e[gi]||"@@iterator"in e||sn.hasOwnProperty(ne(e))},bi=Ht("isConcatSpreadable"),wi=9007199254740991,_i="Maximum allowed index exceeded",xi=Vr>=51||!a((function(){var t=[];return t[bi]=!1,t.concat()[0]!==t})),Si=Ur("concat"),Ti=function(t){if(!m(t))return!1;var e=t[bi];return void 0!==e?!!e:Tt(t)};V({target:"Array",proto:!0,forced:!xi||!Si},{concat:function(t){var e,n,r,i,o,a=Et(this),s=xe(a,0),u=0;for(e=-1,r=arguments.length;e<r;e++)if(Ti(o=-1===e?a:arguments[e])){if(u+(i=Q(o.length))>wi)throw TypeError(_i);for(n=0;n<i;n++,u++)n in o&&yt(s,u,o[n])}else{if(u>=wi)throw TypeError(_i);yt(s,u++,o)}return s.length=u,s}});var Ei=Object.freeze({__proto__:null});Qt("asyncIterator");var Ai=Object.freeze({__proto__:null});Qt("hasInstance"),Qt("isConcatSpreadable"),Qt("iterator"),Qt("match"),Qt("matchAll"),Qt("replace"),Qt("search"),Qt("species"),Qt("split"),Qt("toPrimitive"),Qt("toStringTag"),Qt("unscopables"),ae(o.JSON,"JSON",!0);var Oi=Object.freeze({__proto__:null}),ki=Object.freeze({__proto__:null});r(Ei),r(Ai),r(Oi),r(ki);var Ci=I.Symbol;Qt("asyncDispose"),Qt("dispose"),Qt("observable"),Qt("patternMatch"),Qt("replaceAll");var Li=Ci;var Pi=function(t,e){if(void 0!==Li&&mi(Object(t))){var n=[],r=!0,i=!1,o=void 0;try{for(var a,s=Fn(t);!(r=(a=s.next()).done)&&(n.push(a.value),!e||n.length!==e);r=!0);}catch(t){i=!0,o=t}finally{try{r||null==s.return||s.return()}finally{if(i)throw o}}return n}},Di=Qn,Mi=Ur("slice"),Ri=wr("slice",{ACCESSORS:!0,0:0,1:2}),Ii=Ht("species"),ji=[].slice,zi=Math.max;V({target:"Array",proto:!0,forced:!Mi||!Ri},{slice:function(t,e){var n,r,i,o=g(this),a=Q(o.length),s=tt(t,a),u=tt(void 0===e?a:e,a);if(Tt(o)&&("function"!=typeof(n=o.constructor)||n!==Array&&!Tt(n.prototype)?m(n)&&null===(n=n[Ii])&&(n=void 0):n=void 0,n===Array||void 0===n))return ji.call(o,s,u);for(r=new(void 0===n?Array:n)(zi(u-s,0)),i=0;s<u;s++,i++)s in o&&yt(r,i,o[s]);return r.length=i,r}});var Ni=fr("Array").slice,Fi=Array.prototype,Bi=function(t){var e=t.slice;return t===Fi||t instanceof Array&&e===Fi.slice?Ni:e},Wi=Bi;var Yi=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var n=0,r=new Array(e);n<e;n++)r[n]=t[n];return r};var Gi=function(t,e){var n;if(t){if("string"==typeof t)return Yi(t,e);var r=Wi(n=Object.prototype.toString.call(t)).call(n,8,-1);return"Object"===r&&t.constructor&&(r=t.constructor.name),"Map"===r||"Set"===r?Di(t):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Yi(t,e):void 0}};var Vi=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var Xi=function(t,e){return yi(t)||Pi(t,e)||Gi(t,e)||Vi()};V({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});var Ui=I.Date.now,Zi=a((function(){st(1)}));V({target:"Object",stat:!0,forced:Zi},{keys:function(t){return st(Et(t))}});var Hi=I.Object.keys,qi=Ee.map,$i=Ur("map"),Qi=wr("map");V({target:"Array",proto:!0,forced:!$i||!Qi},{map:function(t){return qi(this,t,arguments.length>1?arguments[1]:void 0)}});var Ki=fr("Array").map,Ji=Array.prototype,to=function(t){var e=t.map;return t===Ji||t instanceof Array&&e===Ji.map?Ki:e},eo=pi,no=qt.f("iterator"),ro=no,io=n((function(t){function e(n){return t.exports=e="function"==typeof Li&&"symbol"==typeof ro?function(t){return typeof t}:function(t){return t&&"function"==typeof Li&&t.constructor===Li&&t!==Li.prototype?"symbol":typeof t},e(n)}t.exports=e}));V({target:"Reflect",stat:!0},{ownKeys:vt});var oo=I.Reflect.ownKeys,ao=Bi;var so=function(t){if(vi(t))return Yi(t)};var uo=function(t){if(void 0!==Li&&mi(Object(t)))return Di(t)};var lo=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var co=function(t){return so(t)||uo(t)||Gi(t)||lo()},ho=fr("Array").concat,fo=Array.prototype,po=function(t){var e=t.concat;return t===fo||t instanceof Array&&e===fo.concat?ho:e},vo=Ci;function yo(t,e){var n=Hi(t);if(an){var r=an(t);e&&(r=Kr(r).call(r,(function(e){return _t(t,e).enumerable}))),n.push.apply(n,r)}return n}function go(t){for(var e=1;e<arguments.length;e++){var n,r=null!=arguments[e]?arguments[e]:{};if(e%2)kr(n=yo(Object(r),!0)).call(n,(function(e){ir(t,e,r[e])}));else if(gt)lt(t,gt(r));else{var i;kr(i=yo(Object(r))).call(i,(function(e){U(t,e,_t(r,e))}))}}return t}function mo(t,e){var n;if(void 0===vo||null==Bn(t)){if(eo(t)||(n=function(t,e){var n;if(!t)return;if("string"==typeof t)return bo(t,e);var r=ao(n=Object.prototype.toString.call(t)).call(n,8,-1);"Object"===r&&t.constructor&&(r=t.constructor.name);if("Map"===r||"Set"===r)return Kn(t);if("Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r))return bo(t,e)}(t))||e&&t&&"number"==typeof t.length){n&&(t=n);var r=0,i=function(){};return{s:i,n:function(){return r>=t.length?{done:!0}:{done:!1,value:t[r++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){n=Fn(t)},n:function(){var t=n.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==n.return||n.return()}finally{if(s)throw o}}}}function bo(t,e){(null==e||e>t.length)&&(e=t.length);for(var n=0,r=new Array(e);n<e;n++)r[n]=t[n];return r}
/**
	 * vis-util
	 * https://github.com/visjs/vis-util
	 *
	 * utilitie collection for visjs
	 *
	 * @version 4.3.4
	 * @date    2020-08-01T15:11:53.524Z
	 *
	 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
	 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
	 *
	 * @license
	 * vis.js is dual licensed under both
	 *
	 *   1. The Apache 2.0 License
	 *      http://www.apache.org/licenses/LICENSE-2.0
	 *
	 *   and
	 *
	 *   2. The MIT License
	 *      http://opensource.org/licenses/MIT
	 *
	 * vis.js may be distributed under either license.
	 */var wo=vo("DELETE");function _o(t){for(var e,n=arguments.length,r=new Array(n>1?n-1:0),i=1;i<n;i++)r[i-1]=arguments[i];return xo.apply(void 0,po(e=[{},t]).call(e,r))}function xo(){var t=So.apply(void 0,arguments);return Eo(t),t}function So(){for(var t=arguments.length,e=new Array(t),n=0;n<t;n++)e[n]=arguments[n];if(e.length<2)return e[0];var r;if(e.length>2)return So.apply(void 0,po(r=[xo(e[0],e[1])]).call(r,co(ao(e).call(e,2))));var i,o=e[0],a=e[1],s=mo(oo(a));try{for(s.s();!(i=s.n()).done;){var u=i.value;Object.prototype.propertyIsEnumerable.call(a,u)&&(a[u]===wo?delete o[u]:null===o[u]||null===a[u]||"object"!==io(o[u])||"object"!==io(a[u])||eo(o[u])||eo(a[u])?o[u]=To(a[u]):o[u]=So(o[u],a[u]))}}catch(t){s.e(t)}finally{s.f()}return o}function To(t){return eo(t)?to(t).call(t,(function(t){return To(t)})):"object"===io(t)&&null!==t?So({},t):t}function Eo(t){for(var e=0,n=Hi(t);e<n.length;e++){var r=n[e];t[r]===wo?delete t[r]:"object"===io(t[r])&&null!==t[r]&&Eo(t[r])}}function Ao(t){var e=function(){for(var t=Oo(),e=t(" "),n=t(" "),r=t(" "),i=0;i<arguments.length;i++)(e-=t(i<0||arguments.length<=i?void 0:arguments[i]))<0&&(e+=1),(n-=t(i<0||arguments.length<=i?void 0:arguments[i]))<0&&(n+=1),(r-=t(i<0||arguments.length<=i?void 0:arguments[i]))<0&&(r+=1);return[e,n,r]}(t),n=Xi(e,3),r=n[0],i=n[1],o=n[2],a=1,s=function(){var t=2091639*r+2.3283064365386963e-10*a;return r=i,i=o,o=t-(a=0|t)};return s.uint32=function(){return 4294967296*s()},s.fract53=function(){return s()+11102230246251565e-32*(2097152*s()|0)},s.algorithm="Alea",s.seed=t,s.version="0.9",s}function Oo(){var t=4022871197;return function(e){for(var n=e.toString(),r=0;r<n.length;r++){var i=.02519603282416938*(t+=n.charCodeAt(r));i-=t=i>>>0,t=(i*=t)>>>0,t+=4294967296*(i-=t)}return 2.3283064365386963e-10*(t>>>0)}}var ko=/^\/?Date\((-?\d+)/i,Co=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,Lo=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,Po=/^rgb\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *\)$/i,Do=/^rgba\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *([01]|0?\.\d+) *\)$/i;function Mo(t){return t instanceof Number||"number"==typeof t}function Ro(t){return t instanceof String||"string"==typeof t}function Io(t){return"object"===io(t)&&null!==t}function jo(t,e,n,r){var i=!1;!0===r&&(i=null===e[n]&&void 0!==t[n]),i?delete t[n]:t[n]=e[n]}var zo=di;function No(t,e,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(eo(n))throw new TypeError("Arrays are not supported by deepExtend");for(var i=0;i<t.length;i++){var o=t[i];if(Object.prototype.hasOwnProperty.call(n,o))if(n[o]&&n[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?Fo(e[o],n[o],!1,r):jo(e,n,o,r);else{if(eo(n[o]))throw new TypeError("Arrays are not supported by deepExtend");jo(e,n,o,r)}}return e}function Fo(t,e){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var i in e)if(Object.prototype.hasOwnProperty.call(e,i)||!0===n)if("object"===io(e[i])&&null!==e[i]&&ei(e[i])===Object.prototype)void 0===t[i]?t[i]=Fo({},e[i],n):"object"===io(t[i])&&null!==t[i]&&ei(t[i])===Object.prototype?Fo(t[i],e[i],n):jo(t,e,i,r);else if(eo(e[i])){var o;t[i]=ao(o=e[i]).call(o)}else jo(t,e,i,r);return t}function Bo(t,e){var n;return po(n=[]).call(n,co(t),[e])}function Wo(t){return ao(t).call(t)}var Yo=Fr;function Go(t,e,n,r){var i;t.addEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&li(i=navigator.userAgent).call(i,"Firefox")>=0&&(e="DOMMouseScroll"),t.addEventListener(e,n,r)):t.attachEvent("on"+e,n)}function Vo(t,e,n,r){var i;t.removeEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&li(i=navigator.userAgent).call(i,"Firefox")>=0&&(e="DOMMouseScroll"),t.removeEventListener(e,n,r)):t.detachEvent("on"+e,n)}function Xo(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)}var Uo={asBoolean:function(t,e){return"function"==typeof t&&(t=t()),null!=t?0!=t:e||null},asNumber:function(t,e){return"function"==typeof t&&(t=t()),null!=t?Number(t)||e||null:e||null},asString:function(t,e){return"function"==typeof t&&(t=t()),null!=t?String(t):e||null},asSize:function(t,e){return"function"==typeof t&&(t=t()),Ro(t)?t:Mo(t)?t+"px":e||null},asElement:function(t,e){return"function"==typeof t&&(t=t()),t||e||null}};function Zo(t){var e;switch(t.length){case 3:case 4:return(e=Lo.exec(t))?{r:Mr(e[1]+e[1],16),g:Mr(e[2]+e[2],16),b:Mr(e[3]+e[3],16)}:null;case 6:case 7:return(e=Co.exec(t))?{r:Mr(e[1],16),g:Mr(e[2],16),b:Mr(e[3],16)}:null;default:return null}}function Ho(t,e,n){var r;return"#"+ao(r=((1<<24)+(t<<16)+(e<<8)+n).toString(16)).call(r,1)}function qo(t,e,n){t/=255,e/=255,n/=255;var r=Math.min(t,Math.min(e,n)),i=Math.max(t,Math.max(e,n));return r===i?{h:0,s:0,v:r}:{h:60*((t===r?3:n===r?1:5)-(t===r?e-n:n===r?t-e:n-t)/(i-r))/360,s:(i-r)/i,v:i}}var $o=function(t){var e,n={};return kr(e=t.split(";")).call(e,(function(t){if(""!=vr(t).call(t)){var e,r,i=t.split(":"),o=vr(e=i[0]).call(e),a=vr(r=i[1]).call(r);n[o]=a}})),n},Qo=function(t){var e;return to(e=Hi(t)).call(e,(function(e){return e+": "+t[e]})).join("; ")};function Ko(t,e,n){var r,i,o,a=Math.floor(6*t),s=6*t-a,u=n*(1-e),l=n*(1-s*e),c=n*(1-(1-s)*e);switch(a%6){case 0:r=n,i=c,o=u;break;case 1:r=l,i=n,o=u;break;case 2:r=u,i=n,o=c;break;case 3:r=u,i=l,o=n;break;case 4:r=c,i=u,o=n;break;case 5:r=n,i=u,o=l}return{r:Math.floor(255*r),g:Math.floor(255*i),b:Math.floor(255*o)}}function Jo(t,e,n){var r=Ko(t,e,n);return Ho(r.r,r.g,r.b)}function ta(t){var e=Zo(t);if(!e)throw new TypeError("'".concat(t,"' is not a valid color."));return qo(e.r,e.g,e.b)}function ea(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}function na(t){return Po.test(t)}function ra(t){if(null===t||"object"!==io(t))return null;if(t instanceof Element)return t;var e=er(t);for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&"object"==io(t[n])&&(e[n]=ra(t[n]));return e}var ia=Object.freeze({__proto__:null,Alea:function(){for(var t=arguments.length,e=new Array(t),n=0;n<t;n++)e[n]=arguments[n];return Ao(e.length?e:[Ui()])},DELETE:wo,HSVToHex:Jo,HSVToRGB:Ko,RGBToHSV:qo,RGBToHex:Ho,addClassName:function(t,e){var n=t.className.split(" "),r=e.split(" ");n=po(n).call(n,Kr(r).call(r,(function(t){return li(n).call(n,t)<0}))),t.className=n.join(" ")},addCssText:function(t,e){var n=$o(t.style.cssText),r=$o(e),i=go(go({},n),r);t.style.cssText=Qo(i)},addEventListener:Go,binarySearchCustom:function(t,e,n,r){for(var i=0,o=0,a=t.length-1;o<=a&&i<1e4;){var s=Math.floor((o+a)/2),u=t[s],l=e(void 0===r?u[n]:u[n][r]);if(0==l)return s;-1==l?o=s+1:a=s-1,i++}return-1},binarySearchValue:function(t,e,n,r,i){var o,a,s,u,l=0,c=0,h=t.length-1;for(i=null!=i?i:function(t,e){return t==e?0:t<e?-1:1};c<=h&&l<1e4;){if(u=Math.floor(.5*(h+c)),o=t[Math.max(0,u-1)][n],a=t[u][n],s=t[Math.min(t.length-1,u+1)][n],0==i(a,e))return u;if(i(o,e)<0&&i(a,e)>0)return"before"==r?Math.max(0,u-1):u;if(i(a,e)<0&&i(s,e)>0)return"before"==r?u:Math.min(t.length-1,u+1);i(a,e)<0?c=u+1:h=u-1,l++}return-1},bridgeObject:ra,copyAndExtendArray:Bo,copyArray:Wo,deepExtend:Fo,deepObjectAssign:xo,easingFunctions:{linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return t*(2-t)},easeInOutQuad:function(t){return t<.5?2*t*t:(4-2*t)*t-1},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return--t*t*t+1},easeInOutCubic:function(t){return t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return 1- --t*t*t*t},easeInOutQuart:function(t){return t<.5?8*t*t*t*t:1-8*--t*t*t*t},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return 1+--t*t*t*t*t},easeInOutQuint:function(t){return t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t}},equalArray:function(t,e){if(t.length!==e.length)return!1;for(var n=0,r=t.length;n<r;n++)if(t[n]!=e[n])return!1;return!0},extend:zo,fillIfDefined:function t(e,n){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];for(var i in e)if(void 0!==n[i])if(null===n[i]||"object"!==io(n[i]))jo(e,n,i,r);else{var o=e[i],a=n[i];Io(o)&&Io(a)&&t(o,a,r)}},forEach:function(t,e){if(eo(t))for(var n=t.length,r=0;r<n;r++)e(t[r],r,t);else for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&e(t[i],i,t)},getAbsoluteLeft:function(t){return t.getBoundingClientRect().left},getAbsoluteRight:function(t){return t.getBoundingClientRect().right},getAbsoluteTop:function(t){return t.getBoundingClientRect().top},getScrollBarWidth:function(){var t=document.createElement("p");t.style.width="100%",t.style.height="200px";var e=document.createElement("div");e.style.position="absolute",e.style.top="0px",e.style.left="0px",e.style.visibility="hidden",e.style.width="200px",e.style.height="150px",e.style.overflow="hidden",e.appendChild(t),document.body.appendChild(e);var n=t.offsetWidth;e.style.overflow="scroll";var r=t.offsetWidth;return n==r&&(r=e.clientWidth),document.body.removeChild(e),n-r},getTarget:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window.event,e=null;return t&&(t.target?e=t.target:t.srcElement&&(e=t.srcElement)),e instanceof Element&&(null==e.nodeType||3!=e.nodeType||(e=e.parentNode)instanceof Element)?e:null},getType:function(t){var e=io(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":eo(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e},hasParent:function(t,e){for(var n=t;n;){if(n===e)return!0;if(!n.parentNode)return!1;n=n.parentNode}return!1},hexToHSV:ta,hexToRGB:Zo,insertSort:function(t,e){for(var n=0;n<t.length;n++){var r=t[n],i=void 0;for(i=n;i>0&&e(r,t[i-1])<0;i--)t[i]=t[i-1];t[i]=r}return t},isDate:function(t){if(t instanceof Date)return!0;if(Ro(t)){if(ko.exec(t))return!0;if(!isNaN(Date.parse(t)))return!0}return!1},isNumber:Mo,isObject:Io,isString:Ro,isValidHex:ea,isValidRGB:na,isValidRGBA:function(t){return Do.test(t)},mergeOptions:function(t,e,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},i=function(t){return null!=t},o=function(t){return null!==t&&"object"===io(t)},a=function(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0};if(!o(t))throw new Error("Parameter mergeTarget must be an object");if(!o(e))throw new Error("Parameter options must be an object");if(!i(n))throw new Error("Parameter option must have a value");if(!o(r))throw new Error("Parameter globalOptions must be an object");var s=function(t,e,n){o(t[n])||(t[n]={});var r=e[n],i=t[n];for(var a in r)Object.prototype.hasOwnProperty.call(r,a)&&(i[a]=r[a])},u=e[n],l=o(r)&&!a(r),c=l?r[n]:void 0,h=c?c.enabled:void 0;if(void 0!==u){if("boolean"==typeof u)return o(t[n])||(t[n]={}),void(t[n].enabled=u);if(null===u&&!o(t[n])){if(!i(c))return;t[n]=er(c)}if(o(u)){var f=!0;void 0!==u.enabled?f=u.enabled:void 0!==h&&(f=c.enabled),s(t,e,n),t[n].enabled=f}}},option:Uo,overrideOpacity:function(t,e){if(-1!==li(t).call(t,"rgba"))return t;if(-1!==li(t).call(t,"rgb")){var n=t.substr(li(t).call(t,"(")+1).replace(")","").split(",");return"rgba("+n[0]+","+n[1]+","+n[2]+","+e+")"}var r=Zo(t);return null==r?t:"rgba("+r.r+","+r.g+","+r.b+","+e+")"},parseColor:function(t,e){if(Ro(t)){var n=t;if(na(n)){var r,i=to(r=n.substr(4).substr(0,n.length-5).split(",")).call(r,(function(t){return Mr(t)}));n=Ho(i[0],i[1],i[2])}if(!0===ea(n)){var o=ta(n),a={h:o.h,s:.8*o.s,v:Math.min(1,1.02*o.v)},s={h:o.h,s:Math.min(1,1.25*o.s),v:.8*o.v},u=Jo(s.h,s.s,s.v),l=Jo(a.h,a.s,a.v);return{background:n,border:u,highlight:{background:l,border:u},hover:{background:l,border:u}}}return{background:n,border:n,highlight:{background:n,border:n},hover:{background:n,border:n}}}return e?{background:t.background||e.background,border:t.border||e.border,highlight:Ro(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||e.highlight.background,border:t.highlight&&t.highlight.border||e.highlight.border},hover:Ro(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||e.hover.border,background:t.hover&&t.hover.background||e.hover.background}}:{background:t.background||void 0,border:t.border||void 0,highlight:Ro(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||void 0,border:t.highlight&&t.highlight.border||void 0},hover:Ro(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||void 0,background:t.hover&&t.hover.background||void 0}}},preventDefault:Xo,pureDeepObjectAssign:_o,recursiveDOMDelete:function t(e){if(e)for(;!0===e.hasChildNodes();){var n=e.firstChild;n&&(t(n),e.removeChild(n))}},removeClassName:function(t,e){var n=t.className.split(" "),r=e.split(" ");n=Kr(n).call(n,(function(t){return li(r).call(r,t)<0})),t.className=n.join(" ")},removeCssText:function(t,e){var n=$o(t.style.cssText),r=$o(e);for(var i in r)Object.prototype.hasOwnProperty.call(r,i)&&delete n[i];t.style.cssText=Qo(n)},removeEventListener:Vo,selectiveBridgeObject:function(t,e){if(null!==e&&"object"===io(e)){for(var n=er(e),r=0;r<t.length;r++)Object.prototype.hasOwnProperty.call(e,t[r])&&"object"==io(e[t[r]])&&(n[t[r]]=ra(e[t[r]]));return n}return null},selectiveDeepExtend:No,selectiveExtend:function(t,e){if(!eo(t))throw new Error("Array with property names expected as first argument");for(var n=arguments.length,r=new Array(n>2?n-2:0),i=2;i<n;i++)r[i-2]=arguments[i];for(var o=0,a=r;o<a.length;o++)for(var s=a[o],u=0;u<t.length;u++){var l=t[u];s&&Object.prototype.hasOwnProperty.call(s,l)&&(e[l]=s[l])}return e},selectiveNotDeepExtend:function(t,e,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(eo(n))throw new TypeError("Arrays are not supported by deepExtend");for(var i in n)if(Object.prototype.hasOwnProperty.call(n,i)&&-1===li(t).call(t,i))if(n[i]&&n[i].constructor===Object)void 0===e[i]&&(e[i]={}),e[i].constructor===Object?Fo(e[i],n[i]):jo(e,n,i,r);else if(eo(n[i])){e[i]=[];for(var o=0;o<n[i].length;o++)e[i].push(n[i][o])}else jo(e,n,i,r);return e},throttle:function(t){var e=!1;return function(){e||(e=!0,requestAnimationFrame((function(){e=!1,t()})))}},toArray:Yo,topMost:function(t,e){var n;eo(e)||(e=[e]);var r,i=mo(t);try{for(i.s();!(r=i.n()).done;){var o=r.value;if(o){n=o[e[0]];for(var a=1;a<e.length;a++)n&&(n=n[e[a]]);if(void 0!==n)break}}}catch(t){i.e(t)}finally{i.f()}return n},updateProperty:function(t,e,n){return t[e]!==n&&(t[e]=n,!0)}}),oa=n((function(t,e){e.prepareElements=function(t){for(var e in t)t.hasOwnProperty(e)&&(t[e].redundant=t[e].used,t[e].used=[])},e.cleanupElements=function(t){for(var e in t)if(t.hasOwnProperty(e)&&t[e].redundant){for(var n=0;n<t[e].redundant.length;n++)t[e].redundant[n].parentNode.removeChild(t[e].redundant[n]);t[e].redundant=[]}},e.resetElements=function(t){e.prepareElements(t),e.cleanupElements(t),e.prepareElements(t)},e.getSVGElement=function(t,e,n){var r;return e.hasOwnProperty(t)?e[t].redundant.length>0?(r=e[t].redundant[0],e[t].redundant.shift()):(r=document.createElementNS("http://www.w3.org/2000/svg",t),n.appendChild(r)):(r=document.createElementNS("http://www.w3.org/2000/svg",t),e[t]={used:[],redundant:[]},n.appendChild(r)),e[t].used.push(r),r},e.getDOMElement=function(t,e,n,r){var i;return e.hasOwnProperty(t)?e[t].redundant.length>0?(i=e[t].redundant[0],e[t].redundant.shift()):(i=document.createElement(t),void 0!==r?n.insertBefore(i,r):n.appendChild(i)):(i=document.createElement(t),e[t]={used:[],redundant:[]},void 0!==r?n.insertBefore(i,r):n.appendChild(i)),e[t].used.push(i),i},e.drawPoint=function(t,n,r,i,o,a){var s;if("circle"==r.style?((s=e.getSVGElement("circle",i,o)).setAttributeNS(null,"cx",t),s.setAttributeNS(null,"cy",n),s.setAttributeNS(null,"r",.5*r.size)):((s=e.getSVGElement("rect",i,o)).setAttributeNS(null,"x",t-.5*r.size),s.setAttributeNS(null,"y",n-.5*r.size),s.setAttributeNS(null,"width",r.size),s.setAttributeNS(null,"height",r.size)),void 0!==r.styles&&s.setAttributeNS(null,"style",r.styles),s.setAttributeNS(null,"class",r.className+" vis-point"),a){var u=e.getSVGElement("text",i,o);a.xOffset&&(t+=a.xOffset),a.yOffset&&(n+=a.yOffset),a.content&&(u.textContent=a.content),a.className&&u.setAttributeNS(null,"class",a.className+" vis-label"),u.setAttributeNS(null,"x",t),u.setAttributeNS(null,"y",n)}return s},e.drawBar=function(t,n,r,i,o,a,s,u){if(0!=i){i<0&&(n-=i*=-1);var l=e.getSVGElement("rect",a,s);l.setAttributeNS(null,"x",t-.5*r),l.setAttributeNS(null,"y",n),l.setAttributeNS(null,"width",r),l.setAttributeNS(null,"height",i),l.setAttributeNS(null,"class",o),u&&l.setAttributeNS(null,"style",u)}}}));oa.prepareElements,oa.cleanupElements,oa.resetElements,oa.getSVGElement,oa.getDOMElement,oa.drawPoint,oa.drawBar;var aa=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t},sa=[].slice,ua={},la=function(t,e,n){if(!(e in ua)){for(var r=[],i=0;i<e;i++)r[i]="a["+i+"]";ua[e]=Function("C,a","return new C("+r.join(",")+")")}return ua[e](t,n)},ca=Function.bind||function(t){var e=j(this),n=sa.call(arguments,1),r=function(){var i=n.concat(sa.call(arguments));return this instanceof r?la(e,i.length,i):e.apply(t,i)};return m(e.prototype)&&(r.prototype=e.prototype),r},ha=ht("Reflect","construct"),fa=a((function(){function t(){}return!(ha((function(){}),[],t)instanceof t)})),da=!a((function(){ha((function(){}))})),pa=fa||da;V({target:"Reflect",stat:!0,forced:pa,sham:pa},{construct:function(t,e){j(t),N(e);var n=arguments.length<3?t:j(arguments[2]);if(da&&!fa)return ha(t,e,n);if(t==n){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var r=[null];return r.push.apply(r,e),new(ca.apply(t,r))}var i=n.prototype,o=Ft(m(i)?i:Object.prototype),a=Function.apply.call(t,o,e);return m(a)?a:o}});var va=I.Reflect.construct,ya=fr("Array").entries,ga=Array.prototype,ma={DOMTokenList:!0,NodeList:!0},ba=function(t){var e=t.entries;return t===ga||t instanceof Array&&e===ga.entries||ma.hasOwnProperty(ne(t))?ya:e},wa=ht("JSON","stringify"),_a=/[\uD800-\uDFFF]/g,xa=/^[\uD800-\uDBFF]$/,Sa=/^[\uDC00-\uDFFF]$/,Ta=function(t,e,n){var r=n.charAt(e-1),i=n.charAt(e+1);return xa.test(t)&&!Sa.test(i)||Sa.test(t)&&!xa.test(r)?"\\u"+t.charCodeAt(0).toString(16):t},Ea=a((function(){return'"\\udf06\\ud834"'!==wa("\udf06\ud834")||'"\\udead"'!==wa("\udead")}));wa&&V({target:"JSON",stat:!0,forced:Ea},{stringify:function(t,e,n){var r=wa.apply(null,arguments);return"string"==typeof r?r.replace(_a,Ta):r}}),I.JSON||(I.JSON={stringify:JSON.stringify});var Aa=function(t,e,n){return I.JSON.stringify.apply(null,arguments)},Oa=fr("Array").values,ka=Array.prototype,Ca={DOMTokenList:!0,NodeList:!0},La=function(t){var e=t.values;return t===ka||t instanceof Array&&e===ka.values||Ca.hasOwnProperty(ne(t))?Oa:e},Pa=fr("Array").keys,Da=Array.prototype,Ma={DOMTokenList:!0,NodeList:!0},Ra=function(t){var e=t.keys;return t===Da||t instanceof Array&&e===Da.keys||Ma.hasOwnProperty(ne(t))?Pa:e},Ia=Ee.some,ja=yr("some"),za=wr("some");V({target:"Array",proto:!0,forced:!ja||!za},{some:function(t){return Ia(this,t,arguments.length>1?arguments[1]:void 0)}});var Na=fr("Array").some,Fa=Array.prototype,Ba=function(t){var e=t.some;return t===Fa||t instanceof Array&&e===Fa.some?Na:e},Wa=tr;V({target:"Object",stat:!0},{setPrototypeOf:yn});var Ya=I.Object.setPrototypeOf,Ga=n((function(t){function e(n,r){return t.exports=e=Ya||function(t,e){return t.__proto__=e,t},e(n,r)}t.exports=e}));var Va=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Wa(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&Ga(t,e)};var Xa=function(t,e){return!e||"object"!==io(e)&&"function"!=typeof e?aa(t):e},Ua=ti,Za=n((function(t){function e(n){return t.exports=e=Ya?Ua:function(t){return t.__proto__||Ua(t)},e(n)}t.exports=e})),Ha=[],qa=Ha.sort,$a=a((function(){Ha.sort(void 0)})),Qa=a((function(){Ha.sort(null)})),Ka=yr("sort");V({target:"Array",proto:!0,forced:$a||!Qa||!Ka},{sort:function(t){return void 0===t?qa.call(Et(this)):qa.call(Et(this),j(t))}});var Ja=fr("Array").sort,ts=Array.prototype,es=function(t){var e=t.sort;return t===ts||t instanceof Array&&e===ts.sort?Ja:e},ns=!a((function(){return Object.isExtensible(Object.preventExtensions({}))})),rs=n((function(t){var e=B.f,n=Dt("meta"),r=0,i=Object.isExtensible||function(){return!0},o=function(t){e(t,n,{value:{objectID:"O"+ ++r,weakData:{}}})},a=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!m(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!_(t,n)){if(!i(t))return"F";if(!e)return"E";o(t)}return t[n].objectID},getWeakData:function(t,e){if(!_(t,n)){if(!i(t))return!0;if(!e)return!1;o(t)}return t[n].weakData},onFreeze:function(t){return ns&&a.REQUIRED&&i(t)&&!_(t,n)&&o(t),t}};rt[n]=!0})),is=(rs.REQUIRED,rs.fastKey,rs.getWeakData,rs.onFreeze,function(t,e){this.stopped=t,this.result=e}),os=function(t,e,n){var r,i,o,a,s,u,l,c=n&&n.that,h=!(!n||!n.AS_ENTRIES),f=!(!n||!n.IS_ITERATOR),d=!(!n||!n.INTERRUPTED),p=z(e,c,1+h+d),v=function(t){return r&&Wn(r),new is(!0,t)},y=function(t){return h?(N(t),d?p(t[0],t[1],v):p(t[0],t[1])):d?p(t,v):p(t)};if(f)r=t;else{if("function"!=typeof(i=Nn(t)))throw TypeError("Target is not iterable");if(Xn(i)){for(o=0,a=Q(t.length);a>o;o++)if((s=y(t[o]))&&s instanceof is)return s;return new is(!1)}r=i.call(t)}for(u=r.next;!(l=u.call(r)).done;){try{s=y(l.value)}catch(t){throw Wn(r),t}if("object"==typeof s&&s&&s instanceof is)return s}return new is(!1)},as=function(t,e,n){if(!(t instanceof e))throw TypeError("Incorrect "+(n?n+" ":"")+"invocation");return t},ss=B.f,us=Ee.forEach,ls=we.set,cs=we.getterFor,hs=function(t,e,n){var r,i=-1!==t.indexOf("Map"),u=-1!==t.indexOf("Weak"),l=i?"set":"add",c=o[t],h=c&&c.prototype,f={};if(s&&"function"==typeof c&&(u||h.forEach&&!a((function(){(new c).entries().next()})))){r=e((function(e,n){ls(as(e,r,t),{type:t,collection:new c}),null!=n&&os(n,e[l],{that:e,AS_ENTRIES:i})}));var d=cs(t);us(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in h)||u&&"clear"==t||W(r.prototype,t,(function(n,r){var i=d(this).collection;if(!e&&u&&!m(n))return"get"==t&&void 0;var o=i[t](0===n?0:n,r);return e?this:o}))})),u||ss(r.prototype,"size",{configurable:!0,get:function(){return d(this).collection.size}})}else r=n.getConstructor(e,t,i,l),rs.REQUIRED=!0;return ae(r,t,!1,!0),f[t]=r,V({global:!0,forced:!0},f),u||n.setStrong(r,t,i),r},fs=function(t,e,n){for(var r in e)n&&n.unsafe&&t[r]?t[r]=e[r]:Vt(t,r,e[r],n);return t},ds=Ht("species"),ps=B.f,vs=rs.fastKey,ys=we.set,gs=we.getterFor,ms={getConstructor:function(t,e,n,r){var i=t((function(t,o){as(t,i,e),ys(t,{type:e,index:Ft(null),first:void 0,last:void 0,size:0}),s||(t.size=0),null!=o&&os(o,t[r],{that:t,AS_ENTRIES:n})})),o=gs(e),a=function(t,e,n){var r,i,a=o(t),l=u(t,e);return l?l.value=n:(a.last=l={index:i=vs(e,!0),key:e,value:n,previous:r=a.last,next:void 0,removed:!1},a.first||(a.first=l),r&&(r.next=l),s?a.size++:t.size++,"F"!==i&&(a.index[i]=l)),t},u=function(t,e){var n,r=o(t),i=vs(e);if("F"!==i)return r.index[i];for(n=r.first;n;n=n.next)if(n.key==e)return n};return fs(i.prototype,{clear:function(){for(var t=o(this),e=t.index,n=t.first;n;)n.removed=!0,n.previous&&(n.previous=n.previous.next=void 0),delete e[n.index],n=n.next;t.first=t.last=void 0,s?t.size=0:this.size=0},delete:function(t){var e=this,n=o(e),r=u(e,t);if(r){var i=r.next,a=r.previous;delete n.index[r.index],r.removed=!0,a&&(a.next=i),i&&(i.previous=a),n.first==r&&(n.first=i),n.last==r&&(n.last=a),s?n.size--:e.size--}return!!r},forEach:function(t){for(var e,n=o(this),r=z(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:n.first;)for(r(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!u(this,t)}}),fs(i.prototype,n?{get:function(t){var e=u(this,t);return e&&e.value},set:function(t,e){return a(this,0===t?0:t,e)}}:{add:function(t){return a(this,t=0===t?0:t,t)}}),s&&ps(i.prototype,"size",{get:function(){return o(this).size}}),i},setStrong:function(t,e,n){var r=e+" Iterator",i=gs(e),o=gs(r);Tn(t,e,(function(t,e){ys(this,{type:r,target:t,state:i(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,n=t.last;n&&n.removed;)n=n.previous;return t.target&&(t.last=n=n?n.next:t.state.first)?"keys"==e?{value:n.key,done:!1}:"values"==e?{value:n.value,done:!1}:{value:[n.key,n.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),n?"entries":"values",!n,!0),function(t){var e=ht(t),n=B.f;s&&e&&!e[ds]&&n(e,ds,{configurable:!0,get:function(){return this}})}(e)}},bs=(hs("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),ms),I.Set),ws=(hs("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),ms),I.Map),_s=n((function(t){var e=function(t){var e,n=Object.prototype,r=n.hasOwnProperty,i="function"==typeof Symbol?Symbol:{},o=i.iterator||"@@iterator",a=i.asyncIterator||"@@asyncIterator",s=i.toStringTag||"@@toStringTag";function u(t,e,n){return Object.defineProperty(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{u({},"")}catch(t){u=function(t,e,n){return t[e]=n}}function l(t,e,n,r){var i=e&&e.prototype instanceof y?e:y,o=Object.create(i.prototype),a=new k(r||[]);return o._invoke=function(t,e,n){var r=h;return function(i,o){if(r===d)throw new Error("Generator is already running");if(r===p){if("throw"===i)throw o;return L()}for(n.method=i,n.arg=o;;){var a=n.delegate;if(a){var s=E(a,n);if(s){if(s===v)continue;return s}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(r===h)throw r=p,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);r=d;var u=c(t,e,n);if("normal"===u.type){if(r=n.done?p:f,u.arg===v)continue;return{value:u.arg,done:n.done}}"throw"===u.type&&(r=p,n.method="throw",n.arg=u.arg)}}}(t,n,a),o}function c(t,e,n){try{return{type:"normal",arg:t.call(e,n)}}catch(t){return{type:"throw",arg:t}}}t.wrap=l;var h="suspendedStart",f="suspendedYield",d="executing",p="completed",v={};function y(){}function g(){}function m(){}var b={};b[o]=function(){return this};var w=Object.getPrototypeOf,_=w&&w(w(C([])));_&&_!==n&&r.call(_,o)&&(b=_);var x=m.prototype=y.prototype=Object.create(b);function S(t){["next","throw","return"].forEach((function(e){u(t,e,(function(t){return this._invoke(e,t)}))}))}function T(t,e){var n;this._invoke=function(i,o){function a(){return new e((function(n,a){!function n(i,o,a,s){var u=c(t[i],t,o);if("throw"!==u.type){var l=u.arg,h=l.value;return h&&"object"==typeof h&&r.call(h,"__await")?e.resolve(h.__await).then((function(t){n("next",t,a,s)}),(function(t){n("throw",t,a,s)})):e.resolve(h).then((function(t){l.value=t,a(l)}),(function(t){return n("throw",t,a,s)}))}s(u.arg)}(i,o,n,a)}))}return n=n?n.then(a,a):a()}}function E(t,n){var r=t.iterator[n.method];if(r===e){if(n.delegate=null,"throw"===n.method){if(t.iterator.return&&(n.method="return",n.arg=e,E(t,n),"throw"===n.method))return v;n.method="throw",n.arg=new TypeError("The iterator does not provide a 'throw' method")}return v}var i=c(r,t.iterator,n.arg);if("throw"===i.type)return n.method="throw",n.arg=i.arg,n.delegate=null,v;var o=i.arg;return o?o.done?(n[t.resultName]=o.value,n.next=t.nextLoc,"return"!==n.method&&(n.method="next",n.arg=e),n.delegate=null,v):o:(n.method="throw",n.arg=new TypeError("iterator result is not an object"),n.delegate=null,v)}function A(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function O(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function k(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(A,this),this.reset(!0)}function C(t){if(t){var n=t[o];if(n)return n.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var i=-1,a=function n(){for(;++i<t.length;)if(r.call(t,i))return n.value=t[i],n.done=!1,n;return n.value=e,n.done=!0,n};return a.next=a}}return{next:L}}function L(){return{value:e,done:!0}}return g.prototype=x.constructor=m,m.constructor=g,g.displayName=u(m,s,"GeneratorFunction"),t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===g||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,m):(t.__proto__=m,u(t,s,"GeneratorFunction")),t.prototype=Object.create(x),t},t.awrap=function(t){return{__await:t}},S(T.prototype),T.prototype[a]=function(){return this},t.AsyncIterator=T,t.async=function(e,n,r,i,o){void 0===o&&(o=Promise);var a=new T(l(e,n,r,i),o);return t.isGeneratorFunction(n)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},S(x),u(x,s,"Generator"),x[o]=function(){return this},x.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var n in t)e.push(n);return e.reverse(),function n(){for(;e.length;){var r=e.pop();if(r in t)return n.value=r,n.done=!1,n}return n.done=!0,n}},t.values=C,k.prototype={constructor:k,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=e,this.done=!1,this.delegate=null,this.method="next",this.arg=e,this.tryEntries.forEach(O),!t)for(var n in this)"t"===n.charAt(0)&&r.call(this,n)&&!isNaN(+n.slice(1))&&(this[n]=e)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var n=this;function i(r,i){return s.type="throw",s.arg=t,n.next=r,i&&(n.method="next",n.arg=e),!!i}for(var o=this.tryEntries.length-1;o>=0;--o){var a=this.tryEntries[o],s=a.completion;if("root"===a.tryLoc)return i("end");if(a.tryLoc<=this.prev){var u=r.call(a,"catchLoc"),l=r.call(a,"finallyLoc");if(u&&l){if(this.prev<a.catchLoc)return i(a.catchLoc,!0);if(this.prev<a.finallyLoc)return i(a.finallyLoc)}else if(u){if(this.prev<a.catchLoc)return i(a.catchLoc,!0)}else{if(!l)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return i(a.finallyLoc)}}}},abrupt:function(t,e){for(var n=this.tryEntries.length-1;n>=0;--n){var i=this.tryEntries[n];if(i.tryLoc<=this.prev&&r.call(i,"finallyLoc")&&this.prev<i.finallyLoc){var o=i;break}}o&&("break"===t||"continue"===t)&&o.tryLoc<=e&&e<=o.finallyLoc&&(o=null);var a=o?o.completion:{};return a.type=t,a.arg=e,o?(this.method="next",this.next=o.finallyLoc,v):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),v},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var n=this.tryEntries[e];if(n.finallyLoc===t)return this.complete(n.completion,n.afterLoc),O(n),v}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var n=this.tryEntries[e];if(n.tryLoc===t){var r=n.completion;if("throw"===r.type){var i=r.arg;O(n)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(t,n,r){return this.delegate={iterator:C(t),resultName:n,nextLoc:r},"next"===this.method&&(this.arg=e),v}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}})),xs=no,Ss=Ur("splice"),Ts=wr("splice",{ACCESSORS:!0,0:0,1:2}),Es=Math.max,As=Math.min,Os=9007199254740991,ks="Maximum allowed length exceeded";V({target:"Array",proto:!0,forced:!Ss||!Ts},{splice:function(t,e){var n,r,i,o,a,s,u=Et(this),l=Q(u.length),c=tt(t,l),h=arguments.length;if(0===h?n=r=0:1===h?(n=0,r=l-c):(n=h-2,r=As(Es(q(e),0),l-c)),l+n-r>Os)throw TypeError(ks);for(i=xe(u,r),o=0;o<r;o++)(a=c+o)in u&&yt(i,o,u[a]);if(i.length=r,n<r){for(o=c;o<l-r;o++)s=o+n,(a=o+r)in u?u[s]=u[a]:delete u[s];for(o=l;o>l-r+n;o--)delete u[o-1]}else if(n>r)for(o=l-r;o>c;o--)s=o+n-1,(a=o+r-1)in u?u[s]=u[a]:delete u[s];for(o=0;o<n;o++)u[o+c]=arguments[o+2];return u.length=l-r+n,i}});var Cs=fr("Array").splice,Ls=Array.prototype,Ps=function(t){var e=t.splice;return t===Ls||t instanceof Array&&e===Ls.splice?Cs:e},Ds=[].slice,Ms=/MSIE .\./.test(Br),Rs=function(t){return function(e,n){var r=arguments.length>2,i=r?Ds.call(arguments,2):void 0;return t(r?function(){("function"==typeof e?e:Function(e)).apply(this,i)}:e,n)}};V({global:!0,bind:!0,forced:Ms},{setTimeout:Rs(o.setTimeout),setInterval:Rs(o.setInterval)});var Is=I.setTimeout,js=function(t,e,n,r,i,o,a,s){for(var u,l=i,c=0,h=!!a&&z(a,s,3);c<r;){if(c in n){if(u=h?h(n[c],c,e):n[c],o>0&&Tt(u))l=js(t,e,u,Q(u.length),l,o-1)-1;else{if(l>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[l]=u}l++}c++}return l},zs=js;V({target:"Array",proto:!0},{flatMap:function(t){var e,n=Et(this),r=Q(n.length);return j(t),(e=xe(n,0)).length=zs(e,n,n,r,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var Ns=fr("Array").flatMap,Fs=Array.prototype,Bs=function(t){var e=t.flatMap;return t===Fs||t instanceof Array&&e===Fs.flatMap?Ns:e},Ws=function(t){return function(e,n,r,i){j(n);var o=Et(e),a=v(o),s=Q(o.length),u=t?s-1:0,l=t?-1:1;if(r<2)for(;;){if(u in a){i=a[u],u+=l;break}if(u+=l,t?u<0:s<=u)throw TypeError("Reduce of empty array with no initial value")}for(;t?u>=0:s>u;u+=l)u in a&&(i=n(i,a[u],u,o));return i}},Ys={left:Ws(!1),right:Ws(!0)},Gs="process"==d(o.process),Vs=Ys.left,Xs=yr("reduce"),Us=wr("reduce",{1:0});V({target:"Array",proto:!0,forced:!Xs||!Us||!Gs&&Vr>79&&Vr<83},{reduce:function(t){return Vs(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var Zs=fr("Array").reduce,Hs=Array.prototype,qs=function(t){var e=t.reduce;return t===Hs||t instanceof Array&&e===Hs.reduce?Zs:e};V({target:"Function",proto:!0},{bind:ca});var $s=fr("Function").bind,Qs=Function.prototype,Ks=function(t){var e=t.bind;return t===Qs||t instanceof Function&&e===Qs.bind?$s:e};var Js=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};function tu(t,e){for(var n=0;n<e.length;n++){var r=e[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),nr(t,r.key,r)}}var eu,nu=function(t,e,n){return e&&tu(t.prototype,e),n&&tu(t,n),t},ru=new Uint8Array(16);function iu(){if(!eu&&!(eu="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto)))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return eu(ru)}var ou=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;function au(t){return"string"==typeof t&&ou.test(t)}for(var su=[],uu=0;uu<256;++uu)su.push((uu+256).toString(16).substr(1));function lu(t,e,n){var r=(t=t||{}).random||(t.rng||iu)();if(r[6]=15&r[6]|64,r[8]=63&r[8]|128,e){n=n||0;for(var i=0;i<16;++i)e[n+i]=r[i];return e}return function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,n=(su[t[e+0]]+su[t[e+1]]+su[t[e+2]]+su[t[e+3]]+"-"+su[t[e+4]]+su[t[e+5]]+"-"+su[t[e+6]]+su[t[e+7]]+"-"+su[t[e+8]]+su[t[e+9]]+"-"+su[t[e+10]]+su[t[e+11]]+su[t[e+12]]+su[t[e+13]]+su[t[e+14]]+su[t[e+15]]).toLowerCase();if(!au(n))throw TypeError("Stringified UUID is invalid");return n}(r)}function cu(t,e){var n=Hi(t);if(an){var r=an(t);e&&(r=Kr(r).call(r,(function(e){return _t(t,e).enumerable}))),n.push.apply(n,r)}return n}function hu(t){for(var e=1;e<arguments.length;e++){var n,r=null!=arguments[e]?arguments[e]:{};if(e%2)kr(n=cu(Object(r),!0)).call(n,(function(e){ir(t,e,r[e])}));else if(gt)lt(t,gt(r));else{var i;kr(i=cu(Object(r))).call(i,(function(e){U(t,e,_t(r,e))}))}}return t}function fu(t){var e=function(){if("undefined"==typeof Reflect||!va)return!1;if(va.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(va(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var n,r=Za(t);if(e){var i=Za(this).constructor;n=va(r,arguments,i)}else n=r.apply(this,arguments);return Xa(this,n)}}function du(t,e){var n;if(void 0===vo||null==Bn(t)){if(eo(t)||(n=function(t,e){var n;if(!t)return;if("string"==typeof t)return pu(t,e);var r=ao(n=Object.prototype.toString.call(t)).call(n,8,-1);"Object"===r&&t.constructor&&(r=t.constructor.name);if("Map"===r||"Set"===r)return Kn(t);if("Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r))return pu(t,e)}(t))||e&&t&&"number"==typeof t.length){n&&(t=n);var r=0,i=function(){};return{s:i,n:function(){return r>=t.length?{done:!0}:{done:!1,value:t[r++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){n=Fn(t)},n:function(){var t=n.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==n.return||n.return()}finally{if(s)throw o}}}}function pu(t,e){(null==e||e>t.length)&&(e=t.length);for(var n=0,r=new Array(e);n<e;n++)r[n]=t[n];return r}var vu=function(){function t(e,n,r){var i,o,a;Js(this,t),this._source=e,this._transformers=n,this._target=r,this._listeners={add:Ks(i=this._add).call(i,this),remove:Ks(o=this._remove).call(o,this),update:Ks(a=this._update).call(a,this)}}return nu(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return qs(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),yu=function(){function t(e){Js(this,t),this._source=e,this._transformers=[]}return nu(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return Kr(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return to(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return Bs(e).call(e,t)})),this}},{key:"to",value:function(t){return new vu(this._source,this._transformers,t)}}]),t}();function gu(t){return"string"==typeof t||"number"==typeof t}var mu=function(){function t(e){Js(this,t),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(e)}return nu(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,n=0;n<e.length;n++){var r=e[n];r.original?t[r.name]=r.original:delete t[r.name]}this._extended=null}}},{key:"replace",value:function(t,e){var n=this,r=t[e];if(!r)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];n.queue({args:e,fn:r,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=Is((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;kr(t=Ps(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,n){var r=new t(n);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){r.flush()};var i=[{name:"flush",original:void 0}];if(n&&n.replace)for(var o=0;o<n.replace.length;o++){var a=n.replace[o];i.push({name:a,original:e[a]}),r.replace(e,a)}return r._extended={object:e,methods:i},r}}]),t}(),bu=function(){function t(){Js(this,t),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return nu(t,[{key:"_trigger",value:function(t,e,n){var r,i;if("*"===t)throw new Error("Cannot trigger event *");kr(r=po(i=[]).call(i,co(this._subscribers[t]),co(this._subscribers["*"]))).call(r,(function(r){r(t,e,null!=n?n:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var n;this._subscribers[t]=Kr(n=this._subscribers[t]).call(n,(function(t){return t!==e}))}}]),t}(),wu=function(){function t(e){Js(this,t),this._pairs=e}return nu(t,[{key:xs,value:_s.mark((function t(){var e,n,r,i,o;return _s.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=du(this._pairs),t.prev=1,e.s();case 3:if((n=e.n()).done){t.next=9;break}return r=Xi(n.value,2),i=r[0],o=r[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:_s.mark((function t(){var e,n,r,i,o;return _s.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=du(this._pairs),t.prev=1,e.s();case 3:if((n=e.n()).done){t.next=9;break}return r=Xi(n.value,2),i=r[0],o=r[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:_s.mark((function t(){var e,n,r,i;return _s.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=du(this._pairs),t.prev=1,e.s();case 3:if((n=e.n()).done){t.next=9;break}return r=Xi(n.value,1),i=r[0],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:_s.mark((function t(){var e,n,r,i;return _s.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=du(this._pairs),t.prev=1,e.s();case 3:if((n=e.n()).done){t.next=9;break}return r=Xi(n.value,2),i=r[1],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return to(t=co(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return to(t=co(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return co(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=er(null),n=du(this._pairs);try{for(n.s();!(t=n.n()).done;){var r=Xi(t.value,2),i=r[0],o=r[1];e[i]=o}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"toMap",value:function(){return new ws(this._pairs)}},{key:"toIdSet",value:function(){return new bs(this.toIdArray())}},{key:"toItemSet",value:function(){return new bs(this.toItemArray())}},{key:"cache",value:function(){return new t(co(this._pairs))}},{key:"distinct",value:function(t){var e,n=new bs,r=du(this._pairs);try{for(r.s();!(e=r.n()).done;){var i=Xi(e.value,2),o=i[0],a=i[1];n.add(t(a,o))}}catch(t){r.e(t)}finally{r.f()}return n}},{key:"filter",value:function(e){var n=this._pairs;return new t(ir({},xs,_s.mark((function t(){var r,i,o,a,s;return _s.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:r=du(n),t.prev=1,r.s();case 3:if((i=r.n()).done){t.next=10;break}if(o=Xi(i.value,2),a=o[0],s=o[1],!e(s,a)){t.next=8;break}return t.next=8,[a,s];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),r.e(t.t0);case 15:return t.prev=15,r.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,n=du(this._pairs);try{for(n.s();!(e=n.n()).done;){var r=Xi(e.value,2),i=r[0];t(r[1],i)}}catch(t){n.e(t)}finally{n.f()}}},{key:"map",value:function(e){var n=this._pairs;return new t(ir({},xs,_s.mark((function t(){var r,i,o,a,s;return _s.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:r=du(n),t.prev=1,r.s();case 3:if((i=r.n()).done){t.next=9;break}return o=Xi(i.value,2),a=o[0],s=o[1],t.next=7,[a,e(s,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),r.e(t.t0);case 14:return t.prev=14,r.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=Fn(this._pairs),n=e.next();if(n.done)return null;for(var r=n.value[1],i=t(n.value[1],n.value[0]);!(n=e.next()).done;){var o=Xi(n.value,2),a=o[0],s=o[1],u=t(s,a);u>i&&(i=u,r=s)}return r}},{key:"min",value:function(t){var e=Fn(this._pairs),n=e.next();if(n.done)return null;for(var r=n.value[1],i=t(n.value[1],n.value[0]);!(n=e.next()).done;){var o=Xi(n.value,2),a=o[0],s=o[1],u=t(s,a);u<i&&(i=u,r=s)}return r}},{key:"reduce",value:function(t,e){var n,r=du(this._pairs);try{for(r.s();!(n=r.n()).done;){var i=Xi(n.value,2),o=i[0];e=t(e,i[1],o)}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"sort",value:function(e){var n=this;return new t(ir({},xs,(function(){var t;return Fn(es(t=co(n._pairs)).call(t,(function(t,n){var r=Xi(t,2),i=r[0],o=r[1],a=Xi(n,2),s=a[0],u=a[1];return e(o,u,i,s)})))})))}}]),t}();var _u=function(t){Va(n,t);var e=fu(n);function n(t,r){var i;return Js(this,n),(i=e.call(this))._queue=null,t&&!eo(t)&&(r=t,t=[]),i._options=r||{},i._data=new ws,i.length=0,i._idProp=i._options.fieldId||"id",t&&t.length&&i.add(t),i.setOptions(r),i}return nu(n,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=mu.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===io(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var n,r=this,i=[];if(eo(t)){var o=to(t).call(t,(function(t){return t[r._idProp]}));if(Ba(o).call(o,(function(t){return r._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,s=t.length;a<s;a++)n=this._addItem(t[a]),i.push(n)}else{if(!t||"object"!==io(t))throw new Error("Unknown dataType");n=this._addItem(t),i.push(n)}return i.length&&this._trigger("add",{items:i},e),i}},{key:"update",value:function(t,e){var n=this,r=[],i=[],o=[],a=[],s=this._idProp,u=function(t){var e=t[s];if(null!=e&&n._data.has(e)){var u=t,l=di({},n._data.get(e)),c=n._updateItem(u);i.push(c),a.push(u),o.push(l)}else{var h=n._addItem(t);r.push(h)}};if(eo(t))for(var l=0,c=t.length;l<c;l++)t[l]&&"object"===io(t[l])?u(t[l]):console.warn("Ignoring input item, which is not an object at index "+l);else{if(!t||"object"!==io(t))throw new Error("Unknown dataType");u(t)}if(r.length&&this._trigger("add",{items:r},e),i.length){var h={items:i,oldData:o,data:a};this._trigger("update",h,e)}return po(r).call(r,i)}},{key:"updateOnly",value:function(t,e){var n,r=this;eo(t)||(t=[t]);var i=to(n=to(t).call(t,(function(t){var e=r._data.get(t[r._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(n,(function(t){var e=t.oldData,n=t.update,i=e[r._idProp],o=_o(e,n);return r._data.set(i,o),{id:i,oldData:e,updatedData:o}}));if(i.length){var o={items:to(i).call(i,(function(t){return t.id})),oldData:to(i).call(i,(function(t){return t.oldData})),data:to(i).call(i,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var n=void 0,r=void 0,i=void 0;gu(t)?(n=t,i=e):eo(t)?(r=t,i=e):i=t;var o,a=i&&"Object"===i.returnType?"Object":"Array",s=i&&Kr(i),u=[],l=void 0,c=void 0,h=void 0;if(null!=n)(l=this._data.get(n))&&s&&!s(l)&&(l=void 0);else if(null!=r)for(var f=0,d=r.length;f<d;f++)null==(l=this._data.get(r[f]))||s&&!s(l)||u.push(l);else for(var p,v=0,y=(c=co(Ra(p=this._data).call(p))).length;v<y;v++)h=c[v],null==(l=this._data.get(h))||s&&!s(l)||u.push(l);if(i&&i.order&&null==n&&this._sort(u,i.order),i&&i.fields){var g=i.fields;if(null!=n&&null!=l)l=this._filterFields(l,g);else for(var m=0,b=u.length;m<b;m++)u[m]=this._filterFields(u[m],g)}if("Object"==a){for(var w={},_=0,x=u.length;_<x;_++){var S=u[_];w[S[this._idProp]]=S}return w}return null!=n?null!==(o=l)&&void 0!==o?o:null:u}},{key:"getIds",value:function(t){var e=this._data,n=t&&Kr(t),r=t&&t.order,i=co(Ra(e).call(e)),o=[];if(n)if(r){for(var a=[],s=0,u=i.length;s<u;s++){var l=i[s],c=this._data.get(l);null!=c&&n(c)&&a.push(c)}this._sort(a,r);for(var h=0,f=a.length;h<f;h++)o.push(a[h][this._idProp])}else for(var d=0,p=i.length;d<p;d++){var v=i[d],y=this._data.get(v);null!=y&&n(y)&&o.push(y[this._idProp])}else if(r){for(var g=[],m=0,b=i.length;m<b;m++){var w=i[m];g.push(e.get(w))}this._sort(g,r);for(var _=0,x=g.length;_<x;_++)o.push(g[_][this._idProp])}else for(var S=0,T=i.length;S<T;S++){var E=i[S],A=e.get(E);null!=A&&o.push(A[this._idProp])}return o}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var n=e&&Kr(e),r=this._data,i=co(Ra(r).call(r));if(e&&e.order)for(var o=this.get(e),a=0,s=o.length;a<s;a++){var u=o[a];t(u,u[this._idProp])}else for(var l=0,c=i.length;l<c;l++){var h=i[l],f=this._data.get(h);null==f||n&&!n(f)||t(f,h)}}},{key:"map",value:function(t,e){for(var n=e&&Kr(e),r=[],i=this._data,o=co(Ra(i).call(i)),a=0,s=o.length;a<s;a++){var u=o[a],l=this._data.get(u);null==l||n&&!n(l)||r.push(t(l,u))}return e&&e.order&&this._sort(r,e.order),r}},{key:"_filterFields",value:function(t,e){var n;return t?qs(n=eo(e)?e:Hi(e)).call(n,(function(e,n){return e[n]=t[n],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var n=e;es(t).call(t,(function(t,e){var r=t[n],i=e[n];return r>i?1:r<i?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");es(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var n=[],r=[],i=eo(t)?t:[t],o=0,a=i.length;o<a;o++){var s=this._remove(i[o]);if(s){var u=s[this._idProp];null!=u&&(n.push(u),r.push(s))}}return n.length&&this._trigger("remove",{items:n,oldData:r},e),n}},{key:"_remove",value:function(t){var e;if(gu(t)?e=t:t&&"object"===io(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var n=this._data.get(e)||null;return this._data.delete(e),--this.length,n}return null}},{key:"clear",value:function(t){for(var e,n=co(Ra(e=this._data).call(e)),r=[],i=0,o=n.length;i<o;i++)r.push(this._data.get(n[i]));return this._data.clear(),this.length=0,this._trigger("remove",{items:n,oldData:r},t),n}},{key:"max",value:function(t){var e,n,r=null,i=null,o=du(La(e=this._data).call(e));try{for(o.s();!(n=o.n()).done;){var a=n.value,s=a[t];"number"==typeof s&&(null==i||s>i)&&(r=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return r||null}},{key:"min",value:function(t){var e,n,r=null,i=null,o=du(La(e=this._data).call(e));try{for(o.s();!(n=o.n()).done;){var a=n.value,s=a[t];"number"==typeof s&&(null==i||s<i)&&(r=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return r||null}},{key:"distinct",value:function(t){for(var e=this._data,n=co(Ra(e).call(e)),r=[],i=0,o=0,a=n.length;o<a;o++){for(var s=n[o],u=e.get(s)[t],l=!1,c=0;c<i;c++)if(r[c]==u){l=!0;break}l||void 0===u||(r[i]=u,i++)}return r}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=lu()),t}(t,this._idProp),n=e[this._idProp];if(this._data.has(n))throw new Error("Cannot add item: item with id "+n+" already exists");return this._data.set(n,e),++this.length,n}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Aa(t)+")");var n=this._data.get(e);if(!n)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,hu(hu({},n),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new wu(ir({},xs,_s.mark((function n(){var r,i,o,a;return _s.wrap((function(n){for(;;)switch(n.prev=n.next){case 0:r=du(t),n.prev=1,r.s();case 3:if((i=r.n()).done){n.next=11;break}if(o=i.value,null==(a=e.get(o))){n.next=9;break}return n.next=9,[o,a];case 9:n.next=3;break;case 11:n.next=16;break;case 13:n.prev=13,n.t0=n.catch(1),r.e(n.t0);case 16:return n.prev=16,r.f(),n.finish(16);case 19:case"end":return n.stop()}}),n,null,[[1,13,16,19]])}))))}var n;return new wu(ir({},xs,Ks(n=ba(this._data)).call(n,this._data)))}},{key:"idProp",get:function(){return this._idProp}}]),n}(bu),xu=function(t){Va(n,t);var e=fu(n);function n(t,r){var i,o;return Js(this,n),(o=e.call(this)).length=0,o._ids=new bs,o._options=r||{},o._listener=Ks(i=o._onEvent).call(i,aa(o)),o.setData(t),o}return nu(n,[{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:Kr(this._options)}),n=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:n})}if(null!=t){this._data=t;for(var r=this._data.getIds({filter:Kr(this._options)}),i=0,o=r.length;i<o;i++){var a=r[i];this._ids.add(a)}this.length=r.length,this._trigger("add",{items:r})}else this._data=new _u;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:Kr(this._options)}),e=co(this._ids),n={},r=[],i=[],o=[],a=0,s=t.length;a<s;a++){var u=t[a];n[u]=!0,this._ids.has(u)||(r.push(u),this._ids.add(u))}for(var l=0,c=e.length;l<c;l++){var h=e[l],f=this._data.get(h);null==f?console.error("If you see this, report it please."):n[h]||(i.push(h),o.push(f),this._ids.delete(h))}this.length+=r.length-i.length,r.length&&this._trigger("add",{items:r}),i.length&&this._trigger("remove",{items:i,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var n,r=null;gu(t)||eo(t)?(r=t,n=e):n=t;var i=di({},this._options,n),o=Kr(this._options),a=n&&Kr(n);return o&&a&&(i.filter=function(t){return o(t)&&a(t)}),null==r?this._data.get(i):this._data.get(r,i)}},{key:"getIds",value:function(t){if(this._data.length){var e,n=Kr(this._options),r=null!=t?Kr(t):null;return e=r?n?function(t){return n(t)&&r(t)}:r:n,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var n,r,i=Kr(this._options),o=e&&Kr(e);r=o?i?function(t){return i(t)&&o(t)}:o:i,kr(n=this._data).call(n,t,{filter:r,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var n,r,i=Kr(this._options),o=e&&Kr(e);return r=o?i?function(t){return i(t)&&o(t)}:o:i,to(n=this._data).call(n,t,{filter:r,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||ir({},xs,Ks(e=Ra(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,r="This data view has already been disposed of.",i={get:function(){throw new Error(r)},set:function(){throw new Error(r)},configurable:!1},o=du(oo(n.prototype));try{for(o.s();!(e=o.n()).done;){var a=e.value;U(this,a,i)}}catch(t){o.e(t)}finally{o.f()}}},{key:"_onEvent",value:function(t,e,n){if(e&&e.items&&this._data){var r=e.items,i=[],o=[],a=[],s=[],u=[],l=[];switch(t){case"add":for(var c=0,h=r.length;c<h;c++){var f=r[c];this.get(f)&&(this._ids.add(f),i.push(f))}break;case"update":for(var d=0,p=r.length;d<p;d++){var v=r[d];this.get(v)?this._ids.has(v)?(o.push(v),u.push(e.data[d]),s.push(e.oldData[d])):(this._ids.add(v),i.push(v)):this._ids.has(v)&&(this._ids.delete(v),a.push(v),l.push(e.oldData[d]))}break;case"remove":for(var y=0,g=r.length;y<g;y++){var m=r[y];this._ids.has(m)&&(this._ids.delete(m),a.push(m),l.push(e.oldData[y]))}}this.length+=i.length-a.length,i.length&&this._trigger("add",{items:i},n),o.length&&this._trigger("update",{items:o,oldData:s,data:u},n),a.length&&this._trigger("remove",{items:a,oldData:l},n)}}},{key:"idProp",get:function(){return this.getDataSet().idProp}}]),n}(bu);function Su(t,e){return"object"===io(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof kr(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof to(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}var Tu=Object.freeze({__proto__:null,DELETE:wo,DataSet:_u,DataStream:wu,DataView:xu,Queue:mu,createNewDataPipeFrom:function(t){return new yu(t)},isDataSetLike:Su,isDataViewLike:function(t,e){return"object"===io(e)&&null!==e&&t===e.idProp&&"function"==typeof kr(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof to(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&Su(t,e.getDataSet())}});V({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var Eu=I.Number.isNaN;V({target:"Array",proto:!0},{fill:function(t){for(var e=Et(this),n=Q(e.length),r=arguments.length,i=tt(r>1?arguments[1]:void 0,n),o=r>2?arguments[2]:void 0,a=void 0===o?n:tt(o,n);a>i;)e[i++]=t;return e}});var Au=fr("Array").fill,Ou=Array.prototype,ku=function(t){var e=t.fill;return t===Ou||t instanceof Array&&e===Ou.fill?Au:e},Cu=cr.trim,Lu=o.parseFloat,Pu=1/Lu(or+"-0")!=-1/0?function(t){var e=Cu(String(t)),n=Lu(e);return 0===n&&"-"==e.charAt(0)?-0:n}:Lu;V({global:!0,forced:parseFloat!=Pu},{parseFloat:Pu});var Du=I.parseFloat,Mu=n((function(t){function e(t){if(t)return function(t){for(var n in e.prototype)t[n]=e.prototype[n];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function n(){this.off(t,n),e.apply(this,arguments)}return n.fn=e,this.on(t,n),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var n,r=this._callbacks["$"+t];if(!r)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i=0;i<r.length;i++)if((n=r[i])===e||n.fn===e){r.splice(i,1);break}return 0===r.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),n=this._callbacks["$"+t],r=1;r<arguments.length;r++)e[r-1]=arguments[r];if(n){r=0;for(var i=(n=n.slice(0)).length;r<i;++r)n[r].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}));function Ru(t,e,n){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0,this.z=void 0!==n?n:0}Ru.subtract=function(t,e){var n=new Ru;return n.x=t.x-e.x,n.y=t.y-e.y,n.z=t.z-e.z,n},Ru.add=function(t,e){var n=new Ru;return n.x=t.x+e.x,n.y=t.y+e.y,n.z=t.z+e.z,n},Ru.avg=function(t,e){return new Ru((t.x+e.x)/2,(t.y+e.y)/2,(t.z+e.z)/2)},Ru.scalarProduct=function(t,e){return new Ru(t.x*e,t.y*e,t.z*e)},Ru.dotProduct=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},Ru.crossProduct=function(t,e){var n=new Ru;return n.x=t.y*e.z-t.z*e.y,n.y=t.z*e.x-t.x*e.z,n.z=t.x*e.y-t.y*e.x,n},Ru.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},Ru.prototype.normalize=function(){return Ru.scalarProduct(this,1/this.length())};var Iu=Ru;var ju=function(t,e){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0};function zu(t,e){if(void 0===t)throw new Error("No container element defined");if(this.container=t,this.visible=!e||null==e.visible||e.visible,this.visible){this.frame=document.createElement("DIV"),this.frame.style.width="100%",this.frame.style.position="relative",this.container.appendChild(this.frame),this.frame.prev=document.createElement("INPUT"),this.frame.prev.type="BUTTON",this.frame.prev.value="Prev",this.frame.appendChild(this.frame.prev),this.frame.play=document.createElement("INPUT"),this.frame.play.type="BUTTON",this.frame.play.value="Play",this.frame.appendChild(this.frame.play),this.frame.next=document.createElement("INPUT"),this.frame.next.type="BUTTON",this.frame.next.value="Next",this.frame.appendChild(this.frame.next),this.frame.bar=document.createElement("INPUT"),this.frame.bar.type="BUTTON",this.frame.bar.style.position="absolute",this.frame.bar.style.border="1px solid red",this.frame.bar.style.width="100px",this.frame.bar.style.height="6px",this.frame.bar.style.borderRadius="2px",this.frame.bar.style.MozBorderRadius="2px",this.frame.bar.style.border="1px solid #7F7F7F",this.frame.bar.style.backgroundColor="#E5E5E5",this.frame.appendChild(this.frame.bar),this.frame.slide=document.createElement("INPUT"),this.frame.slide.type="BUTTON",this.frame.slide.style.margin="0px",this.frame.slide.value=" ",this.frame.slide.style.position="relative",this.frame.slide.style.left="-100px",this.frame.appendChild(this.frame.slide);var n=this;this.frame.slide.onmousedown=function(t){n._onMouseDown(t)},this.frame.prev.onclick=function(t){n.prev(t)},this.frame.play.onclick=function(t){n.togglePlay(t)},this.frame.next.onclick=function(t){n.next(t)}}this.onChangeCallback=void 0,this.values=[],this.index=void 0,this.playTimeout=void 0,this.playInterval=1e3,this.playLoop=!0}zu.prototype.prev=function(){var t=this.getIndex();t>0&&(t--,this.setIndex(t))},zu.prototype.next=function(){var t=this.getIndex();t<La(this).length-1&&(t++,this.setIndex(t))},zu.prototype.playNext=function(){var t=new Date,e=this.getIndex();e<La(this).length-1?(e++,this.setIndex(e)):this.playLoop&&(e=0,this.setIndex(e));var n=new Date-t,r=Math.max(this.playInterval-n,0),i=this;this.playTimeout=Is((function(){i.playNext()}),r)},zu.prototype.togglePlay=function(){void 0===this.playTimeout?this.play():this.stop()},zu.prototype.play=function(){this.playTimeout||(this.playNext(),this.frame&&(this.frame.play.value="Stop"))},zu.prototype.stop=function(){clearInterval(this.playTimeout),this.playTimeout=void 0,this.frame&&(this.frame.play.value="Play")},zu.prototype.setOnChangeCallback=function(t){this.onChangeCallback=t},zu.prototype.setPlayInterval=function(t){this.playInterval=t},zu.prototype.getPlayInterval=function(){return this.playInterval},zu.prototype.setPlayLoop=function(t){this.playLoop=t},zu.prototype.onChange=function(){void 0!==this.onChangeCallback&&this.onChangeCallback()},zu.prototype.redraw=function(){if(this.frame){this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px",this.frame.bar.style.width=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30+"px";var t=this.indexToLeft(this.index);this.frame.slide.style.left=t+"px"}},zu.prototype.setValues=function(t){this.values=t,La(this).length>0?this.setIndex(0):this.index=void 0},zu.prototype.setIndex=function(t){if(!(t<La(this).length))throw new Error("Index out of range");this.index=t,this.redraw(),this.onChange()},zu.prototype.getIndex=function(){return this.index},zu.prototype.get=function(){return La(this)[this.index]},zu.prototype._onMouseDown=function(t){if(t.which?1===t.which:1===t.button){this.startClientX=t.clientX,this.startSlideX=Du(this.frame.slide.style.left),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},Go(document,"mousemove",this.onmousemove),Go(document,"mouseup",this.onmouseup),Xo(t)}},zu.prototype.leftToIndex=function(t){var e=Du(this.frame.bar.style.width)-this.frame.slide.clientWidth-10,n=t-3,r=Math.round(n/e*(La(this).length-1));return r<0&&(r=0),r>La(this).length-1&&(r=La(this).length-1),r},zu.prototype.indexToLeft=function(t){var e=Du(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return t/(La(this).length-1)*e+3},zu.prototype._onMouseMove=function(t){var e=t.clientX-this.startClientX,n=this.startSlideX+e,r=this.leftToIndex(n);this.setIndex(r),Xo()},zu.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",Vo(document,"mousemove",this.onmousemove),Vo(document,"mouseup",this.onmouseup),Xo()};var Nu=Object.freeze({__proto__:null,default:zu});function Fu(t,e,n,r){this._start=0,this._end=0,this._step=1,this.prettyStep=!0,this.precision=5,this._current=0,this.setRange(t,e,n,r)}Fu.prototype.isNumeric=function(t){return!isNaN(Du(t))&&isFinite(t)},Fu.prototype.setRange=function(t,e,n,r){if(!this.isNumeric(t))throw new Error("Parameter 'start' is not numeric; value: "+t);if(!this.isNumeric(e))throw new Error("Parameter 'end' is not numeric; value: "+t);if(!this.isNumeric(n))throw new Error("Parameter 'step' is not numeric; value: "+t);this._start=t||0,this._end=e||0,this.setStep(n,r)},Fu.prototype.setStep=function(t,e){void 0===t||t<=0||(void 0!==e&&(this.prettyStep=e),!0===this.prettyStep?this._step=Fu.calculatePrettyStep(t):this._step=t)},Fu.calculatePrettyStep=function(t){var e=function(t){return Math.log(t)/Math.LN10},n=Math.pow(10,Math.round(e(t))),r=2*Math.pow(10,Math.round(e(t/2))),i=5*Math.pow(10,Math.round(e(t/5))),o=n;return Math.abs(r-t)<=Math.abs(o-t)&&(o=r),Math.abs(i-t)<=Math.abs(o-t)&&(o=i),o<=0&&(o=1),o},Fu.prototype.getCurrent=function(){return Du(this._current.toPrecision(this.precision))},Fu.prototype.getStep=function(){return this._step},Fu.prototype.start=function(t){void 0===t&&(t=!1),this._current=this._start-this._start%this._step,t&&this.getCurrent()<this._start&&this.next()},Fu.prototype.next=function(){this._current+=this._step},Fu.prototype.end=function(){return this._current>this._end};var Bu=Fu,Wu=[].reverse,Yu=[1,2];V({target:"Array",proto:!0,forced:String(Yu)===String(Yu.reverse())},{reverse:function(){return Tt(this)&&(this.length=this.length),Wu.call(this)}});var Gu=fr("Array").reverse,Vu=Array.prototype,Xu=function(t){var e=t.reverse;return t===Vu||t instanceof Array&&e===Vu.reverse?Gu:e},Uu=Math.sign||function(t){return 0==(t=+t)||t!=t?t:t<0?-1:1};V({target:"Math",stat:!0},{sign:Uu});var Zu=I.Math.sign;function Hu(){this.armLocation=new Iu,this.armRotation={},this.armRotation.horizontal=0,this.armRotation.vertical=0,this.armLength=1.7,this.cameraOffset=new Iu,this.offsetMultiplier=.6,this.cameraLocation=new Iu,this.cameraRotation=new Iu(.5*Math.PI,0,0),this.calculateCameraOrientation()}Hu.prototype.setOffset=function(t,e){var n=Math.abs,r=Zu,i=this.offsetMultiplier,o=this.armLength*i;n(t)>o&&(t=r(t)*o),n(e)>o&&(e=r(e)*o),this.cameraOffset.x=t,this.cameraOffset.y=e,this.calculateCameraOrientation()},Hu.prototype.getOffset=function(){return this.cameraOffset},Hu.prototype.setArmLocation=function(t,e,n){this.armLocation.x=t,this.armLocation.y=e,this.armLocation.z=n,this.calculateCameraOrientation()},Hu.prototype.setArmRotation=function(t,e){void 0!==t&&(this.armRotation.horizontal=t),void 0!==e&&(this.armRotation.vertical=e,this.armRotation.vertical<0&&(this.armRotation.vertical=0),this.armRotation.vertical>.5*Math.PI&&(this.armRotation.vertical=.5*Math.PI)),void 0===t&&void 0===e||this.calculateCameraOrientation()},Hu.prototype.getArmRotation=function(){var t={};return t.horizontal=this.armRotation.horizontal,t.vertical=this.armRotation.vertical,t},Hu.prototype.setArmLength=function(t){void 0!==t&&(this.armLength=t,this.armLength<.71&&(this.armLength=.71),this.armLength>5&&(this.armLength=5),this.setOffset(this.cameraOffset.x,this.cameraOffset.y),this.calculateCameraOrientation())},Hu.prototype.getArmLength=function(){return this.armLength},Hu.prototype.getCameraLocation=function(){return this.cameraLocation},Hu.prototype.getCameraRotation=function(){return this.cameraRotation},Hu.prototype.calculateCameraOrientation=function(){this.cameraLocation.x=this.armLocation.x-this.armLength*Math.sin(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.y=this.armLocation.y-this.armLength*Math.cos(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.z=this.armLocation.z+this.armLength*Math.sin(this.armRotation.vertical),this.cameraRotation.x=Math.PI/2-this.armRotation.vertical,this.cameraRotation.y=0,this.cameraRotation.z=-this.armRotation.horizontal;var t=this.cameraRotation.x,e=this.cameraRotation.z,n=this.cameraOffset.x,r=this.cameraOffset.y,i=Math.sin,o=Math.cos;this.cameraLocation.x=this.cameraLocation.x+n*o(e)+r*-i(e)*o(t),this.cameraLocation.y=this.cameraLocation.y+n*i(e)+r*o(e)*o(t),this.cameraLocation.z=this.cameraLocation.z+r*i(t)};var qu=Object.freeze({__proto__:null,default:Hu}),$u={BAR:0,BARCOLOR:1,BARSIZE:2,DOT:3,DOTLINE:4,DOTCOLOR:5,DOTSIZE:6,GRID:7,LINE:8,SURFACE:9},Qu={dot:$u.DOT,"dot-line":$u.DOTLINE,"dot-color":$u.DOTCOLOR,"dot-size":$u.DOTSIZE,line:$u.LINE,grid:$u.GRID,surface:$u.SURFACE,bar:$u.BAR,"bar-color":$u.BARCOLOR,"bar-size":$u.BARSIZE},Ku=["width","height","filterLabel","legendLabel","xLabel","yLabel","zLabel","xValueLabel","yValueLabel","zValueLabel","showXAxis","showYAxis","showZAxis","showGrayBottom","showGrid","showPerspective","showShadow","showSurfaceGrid","keepAspectRatio","rotateAxisLabels","verticalRatio","dotSizeRatio","dotSizeMinFraction","dotSizeMaxFraction","showAnimationControls","animationInterval","animationPreload","animationAutoStart","axisColor","axisFontSize","axisFontType","gridColor","xCenter","yCenter","zoomable","tooltipDelay","ctrlToZoom"],Ju=["xBarWidth","yBarWidth","valueMin","valueMax","xMin","xMax","xStep","yMin","yMax","yStep","zMin","zMax","zStep"],tl=void 0;function el(t){for(var e in t)if(t.hasOwnProperty(e))return!1;return!0}function nl(t,e){return void 0===t||""===t?e:t+(void 0===(n=e)||""===n||"string"!=typeof n?n:n.charAt(0).toUpperCase()+ao(n).call(n,1));var n}function rl(t,e,n,r){for(var i,o=0;o<n.length;++o)e[nl(r,i=n[o])]=t[i]}function il(t,e,n,r){for(var i,o=0;o<n.length;++o)void 0!==t[i=n[o]]&&(e[nl(r,i)]=t[i])}function ol(t,e){if(void 0!==t.backgroundColor&&function(t,e){var n="white",r="gray",i=1;if("string"==typeof t)n=t,r="none",i=0;else{if("object"!==io(t))throw new Error("Unsupported type of backgroundColor");void 0!==ku(t)&&(n=ku(t)),void 0!==t.stroke&&(r=t.stroke),void 0!==t.strokeWidth&&(i=t.strokeWidth)}e.frame.style.backgroundColor=n,e.frame.style.borderColor=r,e.frame.style.borderWidth=i+"px",e.frame.style.borderStyle="solid"}(t.backgroundColor,e),function(t,e){if(void 0===t)return;void 0===e.dataColor&&(e.dataColor={});"string"==typeof t?(e.dataColor.fill=t,e.dataColor.stroke=t):(ku(t)&&(e.dataColor.fill=ku(t)),t.stroke&&(e.dataColor.stroke=t.stroke),void 0!==t.strokeWidth&&(e.dataColor.strokeWidth=t.strokeWidth))}(t.dataColor,e),function(t,e){if(void 0===t)return;var n;if("string"==typeof t){if(-1===(n=function(t){var e=Qu[t];if(void 0===e)return-1;return e}(t)))throw new Error("Style '"+t+"' is invalid")}else{if(!function(t){var e=!1;for(var n in $u)if($u[n]===t){e=!0;break}return e}(t))throw new Error("Style '"+t+"' is invalid");n=t}e.style=n}(t.style,e),void 0!==t.surfaceColors){if(console.warn("`options.surfaceColors` is deprecated and may be removed in a future version. Please use `options.colormap` instead. Note that the `colormap` option uses the inverse array ordering (running from vMin to vMax)."),void 0!==t.colormap)throw new Error("The `colormap` and `surfaceColors` options are mutually exclusive.");"surface"!==e.style?console.warn("Ignoring `surfaceColors` in graph style `"+e.style+"` for backward compatibility (only effective in `surface` plots)."):function(t,e){if(void 0===t||!0===t)return;if(!1===t)return void(e.surfaceColors=void 0);void 0===e.surfaceColors&&(e.surfaceColors={});var n;if(eo(t))n=al(t);else{if("object"!==io(t))throw new Error("Unsupported type of surfaceColors");n=sl(t.hue)}Xu(n).call(n),e.colormap=n}(t.surfaceColors,e)}else!function(t,e){if(void 0===t)return;var n;if(eo(t))n=al(t);else if("object"===io(t))n=sl(t.hue);else{if("function"!=typeof t)throw new Error("Unsupported type of colormap");n=t}e.colormap=n}(t.colormap,e);!function(t,e){if(void 0===t){if(void 0===tl.showLegend){var n=e.style===$u.DOTCOLOR||e.style===$u.DOTSIZE;e.showLegend=n}}else e.showLegend=t}(t.showLegend,e),ul(t.cameraPosition,e),void 0!==t.tooltip&&(e.showTooltip=t.tooltip),null!=t.onclick&&(e.onclick_callback=t.onclick,console.warn("`options.onclick` is deprecated and may be removed in a future version. Please use `Graph3d.on('click', handler)` instead.")),void 0!==t.tooltipStyle&&No(["tooltipStyle"],e,t)}function al(t){if(t.length<2)throw new Error("Colormap array length must be 2 or above.");return to(t).call(t,(function(t){if(!ea(t))throw new Error("Invalid hex color code supplied to colormap.");return Zo(t)}))}function sl(t){if(void 0===t)throw new Error("Unsupported type of colormap");if(!(t.saturation>=0&&t.saturation<=100))throw new Error("Saturation is out of bounds. Expected range is 0-100.");if(!(t.brightness>=0&&t.brightness<=100))throw new Error("Brightness is out of bounds. Expected range is 0-100.");if(!(t.colorStops>=2))throw new Error("colorStops is out of bounds. Expected 2 or above.");for(var e=(t.end-t.start)/(t.colorStops-1),n=[],r=0;r<t.colorStops;++r){var i=(t.start+e*r)%360/360;n.push(Ko(i<0?i+1:i,t.saturation/100,t.brightness/100))}return n}function ul(t,e){var n=t;void 0!==n&&(void 0===e.camera&&(e.camera=new Hu),e.camera.setArmRotation(n.horizontal,n.vertical),e.camera.setArmLength(n.distance))}var ll,cl=!1,hl="background: #FFeeee; color: #dd0000",fl=function(){function t(){Js(this,t)}return nu(t,null,[{key:"validate",value:function(e,n,r){cl=!1,ll=n;var i=n;return void 0!==r&&(i=n[r]),t.parse(e,i,[]),cl}},{key:"parse",value:function(e,n,r){for(var i in e)e.hasOwnProperty(i)&&t.check(i,e,n,r)}},{key:"check",value:function(e,n,r,i){if(void 0!==r[e]||void 0!==r.__any__){var o=e,a=!0;void 0===r[e]&&void 0!==r.__any__&&(o="__any__",a="object"===t.getType(n[e]));var s=r[o];a&&void 0!==s.__type__&&(s=s.__type__),t.checkFields(e,n,r,o,s,i)}else t.getSuggestion(e,r,i)}},{key:"checkFields",value:function(e,n,r,i,o,a){var s=function(n){console.log("%c"+n+t.printLocation(a,e),hl)},u=t.getType(n[e]),l=o[u];void 0!==l?"array"===t.getType(l)&&-1===li(l).call(l,n[e])?(s('Invalid option detected in "'+e+'". Allowed values are:'+t.print(l)+' not "'+n[e]+'". '),cl=!0):"object"===u&&"__any__"!==i&&(a=Bo(a,e),t.parse(n[e],r[i],a)):void 0===o.any&&(s('Invalid type received for "'+e+'". Expected: '+t.print(Hi(o))+". Received ["+u+'] "'+n[e]+'"'),cl=!0)}},{key:"getType",value:function(t){var e=io(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":eo(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,n,r){var i,o=t.findInOptions(e,n,r,!1),a=t.findInOptions(e,ll,[],!0);i=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':a.distance<=4&&o.distance>a.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(a.path,a.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(Hi(n))+t.printLocation(r,e),console.log('%cUnknown option detected: "'+e+'"'+i,hl),cl=!0}},{key:"findInOptions",value:function(e,n,r){var i=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,a="",s=[],u=e.toLowerCase(),l=void 0;for(var c in n){var h=void 0;if(void 0!==n[c].__type__&&!0===i){var f=t.findInOptions(e,n[c],Bo(r,c));o>f.distance&&(a=f.closestMatch,s=f.path,o=f.distance,l=f.indexMatch)}else{var d;-1!==li(d=c.toLowerCase()).call(d,u)&&(l=c),o>(h=t.levenshteinDistance(e,c))&&(a=c,s=Wo(r),o=h)}}return{closestMatch:a,path:s,distance:o,indexMatch:l}}},{key:"printLocation",value:function(t,e){for(var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",r="\n\n"+n+"options = {\n",i=0;i<t.length;i++){for(var o=0;o<i+1;o++)r+="  ";r+=t[i]+": {\n"}for(var a=0;a<t.length+1;a++)r+="  ";r+=e+"\n";for(var s=0;s<t.length+1;s++){for(var u=0;u<t.length-s;u++)r+="  ";r+="}\n"}return r+"\n\n"}},{key:"print",value:function(t){return Aa(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var n,r,i=[];for(n=0;n<=e.length;n++)i[n]=[n];for(r=0;r<=t.length;r++)i[0][r]=r;for(n=1;n<=e.length;n++)for(r=1;r<=t.length;r++)e.charAt(n-1)==t.charAt(r-1)?i[n][r]=i[n-1][r-1]:i[n][r]=Math.min(i[n-1][r-1]+1,Math.min(i[n][r-1]+1,i[n-1][r]+1));return i[e.length][t.length]}}]),t}(),dl="string",pl="boolean",vl="number",yl="object",gl="array",ml={fill:{string:dl},stroke:{string:dl},strokeWidth:{number:vl},__type__:{string:dl,object:yl,undefined:"undefined"}},bl={animationAutoStart:{boolean:pl,undefined:"undefined"},animationInterval:{number:vl},animationPreload:{boolean:pl},axisColor:{string:dl},axisFontSize:{number:vl},axisFontType:{string:dl},backgroundColor:ml,xBarWidth:{number:vl,undefined:"undefined"},yBarWidth:{number:vl,undefined:"undefined"},cameraPosition:{distance:{number:vl},horizontal:{number:vl},vertical:{number:vl},__type__:{object:yl}},zoomable:{boolean:pl},ctrlToZoom:{boolean:pl},xCenter:{string:dl},yCenter:{string:dl},colormap:{hue:{start:{number:vl},end:{number:vl},saturation:{number:vl},brightness:{number:vl},colorStops:{number:vl},__type__:{object:yl}},__type__:{array:gl,object:yl,function:"function",undefined:"undefined"}},dataColor:ml,dotSizeMinFraction:{number:vl},dotSizeMaxFraction:{number:vl},dotSizeRatio:{number:vl},filterLabel:{string:dl},gridColor:{string:dl},onclick:{function:"function"},keepAspectRatio:{boolean:pl},xLabel:{string:dl},yLabel:{string:dl},zLabel:{string:dl},legendLabel:{string:dl},xMin:{number:vl,undefined:"undefined"},yMin:{number:vl,undefined:"undefined"},zMin:{number:vl,undefined:"undefined"},xMax:{number:vl,undefined:"undefined"},yMax:{number:vl,undefined:"undefined"},zMax:{number:vl,undefined:"undefined"},showAnimationControls:{boolean:pl,undefined:"undefined"},showGrayBottom:{boolean:pl},showGrid:{boolean:pl},showLegend:{boolean:pl,undefined:"undefined"},showPerspective:{boolean:pl},showShadow:{boolean:pl},showSurfaceGrid:{boolean:pl},showXAxis:{boolean:pl},showYAxis:{boolean:pl},showZAxis:{boolean:pl},rotateAxisLabels:{boolean:pl},surfaceColors:{hue:{start:{number:vl},end:{number:vl},saturation:{number:vl},brightness:{number:vl},colorStops:{number:vl},__type__:{object:yl}},__type__:{boolean:pl,array:gl,object:yl,undefined:"undefined"}},xStep:{number:vl,undefined:"undefined"},yStep:{number:vl,undefined:"undefined"},zStep:{number:vl,undefined:"undefined"},style:{number:vl,string:["bar","bar-color","bar-size","dot","dot-line","dot-color","dot-size","line","grid","surface"]},tooltip:{boolean:pl,function:"function"},tooltipDelay:{number:vl},tooltipStyle:{content:{color:{string:dl},background:{string:dl},border:{string:dl},borderRadius:{string:dl},boxShadow:{string:dl},padding:{string:dl},__type__:{object:yl}},line:{borderLeft:{string:dl},height:{string:dl},width:{string:dl},pointerEvents:{string:dl},__type__:{object:yl}},dot:{border:{string:dl},borderRadius:{string:dl},height:{string:dl},width:{string:dl},pointerEvents:{string:dl},__type__:{object:yl}},__type__:{object:yl}},xValueLabel:{function:"function"},yValueLabel:{function:"function"},zValueLabel:{function:"function"},valueMax:{number:vl,undefined:"undefined"},valueMin:{number:vl,undefined:"undefined"},verticalRatio:{number:vl},height:{string:dl},width:{string:dl},__type__:{object:yl}};function wl(){this.min=void 0,this.max=void 0}wl.prototype.adjust=function(t){void 0!==t&&((void 0===this.min||this.min>t)&&(this.min=t),(void 0===this.max||this.max<t)&&(this.max=t))},wl.prototype.combine=function(t){this.add(t.min),this.add(t.max)},wl.prototype.expand=function(t){if(void 0!==t){var e=this.min-t,n=this.max+t;if(e>n)throw new Error("Passed expansion value makes range invalid");this.min=e,this.max=n}},wl.prototype.range=function(){return this.max-this.min},wl.prototype.center=function(){return(this.min+this.max)/2};var _l=wl;function xl(t,e,n){this.dataGroup=t,this.column=e,this.graph=n,this.index=void 0,this.value=void 0,this.values=t.getDistinctValues(this.column),La(this).length>0&&this.selectValue(0),this.dataPoints=[],this.loaded=!1,this.onLoadCallback=void 0,n.animationPreload?(this.loaded=!1,this.loadInBackground()):this.loaded=!0}xl.prototype.isLoaded=function(){return this.loaded},xl.prototype.getLoadedProgress=function(){for(var t=La(this).length,e=0;this.dataPoints[e];)e++;return Math.round(e/t*100)},xl.prototype.getLabel=function(){return this.graph.filterLabel},xl.prototype.getColumn=function(){return this.column},xl.prototype.getSelectedValue=function(){if(void 0!==this.index)return La(this)[this.index]},xl.prototype.getValues=function(){return La(this)},xl.prototype.getValue=function(t){if(t>=La(this).length)throw new Error("Index out of range");return La(this)[t]},xl.prototype._getDataPoints=function(t){if(void 0===t&&(t=this.index),void 0===t)return[];var e;if(this.dataPoints[t])e=this.dataPoints[t];else{var n={};n.column=this.column,n.value=La(this)[t];var r=new xu(this.dataGroup.getDataSet(),{filter:function(t){return t[n.column]==n.value}}).get();e=this.dataGroup._getDataPoints(r),this.dataPoints[t]=e}return e},xl.prototype.setOnLoadCallback=function(t){this.onLoadCallback=t},xl.prototype.selectValue=function(t){if(t>=La(this).length)throw new Error("Index out of range");this.index=t,this.value=La(this)[t]},xl.prototype.loadInBackground=function(t){void 0===t&&(t=0);var e=this.graph.frame;if(t<La(this).length){void 0===e.progress&&(e.progress=document.createElement("DIV"),e.progress.style.position="absolute",e.progress.style.color="gray",e.appendChild(e.progress));var n=this.getLoadedProgress();e.progress.innerHTML="Loading animation... "+n+"%",e.progress.style.bottom="60px",e.progress.style.left="10px";var r=this;Is((function(){r.loadInBackground(t+1)}),10),this.loaded=!1}else this.loaded=!0,void 0!==e.progress&&(e.removeChild(e.progress),e.progress=void 0),this.onLoadCallback&&this.onLoadCallback()};var Sl=Object.freeze({__proto__:null,default:xl});function Tl(){this.dataTable=null}Tl.prototype.initializeData=function(t,e,n){if(void 0!==e){var r;if(eo(e)&&(e=new _u(e)),!(e instanceof _u||e instanceof xu))throw new Error("Array, DataSet, or DataView expected");if(0!=(r=e.get()).length){this.style=n,this.dataSet&&this.dataSet.off("*",this._onChange),this.dataSet=e,this.dataTable=r;var i=this;this._onChange=function(){t.setData(i.dataSet)},this.dataSet.on("*",this._onChange),this.colX="x",this.colY="y",this.colZ="z";var o=t.hasBars(n);if(o&&(void 0!==t.defaultXBarWidth?this.xBarWidth=t.defaultXBarWidth:this.xBarWidth=this.getSmallestDifference(r,this.colX)||1,void 0!==t.defaultYBarWidth?this.yBarWidth=t.defaultYBarWidth:this.yBarWidth=this.getSmallestDifference(r,this.colY)||1),this._initializeRange(r,this.colX,t,o),this._initializeRange(r,this.colY,t,o),this._initializeRange(r,this.colZ,t,!1),r[0].hasOwnProperty("style")){this.colValue="style";var a=this.getColumnRange(r,this.colValue);this._setRangeDefaults(a,t.defaultValueMin,t.defaultValueMax),this.valueRange=a}else this.colValue="z",this.valueRange=this.zRange;return this.getDataTable()[0].hasOwnProperty("filter")&&void 0===this.dataFilter&&(this.dataFilter=new xl(this,"filter",t),this.dataFilter.setOnLoadCallback((function(){t.redraw()}))),this.dataFilter?this.dataFilter._getDataPoints():this._getDataPoints(this.getDataTable())}}},Tl.prototype._collectRangeSettings=function(t,e){var n;if(-1==li(n=["x","y","z"]).call(n,t))throw new Error("Column '"+t+"' invalid");var r=t.toUpperCase();return{barWidth:this[t+"BarWidth"],min:e["default"+r+"Min"],max:e["default"+r+"Max"],step:e["default"+r+"Step"],range_label:t+"Range",step_label:t+"Step"}},Tl.prototype._initializeRange=function(t,e,n,r){var i=this._collectRangeSettings(e,n),o=this.getColumnRange(t,e);r&&"z"!=e&&o.expand(i.barWidth/2),this._setRangeDefaults(o,i.min,i.max),this[i.range_label]=o,this[i.step_label]=void 0!==i.step?i.step:o.range()/5},Tl.prototype.getDistinctValues=function(t,e){void 0===e&&(e=this.dataTable);for(var n=[],r=0;r<e.length;r++){var i=e[r][t]||0;-1===li(n).call(n,i)&&n.push(i)}return es(n).call(n,(function(t,e){return t-e}))},Tl.prototype.getSmallestDifference=function(t,e){for(var n=this.getDistinctValues(t,e),r=null,i=1;i<n.length;i++){var o=n[i]-n[i-1];(null==r||r>o)&&(r=o)}return r},Tl.prototype.getColumnRange=function(t,e){for(var n=new _l,r=0;r<t.length;r++){var i=t[r][e];n.adjust(i)}return n},Tl.prototype.getNumberOfRows=function(){return this.dataTable.length},Tl.prototype._setRangeDefaults=function(t,e,n){void 0!==e&&(t.min=e),void 0!==n&&(t.max=n),t.max<=t.min&&(t.max=t.min+1)},Tl.prototype.getDataTable=function(){return this.dataTable},Tl.prototype.getDataSet=function(){return this.dataSet},Tl.prototype.getDataPoints=function(t){for(var e=[],n=0;n<t.length;n++){var r=new Iu;r.x=t[n][this.colX]||0,r.y=t[n][this.colY]||0,r.z=t[n][this.colZ]||0,r.data=t[n],r.value=t[n][this.colValue]||0;var i={};i.point=r,i.bottom=new Iu(r.x,r.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},Tl.prototype.initDataAsMatrix=function(t){var e,n,r,i,o=this.getDistinctValues(this.colX,t),a=this.getDistinctValues(this.colY,t),s=this.getDataPoints(t),u=[];for(r=0;r<s.length;r++){i=s[r];var l=li(o).call(o,i.point.x),c=li(a).call(a,i.point.y);void 0===u[l]&&(u[l]=[]),u[l][c]=i}for(e=0;e<u.length;e++)for(n=0;n<u[e].length;n++)u[e][n]&&(u[e][n].pointRight=e<u.length-1?u[e+1][n]:void 0,u[e][n].pointTop=n<u[e].length-1?u[e][n+1]:void 0,u[e][n].pointCross=e<u.length-1&&n<u[e].length-1?u[e+1][n+1]:void 0);return s},Tl.prototype.getInfo=function(){var t=this.dataFilter;if(t)return t.getLabel()+": "+t.getSelectedValue()},Tl.prototype.reload=function(){this.dataTable&&this.setData(this.dataTable)},Tl.prototype._getDataPoints=function(t){var e=[];if(this.style===$u.GRID||this.style===$u.SURFACE)e=this.initDataAsMatrix(t);else if(e=this.getDataPoints(t),this.style===$u.LINE)for(var n=0;n<e.length;n++)n>0&&(e[n-1].pointNext=e[n]);return e},Al.STYLE=$u;var El=void 0;function Al(t,e,n){if(!(this instanceof Al))throw new SyntaxError("Constructor must be called with the new operator");this.containerElement=t,this.dataGroup=new Tl,this.dataPoints=null,this.create(),function(t,e){if(void 0===t||el(t))throw new Error("No DEFAULTS passed");if(void 0===e)throw new Error("No dst passed");tl=t,rl(t,e,Ku),rl(t,e,Ju,"default"),ol(t,e),e.margin=10,e.showTooltip=!1,e.onclick_callback=null,e.eye=new Iu(0,0,-1)}(Al.DEFAULTS,this),this.colX=void 0,this.colY=void 0,this.colZ=void 0,this.colValue=void 0,this.setOptions(n),this.setData(e)}function Ol(t){return"clientX"in t?t.clientX:t.targetTouches[0]&&t.targetTouches[0].clientX||0}function kl(t){return"clientY"in t?t.clientY:t.targetTouches[0]&&t.targetTouches[0].clientY||0}Al.DEFAULTS={width:"400px",height:"400px",filterLabel:"time",legendLabel:"value",xLabel:"x",yLabel:"y",zLabel:"z",xValueLabel:function(t){return t},yValueLabel:function(t){return t},zValueLabel:function(t){return t},showXAxis:!0,showYAxis:!0,showZAxis:!0,showGrayBottom:!1,showGrid:!0,showPerspective:!0,showShadow:!1,showSurfaceGrid:!0,keepAspectRatio:!0,rotateAxisLabels:!0,verticalRatio:.5,dotSizeRatio:.02,dotSizeMinFraction:.5,dotSizeMaxFraction:2.5,showAnimationControls:El,animationInterval:1e3,animationPreload:!1,animationAutoStart:El,axisFontSize:14,axisFontType:"arial",axisColor:"#4D4D4D",gridColor:"#D3D3D3",xCenter:"55%",yCenter:"50%",style:Al.STYLE.DOT,tooltip:!1,tooltipDelay:300,tooltipStyle:{content:{padding:"10px",border:"1px solid #4d4d4d",color:"#1a1a1a",background:"rgba(255,255,255,0.7)",borderRadius:"2px",boxShadow:"5px 5px 10px rgba(128,128,128,0.5)"},line:{height:"40px",width:"0",borderLeft:"1px solid #4d4d4d",pointerEvents:"none"},dot:{height:"0",width:"0",border:"5px solid #4d4d4d",borderRadius:"5px",pointerEvents:"none"}},dataColor:{fill:"#7DC1FF",stroke:"#3267D2",strokeWidth:1},surfaceColors:El,colormap:El,cameraPosition:{horizontal:1,vertical:.5,distance:1.7},zoomable:!0,ctrlToZoom:!1,showLegend:El,backgroundColor:El,xBarWidth:El,yBarWidth:El,valueMin:El,valueMax:El,xMin:El,xMax:El,xStep:El,yMin:El,yMax:El,yStep:El,zMin:El,zMax:El,zStep:El},Mu(Al.prototype),Al.prototype._setScale=function(){this.scale=new Iu(1/this.xRange.range(),1/this.yRange.range(),1/this.zRange.range()),this.keepAspectRatio&&(this.scale.x<this.scale.y?this.scale.y=this.scale.x:this.scale.x=this.scale.y),this.scale.z*=this.verticalRatio,void 0!==this.valueRange&&(this.scale.value=1/this.valueRange.range());var t=this.xRange.center()*this.scale.x,e=this.yRange.center()*this.scale.y,n=this.zRange.center()*this.scale.z;this.camera.setArmLocation(t,e,n)},Al.prototype._convert3Dto2D=function(t){var e=this._convertPointToTranslation(t);return this._convertTranslationToScreen(e)},Al.prototype._convertPointToTranslation=function(t){var e=this.camera.getCameraLocation(),n=this.camera.getCameraRotation(),r=t.x*this.scale.x,i=t.y*this.scale.y,o=t.z*this.scale.z,a=e.x,s=e.y,u=e.z,l=Math.sin(n.x),c=Math.cos(n.x),h=Math.sin(n.y),f=Math.cos(n.y),d=Math.sin(n.z),p=Math.cos(n.z);return new Iu(f*(d*(i-s)+p*(r-a))-h*(o-u),l*(f*(o-u)+h*(d*(i-s)+p*(r-a)))+c*(p*(i-s)-d*(r-a)),c*(f*(o-u)+h*(d*(i-s)+p*(r-a)))-l*(p*(i-s)-d*(r-a)))},Al.prototype._convertTranslationToScreen=function(t){var e,n,r=this.eye.x,i=this.eye.y,o=this.eye.z,a=t.x,s=t.y,u=t.z;return this.showPerspective?(e=o/u*(a-r),n=o/u*(s-i)):(e=a*(-o/this.camera.getArmLength()),n=s*(-o/this.camera.getArmLength())),new ju(this.currentXCenter+e*this.frame.canvas.clientWidth,this.currentYCenter-n*this.frame.canvas.clientWidth)},Al.prototype._calcTranslations=function(t){for(var e=0;e<t.length;e++){var n=t[e];n.trans=this._convertPointToTranslation(n.point),n.screen=this._convertTranslationToScreen(n.trans);var r=this._convertPointToTranslation(n.bottom);n.dist=this.showPerspective?r.length():-r.z}es(t).call(t,(function(t,e){return e.dist-t.dist}))},Al.prototype._initializeRanges=function(){var t=this.dataGroup;this.xRange=t.xRange,this.yRange=t.yRange,this.zRange=t.zRange,this.valueRange=t.valueRange,this.xStep=t.xStep,this.yStep=t.yStep,this.zStep=t.zStep,this.xBarWidth=t.xBarWidth,this.yBarWidth=t.yBarWidth,this.colX=t.colX,this.colY=t.colY,this.colZ=t.colZ,this.colValue=t.colValue,this._setScale()},Al.prototype.getDataPoints=function(t){for(var e=[],n=0;n<t.length;n++){var r=new Iu;r.x=t[n][this.colX]||0,r.y=t[n][this.colY]||0,r.z=t[n][this.colZ]||0,r.data=t[n],r.value=t[n][this.colValue]||0;var i={};i.point=r,i.bottom=new Iu(r.x,r.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},Al.prototype._getDataPoints=function(t){var e,n,r,i,o=[];if(this.style===Al.STYLE.GRID||this.style===Al.STYLE.SURFACE){var a=this.dataGroup.getDistinctValues(this.colX,t),s=this.dataGroup.getDistinctValues(this.colY,t);o=this.getDataPoints(t);var u=[];for(r=0;r<o.length;r++){i=o[r];var l=li(a).call(a,i.point.x),c=li(s).call(s,i.point.y);void 0===u[l]&&(u[l]=[]),u[l][c]=i}for(e=0;e<u.length;e++)for(n=0;n<u[e].length;n++)u[e][n]&&(u[e][n].pointRight=e<u.length-1?u[e+1][n]:void 0,u[e][n].pointTop=n<u[e].length-1?u[e][n+1]:void 0,u[e][n].pointCross=e<u.length-1&&n<u[e].length-1?u[e+1][n+1]:void 0)}else if(o=this.getDataPoints(t),this.style===Al.STYLE.LINE)for(r=0;r<o.length;r++)r>0&&(o[r-1].pointNext=o[r]);return o},Al.prototype.create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div"),this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas);var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t),this.frame.filter=document.createElement("div"),Kr(this.frame).style.position="absolute",Kr(this.frame).style.bottom="0px",Kr(this.frame).style.left="0px",Kr(this.frame).style.width="100%",this.frame.appendChild(Kr(this.frame));var e=this;Go(this.frame.canvas,"mousedown",(function(t){e._onMouseDown(t)})),Go(this.frame.canvas,"touchstart",(function(t){e._onTouchStart(t)})),Go(this.frame.canvas,"mousewheel",(function(t){e._onWheel(t)})),Go(this.frame.canvas,"mousemove",(function(t){e._onTooltip(t)})),Go(this.frame.canvas,"click",(function(t){e._onClick(t)})),this.containerElement.appendChild(this.frame)},Al.prototype._setSize=function(t,e){this.frame.style.width=t,this.frame.style.height=e,this._resizeCanvas()},Al.prototype._resizeCanvas=function(){this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=this.frame.canvas.clientWidth,this.frame.canvas.height=this.frame.canvas.clientHeight,Kr(this.frame).style.width=this.frame.canvas.clientWidth-20+"px"},Al.prototype.animationStart=function(){if(this.animationAutoStart&&this.dataGroup.dataFilter){if(!Kr(this.frame)||!Kr(this.frame).slider)throw new Error("No animation available");Kr(this.frame).slider.play()}},Al.prototype.animationStop=function(){Kr(this.frame)&&Kr(this.frame).slider&&Kr(this.frame).slider.stop()},Al.prototype._resizeCenter=function(){"%"===this.xCenter.charAt(this.xCenter.length-1)?this.currentXCenter=Du(this.xCenter)/100*this.frame.canvas.clientWidth:this.currentXCenter=Du(this.xCenter),"%"===this.yCenter.charAt(this.yCenter.length-1)?this.currentYCenter=Du(this.yCenter)/100*(this.frame.canvas.clientHeight-Kr(this.frame).clientHeight):this.currentYCenter=Du(this.yCenter)},Al.prototype.getCameraPosition=function(){var t=this.camera.getArmRotation();return t.distance=this.camera.getArmLength(),t},Al.prototype._readData=function(t){this.dataPoints=this.dataGroup.initializeData(this,t,this.style),this._initializeRanges(),this._redrawFilter()},Al.prototype.setData=function(t){null!=t&&(this._readData(t),this.redraw(),this.animationStart())},Al.prototype.setOptions=function(t){void 0!==t&&(!0===fl.validate(t,bl)&&console.log("%cErrors have been found in the supplied options object.",hl),this.animationStop(),function(t,e){if(void 0!==t){if(void 0===e)throw new Error("No dst passed");if(void 0===tl||el(tl))throw new Error("DEFAULTS not set for module Settings");il(t,e,Ku),il(t,e,Ju,"default"),ol(t,e)}}(t,this),this.setPointDrawingMethod(),this._setSize(this.width,this.height),this.setAxisLabelMethod(),this.setData(this.dataGroup.getDataTable()),this.animationStart())},Al.prototype.setPointDrawingMethod=function(){var t=void 0;switch(this.style){case Al.STYLE.BAR:t=this._redrawBarGraphPoint;break;case Al.STYLE.BARCOLOR:t=this._redrawBarColorGraphPoint;break;case Al.STYLE.BARSIZE:t=this._redrawBarSizeGraphPoint;break;case Al.STYLE.DOT:t=this._redrawDotGraphPoint;break;case Al.STYLE.DOTLINE:t=this._redrawDotLineGraphPoint;break;case Al.STYLE.DOTCOLOR:t=this._redrawDotColorGraphPoint;break;case Al.STYLE.DOTSIZE:t=this._redrawDotSizeGraphPoint;break;case Al.STYLE.SURFACE:t=this._redrawSurfaceGraphPoint;break;case Al.STYLE.GRID:t=this._redrawGridGraphPoint;break;case Al.STYLE.LINE:t=this._redrawLineGraphPoint;break;default:throw new Error("Can not determine point drawing method for graph style '"+this.style+"'")}this._pointDrawingMethod=t},Al.prototype.setAxisLabelMethod=function(){this.rotateAxisLabels?(this._drawAxisLabelX=this.drawAxisLabelXRotate,this._drawAxisLabelY=this.drawAxisLabelYRotate,this._drawAxisLabelZ=this.drawAxisLabelZRotate):(this._drawAxisLabelX=this.drawAxisLabelX,this._drawAxisLabelY=this.drawAxisLabelY,this._drawAxisLabelZ=this.drawAxisLabelZ)},Al.prototype.redraw=function(){if(void 0===this.dataPoints)throw new Error("Graph data not initialized");this._resizeCanvas(),this._resizeCenter(),this._redrawSlider(),this._redrawClear(),this._redrawAxis(),this._redrawDataGraph(),this._redrawInfo(),this._redrawLegend()},Al.prototype._getContext=function(){var t=this.frame.canvas.getContext("2d");return t.lineJoin="round",t.lineCap="round",t},Al.prototype._redrawClear=function(){var t=this.frame.canvas;t.getContext("2d").clearRect(0,0,t.width,t.height)},Al.prototype._dotSize=function(){return this.frame.clientWidth*this.dotSizeRatio},Al.prototype._getLegendWidth=function(){var t;this.style===Al.STYLE.DOTSIZE?t=this._dotSize()*this.dotSizeMaxFraction:t=this.style===Al.STYLE.BARSIZE?this.xBarWidth:20;return t},Al.prototype._redrawLegend=function(){if(!0===this.showLegend&&this.style!==Al.STYLE.LINE&&this.style!==Al.STYLE.BARSIZE){var t=this.style===Al.STYLE.BARSIZE||this.style===Al.STYLE.DOTSIZE,e=this.style===Al.STYLE.DOTSIZE||this.style===Al.STYLE.DOTCOLOR||this.style===Al.STYLE.SURFACE||this.style===Al.STYLE.BARCOLOR,n=Math.max(.25*this.frame.clientHeight,100),r=this.margin,i=this._getLegendWidth(),o=this.frame.clientWidth-this.margin,a=o-i,s=r+n,u=this._getContext();if(u.lineWidth=1,u.font="14px arial",!1===t){var l,c=n;for(l=0;l<c;l++){var h=1-(l-0)/(c-0),f=this._colormap(h,1);u.strokeStyle=f,u.beginPath(),u.moveTo(a,r+l),u.lineTo(o,r+l),u.stroke()}u.strokeStyle=this.axisColor,u.strokeRect(a,r,i,n)}else{var d;this.style===Al.STYLE.DOTSIZE?d=i*(this.dotSizeMinFraction/this.dotSizeMaxFraction):(this.style,Al.STYLE.BARSIZE),u.strokeStyle=this.axisColor,u.fillStyle=ku(this.dataColor),u.beginPath(),u.moveTo(a,r),u.lineTo(o,r),u.lineTo(a+d,s),u.lineTo(a,s),u.closePath(),ku(u).call(u),u.stroke()}var p,v,y=e?this.valueRange.min:this.zRange.min,g=e?this.valueRange.max:this.zRange.max,m=new Bu(y,g,(g-y)/5,!0);for(m.start(!0);!m.end();)l=s-(m.getCurrent()-y)/(g-y)*n,p=new ju(a-5,l),v=new ju(a,l),this._line(u,p,v),u.textAlign="right",u.textBaseline="middle",u.fillStyle=this.axisColor,u.fillText(m.getCurrent(),a-10,l),m.next();u.textAlign="right",u.textBaseline="top";var b=this.legendLabel;u.fillText(b,o,s+this.margin)}},Al.prototype._redrawFilter=function(){var t=this.dataGroup.dataFilter,e=Kr(this.frame);if(e.innerHTML="",t){var n=new zu(e,{visible:this.showAnimationControls});e.slider=n,e.style.padding="10px",n.setValues(La(t)),n.setPlayInterval(this.animationInterval);var r=this;n.setOnChangeCallback((function(){var t=r.dataGroup.dataFilter,e=n.getIndex();t.selectValue(e),r.dataPoints=t._getDataPoints(),r.redraw()}))}else e.slider=void 0},Al.prototype._redrawSlider=function(){void 0!==Kr(this.frame).slider&&Kr(this.frame).slider.redraw()},Al.prototype._redrawInfo=function(){var t=this.dataGroup.getInfo();if(void 0!==t){var e=this._getContext();e.font="14px arial",e.lineStyle="gray",e.fillStyle="gray",e.textAlign="left",e.textBaseline="top";var n=this.margin,r=this.margin;e.fillText(t,n,r)}},Al.prototype._line=function(t,e,n,r){void 0!==r&&(t.strokeStyle=r),t.beginPath(),t.moveTo(e.x,e.y),t.lineTo(n.x,n.y),t.stroke()},Al.prototype.drawAxisLabelX=function(t,e,n,r,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*r)>0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*r)<0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)},Al.prototype.drawAxisLabelY=function(t,e,n,r,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*r)<0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*r)>0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)},Al.prototype.drawAxisLabelZ=function(t,e,n,r){void 0===r&&(r=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,i.x-r,i.y)},Al.prototype.drawAxisLabelXRotate=function(t,e,n,r,i){var o=this._convert3Dto2D(e);Math.cos(2*r)>0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,0,0),t.restore()):Math.sin(2*r)<0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y))},Al.prototype.drawAxisLabelYRotate=function(t,e,n,r,i){var o=this._convert3Dto2D(e);Math.cos(2*r)<0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,0,0),t.restore()):Math.sin(2*r)>0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y))},Al.prototype.drawAxisLabelZRotate=function(t,e,n,r){void 0===r&&(r=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,i.x-r,i.y)},Al.prototype._line3d=function(t,e,n,r){var i=this._convert3Dto2D(e),o=this._convert3Dto2D(n);this._line(t,i,o,r)},Al.prototype._redrawAxis=function(){var t,e,n,r,i,o,a,s,u,l,c=this._getContext();c.font=this.axisFontSize/this.camera.getArmLength()+"px "+this.axisFontType;var h,f,d,p=.025/this.scale.x,v=.025/this.scale.y,y=5/this.camera.getArmLength(),g=this.camera.getArmRotation().horizontal,m=new ju(Math.cos(g),Math.sin(g)),b=this.xRange,w=this.yRange,_=this.zRange;for(c.lineWidth=1,r=void 0===this.defaultXStep,(n=new Bu(b.min,b.max,this.xStep,r)).start(!0);!n.end();){var x=n.getCurrent();if(this.showGrid?(t=new Iu(x,w.min,_.min),e=new Iu(x,w.max,_.min),this._line3d(c,t,e,this.gridColor)):this.showXAxis&&(t=new Iu(x,w.min,_.min),e=new Iu(x,w.min+p,_.min),this._line3d(c,t,e,this.axisColor),t=new Iu(x,w.max,_.min),e=new Iu(x,w.max-p,_.min),this._line3d(c,t,e,this.axisColor)),this.showXAxis){a=m.x>0?w.min:w.max,h=new Iu(x,a,_.min);var S="  "+this.xValueLabel(x)+"  ";this._drawAxisLabelX.call(this,c,h,S,g,y)}n.next()}for(c.lineWidth=1,r=void 0===this.defaultYStep,(n=new Bu(w.min,w.max,this.yStep,r)).start(!0);!n.end();){var T=n.getCurrent();if(this.showGrid?(t=new Iu(b.min,T,_.min),e=new Iu(b.max,T,_.min),this._line3d(c,t,e,this.gridColor)):this.showYAxis&&(t=new Iu(b.min,T,_.min),e=new Iu(b.min+v,T,_.min),this._line3d(c,t,e,this.axisColor),t=new Iu(b.max,T,_.min),e=new Iu(b.max-v,T,_.min),this._line3d(c,t,e,this.axisColor)),this.showYAxis){o=m.y>0?b.min:b.max,h=new Iu(o,T,_.min);var E="  "+this.yValueLabel(T)+"  ";this._drawAxisLabelY.call(this,c,h,E,g,y)}n.next()}if(this.showZAxis){for(c.lineWidth=1,r=void 0===this.defaultZStep,(n=new Bu(_.min,_.max,this.zStep,r)).start(!0),o=m.x>0?b.min:b.max,a=m.y<0?w.min:w.max;!n.end();){var A=n.getCurrent(),O=new Iu(o,a,A),k=this._convert3Dto2D(O);e=new ju(k.x-y,k.y),this._line(c,k,e,this.axisColor);var C=this.zValueLabel(A)+" ";this._drawAxisLabelZ.call(this,c,O,C,5),n.next()}c.lineWidth=1,t=new Iu(o,a,_.min),e=new Iu(o,a,_.max),this._line3d(c,t,e,this.axisColor)}this.showXAxis&&(c.lineWidth=1,f=new Iu(b.min,w.min,_.min),d=new Iu(b.max,w.min,_.min),this._line3d(c,f,d,this.axisColor),f=new Iu(b.min,w.max,_.min),d=new Iu(b.max,w.max,_.min),this._line3d(c,f,d,this.axisColor));this.showYAxis&&(c.lineWidth=1,t=new Iu(b.min,w.min,_.min),e=new Iu(b.min,w.max,_.min),this._line3d(c,t,e,this.axisColor),t=new Iu(b.max,w.min,_.min),e=new Iu(b.max,w.max,_.min),this._line3d(c,t,e,this.axisColor));var L=this.xLabel;L.length>0&&this.showXAxis&&(l=.1/this.scale.y,o=(b.max+3*b.min)/4,a=m.x>0?w.min-l:w.max+l,i=new Iu(o,a,_.min),this.drawAxisLabelX(c,i,L,g));var P=this.yLabel;P.length>0&&this.showYAxis&&(u=.1/this.scale.x,o=m.y>0?b.min-u:b.max+u,a=(w.max+3*w.min)/4,i=new Iu(o,a,_.min),this.drawAxisLabelY(c,i,P,g));var D=this.zLabel;D.length>0&&this.showZAxis&&(30,o=m.x>0?b.min:b.max,a=m.y<0?w.min:w.max,s=(_.max+3*_.min)/4,i=new Iu(o,a,s),this.drawAxisLabelZ(c,i,D,30))},Al.prototype._getStrokeWidth=function(t){return void 0!==t?this.showPerspective?1/-t.trans.z*this.dataColor.strokeWidth:-this.eye.z/this.camera.getArmLength()*this.dataColor.strokeWidth:this.dataColor.strokeWidth},Al.prototype._redrawBar=function(t,e,n,r,i,o){var a,s=this,u=e.point,l=this.zRange.min,c=[{point:new Iu(u.x-n,u.y-r,u.z)},{point:new Iu(u.x+n,u.y-r,u.z)},{point:new Iu(u.x+n,u.y+r,u.z)},{point:new Iu(u.x-n,u.y+r,u.z)}],h=[{point:new Iu(u.x-n,u.y-r,l)},{point:new Iu(u.x+n,u.y-r,l)},{point:new Iu(u.x+n,u.y+r,l)},{point:new Iu(u.x-n,u.y+r,l)}];kr(c).call(c,(function(t){t.screen=s._convert3Dto2D(t.point)})),kr(h).call(h,(function(t){t.screen=s._convert3Dto2D(t.point)}));var f=[{corners:c,center:Iu.avg(h[0].point,h[2].point)},{corners:[c[0],c[1],h[1],h[0]],center:Iu.avg(h[1].point,h[0].point)},{corners:[c[1],c[2],h[2],h[1]],center:Iu.avg(h[2].point,h[1].point)},{corners:[c[2],c[3],h[3],h[2]],center:Iu.avg(h[3].point,h[2].point)},{corners:[c[3],c[0],h[0],h[3]],center:Iu.avg(h[0].point,h[3].point)}];e.surfaces=f;for(var d=0;d<f.length;d++){a=f[d];var p=this._convertPointToTranslation(a.center);a.dist=this.showPerspective?p.length():-p.z}es(f).call(f,(function(t,e){var n=e.dist-t.dist;return n||(t.corners===c?1:e.corners===c?-1:0)})),t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=o,t.fillStyle=i;for(var v=2;v<f.length;v++)a=f[v],this._polygon(t,a.corners)},Al.prototype._polygon=function(t,e,n,r){if(!(e.length<2)){void 0!==n&&(t.fillStyle=n),void 0!==r&&(t.strokeStyle=r),t.beginPath(),t.moveTo(e[0].screen.x,e[0].screen.y);for(var i=1;i<e.length;++i){var o=e[i];t.lineTo(o.screen.x,o.screen.y)}t.closePath(),ku(t).call(t),t.stroke()}},Al.prototype._drawCircle=function(t,e,n,r,i){var o=this._calcRadius(e,i);t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=r,t.fillStyle=n,t.beginPath(),t.arc(e.screen.x,e.screen.y,o,0,2*Math.PI,!0),ku(t).call(t),t.stroke()},Al.prototype._getColorsRegular=function(t){var e=(t.point.value-this.valueRange.min)*this.scale.value;return{fill:this._colormap(e,1),border:this._colormap(e,.8)}},Al.prototype._getColorsColor=function(t){var e,n,r;if(t&&t.point&&t.point.data&&t.point.data.style&&(r=t.point.data.style),r&&"object"===io(r)&&ku(r)&&r.stroke)return{fill:ku(r),border:r.stroke};if("string"==typeof t.point.value)e=t.point.value,n=t.point.value;else{var i=(t.point.value-this.valueRange.min)*this.scale.value;e=this._colormap(i,1),n=this._colormap(i,.8)}return{fill:e,border:n}},Al.prototype._getColorsSize=function(){return{fill:ku(this.dataColor),border:this.dataColor.stroke}},Al.prototype._colormap=function(t){var e,n,r,i,o,a,s,u,l,c=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,h=this.colormap;if(eo(h)){var f=h.length-1,d=Math.max(Math.floor(t*f),0),p=Math.min(d+1,f),v=t*f-d,y=h[d],g=h[p];e=y.r+v*(g.r-y.r),n=y.g+v*(g.g-y.g),r=y.b+v*(g.b-y.b)}else if("function"==typeof h){var m=h(t);e=m.r,n=m.g,r=m.b,i=m.a}else{var b=240*(1-t),w=Ko(b/360,1,1);e=w.r,n=w.g,r=w.b}return"number"!=typeof i||Eu(i)?po(o=po(a="RGB(".concat(Math.round(e*c),", ")).call(a,Math.round(n*c),", ")).call(o,Math.round(r*c),")"):po(s=po(u=po(l="RGBA(".concat(Math.round(e*c),", ")).call(l,Math.round(n*c),", ")).call(u,Math.round(r*c),", ")).call(s,i,")")},Al.prototype._calcRadius=function(t,e){var n;return void 0===e&&(e=this._dotSize()),(n=this.showPerspective?e/-t.trans.z:e*(-this.eye.z/this.camera.getArmLength()))<0&&(n=0),n},Al.prototype._redrawBarGraphPoint=function(t,e){var n=this.xBarWidth/2,r=this.yBarWidth/2,i=this._getColorsRegular(e);this._redrawBar(t,e,n,r,ku(i),i.border)},Al.prototype._redrawBarColorGraphPoint=function(t,e){var n=this.xBarWidth/2,r=this.yBarWidth/2,i=this._getColorsColor(e);this._redrawBar(t,e,n,r,ku(i),i.border)},Al.prototype._redrawBarSizeGraphPoint=function(t,e){var n=(e.point.value-this.valueRange.min)/this.valueRange.range(),r=this.xBarWidth/2*(.8*n+.2),i=this.yBarWidth/2*(.8*n+.2),o=this._getColorsSize();this._redrawBar(t,e,r,i,ku(o),o.border)},Al.prototype._redrawDotGraphPoint=function(t,e){var n=this._getColorsRegular(e);this._drawCircle(t,e,ku(n),n.border)},Al.prototype._redrawDotLineGraphPoint=function(t,e){var n=this._convert3Dto2D(e.bottom);t.lineWidth=1,this._line(t,n,e.screen,this.gridColor),this._redrawDotGraphPoint(t,e)},Al.prototype._redrawDotColorGraphPoint=function(t,e){var n=this._getColorsColor(e);this._drawCircle(t,e,ku(n),n.border)},Al.prototype._redrawDotSizeGraphPoint=function(t,e){var n=this._dotSize(),r=(e.point.value-this.valueRange.min)/this.valueRange.range(),i=n*this.dotSizeMinFraction,o=i+(n*this.dotSizeMaxFraction-i)*r,a=this._getColorsSize();this._drawCircle(t,e,ku(a),a.border,o)},Al.prototype._redrawSurfaceGraphPoint=function(t,e){var n=e.pointRight,r=e.pointTop,i=e.pointCross;if(void 0!==e&&void 0!==n&&void 0!==r&&void 0!==i){var o,a,s,u=!0;if(this.showGrayBottom||this.showShadow){var l=Iu.subtract(i.trans,e.trans),c=Iu.subtract(r.trans,n.trans),h=Iu.crossProduct(l,c);if(this.showPerspective){var f=Iu.avg(Iu.avg(e.trans,i.trans),Iu.avg(n.trans,r.trans));s=-Iu.dotProduct(h.normalize(),f.normalize())}else s=h.z/h.length();u=s>0}if(u||!this.showGrayBottom){var d=((e.point.value+n.point.value+r.point.value+i.point.value)/4-this.valueRange.min)*this.scale.value,p=this.showShadow?(1+s)/2:1;o=this._colormap(d,p)}else o="gray";a=this.showSurfaceGrid?this.axisColor:o,t.lineWidth=this._getStrokeWidth(e);var v=[e,n,i,r];this._polygon(t,v,o,a)}},Al.prototype._drawGridLine=function(t,e,n){if(void 0!==e&&void 0!==n){var r=((e.point.value+n.point.value)/2-this.valueRange.min)*this.scale.value;t.lineWidth=2*this._getStrokeWidth(e),t.strokeStyle=this._colormap(r,1),this._line(t,e.screen,n.screen)}},Al.prototype._redrawGridGraphPoint=function(t,e){this._drawGridLine(t,e,e.pointRight),this._drawGridLine(t,e,e.pointTop)},Al.prototype._redrawLineGraphPoint=function(t,e){void 0!==e.pointNext&&(t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=this.dataColor.stroke,this._line(t,e.screen,e.pointNext.screen))},Al.prototype._redrawDataGraph=function(){var t,e=this._getContext();if(!(void 0===this.dataPoints||this.dataPoints.length<=0))for(this._calcTranslations(this.dataPoints),t=0;t<this.dataPoints.length;t++){var n=this.dataPoints[t];this._pointDrawingMethod.call(this,e,n)}},Al.prototype._storeMousePosition=function(t){this.startMouseX=Ol(t),this.startMouseY=kl(t),this._startCameraOffset=this.camera.getOffset()},Al.prototype._onMouseDown=function(t){if(t=t||window.event,this.leftButtonDown&&this._onMouseUp(t),this.leftButtonDown=t.which?1===t.which:1===t.button,this.leftButtonDown||this.touchDown){this._storeMousePosition(t),this.startStart=new Date(this.start),this.startEnd=new Date(this.end),this.startArmRotation=this.camera.getArmRotation(),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},Go(document,"mousemove",e.onmousemove),Go(document,"mouseup",e.onmouseup),Xo(t)}},Al.prototype._onMouseMove=function(t){this.moving=!0,t=t||window.event;var e=Du(Ol(t))-this.startMouseX,n=Du(kl(t))-this.startMouseY;if(t&&!0===t.ctrlKey){var r=.5*this.frame.clientWidth,i=.5*this.frame.clientHeight,o=(this._startCameraOffset.x||0)-e/r*this.camera.armLength*.8,a=(this._startCameraOffset.y||0)+n/i*this.camera.armLength*.8;this.camera.setOffset(o,a),this._storeMousePosition(t)}else{var s=this.startArmRotation.horizontal+e/200,u=this.startArmRotation.vertical+n/200,l=Math.sin(4/360*2*Math.PI);Math.abs(Math.sin(s))<l&&(s=Math.round(s/Math.PI)*Math.PI-.001),Math.abs(Math.cos(s))<l&&(s=(Math.round(s/Math.PI-.5)+.5)*Math.PI-.001),Math.abs(Math.sin(u))<l&&(u=Math.round(u/Math.PI)*Math.PI),Math.abs(Math.cos(u))<l&&(u=(Math.round(u/Math.PI-.5)+.5)*Math.PI),this.camera.setArmRotation(s,u)}this.redraw();var c=this.getCameraPosition();this.emit("cameraPositionChange",c),Xo(t)},Al.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",this.leftButtonDown=!1,Vo(document,"mousemove",this.onmousemove),Vo(document,"mouseup",this.onmouseup),Xo(t)},Al.prototype._onClick=function(t){if(this.onclick_callback||this.hasListeners("click")){if(this.moving)this.moving=!1;else{var e=this.frame.getBoundingClientRect(),n=Ol(t)-e.left,r=kl(t)-e.top,i=this._dataPointFromXY(n,r);i&&(this.onclick_callback&&this.onclick_callback(i.point.data),this.emit("click",i.point.data))}Xo(t)}},Al.prototype._onTooltip=function(t){var e=this.tooltipDelay,n=this.frame.getBoundingClientRect(),r=Ol(t)-n.left,i=kl(t)-n.top;if(this.showTooltip)if(this.tooltipTimeout&&clearTimeout(this.tooltipTimeout),this.leftButtonDown)this._hideTooltip();else if(this.tooltip&&this.tooltip.dataPoint){var o=this._dataPointFromXY(r,i);o!==this.tooltip.dataPoint&&(o?this._showTooltip(o):this._hideTooltip())}else{var a=this;this.tooltipTimeout=Is((function(){a.tooltipTimeout=null;var t=a._dataPointFromXY(r,i);t&&a._showTooltip(t)}),e)}},Al.prototype._onTouchStart=function(t){this.touchDown=!0;var e=this;this.ontouchmove=function(t){e._onTouchMove(t)},this.ontouchend=function(t){e._onTouchEnd(t)},Go(document,"touchmove",e.ontouchmove),Go(document,"touchend",e.ontouchend),this._onMouseDown(t)},Al.prototype._onTouchMove=function(t){this._onMouseMove(t)},Al.prototype._onTouchEnd=function(t){this.touchDown=!1,Vo(document,"touchmove",this.ontouchmove),Vo(document,"touchend",this.ontouchend),this._onMouseUp(t)},Al.prototype._onWheel=function(t){if(t||(t=window.event),this.zoomable&&(!this.ctrlToZoom||t.ctrlKey)){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail&&(e=-t.detail/3),e){var n=this.camera.getArmLength()*(1-e/10);this.camera.setArmLength(n),this.redraw(),this._hideTooltip()}var r=this.getCameraPosition();this.emit("cameraPositionChange",r),Xo(t)}},Al.prototype._insideTriangle=function(t,e){var n=e[0],r=e[1],i=e[2];function o(t){return t>0?1:t<0?-1:0}var a=o((r.x-n.x)*(t.y-n.y)-(r.y-n.y)*(t.x-n.x)),s=o((i.x-r.x)*(t.y-r.y)-(i.y-r.y)*(t.x-r.x)),u=o((n.x-i.x)*(t.y-i.y)-(n.y-i.y)*(t.x-i.x));return!(0!=a&&0!=s&&a!=s||0!=s&&0!=u&&s!=u||0!=a&&0!=u&&a!=u)},Al.prototype._dataPointFromXY=function(t,e){var n,r=null,i=null,o=null,a=new ju(t,e);if(this.style===Al.STYLE.BAR||this.style===Al.STYLE.BARCOLOR||this.style===Al.STYLE.BARSIZE)for(n=this.dataPoints.length-1;n>=0;n--){var s=(r=this.dataPoints[n]).surfaces;if(s)for(var u=s.length-1;u>=0;u--){var l=s[u].corners,c=[l[0].screen,l[1].screen,l[2].screen],h=[l[2].screen,l[3].screen,l[0].screen];if(this._insideTriangle(a,c)||this._insideTriangle(a,h))return r}}else for(n=0;n<this.dataPoints.length;n++){var f=(r=this.dataPoints[n]).screen;if(f){var d=Math.abs(t-f.x),p=Math.abs(e-f.y),v=Math.sqrt(d*d+p*p);(null===o||v<o)&&v<100&&(o=v,i=r)}}return i},Al.prototype.hasBars=function(t){return t==Al.STYLE.BAR||t==Al.STYLE.BARCOLOR||t==Al.STYLE.BARSIZE},Al.prototype._showTooltip=function(t){var e,n,r;this.tooltip?(e=this.tooltip.dom.content,n=this.tooltip.dom.line,r=this.tooltip.dom.dot):(e=document.createElement("div"),di(e.style,{},this.tooltipStyle.content),e.style.position="absolute",n=document.createElement("div"),di(n.style,{},this.tooltipStyle.line),n.style.position="absolute",r=document.createElement("div"),di(r.style,{},this.tooltipStyle.dot),r.style.position="absolute",this.tooltip={dataPoint:null,dom:{content:e,line:n,dot:r}}),this._hideTooltip(),this.tooltip.dataPoint=t,"function"==typeof this.showTooltip?e.innerHTML=this.showTooltip(t.point):e.innerHTML="<table><tr><td>"+this.xLabel+":</td><td>"+t.point.x+"</td></tr><tr><td>"+this.yLabel+":</td><td>"+t.point.y+"</td></tr><tr><td>"+this.zLabel+":</td><td>"+t.point.z+"</td></tr></table>",e.style.left="0",e.style.top="0",this.frame.appendChild(e),this.frame.appendChild(n),this.frame.appendChild(r);var i=e.offsetWidth,o=e.offsetHeight,a=n.offsetHeight,s=r.offsetWidth,u=r.offsetHeight,l=t.screen.x-i/2;l=Math.min(Math.max(l,10),this.frame.clientWidth-10-i),n.style.left=t.screen.x+"px",n.style.top=t.screen.y-a+"px",e.style.left=l+"px",e.style.top=t.screen.y-a-o+"px",r.style.left=t.screen.x-s/2+"px",r.style.top=t.screen.y-u/2+"px"},Al.prototype._hideTooltip=function(){if(this.tooltip)for(var t in this.tooltip.dataPoint=null,this.tooltip.dom)if(this.tooltip.dom.hasOwnProperty(t)){var e=this.tooltip.dom[t];e&&e.parentNode&&e.parentNode.removeChild(e)}},Al.prototype.setCameraPosition=function(t){ul(t,this),this.redraw()},Al.prototype.setSize=function(t,e){this._setSize(t,e),this.redraw()};var Cl=Object.freeze({__proto__:null,default:Al}),Ll=null;var Pl,Dl=n((function(t){!function(e,n,r,i){var o,a=["","webkit","Moz","MS","ms","o"],s=n.createElement("div"),u=Math.round,l=Math.abs,c=Date.now;function h(t,e,n){return setTimeout(m(t,n),e)}function f(t,e,n){return!!Array.isArray(t)&&(d(t,n[e],n),!0)}function d(t,e,n){var r;if(t)if(t.forEach)t.forEach(e,n);else if(t.length!==i)for(r=0;r<t.length;)e.call(n,t[r],r,t),r++;else for(r in t)t.hasOwnProperty(r)&&e.call(n,t[r],r,t)}function p(t,n,r){var i="DEPRECATED METHOD: "+n+"\n"+r+" AT \n";return function(){var n=new Error("get-stack-trace"),r=n&&n.stack?n.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",o=e.console&&(e.console.warn||e.console.log);return o&&o.call(e.console,i,r),t.apply(this,arguments)}}o="function"!=typeof Object.assign?function(t){if(t===i||null===t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),n=1;n<arguments.length;n++){var r=arguments[n];if(r!==i&&null!==r)for(var o in r)r.hasOwnProperty(o)&&(e[o]=r[o])}return e}:Object.assign;var v=p((function(t,e,n){for(var r=Object.keys(e),o=0;o<r.length;)(!n||n&&t[r[o]]===i)&&(t[r[o]]=e[r[o]]),o++;return t}),"extend","Use `assign`."),y=p((function(t,e){return v(t,e,!0)}),"merge","Use `assign`.");function g(t,e,n){var r,i=e.prototype;(r=t.prototype=Object.create(i)).constructor=t,r._super=i,n&&o(r,n)}function m(t,e){return function(){return t.apply(e,arguments)}}function b(t,e){return"function"==typeof t?t.apply(e&&e[0]||i,e):t}function w(t,e){return t===i?e:t}function _(t,e,n){d(E(e),(function(e){t.addEventListener(e,n,!1)}))}function x(t,e,n){d(E(e),(function(e){t.removeEventListener(e,n,!1)}))}function S(t,e){for(;t;){if(t==e)return!0;t=t.parentNode}return!1}function T(t,e){return t.indexOf(e)>-1}function E(t){return t.trim().split(/\s+/g)}function A(t,e,n){if(t.indexOf&&!n)return t.indexOf(e);for(var r=0;r<t.length;){if(n&&t[r][n]==e||!n&&t[r]===e)return r;r++}return-1}function O(t){return Array.prototype.slice.call(t,0)}function k(t,e,n){for(var r=[],i=[],o=0;o<t.length;){var a=e?t[o][e]:t[o];A(i,a)<0&&r.push(t[o]),i[o]=a,o++}return n&&(r=e?r.sort((function(t,n){return t[e]>n[e]})):r.sort()),r}function C(t,e){for(var n,r,o=e[0].toUpperCase()+e.slice(1),s=0;s<a.length;){if((r=(n=a[s])?n+o:e)in t)return r;s++}return i}var L=1;function P(t){var n=t.ownerDocument||t;return n.defaultView||n.parentWindow||e}var D="ontouchstart"in e,M=C(e,"PointerEvent")!==i,R=D&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),I="touch",j="mouse",z=24,N=["x","y"],F=["clientX","clientY"];function B(t,e){var n=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){b(t.options.enable,[t])&&n.handler(e)},this.init()}function W(t,e,n){var r=n.pointers.length,o=n.changedPointers.length,a=1&e&&r-o==0,s=12&e&&r-o==0;n.isFirst=!!a,n.isFinal=!!s,a&&(t.session={}),n.eventType=e,function(t,e){var n=t.session,r=e.pointers,o=r.length;n.firstInput||(n.firstInput=Y(e));o>1&&!n.firstMultiple?n.firstMultiple=Y(e):1===o&&(n.firstMultiple=!1);var a=n.firstInput,s=n.firstMultiple,u=s?s.center:a.center,h=e.center=G(r);e.timeStamp=c(),e.deltaTime=e.timeStamp-a.timeStamp,e.angle=Z(u,h),e.distance=U(u,h),function(t,e){var n=e.center,r=t.offsetDelta||{},i=t.prevDelta||{},o=t.prevInput||{};1!==e.eventType&&4!==o.eventType||(i=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},r=t.offsetDelta={x:n.x,y:n.y});e.deltaX=i.x+(n.x-r.x),e.deltaY=i.y+(n.y-r.y)}(n,e),e.offsetDirection=X(e.deltaX,e.deltaY);var f=V(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=f.x,e.overallVelocityY=f.y,e.overallVelocity=l(f.x)>l(f.y)?f.x:f.y,e.scale=s?(d=s.pointers,p=r,U(p[0],p[1],F)/U(d[0],d[1],F)):1,e.rotation=s?function(t,e){return Z(e[1],e[0],F)+Z(t[1],t[0],F)}(s.pointers,r):0,e.maxPointers=n.prevInput?e.pointers.length>n.prevInput.maxPointers?e.pointers.length:n.prevInput.maxPointers:e.pointers.length,function(t,e){var n,r,o,a,s=t.lastInterval||e,u=e.timeStamp-s.timeStamp;if(8!=e.eventType&&(u>25||s.velocity===i)){var c=e.deltaX-s.deltaX,h=e.deltaY-s.deltaY,f=V(u,c,h);r=f.x,o=f.y,n=l(f.x)>l(f.y)?f.x:f.y,a=X(c,h),t.lastInterval=e}else n=s.velocity,r=s.velocityX,o=s.velocityY,a=s.direction;e.velocity=n,e.velocityX=r,e.velocityY=o,e.direction=a}(n,e);var d,p;var v=t.element;S(e.srcEvent.target,v)&&(v=e.srcEvent.target);e.target=v}(t,n),t.emit("hammer.input",n),t.recognize(n),t.session.prevInput=n}function Y(t){for(var e=[],n=0;n<t.pointers.length;)e[n]={clientX:u(t.pointers[n].clientX),clientY:u(t.pointers[n].clientY)},n++;return{timeStamp:c(),pointers:e,center:G(e),deltaX:t.deltaX,deltaY:t.deltaY}}function G(t){var e=t.length;if(1===e)return{x:u(t[0].clientX),y:u(t[0].clientY)};for(var n=0,r=0,i=0;i<e;)n+=t[i].clientX,r+=t[i].clientY,i++;return{x:u(n/e),y:u(r/e)}}function V(t,e,n){return{x:e/t||0,y:n/t||0}}function X(t,e){return t===e?1:l(t)>=l(e)?t<0?2:4:e<0?8:16}function U(t,e,n){n||(n=N);var r=e[n[0]]-t[n[0]],i=e[n[1]]-t[n[1]];return Math.sqrt(r*r+i*i)}function Z(t,e,n){n||(n=N);var r=e[n[0]]-t[n[0]],i=e[n[1]]-t[n[1]];return 180*Math.atan2(i,r)/Math.PI}B.prototype={handler:function(){},init:function(){this.evEl&&_(this.element,this.evEl,this.domHandler),this.evTarget&&_(this.target,this.evTarget,this.domHandler),this.evWin&&_(P(this.element),this.evWin,this.domHandler)},destroy:function(){this.evEl&&x(this.element,this.evEl,this.domHandler),this.evTarget&&x(this.target,this.evTarget,this.domHandler),this.evWin&&x(P(this.element),this.evWin,this.domHandler)}};var H={mousedown:1,mousemove:2,mouseup:4},q="mousedown",$="mousemove mouseup";function Q(){this.evEl=q,this.evWin=$,this.pressed=!1,B.apply(this,arguments)}g(Q,B,{handler:function(t){var e=H[t.type];1&e&&0===t.button&&(this.pressed=!0),2&e&&1!==t.which&&(e=4),this.pressed&&(4&e&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:j,srcEvent:t}))}});var K={pointerdown:1,pointermove:2,pointerup:4,pointercancel:8,pointerout:8},J={2:I,3:"pen",4:j,5:"kinect"},tt="pointerdown",et="pointermove pointerup pointercancel";function nt(){this.evEl=tt,this.evWin=et,B.apply(this,arguments),this.store=this.manager.session.pointerEvents=[]}e.MSPointerEvent&&!e.PointerEvent&&(tt="MSPointerDown",et="MSPointerMove MSPointerUp MSPointerCancel"),g(nt,B,{handler:function(t){var e=this.store,n=!1,r=t.type.toLowerCase().replace("ms",""),i=K[r],o=J[t.pointerType]||t.pointerType,a=o==I,s=A(e,t.pointerId,"pointerId");1&i&&(0===t.button||a)?s<0&&(e.push(t),s=e.length-1):12&i&&(n=!0),s<0||(e[s]=t,this.callback(this.manager,i,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),n&&e.splice(s,1))}});var rt={touchstart:1,touchmove:2,touchend:4,touchcancel:8},it="touchstart",ot="touchstart touchmove touchend touchcancel";function at(){this.evTarget=it,this.evWin=ot,this.started=!1,B.apply(this,arguments)}function st(t,e){var n=O(t.touches),r=O(t.changedTouches);return 12&e&&(n=k(n.concat(r),"identifier",!0)),[n,r]}g(at,B,{handler:function(t){var e=rt[t.type];if(1===e&&(this.started=!0),this.started){var n=st.call(this,t,e);12&e&&n[0].length-n[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:n[0],changedPointers:n[1],pointerType:I,srcEvent:t})}}});var ut={touchstart:1,touchmove:2,touchend:4,touchcancel:8},lt="touchstart touchmove touchend touchcancel";function ct(){this.evTarget=lt,this.targetIds={},B.apply(this,arguments)}function ht(t,e){var n=O(t.touches),r=this.targetIds;if(3&e&&1===n.length)return r[n[0].identifier]=!0,[n,n];var i,o,a=O(t.changedTouches),s=[],u=this.target;if(o=n.filter((function(t){return S(t.target,u)})),1===e)for(i=0;i<o.length;)r[o[i].identifier]=!0,i++;for(i=0;i<a.length;)r[a[i].identifier]&&s.push(a[i]),12&e&&delete r[a[i].identifier],i++;return s.length?[k(o.concat(s),"identifier",!0),s]:void 0}g(ct,B,{handler:function(t){var e=ut[t.type],n=ht.call(this,t,e);n&&this.callback(this.manager,e,{pointers:n[0],changedPointers:n[1],pointerType:I,srcEvent:t})}});function ft(){B.apply(this,arguments);var t=m(this.handler,this);this.touch=new ct(this.manager,t),this.mouse=new Q(this.manager,t),this.primaryTouch=null,this.lastTouches=[]}function dt(t,e){1&t?(this.primaryTouch=e.changedPointers[0].identifier,pt.call(this,e)):12&t&&pt.call(this,e)}function pt(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var n={x:e.clientX,y:e.clientY};this.lastTouches.push(n);var r=this.lastTouches;setTimeout((function(){var t=r.indexOf(n);t>-1&&r.splice(t,1)}),2500)}}function vt(t){for(var e=t.srcEvent.clientX,n=t.srcEvent.clientY,r=0;r<this.lastTouches.length;r++){var i=this.lastTouches[r],o=Math.abs(e-i.x),a=Math.abs(n-i.y);if(o<=25&&a<=25)return!0}return!1}g(ft,B,{handler:function(t,e,n){var r=n.pointerType==I,i=n.pointerType==j;if(!(i&&n.sourceCapabilities&&n.sourceCapabilities.firesTouchEvents)){if(r)dt.call(this,e,n);else if(i&&vt.call(this,n))return;this.callback(t,e,n)}},destroy:function(){this.touch.destroy(),this.mouse.destroy()}});var yt=C(s.style,"touchAction"),gt=yt!==i,mt="compute",bt="auto",wt="manipulation",_t="none",xt="pan-x",St="pan-y",Tt=function(){if(!gt)return!1;var t={},n=e.CSS&&e.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(r){t[r]=!n||e.CSS.supports("touch-action",r)})),t}();function Et(t,e){this.manager=t,this.set(e)}Et.prototype={set:function(t){t==mt&&(t=this.compute()),gt&&this.manager.element.style&&Tt[t]&&(this.manager.element.style[yt]=t),this.actions=t.toLowerCase().trim()},update:function(){this.set(this.manager.options.touchAction)},compute:function(){var t=[];return d(this.manager.recognizers,(function(e){b(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(T(t,_t))return _t;var e=T(t,xt),n=T(t,St);if(e&&n)return _t;if(e||n)return e?xt:St;if(T(t,wt))return wt;return bt}(t.join(" "))},preventDefaults:function(t){var e=t.srcEvent,n=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var r=this.actions,i=T(r,_t)&&!Tt.none,o=T(r,St)&&!Tt["pan-y"],a=T(r,xt)&&!Tt["pan-x"];if(i){var s=1===t.pointers.length,u=t.distance<2,l=t.deltaTime<250;if(s&&u&&l)return}if(!a||!o)return i||o&&6&n||a&&n&z?this.preventSrc(e):void 0}},preventSrc:function(t){this.manager.session.prevented=!0,t.preventDefault()}};var At=32;function Ot(t){this.options=o({},this.defaults,t||{}),this.id=L++,this.manager=null,this.options.enable=w(this.options.enable,!0),this.state=1,this.simultaneous={},this.requireFail=[]}function kt(t){return 16&t?"cancel":8&t?"end":4&t?"move":2&t?"start":""}function Ct(t){return 16==t?"down":8==t?"up":2==t?"left":4==t?"right":""}function Lt(t,e){var n=e.manager;return n?n.get(t):t}function Pt(){Ot.apply(this,arguments)}function Dt(){Pt.apply(this,arguments),this.pX=null,this.pY=null}function Mt(){Pt.apply(this,arguments)}function Rt(){Ot.apply(this,arguments),this._timer=null,this._input=null}function It(){Pt.apply(this,arguments)}function jt(){Pt.apply(this,arguments)}function zt(){Ot.apply(this,arguments),this.pTime=!1,this.pCenter=!1,this._timer=null,this._input=null,this.count=0}function Nt(t,e){return(e=e||{}).recognizers=w(e.recognizers,Nt.defaults.preset),new Ft(t,e)}Ot.prototype={defaults:{},set:function(t){return o(this.options,t),this.manager&&this.manager.touchAction.update(),this},recognizeWith:function(t){if(f(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=Lt(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},dropRecognizeWith:function(t){return f(t,"dropRecognizeWith",this)||(t=Lt(t,this),delete this.simultaneous[t.id]),this},requireFailure:function(t){if(f(t,"requireFailure",this))return this;var e=this.requireFail;return-1===A(e,t=Lt(t,this))&&(e.push(t),t.requireFailure(this)),this},dropRequireFailure:function(t){if(f(t,"dropRequireFailure",this))return this;t=Lt(t,this);var e=A(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},hasRequireFailures:function(){return this.requireFail.length>0},canRecognizeWith:function(t){return!!this.simultaneous[t.id]},emit:function(t){var e=this,n=this.state;function r(n){e.manager.emit(n,t)}n<8&&r(e.options.event+kt(n)),r(e.options.event),t.additionalEvent&&r(t.additionalEvent),n>=8&&r(e.options.event+kt(n))},tryEmit:function(t){if(this.canEmit())return this.emit(t);this.state=At},canEmit:function(){for(var t=0;t<this.requireFail.length;){if(!(33&this.requireFail[t].state))return!1;t++}return!0},recognize:function(t){var e=o({},t);if(!b(this.options.enable,[this,e]))return this.reset(),void(this.state=At);56&this.state&&(this.state=1),this.state=this.process(e),30&this.state&&this.tryEmit(e)},process:function(t){},getTouchAction:function(){},reset:function(){}},g(Pt,Ot,{defaults:{pointers:1},attrTest:function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},process:function(t){var e=this.state,n=t.eventType,r=6&e,i=this.attrTest(t);return r&&(8&n||!i)?16|e:r||i?4&n?8|e:2&e?4|e:2:At}}),g(Dt,Pt,{defaults:{event:"pan",threshold:10,pointers:1,direction:30},getTouchAction:function(){var t=this.options.direction,e=[];return 6&t&&e.push(St),t&z&&e.push(xt),e},directionTest:function(t){var e=this.options,n=!0,r=t.distance,i=t.direction,o=t.deltaX,a=t.deltaY;return i&e.direction||(6&e.direction?(i=0===o?1:o<0?2:4,n=o!=this.pX,r=Math.abs(t.deltaX)):(i=0===a?1:a<0?8:16,n=a!=this.pY,r=Math.abs(t.deltaY))),t.direction=i,n&&r>e.threshold&&i&e.direction},attrTest:function(t){return Pt.prototype.attrTest.call(this,t)&&(2&this.state||!(2&this.state)&&this.directionTest(t))},emit:function(t){this.pX=t.deltaX,this.pY=t.deltaY;var e=Ct(t.direction);e&&(t.additionalEvent=this.options.event+e),this._super.emit.call(this,t)}}),g(Mt,Pt,{defaults:{event:"pinch",threshold:0,pointers:2},getTouchAction:function(){return[_t]},attrTest:function(t){return this._super.attrTest.call(this,t)&&(Math.abs(t.scale-1)>this.options.threshold||2&this.state)},emit:function(t){if(1!==t.scale){var e=t.scale<1?"in":"out";t.additionalEvent=this.options.event+e}this._super.emit.call(this,t)}}),g(Rt,Ot,{defaults:{event:"press",pointers:1,time:251,threshold:9},getTouchAction:function(){return[bt]},process:function(t){var e=this.options,n=t.pointers.length===e.pointers,r=t.distance<e.threshold,i=t.deltaTime>e.time;if(this._input=t,!r||!n||12&t.eventType&&!i)this.reset();else if(1&t.eventType)this.reset(),this._timer=h((function(){this.state=8,this.tryEmit()}),e.time,this);else if(4&t.eventType)return 8;return At},reset:function(){clearTimeout(this._timer)},emit:function(t){8===this.state&&(t&&4&t.eventType?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=c(),this.manager.emit(this.options.event,this._input)))}}),g(It,Pt,{defaults:{event:"rotate",threshold:0,pointers:2},getTouchAction:function(){return[_t]},attrTest:function(t){return this._super.attrTest.call(this,t)&&(Math.abs(t.rotation)>this.options.threshold||2&this.state)}}),g(jt,Pt,{defaults:{event:"swipe",threshold:10,velocity:.3,direction:30,pointers:1},getTouchAction:function(){return Dt.prototype.getTouchAction.call(this)},attrTest:function(t){var e,n=this.options.direction;return 30&n?e=t.overallVelocity:6&n?e=t.overallVelocityX:n&z&&(e=t.overallVelocityY),this._super.attrTest.call(this,t)&&n&t.offsetDirection&&t.distance>this.options.threshold&&t.maxPointers==this.options.pointers&&l(e)>this.options.velocity&&4&t.eventType},emit:function(t){var e=Ct(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)}}),g(zt,Ot,{defaults:{event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},getTouchAction:function(){return[wt]},process:function(t){var e=this.options,n=t.pointers.length===e.pointers,r=t.distance<e.threshold,i=t.deltaTime<e.time;if(this.reset(),1&t.eventType&&0===this.count)return this.failTimeout();if(r&&i&&n){if(4!=t.eventType)return this.failTimeout();var o=!this.pTime||t.timeStamp-this.pTime<e.interval,a=!this.pCenter||U(this.pCenter,t.center)<e.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,a&&o?this.count+=1:this.count=1,this._input=t,0===this.count%e.taps)return this.hasRequireFailures()?(this._timer=h((function(){this.state=8,this.tryEmit()}),e.interval,this),2):8}return At},failTimeout:function(){return this._timer=h((function(){this.state=At}),this.options.interval,this),At},reset:function(){clearTimeout(this._timer)},emit:function(){8==this.state&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))}}),Nt.VERSION="2.0.7",Nt.defaults={domEvents:!1,touchAction:mt,enable:!0,inputTarget:null,inputClass:null,preset:[[It,{enable:!1}],[Mt,{enable:!1},["rotate"]],[jt,{direction:6}],[Dt,{direction:6},["swipe"]],[zt],[zt,{event:"doubletap",taps:2},["tap"]],[Rt]],cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}};function Ft(t,e){var n;this.options=o({},Nt.defaults,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((n=this).options.inputClass||(M?nt:R?ct:D?ft:Q))(n,W),this.touchAction=new Et(this,this.options.touchAction),Bt(this,!0),d(this.options.recognizers,(function(t){var e=this.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}function Bt(t,e){var n,r=t.element;r.style&&(d(t.options.cssProps,(function(i,o){n=C(r.style,o),e?(t.oldCssProps[n]=r.style[n],r.style[n]=i):r.style[n]=t.oldCssProps[n]||""})),e||(t.oldCssProps={}))}Ft.prototype={set:function(t){return o(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},stop:function(t){this.session.stopped=t?2:1},recognize:function(t){var e=this.session;if(!e.stopped){var n;this.touchAction.preventDefaults(t);var r=this.recognizers,i=e.curRecognizer;(!i||i&&8&i.state)&&(i=e.curRecognizer=null);for(var o=0;o<r.length;)n=r[o],2===e.stopped||i&&n!=i&&!n.canRecognizeWith(i)?n.reset():n.recognize(t),!i&&14&n.state&&(i=e.curRecognizer=n),o++}},get:function(t){if(t instanceof Ot)return t;for(var e=this.recognizers,n=0;n<e.length;n++)if(e[n].options.event==t)return e[n];return null},add:function(t){if(f(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},remove:function(t){if(f(t,"remove",this))return this;if(t=this.get(t)){var e=this.recognizers,n=A(e,t);-1!==n&&(e.splice(n,1),this.touchAction.update())}return this},on:function(t,e){if(t!==i&&e!==i){var n=this.handlers;return d(E(t),(function(t){n[t]=n[t]||[],n[t].push(e)})),this}},off:function(t,e){if(t!==i){var n=this.handlers;return d(E(t),(function(t){e?n[t]&&n[t].splice(A(n[t],e),1):delete n[t]})),this}},emit:function(t,e){this.options.domEvents&&function(t,e){var r=n.createEvent("Event");r.initEvent(t,!0,!0),r.gesture=e,e.target.dispatchEvent(r)}(t,e);var r=this.handlers[t]&&this.handlers[t].slice();if(r&&r.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var i=0;i<r.length;)r[i](e),i++}},destroy:function(){this.element&&Bt(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null}},o(Nt,{INPUT_START:1,INPUT_MOVE:2,INPUT_END:4,INPUT_CANCEL:8,STATE_POSSIBLE:1,STATE_BEGAN:2,STATE_CHANGED:4,STATE_ENDED:8,STATE_RECOGNIZED:8,STATE_CANCELLED:16,STATE_FAILED:At,DIRECTION_NONE:1,DIRECTION_LEFT:2,DIRECTION_RIGHT:4,DIRECTION_UP:8,DIRECTION_DOWN:16,DIRECTION_HORIZONTAL:6,DIRECTION_VERTICAL:z,DIRECTION_ALL:30,Manager:Ft,Input:B,TouchAction:Et,TouchInput:ct,MouseInput:Q,PointerEventInput:nt,TouchMouseInput:ft,SingleTouchInput:at,Recognizer:Ot,AttrRecognizer:Pt,Tap:zt,Pan:Dt,Swipe:jt,Pinch:Mt,Rotate:It,Press:Rt,on:_,off:x,each:d,merge:y,extend:v,assign:o,inherit:g,bindFn:m,prefixed:C}),(void 0!==e?e:"undefined"!=typeof self?self:{}).Hammer=Nt,t.exports?t.exports=Nt:e.Hammer=Nt}(window,document)}));"undefined"!=typeof window?Pl=function t(e,n){var r=n||{preventDefault:!1};if(e.Manager){var i=e,o=function(e,n){var o=Object.create(r);return n&&i.assign(o,n),t(new i(e,o),o)};return i.assign(o,i),o.Manager=function(e,n){var o=Object.create(r);return n&&i.assign(o,n),t(new i.Manager(e,o),o)},o}var a=Object.create(e),s=e.element;function u(t){return t.match(/[^ ]+/g)}function l(t){if("hammer.input"!==t.type){if(t.srcEvent._handled||(t.srcEvent._handled={}),t.srcEvent._handled[t.type])return;t.srcEvent._handled[t.type]=!0}var e=!1;t.stopPropagation=function(){e=!0};var n=t.srcEvent.stopPropagation.bind(t.srcEvent);"function"==typeof n&&(t.srcEvent.stopPropagation=function(){n(),t.stopPropagation()}),t.firstTarget=Ll;for(var r=Ll;r&&!e;){var i=r.hammer;if(i)for(var o,a=0;a<i.length;a++)if(o=i[a]._handlers[t.type])for(var s=0;s<o.length&&!e;s++)o[s](t);r=r.parentNode}}return s.hammer||(s.hammer=[]),s.hammer.push(a),e.on("hammer.input",(function(t){!0!==r.preventDefault&&r.preventDefault!==t.pointerType||t.preventDefault(),t.isFirst&&(Ll=t.target)})),a._handlers={},a.on=function(t,n){return u(t).forEach((function(t){var r=a._handlers[t];r||(a._handlers[t]=r=[],e.on(t,l)),r.push(n)})),a},a.off=function(t,n){return u(t).forEach((function(t){var r=a._handlers[t];r&&((r=n?r.filter((function(t){return t!==n})):[]).length>0?a._handlers[t]=r:(e.off(t,l),delete a._handlers[t]))})),a},a.emit=function(t,n){Ll=n.target,e.emit(t,n)},a.destroy=function(){var t=e.element.hammer,n=t.indexOf(a);-1!==n&&t.splice(n,1),t.length||delete e.element.hammer,a._handlers={},e.destroy()},a}(window.Hammer||Dl,{preventDefault:"mouse"}):Pl=function(){return{on:t=function(){},off:t,destroy:t,emit:t,get:function(e){return{set:t}}};var t};var Ml=Pl,Rl=Object.freeze({__proto__:null,default:Ml});var Il=Object.freeze({__proto__:null,default:function(t){var e,n=t&&t.preventDefault||!1,r=t&&t.container||window,i={},o={keydown:{},keyup:{}},a={};for(e=97;e<=122;e++)a[String.fromCharCode(e)]={code:e-97+65,shift:!1};for(e=65;e<=90;e++)a[String.fromCharCode(e)]={code:e,shift:!0};for(e=0;e<=9;e++)a[""+e]={code:48+e,shift:!1};for(e=1;e<=12;e++)a["F"+e]={code:111+e,shift:!1};for(e=0;e<=9;e++)a["num"+e]={code:96+e,shift:!1};a["num*"]={code:106,shift:!1},a["num+"]={code:107,shift:!1},a["num-"]={code:109,shift:!1},a["num/"]={code:111,shift:!1},a["num."]={code:110,shift:!1},a.left={code:37,shift:!1},a.up={code:38,shift:!1},a.right={code:39,shift:!1},a.down={code:40,shift:!1},a.space={code:32,shift:!1},a.enter={code:13,shift:!1},a.shift={code:16,shift:void 0},a.esc={code:27,shift:!1},a.backspace={code:8,shift:!1},a.tab={code:9,shift:!1},a.ctrl={code:17,shift:!1},a.alt={code:18,shift:!1},a.delete={code:46,shift:!1},a.pageup={code:33,shift:!1},a.pagedown={code:34,shift:!1},a["="]={code:187,shift:!1},a["-"]={code:189,shift:!1},a["]"]={code:221,shift:!1},a["["]={code:219,shift:!1};var s=function(t){l(t,"keydown")},u=function(t){l(t,"keyup")},l=function(t,e){if(void 0!==o[e][t.keyCode]){for(var r=o[e][t.keyCode],i=0;i<r.length;i++)(void 0===r[i].shift||1==r[i].shift&&1==t.shiftKey||0==r[i].shift&&0==t.shiftKey)&&r[i].fn(t);1==n&&t.preventDefault()}};return i.bind=function(t,e,n){if(void 0===n&&(n="keydown"),void 0===a[t])throw new Error("unsupported key: "+t);void 0===o[n][a[t].code]&&(o[n][a[t].code]=[]),o[n][a[t].code].push({fn:e,shift:a[t].shift})},i.bindAll=function(t,e){for(var n in void 0===e&&(e="keydown"),a)a.hasOwnProperty(n)&&i.bind(n,t,e)},i.getKey=function(t){for(var e in a)if(a.hasOwnProperty(e)){if(1==t.shiftKey&&1==a[e].shift&&t.keyCode==a[e].code)return e;if(0==t.shiftKey&&0==a[e].shift&&t.keyCode==a[e].code)return e;if(t.keyCode==a[e].code&&"shift"==e)return e}return"unknown key, currently not supported"},i.unbind=function(t,e,n){if(void 0===n&&(n="keydown"),void 0===a[t])throw new Error("unsupported key: "+t);if(void 0!==e){var r=[],i=o[n][a[t].code];if(void 0!==i)for(var s=0;s<i.length;s++)i[s].fn==e&&i[s].shift==a[t].shift||r.push(o[n][a[t].code][s]);o[n][a[t].code]=r}else o[n][a[t].code]=[]},i.reset=function(){o={keydown:{},keyup:{}}},i.destroy=function(){o={keydown:{},keyup:{}},r.removeEventListener("keydown",s,!0),r.removeEventListener("keyup",u,!0)},r.addEventListener("keydown",s,!0),r.addEventListener("keyup",u,!0),i}}),jl=r(ia),zl=r(Tu),Nl=r(Cl),Fl=r(qu),Bl=r(Sl),Wl=r(Nu),Yl=r(Rl),Gl=r(Il),Vl=jl,Xl=oa,Ul=zl.DataSet,Zl=zl.DataView,Hl=zl.Queue,ql=Nl,$l={Camera:Fl,Filter:Bl,Point2d:ju,Point3d:Iu,Slider:Wl,StepNumber:Bu},Ql=Yl,Kl=Gl,Jl={util:Vl,DOMutil:Xl,DataSet:Ul,DataView:Zl,Queue:Hl,Graph3d:ql,graph3d:$l,Hammer:Ql,keycharm:Kl};t.DOMutil=Xl,t.DataSet=Ul,t.DataView=Zl,t.Graph3d=ql,t.Hammer=Ql,t.Queue=Hl,t.default=Jl,t.graph3d=$l,t.keycharm=Kl,t.util=Vl,Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-graph3d.min.js.map
