/**
 * vis-graph3d
 * https://visjs.github.io/vis-graph3d/
 *
 * Create interactive, animated 3d graphs. Surfaces, lines, dots and block styling out of the box.
 *
 * @version 6.0.1
 * @date    2020-12-16T19:56:54.897Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
import{DataView as t,DataSet as e}from"vis-data/peer/esm/vis-data.js";var i="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function r(t,e,i){return t(i={path:e,exports:{},require:function(t,e){return function(){throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs")}(null==e&&i.path)}},i.exports),i.exports}var n=function(t){return t&&t.Math==Math&&t},o=n("object"==typeof globalThis&&globalThis)||n("object"==typeof window&&window)||n("object"==typeof self&&self)||n("object"==typeof i&&i)||function(){return this}()||Function("return this")(),a=function(t){try{return!!t()}catch(t){return!0}},s=!a((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),l={}.propertyIsEnumerable,h=Object.getOwnPropertyDescriptor,c={f:h&&!l.call({1:2},1)?function(t){var e=h(this,t);return!!e&&e.enumerable}:l},u=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},f={}.toString,d=function(t){return f.call(t).slice(8,-1)},p="".split,y=a((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==d(t)?p.call(t,""):Object(t)}:Object,v=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},m=function(t){return y(v(t))},g=function(t){return"object"==typeof t?null!==t:"function"==typeof t},b=function(t,e){if(!g(t))return t;var i,r;if(e&&"function"==typeof(i=t.toString)&&!g(r=i.call(t)))return r;if("function"==typeof(i=t.valueOf)&&!g(r=i.call(t)))return r;if(!e&&"function"==typeof(i=t.toString)&&!g(r=i.call(t)))return r;throw TypeError("Can't convert object to primitive value")},x={}.hasOwnProperty,w=function(t,e){return x.call(t,e)},_=o.document,S=g(_)&&g(_.createElement),L=function(t){return S?_.createElement(t):{}},C=!s&&!a((function(){return 7!=Object.defineProperty(L("div"),"a",{get:function(){return 7}}).a})),A=Object.getOwnPropertyDescriptor,T={f:s?A:function(t,e){if(t=m(t),e=b(e,!0),C)try{return A(t,e)}catch(t){}if(w(t,e))return u(!c.f.call(t,e),t[e])}},O=/#|\.prototype\./,M=function(t,e){var i=E[P(t)];return i==D||i!=R&&("function"==typeof e?a(e):!!e)},P=M.normalize=function(t){return String(t).replace(O,".").toLowerCase()},E=M.data={},R=M.NATIVE="N",D=M.POLYFILL="P",k=M,z={},I=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},j=function(t,e,i){if(I(t),void 0===e)return t;switch(i){case 0:return function(){return t.call(e)};case 1:return function(i){return t.call(e,i)};case 2:return function(i,r){return t.call(e,i,r)};case 3:return function(i,r,n){return t.call(e,i,r,n)}}return function(){return t.apply(e,arguments)}},B=function(t){if(!g(t))throw TypeError(String(t)+" is not an object");return t},F=Object.defineProperty,W={f:s?F:function(t,e,i){if(B(t),e=b(e,!0),B(i),C)try{return F(t,e,i)}catch(t){}if("get"in i||"set"in i)throw TypeError("Accessors not supported");return"value"in i&&(t[e]=i.value),t}},G=s?function(t,e,i){return W.f(t,e,u(1,i))}:function(t,e,i){return t[e]=i,t},N=T.f,Y=function(t){var e=function(e,i,r){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,i)}return new t(e,i,r)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},V=function(t,e){var i,r,n,a,s,l,h,c,u=t.target,f=t.global,d=t.stat,p=t.proto,y=f?o:d?o[u]:(o[u]||{}).prototype,v=f?z:z[u]||(z[u]={}),m=v.prototype;for(n in e)i=!k(f?n:u+(d?".":"#")+n,t.forced)&&y&&w(y,n),s=v[n],i&&(l=t.noTargetGet?(c=N(y,n))&&c.value:y[n]),a=i&&l?l:e[n],i&&typeof s==typeof a||(h=t.bind&&i?j(a,o):t.wrap&&i?Y(a):p&&"function"==typeof a?j(Function.call,a):a,(t.sham||a&&a.sham||s&&s.sham)&&G(h,"sham",!0),v[n]=h,p&&(w(z,r=u+"Prototype")||G(z,r,{}),z[r][n]=a,t.real&&m&&!m[n]&&G(m,n,a)))},X=Math.ceil,Z=Math.floor,U=function(t){return isNaN(t=+t)?0:(t>0?Z:X)(t)},H=Math.min,$=function(t){return t>0?H(U(t),9007199254740991):0},J=Math.max,q=Math.min,K=function(t,e){var i=U(t);return i<0?J(i+e,0):q(i,e)},Q=function(t){return function(e,i,r){var n,o=m(e),a=$(o.length),s=K(r,a);if(t&&i!=i){for(;a>s;)if((n=o[s++])!=n)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===i)return t||s||0;return!t&&-1}},tt={includes:Q(!0),indexOf:Q(!1)},et={},it=tt.indexOf,rt=function(t,e){var i,r=m(t),n=0,o=[];for(i in r)!w(et,i)&&w(r,i)&&o.push(i);for(;e.length>n;)w(r,i=e[n++])&&(~it(o,i)||o.push(i));return o},nt=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],ot=Object.keys||function(t){return rt(t,nt)},at={f:Object.getOwnPropertySymbols},st=function(t){return Object(v(t))},lt=Object.assign,ht=Object.defineProperty,ct=!lt||a((function(){if(s&&1!==lt({b:1},lt(ht({},"a",{enumerable:!0,get:function(){ht(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},i=Symbol(),r="abcdefghijklmnopqrst";return t[i]=7,r.split("").forEach((function(t){e[t]=t})),7!=lt({},t)[i]||ot(lt({},e)).join("")!=r}))?function(t,e){for(var i=st(t),r=arguments.length,n=1,o=at.f,a=c.f;r>n;)for(var l,h=y(arguments[n++]),u=o?ot(h).concat(o(h)):ot(h),f=u.length,d=0;f>d;)l=u[d++],s&&!a.call(h,l)||(i[l]=h[l]);return i}:lt;V({target:"Object",stat:!0,forced:Object.assign!==ct},{assign:ct});var ut=z.Object.assign,ft=function(t){return"function"==typeof t?t:void 0},dt=function(t,e){return arguments.length<2?ft(z[t])||ft(o[t]):z[t]&&z[t][e]||o[t]&&o[t][e]},pt=dt("navigator","userAgent")||"",yt=[].slice,vt=/MSIE .\./.test(pt),mt=function(t){return function(e,i){var r=arguments.length>2,n=r?yt.call(arguments,2):void 0;return t(r?function(){("function"==typeof e?e:Function(e)).apply(this,n)}:e,i)}};V({global:!0,bind:!0,forced:vt},{setTimeout:mt(o.setTimeout),setInterval:mt(o.setInterval)});var gt,bt,xt=z.setTimeout,wt=Array.isArray||function(t){return"Array"==d(t)},_t=function(t,e,i){var r=b(e);r in t?W.f(t,r,u(0,i)):t[r]=i},St=o["__core-js_shared__"]||function(t,e){try{G(o,t,e)}catch(i){o[t]=e}return e}("__core-js_shared__",{}),Lt=r((function(t){(t.exports=function(t,e){return St[t]||(St[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.8.1",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),Ct=0,At=Math.random(),Tt=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++Ct+At).toString(36)},Ot=!!Object.getOwnPropertySymbols&&!a((function(){return!String(Symbol())})),Mt=Ot&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Pt=Lt("wks"),Et=o.Symbol,Rt=Mt?Et:Et&&Et.withoutSetter||Tt,Dt=function(t){return w(Pt,t)||(Ot&&w(Et,t)?Pt[t]=Et[t]:Pt[t]=Rt("Symbol."+t)),Pt[t]},kt=Dt("species"),zt=function(t,e){var i;return wt(t)&&("function"!=typeof(i=t.constructor)||i!==Array&&!wt(i.prototype)?g(i)&&null===(i=i[kt])&&(i=void 0):i=void 0),new(void 0===i?Array:i)(0===e?0:e)},It=o.process,jt=It&&It.versions,Bt=jt&&jt.v8;Bt?bt=(gt=Bt.split("."))[0]+gt[1]:pt&&(!(gt=pt.match(/Edge\/(\d+)/))||gt[1]>=74)&&(gt=pt.match(/Chrome\/(\d+)/))&&(bt=gt[1]);var Ft=bt&&+bt,Wt=Dt("species"),Gt=function(t){return Ft>=51||!a((function(){var e=[];return(e.constructor={})[Wt]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Nt=Dt("isConcatSpreadable"),Yt=Ft>=51||!a((function(){var t=[];return t[Nt]=!1,t.concat()[0]!==t})),Vt=Gt("concat"),Xt=function(t){if(!g(t))return!1;var e=t[Nt];return void 0!==e?!!e:wt(t)};V({target:"Array",proto:!0,forced:!Yt||!Vt},{concat:function(t){var e,i,r,n,o,a=st(this),s=zt(a,0),l=0;for(e=-1,r=arguments.length;e<r;e++)if(Xt(o=-1===e?a:arguments[e])){if(l+(n=$(o.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(i=0;i<n;i++,l++)i in o&&_t(s,l,o[i])}else{if(l>=9007199254740991)throw TypeError("Maximum allowed index exceeded");_t(s,l++,o)}return s.length=l,s}});var Zt=function(t){return z[t+"Prototype"]},Ut=Zt("Array").concat,Ht=Array.prototype,$t=function(t){var e=t.concat;return t===Ht||t instanceof Array&&e===Ht.concat?Ut:e};V({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var Jt=z.Number.isNaN;V({target:"Array",stat:!0},{isArray:wt});var qt=z.Array.isArray,Kt=qt,Qt={f:Dt},te=W.f,ee=function(t){var e=z.Symbol||(z.Symbol={});w(e,t)||te(e,t,{value:Qt.f(t)})};ee("iterator");var ie=function(t){return function(e,i){var r,n,o=String(v(e)),a=U(i),s=o.length;return a<0||a>=s?t?"":void 0:(r=o.charCodeAt(a))<55296||r>56319||a+1===s||(n=o.charCodeAt(a+1))<56320||n>57343?t?o.charAt(a):r:t?o.slice(a,a+2):n-56320+(r-55296<<10)+65536}},re={codeAt:ie(!1),charAt:ie(!0)},ne=Function.toString;"function"!=typeof St.inspectSource&&(St.inspectSource=function(t){return ne.call(t)});var oe,ae,se,le=St.inspectSource,he=o.WeakMap,ce="function"==typeof he&&/native code/.test(le(he)),ue=Lt("keys"),fe=function(t){return ue[t]||(ue[t]=Tt(t))},de=o.WeakMap;if(ce){var pe=St.state||(St.state=new de),ye=pe.get,ve=pe.has,me=pe.set;oe=function(t,e){return e.facade=t,me.call(pe,t,e),e},ae=function(t){return ye.call(pe,t)||{}},se=function(t){return ve.call(pe,t)}}else{var ge=fe("state");et[ge]=!0,oe=function(t,e){return e.facade=t,G(t,ge,e),e},ae=function(t){return w(t,ge)?t[ge]:{}},se=function(t){return w(t,ge)}}var be,xe,we,_e={set:oe,get:ae,has:se,enforce:function(t){return se(t)?ae(t):oe(t,{})},getterFor:function(t){return function(e){var i;if(!g(e)||(i=ae(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return i}}},Se=!a((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Le=fe("IE_PROTO"),Ce=Object.prototype,Ae=Se?Object.getPrototypeOf:function(t){return t=st(t),w(t,Le)?t[Le]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?Ce:null},Te=(Dt("iterator"),!1);[].keys&&("next"in(we=[].keys())?(xe=Ae(Ae(we)))!==Object.prototype&&(be=xe):Te=!0),null==be&&(be={});var Oe,Me={IteratorPrototype:be,BUGGY_SAFARI_ITERATORS:Te},Pe=s?Object.defineProperties:function(t,e){B(t);for(var i,r=ot(e),n=r.length,o=0;n>o;)W.f(t,i=r[o++],e[i]);return t},Ee=dt("document","documentElement"),Re=fe("IE_PROTO"),De=function(){},ke=function(t){return"<script>"+t+"<\/script>"},ze=function(){try{Oe=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;ze=Oe?function(t){t.write(ke("")),t.close();var e=t.parentWindow.Object;return t=null,e}(Oe):((e=L("iframe")).style.display="none",Ee.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(ke("document.F=Object")),t.close(),t.F);for(var i=nt.length;i--;)delete ze.prototype[nt[i]];return ze()};et[Re]=!0;var Ie=Object.create||function(t,e){var i;return null!==t?(De.prototype=B(t),i=new De,De.prototype=null,i[Re]=t):i=ze(),void 0===e?i:Pe(i,e)},je={};je[Dt("toStringTag")]="z";var Be="[object z]"===String(je),Fe=Dt("toStringTag"),We="Arguments"==d(function(){return arguments}()),Ge=Be?d:function(t){var e,i,r;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(i=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),Fe))?i:We?d(e):"Object"==(r=d(e))&&"function"==typeof e.callee?"Arguments":r},Ne=Be?{}.toString:function(){return"[object "+Ge(this)+"]"},Ye=W.f,Ve=Dt("toStringTag"),Xe=function(t,e,i,r){if(t){var n=i?t:t.prototype;w(n,Ve)||Ye(n,Ve,{configurable:!0,value:e}),r&&!Be&&G(n,"toString",Ne)}},Ze={},Ue=Me.IteratorPrototype,He=function(){return this},$e=(Object.setPrototypeOf||"__proto__"in{}&&function(){var t,e=!1,i={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(i,[]),e=i instanceof Array}catch(t){}}(),function(t,e,i,r){r&&r.enumerable?t[e]=i:G(t,e,i)}),Je=Me.IteratorPrototype,qe=Me.BUGGY_SAFARI_ITERATORS,Ke=Dt("iterator"),Qe=function(){return this},ti=function(t,e,i,r,n,o,a){!function(t,e,i){var r=e+" Iterator";t.prototype=Ie(Ue,{next:u(1,i)}),Xe(t,r,!1,!0),Ze[r]=He}(i,e,r);var s,l,h,c=function(t){if(t===n&&v)return v;if(!qe&&t in p)return p[t];switch(t){case"keys":case"values":case"entries":return function(){return new i(this,t)}}return function(){return new i(this)}},f=e+" Iterator",d=!1,p=t.prototype,y=p[Ke]||p["@@iterator"]||n&&p[n],v=!qe&&y||c(n),m="Array"==e&&p.entries||y;if(m&&(s=Ae(m.call(new t)),Je!==Object.prototype&&s.next&&(Xe(s,f,!0,!0),Ze[f]=Qe)),"values"==n&&y&&"values"!==y.name&&(d=!0,v=function(){return y.call(this)}),a&&p[Ke]!==v&&G(p,Ke,v),Ze[e]=v,n)if(l={values:c("values"),keys:o?v:c("keys"),entries:c("entries")},a)for(h in l)(qe||d||!(h in p))&&$e(p,h,l[h]);else V({target:e,proto:!0,forced:qe||d},l);return l},ei=re.charAt,ii=_e.set,ri=_e.getterFor("String Iterator");ti(String,"String",(function(t){ii(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=ri(this),i=e.string,r=e.index;return r>=i.length?{value:void 0,done:!0}:(t=ei(i,r),e.index+=t.length,{value:t,done:!1})}));var ni=_e.set,oi=_e.getterFor("Array Iterator");ti(Array,"Array",(function(t,e){ni(this,{type:"Array Iterator",target:m(t),index:0,kind:e})}),(function(){var t=oi(this),e=t.target,i=t.kind,r=t.index++;return!e||r>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==i?{value:r,done:!1}:"values"==i?{value:e[r],done:!1}:{value:[r,e[r]],done:!1}}),"values");Ze.Arguments=Ze.Array;var ai=Dt("toStringTag");for(var si in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var li=o[si],hi=li&&li.prototype;hi&&Ge(hi)!==ai&&G(hi,ai,si),Ze[si]=Ze.Array}var ci=Qt.f("iterator"),ui=nt.concat("length","prototype"),fi={f:Object.getOwnPropertyNames||function(t){return rt(t,ui)}},di=fi.f,pi={}.toString,yi="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],vi={f:function(t){return yi&&"[object Window]"==pi.call(t)?function(t){try{return di(t)}catch(t){return yi.slice()}}(t):di(m(t))}},mi=[].push,gi=function(t){var e=1==t,i=2==t,r=3==t,n=4==t,o=6==t,a=7==t,s=5==t||o;return function(l,h,c,u){for(var f,d,p=st(l),v=y(p),m=j(h,c,3),g=$(v.length),b=0,x=u||zt,w=e?x(l,g):i||a?x(l,0):void 0;g>b;b++)if((s||b in v)&&(d=m(f=v[b],b,p),t))if(e)w[b]=d;else if(d)switch(t){case 3:return!0;case 5:return f;case 6:return b;case 2:mi.call(w,f)}else switch(t){case 4:return!1;case 7:mi.call(w,f)}return o?-1:r||n?n:w}},bi={forEach:gi(0),map:gi(1),filter:gi(2),some:gi(3),every:gi(4),find:gi(5),findIndex:gi(6),filterOut:gi(7)},xi=bi.forEach,wi=fe("hidden"),_i=Dt("toPrimitive"),Si=_e.set,Li=_e.getterFor("Symbol"),Ci=Object.prototype,Ai=o.Symbol,Ti=dt("JSON","stringify"),Oi=T.f,Mi=W.f,Pi=vi.f,Ei=c.f,Ri=Lt("symbols"),Di=Lt("op-symbols"),ki=Lt("string-to-symbol-registry"),zi=Lt("symbol-to-string-registry"),Ii=Lt("wks"),ji=o.QObject,Bi=!ji||!ji.prototype||!ji.prototype.findChild,Fi=s&&a((function(){return 7!=Ie(Mi({},"a",{get:function(){return Mi(this,"a",{value:7}).a}})).a}))?function(t,e,i){var r=Oi(Ci,e);r&&delete Ci[e],Mi(t,e,i),r&&t!==Ci&&Mi(Ci,e,r)}:Mi,Wi=function(t,e){var i=Ri[t]=Ie(Ai.prototype);return Si(i,{type:"Symbol",tag:t,description:e}),s||(i.description=e),i},Gi=Mt?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof Ai},Ni=function(t,e,i){t===Ci&&Ni(Di,e,i),B(t);var r=b(e,!0);return B(i),w(Ri,r)?(i.enumerable?(w(t,wi)&&t[wi][r]&&(t[wi][r]=!1),i=Ie(i,{enumerable:u(0,!1)})):(w(t,wi)||Mi(t,wi,u(1,{})),t[wi][r]=!0),Fi(t,r,i)):Mi(t,r,i)},Yi=function(t,e){B(t);var i=m(e),r=ot(i).concat(Ui(i));return xi(r,(function(e){s&&!Vi.call(i,e)||Ni(t,e,i[e])})),t},Vi=function(t){var e=b(t,!0),i=Ei.call(this,e);return!(this===Ci&&w(Ri,e)&&!w(Di,e))&&(!(i||!w(this,e)||!w(Ri,e)||w(this,wi)&&this[wi][e])||i)},Xi=function(t,e){var i=m(t),r=b(e,!0);if(i!==Ci||!w(Ri,r)||w(Di,r)){var n=Oi(i,r);return!n||!w(Ri,r)||w(i,wi)&&i[wi][r]||(n.enumerable=!0),n}},Zi=function(t){var e=Pi(m(t)),i=[];return xi(e,(function(t){w(Ri,t)||w(et,t)||i.push(t)})),i},Ui=function(t){var e=t===Ci,i=Pi(e?Di:m(t)),r=[];return xi(i,(function(t){!w(Ri,t)||e&&!w(Ci,t)||r.push(Ri[t])})),r};if(Ot||($e((Ai=function(){if(this instanceof Ai)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=Tt(t),i=function(t){this===Ci&&i.call(Di,t),w(this,wi)&&w(this[wi],e)&&(this[wi][e]=!1),Fi(this,e,u(1,t))};return s&&Bi&&Fi(Ci,e,{configurable:!0,set:i}),Wi(e,t)}).prototype,"toString",(function(){return Li(this).tag})),$e(Ai,"withoutSetter",(function(t){return Wi(Tt(t),t)})),c.f=Vi,W.f=Ni,T.f=Xi,fi.f=vi.f=Zi,at.f=Ui,Qt.f=function(t){return Wi(Dt(t),t)},s&&Mi(Ai.prototype,"description",{configurable:!0,get:function(){return Li(this).description}})),V({global:!0,wrap:!0,forced:!Ot,sham:!Ot},{Symbol:Ai}),xi(ot(Ii),(function(t){ee(t)})),V({target:"Symbol",stat:!0,forced:!Ot},{for:function(t){var e=String(t);if(w(ki,e))return ki[e];var i=Ai(e);return ki[e]=i,zi[i]=e,i},keyFor:function(t){if(!Gi(t))throw TypeError(t+" is not a symbol");if(w(zi,t))return zi[t]},useSetter:function(){Bi=!0},useSimple:function(){Bi=!1}}),V({target:"Object",stat:!0,forced:!Ot,sham:!s},{create:function(t,e){return void 0===e?Ie(t):Yi(Ie(t),e)},defineProperty:Ni,defineProperties:Yi,getOwnPropertyDescriptor:Xi}),V({target:"Object",stat:!0,forced:!Ot},{getOwnPropertyNames:Zi,getOwnPropertySymbols:Ui}),V({target:"Object",stat:!0,forced:a((function(){at.f(1)}))},{getOwnPropertySymbols:function(t){return at.f(st(t))}}),Ti){var Hi=!Ot||a((function(){var t=Ai();return"[null]"!=Ti([t])||"{}"!=Ti({a:t})||"{}"!=Ti(Object(t))}));V({target:"JSON",stat:!0,forced:Hi},{stringify:function(t,e,i){for(var r,n=[t],o=1;arguments.length>o;)n.push(arguments[o++]);if(r=e,(g(e)||void 0!==t)&&!Gi(t))return wt(e)||(e=function(t,e){if("function"==typeof r&&(e=r.call(this,t,e)),!Gi(e))return e}),n[1]=e,Ti.apply(null,n)}})}Ai.prototype[_i]||G(Ai.prototype,_i,Ai.prototype.valueOf),Xe(Ai,"Symbol"),et[wi]=!0,ee("asyncIterator"),ee("hasInstance"),ee("isConcatSpreadable"),ee("match"),ee("matchAll"),ee("replace"),ee("search"),ee("species"),ee("split"),ee("toPrimitive"),ee("toStringTag"),ee("unscopables"),Xe(o.JSON,"JSON",!0);var $i=z.Symbol;ee("asyncDispose"),ee("dispose"),ee("observable"),ee("patternMatch"),ee("replaceAll");var Ji=$i,qi=r((function(t){function e(i){return t.exports=e="function"==typeof Ji&&"symbol"==typeof ci?function(t){return typeof t}:function(t){return t&&"function"==typeof Ji&&t.constructor===Ji&&t!==Ji.prototype?"symbol":typeof t},e(i)}t.exports=e})),Ki=function(t,e){var i=[][t];return!!i&&a((function(){i.call(null,e||function(){throw 1},1)}))},Qi=Object.defineProperty,tr={},er=function(t){throw t},ir=function(t,e){if(w(tr,t))return tr[t];e||(e={});var i=[][t],r=!!w(e,"ACCESSORS")&&e.ACCESSORS,n=w(e,0)?e[0]:er,o=w(e,1)?e[1]:void 0;return tr[t]=!!i&&!a((function(){if(r&&!s)return!0;var t={length:-1};r?Qi(t,1,{enumerable:!0,get:er}):t[1]=1,i.call(t,n,o)}))},rr=bi.forEach,nr=Ki("forEach"),or=ir("forEach"),ar=nr&&or?[].forEach:function(t){return rr(this,t,arguments.length>1?arguments[1]:void 0)};V({target:"Array",proto:!0,forced:[].forEach!=ar},{forEach:ar});var sr=Zt("Array").forEach,lr=Array.prototype,hr={DOMTokenList:!0,NodeList:!0},cr=function(t){var e=t.forEach;return t===lr||t instanceof Array&&e===lr.forEach||hr.hasOwnProperty(Ge(t))?sr:e},ur=Zt("Array").values,fr=Array.prototype,dr={DOMTokenList:!0,NodeList:!0},pr=function(t){var e=t.values;return t===fr||t instanceof Array&&e===fr.values||dr.hasOwnProperty(Ge(t))?ur:e};V({target:"Array",proto:!0},{fill:function(t){for(var e=st(this),i=$(e.length),r=arguments.length,n=K(r>1?arguments[1]:void 0,i),o=r>2?arguments[2]:void 0,a=void 0===o?i:K(o,i);a>n;)e[n++]=t;return e}});var yr=Zt("Array").fill,vr=Array.prototype,mr=function(t){var e=t.fill;return t===vr||t instanceof Array&&e===vr.fill?yr:e},gr="\t\n\v\f\r                　\u2028\u2029\ufeff",br="["+gr+"]",xr=RegExp("^"+br+br+"*"),wr=RegExp(br+br+"*$"),_r=function(t){return function(e){var i=String(v(e));return 1&t&&(i=i.replace(xr,"")),2&t&&(i=i.replace(wr,"")),i}},Sr={start:_r(1),end:_r(2),trim:_r(3)},Lr=Sr.trim,Cr=o.parseFloat,Ar=1/Cr(gr+"-0")!=-1/0?function(t){var e=Lr(String(t)),i=Cr(e);return 0===i&&"-"==e.charAt(0)?-0:i}:Cr;V({global:!0,forced:parseFloat!=Ar},{parseFloat:Ar});var Tr=z.parseFloat,Or=bi.filter,Mr=Gt("filter"),Pr=ir("filter");V({target:"Array",proto:!0,forced:!Mr||!Pr},{filter:function(t){return Or(this,t,arguments.length>1?arguments[1]:void 0)}});var Er=Zt("Array").filter,Rr=Array.prototype,Dr=function(t){var e=t.filter;return t===Rr||t instanceof Array&&e===Rr.filter?Er:e},kr=tt.indexOf,zr=[].indexOf,Ir=!!zr&&1/[1].indexOf(1,-0)<0,jr=Ki("indexOf"),Br=ir("indexOf",{ACCESSORS:!0,1:0});V({target:"Array",proto:!0,forced:Ir||!jr||!Br},{indexOf:function(t){return Ir?zr.apply(this,arguments)||0:kr(this,t,arguments.length>1?arguments[1]:void 0)}});var Fr=Zt("Array").indexOf,Wr=Array.prototype,Gr=function(t){var e=t.indexOf;return t===Wr||t instanceof Array&&e===Wr.indexOf?Fr:e},Nr=[],Yr=Nr.sort,Vr=a((function(){Nr.sort(void 0)})),Xr=a((function(){Nr.sort(null)})),Zr=Ki("sort");V({target:"Array",proto:!0,forced:Vr||!Xr||!Zr},{sort:function(t){return void 0===t?Yr.call(st(this)):Yr.call(st(this),I(t))}});var Ur=Zt("Array").sort,Hr=Array.prototype,$r=function(t){var e=t.sort;return t===Hr||t instanceof Array&&e===Hr.sort?Ur:e},Jr=r((function(t){function e(t){if(t)return function(t){for(var i in e.prototype)t[i]=e.prototype[i];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function i(){this.off(t,i),e.apply(this,arguments)}return i.fn=e,this.on(t,i),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var i,r=this._callbacks["$"+t];if(!r)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var n=0;n<r.length;n++)if((i=r[n])===e||i.fn===e){r.splice(n,1);break}return 0===r.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),i=this._callbacks["$"+t],r=1;r<arguments.length;r++)e[r-1]=arguments[r];if(i){r=0;for(var n=(i=i.slice(0)).length;r<n;++r)i[r].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}));V({target:"Object",stat:!0,forced:!s,sham:!s},{defineProperty:W.f});var qr=r((function(t){var e=z.Object,i=t.exports=function(t,i,r){return e.defineProperty(t,i,r)};e.defineProperty.sham&&(i.sham=!0)}));V({target:"Object",stat:!0,forced:!s,sham:!s},{defineProperties:Pe});r((function(t){var e=z.Object,i=t.exports=function(t,i){return e.defineProperties(t,i)};e.defineProperties.sham&&(i.sham=!0)}));var Kr=dt("Reflect","ownKeys")||function(t){var e=fi.f(B(t)),i=at.f;return i?e.concat(i(t)):e};V({target:"Object",stat:!0,sham:!s},{getOwnPropertyDescriptors:function(t){for(var e,i,r=m(t),n=T.f,o=Kr(r),a={},s=0;o.length>s;)void 0!==(i=n(r,e=o[s++]))&&_t(a,e,i);return a}});z.Object.getOwnPropertyDescriptors;var Qr=T.f,tn=a((function(){Qr(1)}));V({target:"Object",stat:!0,forced:!s||tn,sham:!s},{getOwnPropertyDescriptor:function(t,e){return Qr(m(t),e)}});r((function(t){var e=z.Object,i=t.exports=function(t,i){return e.getOwnPropertyDescriptor(t,i)};e.getOwnPropertyDescriptor.sham&&(i.sham=!0)})),z.Object.getOwnPropertySymbols;var en=Dt("iterator"),rn=function(t){if(null!=t)return t[en]||t["@@iterator"]||Ze[Ge(t)]},nn=function(t,e,i,r){try{return r?e(B(i)[0],i[1]):e(i)}catch(e){throw function(t){var e=t.return;if(void 0!==e)B(e.call(t)).value}(t),e}},on=Dt("iterator"),an=Array.prototype,sn=function(t){return void 0!==t&&(Ze.Array===t||an[on]===t)},ln=Dt("iterator"),hn=!1;try{var cn=0,un={next:function(){return{done:!!cn++}},return:function(){hn=!0}};un[ln]=function(){return this},Array.from(un,(function(){throw 2}))}catch(t){}var fn=!function(t,e){if(!e&&!hn)return!1;var i=!1;try{var r={};r[ln]=function(){return{next:function(){return{done:i=!0}}}},t(r)}catch(t){}return i}((function(t){Array.from(t)}));V({target:"Array",stat:!0,forced:fn},{from:function(t){var e,i,r,n,o,a,s=st(t),l="function"==typeof this?this:Array,h=arguments.length,c=h>1?arguments[1]:void 0,u=void 0!==c,f=rn(s),d=0;if(u&&(c=j(c,h>2?arguments[2]:void 0,2)),null==f||l==Array&&sn(f))for(i=new l(e=$(s.length));e>d;d++)a=u?c(s[d],d):s[d],_t(i,d,a);else for(o=(n=f.call(s)).next,i=new l;!(r=o.call(n)).done;d++)a=u?nn(n,c,[r.value,d],!0):r.value,_t(i,d,a);return i.length=d,i}});var dn=z.Array.from;V({target:"Object",stat:!0,sham:!s},{create:Ie});var pn,yn=qr,vn=Sr.trim;V({target:"String",proto:!0,forced:(pn="trim",a((function(){return!!gr[pn]()||"​᠎"!="​᠎"[pn]()||gr[pn].name!==pn})))},{trim:function(){return vn(this)}});Zt("String").trim;var mn=Sr.trim,gn=o.parseInt,bn=/^[+-]?0[Xx]/,xn=8!==gn(gr+"08")||22!==gn(gr+"0x16")?function(t,e){var i=mn(String(t));return gn(i,e>>>0||(bn.test(i)?16:10))}:gn;V({global:!0,forced:parseInt!=xn},{parseInt:xn});var wn=z.parseInt,_n=c.f,Sn=function(t){return function(e){for(var i,r=m(e),n=ot(r),o=n.length,a=0,l=[];o>a;)i=n[a++],s&&!_n.call(r,i)||l.push(t?[i,r[i]]:r[i]);return l}},Ln={entries:Sn(!0),values:Sn(!1)}.values;V({target:"Object",stat:!0},{values:function(t){return Ln(t)}});z.Object.values;var Cn=a((function(){Ae(1)}));V({target:"Object",stat:!0,forced:Cn,sham:!Se},{getPrototypeOf:function(t){return Ae(st(t))}});var An=z.Object.getPrototypeOf,Tn=qt,On=Dt("iterator"),Mn=function(t){var e=Object(t);return void 0!==e[On]||"@@iterator"in e||Ze.hasOwnProperty(Ge(e))},Pn=dn,En=Gt("slice"),Rn=ir("slice",{ACCESSORS:!0,0:0,1:2}),Dn=Dt("species"),kn=[].slice,zn=Math.max;V({target:"Array",proto:!0,forced:!En||!Rn},{slice:function(t,e){var i,r,n,o=m(this),a=$(o.length),s=K(t,a),l=K(void 0===e?a:e,a);if(wt(o)&&("function"!=typeof(i=o.constructor)||i!==Array&&!wt(i.prototype)?g(i)&&null===(i=i[Dn])&&(i=void 0):i=void 0,i===Array||void 0===i))return kn.call(o,s,l);for(r=new(void 0===i?Array:i)(zn(l-s,0)),n=0;s<l;s++,n++)s in o&&_t(r,n,o[s]);return r.length=n,r}});var In=Zt("Array").slice,jn=Array.prototype,Bn=function(t){var e=t.slice;return t===jn||t instanceof Array&&e===jn.slice?In:e},Fn=Bn;var Wn=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,r=new Array(e);i<e;i++)r[i]=t[i];return r};var Gn=function(t,e){var i;if(t){if("string"==typeof t)return Wn(t,e);var r=Fn(i=Object.prototype.toString.call(t)).call(i,8,-1);return"Object"===r&&t.constructor&&(r=t.constructor.name),"Map"===r||"Set"===r?Pn(t):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Wn(t,e):void 0}};V({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});z.Date.now;var Nn=a((function(){ot(1)}));V({target:"Object",stat:!0,forced:Nn},{keys:function(t){return ot(st(t))}});var Yn=z.Object.keys,Vn=bi.map,Xn=Gt("map"),Zn=ir("map");V({target:"Array",proto:!0,forced:!Xn||!Zn},{map:function(t){return Vn(this,t,arguments.length>1?arguments[1]:void 0)}});var Un=Zt("Array").map,Hn=Array.prototype,$n=function(t){var e=t.map;return t===Hn||t instanceof Array&&e===Hn.map?Un:e};V({target:"Reflect",stat:!0},{ownKeys:Kr});z.Reflect.ownKeys;var Jn=Bn;var qn=function(t){if(Tn(t))return Wn(t)};var Kn=function(t){if(void 0!==Ji&&Mn(Object(t)))return Pn(t)};var Qn=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var to=function(t){return qn(t)||Kn(t)||Gn(t)||Qn()},eo=($i("DELETE"),/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i),io=/^#?([a-f\d])([a-f\d])([a-f\d])$/i;function ro(t,e,i,r){var n=!1;!0===r&&(n=null===e[i]&&void 0!==t[i]),n?delete t[i]:t[i]=e[i]}function no(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var n in e)if(Object.prototype.hasOwnProperty.call(e,n)||!0===i)if("object"===qi(e[n])&&null!==e[n]&&An(e[n])===Object.prototype)void 0===t[n]?t[n]=no({},e[n],i):"object"===qi(t[n])&&null!==t[n]&&An(t[n])===Object.prototype?no(t[n],e[n],i):ro(t,e,n,r);else if(Kt(e[n])){var o;t[n]=Jn(o=e[n]).call(o)}else ro(t,e,n,r);return t}function oo(t,e){var i;return $t(i=[]).call(i,to(t),[e])}function ao(t){return Jn(t).call(t)}function so(t,e,i,r){var n;t.addEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&Gr(n=navigator.userAgent).call(n,"Firefox")>=0&&(e="DOMMouseScroll"),t.addEventListener(e,i,r)):t.attachEvent("on"+e,i)}function lo(t,e,i,r){var n;t.removeEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&Gr(n=navigator.userAgent).call(n,"Firefox")>=0&&(e="DOMMouseScroll"),t.removeEventListener(e,i,r)):t.detachEvent("on"+e,i)}function ho(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)}function co(t,e,i){var r,n,o,a=Math.floor(6*t),s=6*t-a,l=i*(1-e),h=i*(1-s*e),c=i*(1-(1-s)*e);switch(a%6){case 0:r=i,n=c,o=l;break;case 1:r=h,n=i,o=l;break;case 2:r=l,n=i,o=c;break;case 3:r=l,n=h,o=i;break;case 4:r=c,n=l,o=i;break;case 5:r=i,n=l,o=h}return{r:Math.floor(255*r),g:Math.floor(255*n),b:Math.floor(255*o)}}function uo(t,e,i){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0,this.z=void 0!==i?i:0}uo.subtract=function(t,e){var i=new uo;return i.x=t.x-e.x,i.y=t.y-e.y,i.z=t.z-e.z,i},uo.add=function(t,e){var i=new uo;return i.x=t.x+e.x,i.y=t.y+e.y,i.z=t.z+e.z,i},uo.avg=function(t,e){return new uo((t.x+e.x)/2,(t.y+e.y)/2,(t.z+e.z)/2)},uo.scalarProduct=function(t,e){return new uo(t.x*e,t.y*e,t.z*e)},uo.dotProduct=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},uo.crossProduct=function(t,e){var i=new uo;return i.x=t.y*e.z-t.z*e.y,i.y=t.z*e.x-t.x*e.z,i.z=t.x*e.y-t.y*e.x,i},uo.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},uo.prototype.normalize=function(){return uo.scalarProduct(this,1/this.length())};var fo=uo;var po=function(t,e){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0};function yo(t,e){if(void 0===t)throw new Error("No container element defined");if(this.container=t,this.visible=!e||null==e.visible||e.visible,this.visible){this.frame=document.createElement("DIV"),this.frame.style.width="100%",this.frame.style.position="relative",this.container.appendChild(this.frame),this.frame.prev=document.createElement("INPUT"),this.frame.prev.type="BUTTON",this.frame.prev.value="Prev",this.frame.appendChild(this.frame.prev),this.frame.play=document.createElement("INPUT"),this.frame.play.type="BUTTON",this.frame.play.value="Play",this.frame.appendChild(this.frame.play),this.frame.next=document.createElement("INPUT"),this.frame.next.type="BUTTON",this.frame.next.value="Next",this.frame.appendChild(this.frame.next),this.frame.bar=document.createElement("INPUT"),this.frame.bar.type="BUTTON",this.frame.bar.style.position="absolute",this.frame.bar.style.border="1px solid red",this.frame.bar.style.width="100px",this.frame.bar.style.height="6px",this.frame.bar.style.borderRadius="2px",this.frame.bar.style.MozBorderRadius="2px",this.frame.bar.style.border="1px solid #7F7F7F",this.frame.bar.style.backgroundColor="#E5E5E5",this.frame.appendChild(this.frame.bar),this.frame.slide=document.createElement("INPUT"),this.frame.slide.type="BUTTON",this.frame.slide.style.margin="0px",this.frame.slide.value=" ",this.frame.slide.style.position="relative",this.frame.slide.style.left="-100px",this.frame.appendChild(this.frame.slide);var i=this;this.frame.slide.onmousedown=function(t){i._onMouseDown(t)},this.frame.prev.onclick=function(t){i.prev(t)},this.frame.play.onclick=function(t){i.togglePlay(t)},this.frame.next.onclick=function(t){i.next(t)}}this.onChangeCallback=void 0,this.values=[],this.index=void 0,this.playTimeout=void 0,this.playInterval=1e3,this.playLoop=!0}function vo(t,e,i,r){this._start=0,this._end=0,this._step=1,this.prettyStep=!0,this.precision=5,this._current=0,this.setRange(t,e,i,r)}yo.prototype.prev=function(){var t=this.getIndex();t>0&&(t--,this.setIndex(t))},yo.prototype.next=function(){var t=this.getIndex();t<pr(this).length-1&&(t++,this.setIndex(t))},yo.prototype.playNext=function(){var t=new Date,e=this.getIndex();e<pr(this).length-1?(e++,this.setIndex(e)):this.playLoop&&(e=0,this.setIndex(e));var i=new Date-t,r=Math.max(this.playInterval-i,0),n=this;this.playTimeout=xt((function(){n.playNext()}),r)},yo.prototype.togglePlay=function(){void 0===this.playTimeout?this.play():this.stop()},yo.prototype.play=function(){this.playTimeout||(this.playNext(),this.frame&&(this.frame.play.value="Stop"))},yo.prototype.stop=function(){clearInterval(this.playTimeout),this.playTimeout=void 0,this.frame&&(this.frame.play.value="Play")},yo.prototype.setOnChangeCallback=function(t){this.onChangeCallback=t},yo.prototype.setPlayInterval=function(t){this.playInterval=t},yo.prototype.getPlayInterval=function(){return this.playInterval},yo.prototype.setPlayLoop=function(t){this.playLoop=t},yo.prototype.onChange=function(){void 0!==this.onChangeCallback&&this.onChangeCallback()},yo.prototype.redraw=function(){if(this.frame){this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px",this.frame.bar.style.width=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30+"px";var t=this.indexToLeft(this.index);this.frame.slide.style.left=t+"px"}},yo.prototype.setValues=function(t){this.values=t,pr(this).length>0?this.setIndex(0):this.index=void 0},yo.prototype.setIndex=function(t){if(!(t<pr(this).length))throw new Error("Index out of range");this.index=t,this.redraw(),this.onChange()},yo.prototype.getIndex=function(){return this.index},yo.prototype.get=function(){return pr(this)[this.index]},yo.prototype._onMouseDown=function(t){if(t.which?1===t.which:1===t.button){this.startClientX=t.clientX,this.startSlideX=Tr(this.frame.slide.style.left),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},so(document,"mousemove",this.onmousemove),so(document,"mouseup",this.onmouseup),ho(t)}},yo.prototype.leftToIndex=function(t){var e=Tr(this.frame.bar.style.width)-this.frame.slide.clientWidth-10,i=t-3,r=Math.round(i/e*(pr(this).length-1));return r<0&&(r=0),r>pr(this).length-1&&(r=pr(this).length-1),r},yo.prototype.indexToLeft=function(t){var e=Tr(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return t/(pr(this).length-1)*e+3},yo.prototype._onMouseMove=function(t){var e=t.clientX-this.startClientX,i=this.startSlideX+e,r=this.leftToIndex(i);this.setIndex(r),ho()},yo.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",lo(document,"mousemove",this.onmousemove),lo(document,"mouseup",this.onmouseup),ho()},vo.prototype.isNumeric=function(t){return!isNaN(Tr(t))&&isFinite(t)},vo.prototype.setRange=function(t,e,i,r){if(!this.isNumeric(t))throw new Error("Parameter 'start' is not numeric; value: "+t);if(!this.isNumeric(e))throw new Error("Parameter 'end' is not numeric; value: "+t);if(!this.isNumeric(i))throw new Error("Parameter 'step' is not numeric; value: "+t);this._start=t||0,this._end=e||0,this.setStep(i,r)},vo.prototype.setStep=function(t,e){void 0===t||t<=0||(void 0!==e&&(this.prettyStep=e),!0===this.prettyStep?this._step=vo.calculatePrettyStep(t):this._step=t)},vo.calculatePrettyStep=function(t){var e=function(t){return Math.log(t)/Math.LN10},i=Math.pow(10,Math.round(e(t))),r=2*Math.pow(10,Math.round(e(t/2))),n=5*Math.pow(10,Math.round(e(t/5))),o=i;return Math.abs(r-t)<=Math.abs(o-t)&&(o=r),Math.abs(n-t)<=Math.abs(o-t)&&(o=n),o<=0&&(o=1),o},vo.prototype.getCurrent=function(){return Tr(this._current.toPrecision(this.precision))},vo.prototype.getStep=function(){return this._step},vo.prototype.start=function(t){void 0===t&&(t=!1),this._current=this._start-this._start%this._step,t&&this.getCurrent()<this._start&&this.next()},vo.prototype.next=function(){this._current+=this._step},vo.prototype.end=function(){return this._current>this._end};var mo=vo,go=[].reverse,bo=[1,2];V({target:"Array",proto:!0,forced:String(bo)===String(bo.reverse())},{reverse:function(){return wt(this)&&(this.length=this.length),go.call(this)}});var xo=Zt("Array").reverse,wo=Array.prototype,_o=function(t){var e=t.reverse;return t===wo||t instanceof Array&&e===wo.reverse?xo:e},So=Math.sign||function(t){return 0==(t=+t)||t!=t?t:t<0?-1:1};V({target:"Math",stat:!0},{sign:So});var Lo=z.Math.sign;function Co(){this.armLocation=new fo,this.armRotation={},this.armRotation.horizontal=0,this.armRotation.vertical=0,this.armLength=1.7,this.cameraOffset=new fo,this.offsetMultiplier=.6,this.cameraLocation=new fo,this.cameraRotation=new fo(.5*Math.PI,0,0),this.calculateCameraOrientation()}Co.prototype.setOffset=function(t,e){var i=Math.abs,r=Lo,n=this.offsetMultiplier,o=this.armLength*n;i(t)>o&&(t=r(t)*o),i(e)>o&&(e=r(e)*o),this.cameraOffset.x=t,this.cameraOffset.y=e,this.calculateCameraOrientation()},Co.prototype.getOffset=function(){return this.cameraOffset},Co.prototype.setArmLocation=function(t,e,i){this.armLocation.x=t,this.armLocation.y=e,this.armLocation.z=i,this.calculateCameraOrientation()},Co.prototype.setArmRotation=function(t,e){void 0!==t&&(this.armRotation.horizontal=t),void 0!==e&&(this.armRotation.vertical=e,this.armRotation.vertical<0&&(this.armRotation.vertical=0),this.armRotation.vertical>.5*Math.PI&&(this.armRotation.vertical=.5*Math.PI)),void 0===t&&void 0===e||this.calculateCameraOrientation()},Co.prototype.getArmRotation=function(){var t={};return t.horizontal=this.armRotation.horizontal,t.vertical=this.armRotation.vertical,t},Co.prototype.setArmLength=function(t){void 0!==t&&(this.armLength=t,this.armLength<.71&&(this.armLength=.71),this.armLength>5&&(this.armLength=5),this.setOffset(this.cameraOffset.x,this.cameraOffset.y),this.calculateCameraOrientation())},Co.prototype.getArmLength=function(){return this.armLength},Co.prototype.getCameraLocation=function(){return this.cameraLocation},Co.prototype.getCameraRotation=function(){return this.cameraRotation},Co.prototype.calculateCameraOrientation=function(){this.cameraLocation.x=this.armLocation.x-this.armLength*Math.sin(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.y=this.armLocation.y-this.armLength*Math.cos(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.z=this.armLocation.z+this.armLength*Math.sin(this.armRotation.vertical),this.cameraRotation.x=Math.PI/2-this.armRotation.vertical,this.cameraRotation.y=0,this.cameraRotation.z=-this.armRotation.horizontal;var t=this.cameraRotation.x,e=this.cameraRotation.z,i=this.cameraOffset.x,r=this.cameraOffset.y,n=Math.sin,o=Math.cos;this.cameraLocation.x=this.cameraLocation.x+i*o(e)+r*-n(e)*o(t),this.cameraLocation.y=this.cameraLocation.y+i*n(e)+r*o(e)*o(t),this.cameraLocation.z=this.cameraLocation.z+r*n(t)};var Ao={BAR:0,BARCOLOR:1,BARSIZE:2,DOT:3,DOTLINE:4,DOTCOLOR:5,DOTSIZE:6,GRID:7,LINE:8,SURFACE:9},To={dot:Ao.DOT,"dot-line":Ao.DOTLINE,"dot-color":Ao.DOTCOLOR,"dot-size":Ao.DOTSIZE,line:Ao.LINE,grid:Ao.GRID,surface:Ao.SURFACE,bar:Ao.BAR,"bar-color":Ao.BARCOLOR,"bar-size":Ao.BARSIZE},Oo=["width","height","filterLabel","legendLabel","xLabel","yLabel","zLabel","xValueLabel","yValueLabel","zValueLabel","showXAxis","showYAxis","showZAxis","showGrayBottom","showGrid","showPerspective","showShadow","showSurfaceGrid","keepAspectRatio","rotateAxisLabels","verticalRatio","dotSizeRatio","dotSizeMinFraction","dotSizeMaxFraction","showAnimationControls","animationInterval","animationPreload","animationAutoStart","axisColor","axisFontSize","axisFontType","gridColor","xCenter","yCenter","zoomable","tooltipDelay","ctrlToZoom"],Mo=["xBarWidth","yBarWidth","valueMin","valueMax","xMin","xMax","xStep","yMin","yMax","yStep","zMin","zMax","zStep"],Po=void 0;function Eo(t){for(var e in t)if(t.hasOwnProperty(e))return!1;return!0}function Ro(t,e){return void 0===t||""===t?e:t+(void 0===(i=e)||""===i||"string"!=typeof i?i:i.charAt(0).toUpperCase()+Jn(i).call(i,1));var i}function Do(t,e,i,r){for(var n,o=0;o<i.length;++o)e[Ro(r,n=i[o])]=t[n]}function ko(t,e,i,r){for(var n,o=0;o<i.length;++o)void 0!==t[n=i[o]]&&(e[Ro(r,n)]=t[n])}function zo(t,e){if(void 0!==t.backgroundColor&&function(t,e){var i="white",r="gray",n=1;if("string"==typeof t)i=t,r="none",n=0;else{if("object"!==qi(t))throw new Error("Unsupported type of backgroundColor");void 0!==mr(t)&&(i=mr(t)),void 0!==t.stroke&&(r=t.stroke),void 0!==t.strokeWidth&&(n=t.strokeWidth)}e.frame.style.backgroundColor=i,e.frame.style.borderColor=r,e.frame.style.borderWidth=n+"px",e.frame.style.borderStyle="solid"}(t.backgroundColor,e),function(t,e){if(void 0===t)return;void 0===e.dataColor&&(e.dataColor={});"string"==typeof t?(e.dataColor.fill=t,e.dataColor.stroke=t):(mr(t)&&(e.dataColor.fill=mr(t)),t.stroke&&(e.dataColor.stroke=t.stroke),void 0!==t.strokeWidth&&(e.dataColor.strokeWidth=t.strokeWidth))}(t.dataColor,e),function(t,e){if(void 0===t)return;var i;if("string"==typeof t){if(-1===(i=function(t){var e=To[t];if(void 0===e)return-1;return e}(t)))throw new Error("Style '"+t+"' is invalid")}else{if(!function(t){var e=!1;for(var i in Ao)if(Ao[i]===t){e=!0;break}return e}(t))throw new Error("Style '"+t+"' is invalid");i=t}e.style=i}(t.style,e),void 0!==t.surfaceColors){if(console.warn("`options.surfaceColors` is deprecated and may be removed in a future version. Please use `options.colormap` instead. Note that the `colormap` option uses the inverse array ordering (running from vMin to vMax)."),void 0!==t.colormap)throw new Error("The `colormap` and `surfaceColors` options are mutually exclusive.");"surface"!==e.style?console.warn("Ignoring `surfaceColors` in graph style `"+e.style+"` for backward compatibility (only effective in `surface` plots)."):function(t,e){if(void 0===t||!0===t)return;if(!1===t)return void(e.surfaceColors=void 0);void 0===e.surfaceColors&&(e.surfaceColors={});var i;if(Kt(t))i=Io(t);else{if("object"!==qi(t))throw new Error("Unsupported type of surfaceColors");i=jo(t.hue)}_o(i).call(i),e.colormap=i}(t.surfaceColors,e)}else!function(t,e){if(void 0===t)return;var i;if(Kt(t))i=Io(t);else if("object"===qi(t))i=jo(t.hue);else{if("function"!=typeof t)throw new Error("Unsupported type of colormap");i=t}e.colormap=i}(t.colormap,e);!function(t,e){if(void 0===t){if(void 0===Po.showLegend){var i=e.style===Ao.DOTCOLOR||e.style===Ao.DOTSIZE;e.showLegend=i}}else e.showLegend=t}(t.showLegend,e),Bo(t.cameraPosition,e),void 0!==t.tooltip&&(e.showTooltip=t.tooltip),null!=t.onclick&&(e.onclick_callback=t.onclick,console.warn("`options.onclick` is deprecated and may be removed in a future version. Please use `Graph3d.on('click', handler)` instead.")),void 0!==t.tooltipStyle&&function(t,e,i){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Kt(i))throw new TypeError("Arrays are not supported by deepExtend");for(var n=0;n<t.length;n++){var o=t[n];if(Object.prototype.hasOwnProperty.call(i,o))if(i[o]&&i[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?no(e[o],i[o],!1,r):ro(e,i,o,r);else{if(Kt(i[o]))throw new TypeError("Arrays are not supported by deepExtend");ro(e,i,o,r)}}}(["tooltipStyle"],e,t)}function Io(t){if(t.length<2)throw new Error("Colormap array length must be 2 or above.");return $n(t).call(t,(function(t){if(!function(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}(t))throw new Error("Invalid hex color code supplied to colormap.");return function(t){var e;switch(t.length){case 3:case 4:return(e=io.exec(t))?{r:wn(e[1]+e[1],16),g:wn(e[2]+e[2],16),b:wn(e[3]+e[3],16)}:null;case 6:case 7:return(e=eo.exec(t))?{r:wn(e[1],16),g:wn(e[2],16),b:wn(e[3],16)}:null;default:return null}}(t)}))}function jo(t){if(void 0===t)throw new Error("Unsupported type of colormap");if(!(t.saturation>=0&&t.saturation<=100))throw new Error("Saturation is out of bounds. Expected range is 0-100.");if(!(t.brightness>=0&&t.brightness<=100))throw new Error("Brightness is out of bounds. Expected range is 0-100.");if(!(t.colorStops>=2))throw new Error("colorStops is out of bounds. Expected 2 or above.");for(var e=(t.end-t.start)/(t.colorStops-1),i=[],r=0;r<t.colorStops;++r){var n=(t.start+e*r)%360/360;i.push(co(n<0?n+1:n,t.saturation/100,t.brightness/100))}return i}function Bo(t,e){var i=t;void 0!==i&&(void 0===e.camera&&(e.camera=new Co),e.camera.setArmRotation(i.horizontal,i.vertical),e.camera.setArmLength(i.distance))}var Fo=dt("JSON","stringify"),Wo=/[\uD800-\uDFFF]/g,Go=/^[\uD800-\uDBFF]$/,No=/^[\uDC00-\uDFFF]$/,Yo=function(t,e,i){var r=i.charAt(e-1),n=i.charAt(e+1);return Go.test(t)&&!No.test(n)||No.test(t)&&!Go.test(r)?"\\u"+t.charCodeAt(0).toString(16):t},Vo=a((function(){return'"\\udf06\\ud834"'!==Fo("\udf06\ud834")||'"\\udead"'!==Fo("\udead")}));Fo&&V({target:"JSON",stat:!0,forced:Vo},{stringify:function(t,e,i){var r=Fo.apply(null,arguments);return"string"==typeof r?r.replace(Wo,Yo):r}}),z.JSON||(z.JSON={stringify:JSON.stringify});var Xo=function(t,e,i){return z.JSON.stringify.apply(null,arguments)};var Zo=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};function Uo(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),yn(t,r.key,r)}}var Ho,$o=function(t,e,i){return e&&Uo(t.prototype,e),i&&Uo(t,i),t},Jo=!1,qo="background: #FFeeee; color: #dd0000",Ko=function(){function t(){Zo(this,t)}return $o(t,null,[{key:"validate",value:function(e,i,r){Jo=!1,Ho=i;var n=i;return void 0!==r&&(n=i[r]),t.parse(e,n,[]),Jo}},{key:"parse",value:function(e,i,r){for(var n in e)e.hasOwnProperty(n)&&t.check(n,e,i,r)}},{key:"check",value:function(e,i,r,n){if(void 0!==r[e]||void 0!==r.__any__){var o=e,a=!0;void 0===r[e]&&void 0!==r.__any__&&(o="__any__",a="object"===t.getType(i[e]));var s=r[o];a&&void 0!==s.__type__&&(s=s.__type__),t.checkFields(e,i,r,o,s,n)}else t.getSuggestion(e,r,n)}},{key:"checkFields",value:function(e,i,r,n,o,a){var s=function(i){console.log("%c"+i+t.printLocation(a,e),qo)},l=t.getType(i[e]),h=o[l];void 0!==h?"array"===t.getType(h)&&-1===Gr(h).call(h,i[e])?(s('Invalid option detected in "'+e+'". Allowed values are:'+t.print(h)+' not "'+i[e]+'". '),Jo=!0):"object"===l&&"__any__"!==n&&(a=oo(a,e),t.parse(i[e],r[n],a)):void 0===o.any&&(s('Invalid type received for "'+e+'". Expected: '+t.print(Yn(o))+". Received ["+l+'] "'+i[e]+'"'),Jo=!0)}},{key:"getType",value:function(t){var e=qi(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":Kt(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,r){var n,o=t.findInOptions(e,i,r,!1),a=t.findInOptions(e,Ho,[],!0);n=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':a.distance<=4&&o.distance>a.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(a.path,a.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(Yn(i))+t.printLocation(r,e),console.log('%cUnknown option detected: "'+e+'"'+n,qo),Jo=!0}},{key:"findInOptions",value:function(e,i,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,a="",s=[],l=e.toLowerCase(),h=void 0;for(var c in i){var u=void 0;if(void 0!==i[c].__type__&&!0===n){var f=t.findInOptions(e,i[c],oo(r,c));o>f.distance&&(a=f.closestMatch,s=f.path,o=f.distance,h=f.indexMatch)}else{var d;-1!==Gr(d=c.toLowerCase()).call(d,l)&&(h=c),o>(u=t.levenshteinDistance(e,c))&&(a=c,s=ao(r),o=u)}}return{closestMatch:a,path:s,distance:o,indexMatch:h}}},{key:"printLocation",value:function(t,e){for(var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",r="\n\n"+i+"options = {\n",n=0;n<t.length;n++){for(var o=0;o<n+1;o++)r+="  ";r+=t[n]+": {\n"}for(var a=0;a<t.length+1;a++)r+="  ";r+=e+"\n";for(var s=0;s<t.length+1;s++){for(var l=0;l<t.length-s;l++)r+="  ";r+="}\n"}return r+"\n\n"}},{key:"print",value:function(t){return Xo(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,r,n=[];for(i=0;i<=e.length;i++)n[i]=[i];for(r=0;r<=t.length;r++)n[0][r]=r;for(i=1;i<=e.length;i++)for(r=1;r<=t.length;r++)e.charAt(i-1)==t.charAt(r-1)?n[i][r]=n[i-1][r-1]:n[i][r]=Math.min(n[i-1][r-1]+1,Math.min(n[i][r-1]+1,n[i-1][r]+1));return n[e.length][t.length]}}]),t}(),Qo="string",ta="boolean",ea="number",ia="object",ra={fill:{string:Qo},stroke:{string:Qo},strokeWidth:{number:ea},__type__:{string:Qo,object:ia,undefined:"undefined"}},na={animationAutoStart:{boolean:ta,undefined:"undefined"},animationInterval:{number:ea},animationPreload:{boolean:ta},axisColor:{string:Qo},axisFontSize:{number:ea},axisFontType:{string:Qo},backgroundColor:ra,xBarWidth:{number:ea,undefined:"undefined"},yBarWidth:{number:ea,undefined:"undefined"},cameraPosition:{distance:{number:ea},horizontal:{number:ea},vertical:{number:ea},__type__:{object:ia}},zoomable:{boolean:ta},ctrlToZoom:{boolean:ta},xCenter:{string:Qo},yCenter:{string:Qo},colormap:{hue:{start:{number:ea},end:{number:ea},saturation:{number:ea},brightness:{number:ea},colorStops:{number:ea},__type__:{object:ia}},__type__:{array:"array",object:ia,function:"function",undefined:"undefined"}},dataColor:ra,dotSizeMinFraction:{number:ea},dotSizeMaxFraction:{number:ea},dotSizeRatio:{number:ea},filterLabel:{string:Qo},gridColor:{string:Qo},onclick:{function:"function"},keepAspectRatio:{boolean:ta},xLabel:{string:Qo},yLabel:{string:Qo},zLabel:{string:Qo},legendLabel:{string:Qo},xMin:{number:ea,undefined:"undefined"},yMin:{number:ea,undefined:"undefined"},zMin:{number:ea,undefined:"undefined"},xMax:{number:ea,undefined:"undefined"},yMax:{number:ea,undefined:"undefined"},zMax:{number:ea,undefined:"undefined"},showAnimationControls:{boolean:ta,undefined:"undefined"},showGrayBottom:{boolean:ta},showGrid:{boolean:ta},showLegend:{boolean:ta,undefined:"undefined"},showPerspective:{boolean:ta},showShadow:{boolean:ta},showSurfaceGrid:{boolean:ta},showXAxis:{boolean:ta},showYAxis:{boolean:ta},showZAxis:{boolean:ta},rotateAxisLabels:{boolean:ta},surfaceColors:{hue:{start:{number:ea},end:{number:ea},saturation:{number:ea},brightness:{number:ea},colorStops:{number:ea},__type__:{object:ia}},__type__:{boolean:ta,array:"array",object:ia,undefined:"undefined"}},xStep:{number:ea,undefined:"undefined"},yStep:{number:ea,undefined:"undefined"},zStep:{number:ea,undefined:"undefined"},style:{number:ea,string:["bar","bar-color","bar-size","dot","dot-line","dot-color","dot-size","line","grid","surface"]},tooltip:{boolean:ta,function:"function"},tooltipDelay:{number:ea},tooltipStyle:{content:{color:{string:Qo},background:{string:Qo},border:{string:Qo},borderRadius:{string:Qo},boxShadow:{string:Qo},padding:{string:Qo},__type__:{object:ia}},line:{borderLeft:{string:Qo},height:{string:Qo},width:{string:Qo},pointerEvents:{string:Qo},__type__:{object:ia}},dot:{border:{string:Qo},borderRadius:{string:Qo},height:{string:Qo},width:{string:Qo},pointerEvents:{string:Qo},__type__:{object:ia}},__type__:{object:ia}},xValueLabel:{function:"function"},yValueLabel:{function:"function"},zValueLabel:{function:"function"},valueMax:{number:ea,undefined:"undefined"},valueMin:{number:ea,undefined:"undefined"},verticalRatio:{number:ea},height:{string:Qo},width:{string:Qo},__type__:{object:ia}};function oa(){this.min=void 0,this.max=void 0}oa.prototype.adjust=function(t){void 0!==t&&((void 0===this.min||this.min>t)&&(this.min=t),(void 0===this.max||this.max<t)&&(this.max=t))},oa.prototype.combine=function(t){this.add(t.min),this.add(t.max)},oa.prototype.expand=function(t){if(void 0!==t){var e=this.min-t,i=this.max+t;if(e>i)throw new Error("Passed expansion value makes range invalid");this.min=e,this.max=i}},oa.prototype.range=function(){return this.max-this.min},oa.prototype.center=function(){return(this.min+this.max)/2};var aa=oa;function sa(t,e,i){this.dataGroup=t,this.column=e,this.graph=i,this.index=void 0,this.value=void 0,this.values=t.getDistinctValues(this.column),pr(this).length>0&&this.selectValue(0),this.dataPoints=[],this.loaded=!1,this.onLoadCallback=void 0,i.animationPreload?(this.loaded=!1,this.loadInBackground()):this.loaded=!0}function la(){this.dataTable=null}sa.prototype.isLoaded=function(){return this.loaded},sa.prototype.getLoadedProgress=function(){for(var t=pr(this).length,e=0;this.dataPoints[e];)e++;return Math.round(e/t*100)},sa.prototype.getLabel=function(){return this.graph.filterLabel},sa.prototype.getColumn=function(){return this.column},sa.prototype.getSelectedValue=function(){if(void 0!==this.index)return pr(this)[this.index]},sa.prototype.getValues=function(){return pr(this)},sa.prototype.getValue=function(t){if(t>=pr(this).length)throw new Error("Index out of range");return pr(this)[t]},sa.prototype._getDataPoints=function(e){if(void 0===e&&(e=this.index),void 0===e)return[];var i;if(this.dataPoints[e])i=this.dataPoints[e];else{var r={};r.column=this.column,r.value=pr(this)[e];var n=new t(this.dataGroup.getDataSet(),{filter:function(t){return t[r.column]==r.value}}).get();i=this.dataGroup._getDataPoints(n),this.dataPoints[e]=i}return i},sa.prototype.setOnLoadCallback=function(t){this.onLoadCallback=t},sa.prototype.selectValue=function(t){if(t>=pr(this).length)throw new Error("Index out of range");this.index=t,this.value=pr(this)[t]},sa.prototype.loadInBackground=function(t){void 0===t&&(t=0);var e=this.graph.frame;if(t<pr(this).length){void 0===e.progress&&(e.progress=document.createElement("DIV"),e.progress.style.position="absolute",e.progress.style.color="gray",e.appendChild(e.progress));var i=this.getLoadedProgress();e.progress.innerHTML="Loading animation... "+i+"%",e.progress.style.bottom="60px",e.progress.style.left="10px";var r=this;xt((function(){r.loadInBackground(t+1)}),10),this.loaded=!1}else this.loaded=!0,void 0!==e.progress&&(e.removeChild(e.progress),e.progress=void 0),this.onLoadCallback&&this.onLoadCallback()},la.prototype.initializeData=function(i,r,n){if(void 0!==r){var o;if(Kt(r)&&(r=new e(r)),!(r instanceof e||r instanceof t))throw new Error("Array, DataSet, or DataView expected");if(0!=(o=r.get()).length){this.style=n,this.dataSet&&this.dataSet.off("*",this._onChange),this.dataSet=r,this.dataTable=o;var a=this;this._onChange=function(){i.setData(a.dataSet)},this.dataSet.on("*",this._onChange),this.colX="x",this.colY="y",this.colZ="z";var s=i.hasBars(n);if(s&&(void 0!==i.defaultXBarWidth?this.xBarWidth=i.defaultXBarWidth:this.xBarWidth=this.getSmallestDifference(o,this.colX)||1,void 0!==i.defaultYBarWidth?this.yBarWidth=i.defaultYBarWidth:this.yBarWidth=this.getSmallestDifference(o,this.colY)||1),this._initializeRange(o,this.colX,i,s),this._initializeRange(o,this.colY,i,s),this._initializeRange(o,this.colZ,i,!1),o[0].hasOwnProperty("style")){this.colValue="style";var l=this.getColumnRange(o,this.colValue);this._setRangeDefaults(l,i.defaultValueMin,i.defaultValueMax),this.valueRange=l}else this.colValue="z",this.valueRange=this.zRange;return this.getDataTable()[0].hasOwnProperty("filter")&&void 0===this.dataFilter&&(this.dataFilter=new sa(this,"filter",i),this.dataFilter.setOnLoadCallback((function(){i.redraw()}))),this.dataFilter?this.dataFilter._getDataPoints():this._getDataPoints(this.getDataTable())}}},la.prototype._collectRangeSettings=function(t,e){var i;if(-1==Gr(i=["x","y","z"]).call(i,t))throw new Error("Column '"+t+"' invalid");var r=t.toUpperCase();return{barWidth:this[t+"BarWidth"],min:e["default"+r+"Min"],max:e["default"+r+"Max"],step:e["default"+r+"Step"],range_label:t+"Range",step_label:t+"Step"}},la.prototype._initializeRange=function(t,e,i,r){var n=this._collectRangeSettings(e,i),o=this.getColumnRange(t,e);r&&"z"!=e&&o.expand(n.barWidth/2),this._setRangeDefaults(o,n.min,n.max),this[n.range_label]=o,this[n.step_label]=void 0!==n.step?n.step:o.range()/5},la.prototype.getDistinctValues=function(t,e){void 0===e&&(e=this.dataTable);for(var i=[],r=0;r<e.length;r++){var n=e[r][t]||0;-1===Gr(i).call(i,n)&&i.push(n)}return $r(i).call(i,(function(t,e){return t-e}))},la.prototype.getSmallestDifference=function(t,e){for(var i=this.getDistinctValues(t,e),r=null,n=1;n<i.length;n++){var o=i[n]-i[n-1];(null==r||r>o)&&(r=o)}return r},la.prototype.getColumnRange=function(t,e){for(var i=new aa,r=0;r<t.length;r++){var n=t[r][e];i.adjust(n)}return i},la.prototype.getNumberOfRows=function(){return this.dataTable.length},la.prototype._setRangeDefaults=function(t,e,i){void 0!==e&&(t.min=e),void 0!==i&&(t.max=i),t.max<=t.min&&(t.max=t.min+1)},la.prototype.getDataTable=function(){return this.dataTable},la.prototype.getDataSet=function(){return this.dataSet},la.prototype.getDataPoints=function(t){for(var e=[],i=0;i<t.length;i++){var r=new fo;r.x=t[i][this.colX]||0,r.y=t[i][this.colY]||0,r.z=t[i][this.colZ]||0,r.data=t[i],r.value=t[i][this.colValue]||0;var n={};n.point=r,n.bottom=new fo(r.x,r.y,this.zRange.min),n.trans=void 0,n.screen=void 0,e.push(n)}return e},la.prototype.initDataAsMatrix=function(t){var e,i,r,n,o=this.getDistinctValues(this.colX,t),a=this.getDistinctValues(this.colY,t),s=this.getDataPoints(t),l=[];for(r=0;r<s.length;r++){n=s[r];var h=Gr(o).call(o,n.point.x),c=Gr(a).call(a,n.point.y);void 0===l[h]&&(l[h]=[]),l[h][c]=n}for(e=0;e<l.length;e++)for(i=0;i<l[e].length;i++)l[e][i]&&(l[e][i].pointRight=e<l.length-1?l[e+1][i]:void 0,l[e][i].pointTop=i<l[e].length-1?l[e][i+1]:void 0,l[e][i].pointCross=e<l.length-1&&i<l[e].length-1?l[e+1][i+1]:void 0);return s},la.prototype.getInfo=function(){var t=this.dataFilter;if(t)return t.getLabel()+": "+t.getSelectedValue()},la.prototype.reload=function(){this.dataTable&&this.setData(this.dataTable)},la.prototype._getDataPoints=function(t){var e=[];if(this.style===Ao.GRID||this.style===Ao.SURFACE)e=this.initDataAsMatrix(t);else if(e=this.getDataPoints(t),this.style===Ao.LINE)for(var i=0;i<e.length;i++)i>0&&(e[i-1].pointNext=e[i]);return e},ha.STYLE=Ao;function ha(t,e,i){if(!(this instanceof ha))throw new SyntaxError("Constructor must be called with the new operator");this.containerElement=t,this.dataGroup=new la,this.dataPoints=null,this.create(),function(t,e){if(void 0===t||Eo(t))throw new Error("No DEFAULTS passed");if(void 0===e)throw new Error("No dst passed");Po=t,Do(t,e,Oo),Do(t,e,Mo,"default"),zo(t,e),e.margin=10,e.showTooltip=!1,e.onclick_callback=null,e.eye=new fo(0,0,-1)}(ha.DEFAULTS,this),this.colX=void 0,this.colY=void 0,this.colZ=void 0,this.colValue=void 0,this.setOptions(i),this.setData(e)}function ca(t){return"clientX"in t?t.clientX:t.targetTouches[0]&&t.targetTouches[0].clientX||0}function ua(t){return"clientY"in t?t.clientY:t.targetTouches[0]&&t.targetTouches[0].clientY||0}ha.DEFAULTS={width:"400px",height:"400px",filterLabel:"time",legendLabel:"value",xLabel:"x",yLabel:"y",zLabel:"z",xValueLabel:function(t){return t},yValueLabel:function(t){return t},zValueLabel:function(t){return t},showXAxis:!0,showYAxis:!0,showZAxis:!0,showGrayBottom:!1,showGrid:!0,showPerspective:!0,showShadow:!1,showSurfaceGrid:!0,keepAspectRatio:!0,rotateAxisLabels:!0,verticalRatio:.5,dotSizeRatio:.02,dotSizeMinFraction:.5,dotSizeMaxFraction:2.5,showAnimationControls:undefined,animationInterval:1e3,animationPreload:!1,animationAutoStart:undefined,axisFontSize:14,axisFontType:"arial",axisColor:"#4D4D4D",gridColor:"#D3D3D3",xCenter:"55%",yCenter:"50%",style:ha.STYLE.DOT,tooltip:!1,tooltipDelay:300,tooltipStyle:{content:{padding:"10px",border:"1px solid #4d4d4d",color:"#1a1a1a",background:"rgba(255,255,255,0.7)",borderRadius:"2px",boxShadow:"5px 5px 10px rgba(128,128,128,0.5)"},line:{height:"40px",width:"0",borderLeft:"1px solid #4d4d4d",pointerEvents:"none"},dot:{height:"0",width:"0",border:"5px solid #4d4d4d",borderRadius:"5px",pointerEvents:"none"}},dataColor:{fill:"#7DC1FF",stroke:"#3267D2",strokeWidth:1},surfaceColors:undefined,colormap:undefined,cameraPosition:{horizontal:1,vertical:.5,distance:1.7},zoomable:!0,ctrlToZoom:!1,showLegend:undefined,backgroundColor:undefined,xBarWidth:undefined,yBarWidth:undefined,valueMin:undefined,valueMax:undefined,xMin:undefined,xMax:undefined,xStep:undefined,yMin:undefined,yMax:undefined,yStep:undefined,zMin:undefined,zMax:undefined,zStep:undefined},Jr(ha.prototype),ha.prototype._setScale=function(){this.scale=new fo(1/this.xRange.range(),1/this.yRange.range(),1/this.zRange.range()),this.keepAspectRatio&&(this.scale.x<this.scale.y?this.scale.y=this.scale.x:this.scale.x=this.scale.y),this.scale.z*=this.verticalRatio,void 0!==this.valueRange&&(this.scale.value=1/this.valueRange.range());var t=this.xRange.center()*this.scale.x,e=this.yRange.center()*this.scale.y,i=this.zRange.center()*this.scale.z;this.camera.setArmLocation(t,e,i)},ha.prototype._convert3Dto2D=function(t){var e=this._convertPointToTranslation(t);return this._convertTranslationToScreen(e)},ha.prototype._convertPointToTranslation=function(t){var e=this.camera.getCameraLocation(),i=this.camera.getCameraRotation(),r=t.x*this.scale.x,n=t.y*this.scale.y,o=t.z*this.scale.z,a=e.x,s=e.y,l=e.z,h=Math.sin(i.x),c=Math.cos(i.x),u=Math.sin(i.y),f=Math.cos(i.y),d=Math.sin(i.z),p=Math.cos(i.z);return new fo(f*(d*(n-s)+p*(r-a))-u*(o-l),h*(f*(o-l)+u*(d*(n-s)+p*(r-a)))+c*(p*(n-s)-d*(r-a)),c*(f*(o-l)+u*(d*(n-s)+p*(r-a)))-h*(p*(n-s)-d*(r-a)))},ha.prototype._convertTranslationToScreen=function(t){var e,i,r=this.eye.x,n=this.eye.y,o=this.eye.z,a=t.x,s=t.y,l=t.z;return this.showPerspective?(e=o/l*(a-r),i=o/l*(s-n)):(e=a*(-o/this.camera.getArmLength()),i=s*(-o/this.camera.getArmLength())),new po(this.currentXCenter+e*this.frame.canvas.clientWidth,this.currentYCenter-i*this.frame.canvas.clientWidth)},ha.prototype._calcTranslations=function(t){for(var e=0;e<t.length;e++){var i=t[e];i.trans=this._convertPointToTranslation(i.point),i.screen=this._convertTranslationToScreen(i.trans);var r=this._convertPointToTranslation(i.bottom);i.dist=this.showPerspective?r.length():-r.z}$r(t).call(t,(function(t,e){return e.dist-t.dist}))},ha.prototype._initializeRanges=function(){var t=this.dataGroup;this.xRange=t.xRange,this.yRange=t.yRange,this.zRange=t.zRange,this.valueRange=t.valueRange,this.xStep=t.xStep,this.yStep=t.yStep,this.zStep=t.zStep,this.xBarWidth=t.xBarWidth,this.yBarWidth=t.yBarWidth,this.colX=t.colX,this.colY=t.colY,this.colZ=t.colZ,this.colValue=t.colValue,this._setScale()},ha.prototype.getDataPoints=function(t){for(var e=[],i=0;i<t.length;i++){var r=new fo;r.x=t[i][this.colX]||0,r.y=t[i][this.colY]||0,r.z=t[i][this.colZ]||0,r.data=t[i],r.value=t[i][this.colValue]||0;var n={};n.point=r,n.bottom=new fo(r.x,r.y,this.zRange.min),n.trans=void 0,n.screen=void 0,e.push(n)}return e},ha.prototype._getDataPoints=function(t){var e,i,r,n,o=[];if(this.style===ha.STYLE.GRID||this.style===ha.STYLE.SURFACE){var a=this.dataGroup.getDistinctValues(this.colX,t),s=this.dataGroup.getDistinctValues(this.colY,t);o=this.getDataPoints(t);var l=[];for(r=0;r<o.length;r++){n=o[r];var h=Gr(a).call(a,n.point.x),c=Gr(s).call(s,n.point.y);void 0===l[h]&&(l[h]=[]),l[h][c]=n}for(e=0;e<l.length;e++)for(i=0;i<l[e].length;i++)l[e][i]&&(l[e][i].pointRight=e<l.length-1?l[e+1][i]:void 0,l[e][i].pointTop=i<l[e].length-1?l[e][i+1]:void 0,l[e][i].pointCross=e<l.length-1&&i<l[e].length-1?l[e+1][i+1]:void 0)}else if(o=this.getDataPoints(t),this.style===ha.STYLE.LINE)for(r=0;r<o.length;r++)r>0&&(o[r-1].pointNext=o[r]);return o},ha.prototype.create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div"),this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas);var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t),this.frame.filter=document.createElement("div"),Dr(this.frame).style.position="absolute",Dr(this.frame).style.bottom="0px",Dr(this.frame).style.left="0px",Dr(this.frame).style.width="100%",this.frame.appendChild(Dr(this.frame));var e=this;so(this.frame.canvas,"mousedown",(function(t){e._onMouseDown(t)})),so(this.frame.canvas,"touchstart",(function(t){e._onTouchStart(t)})),so(this.frame.canvas,"mousewheel",(function(t){e._onWheel(t)})),so(this.frame.canvas,"mousemove",(function(t){e._onTooltip(t)})),so(this.frame.canvas,"click",(function(t){e._onClick(t)})),this.containerElement.appendChild(this.frame)},ha.prototype._setSize=function(t,e){this.frame.style.width=t,this.frame.style.height=e,this._resizeCanvas()},ha.prototype._resizeCanvas=function(){this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=this.frame.canvas.clientWidth,this.frame.canvas.height=this.frame.canvas.clientHeight,Dr(this.frame).style.width=this.frame.canvas.clientWidth-20+"px"},ha.prototype.animationStart=function(){if(this.animationAutoStart&&this.dataGroup.dataFilter){if(!Dr(this.frame)||!Dr(this.frame).slider)throw new Error("No animation available");Dr(this.frame).slider.play()}},ha.prototype.animationStop=function(){Dr(this.frame)&&Dr(this.frame).slider&&Dr(this.frame).slider.stop()},ha.prototype._resizeCenter=function(){"%"===this.xCenter.charAt(this.xCenter.length-1)?this.currentXCenter=Tr(this.xCenter)/100*this.frame.canvas.clientWidth:this.currentXCenter=Tr(this.xCenter),"%"===this.yCenter.charAt(this.yCenter.length-1)?this.currentYCenter=Tr(this.yCenter)/100*(this.frame.canvas.clientHeight-Dr(this.frame).clientHeight):this.currentYCenter=Tr(this.yCenter)},ha.prototype.getCameraPosition=function(){var t=this.camera.getArmRotation();return t.distance=this.camera.getArmLength(),t},ha.prototype._readData=function(t){this.dataPoints=this.dataGroup.initializeData(this,t,this.style),this._initializeRanges(),this._redrawFilter()},ha.prototype.setData=function(t){null!=t&&(this._readData(t),this.redraw(),this.animationStart())},ha.prototype.setOptions=function(t){void 0!==t&&(!0===Ko.validate(t,na)&&console.log("%cErrors have been found in the supplied options object.",qo),this.animationStop(),function(t,e){if(void 0!==t){if(void 0===e)throw new Error("No dst passed");if(void 0===Po||Eo(Po))throw new Error("DEFAULTS not set for module Settings");ko(t,e,Oo),ko(t,e,Mo,"default"),zo(t,e)}}(t,this),this.setPointDrawingMethod(),this._setSize(this.width,this.height),this.setAxisLabelMethod(),this.setData(this.dataGroup.getDataTable()),this.animationStart())},ha.prototype.setPointDrawingMethod=function(){var t=void 0;switch(this.style){case ha.STYLE.BAR:t=this._redrawBarGraphPoint;break;case ha.STYLE.BARCOLOR:t=this._redrawBarColorGraphPoint;break;case ha.STYLE.BARSIZE:t=this._redrawBarSizeGraphPoint;break;case ha.STYLE.DOT:t=this._redrawDotGraphPoint;break;case ha.STYLE.DOTLINE:t=this._redrawDotLineGraphPoint;break;case ha.STYLE.DOTCOLOR:t=this._redrawDotColorGraphPoint;break;case ha.STYLE.DOTSIZE:t=this._redrawDotSizeGraphPoint;break;case ha.STYLE.SURFACE:t=this._redrawSurfaceGraphPoint;break;case ha.STYLE.GRID:t=this._redrawGridGraphPoint;break;case ha.STYLE.LINE:t=this._redrawLineGraphPoint;break;default:throw new Error("Can not determine point drawing method for graph style '"+this.style+"'")}this._pointDrawingMethod=t},ha.prototype.setAxisLabelMethod=function(){this.rotateAxisLabels?(this._drawAxisLabelX=this.drawAxisLabelXRotate,this._drawAxisLabelY=this.drawAxisLabelYRotate,this._drawAxisLabelZ=this.drawAxisLabelZRotate):(this._drawAxisLabelX=this.drawAxisLabelX,this._drawAxisLabelY=this.drawAxisLabelY,this._drawAxisLabelZ=this.drawAxisLabelZ)},ha.prototype.redraw=function(){if(void 0===this.dataPoints)throw new Error("Graph data not initialized");this._resizeCanvas(),this._resizeCenter(),this._redrawSlider(),this._redrawClear(),this._redrawAxis(),this._redrawDataGraph(),this._redrawInfo(),this._redrawLegend()},ha.prototype._getContext=function(){var t=this.frame.canvas.getContext("2d");return t.lineJoin="round",t.lineCap="round",t},ha.prototype._redrawClear=function(){var t=this.frame.canvas;t.getContext("2d").clearRect(0,0,t.width,t.height)},ha.prototype._dotSize=function(){return this.frame.clientWidth*this.dotSizeRatio},ha.prototype._getLegendWidth=function(){var t;this.style===ha.STYLE.DOTSIZE?t=this._dotSize()*this.dotSizeMaxFraction:t=this.style===ha.STYLE.BARSIZE?this.xBarWidth:20;return t},ha.prototype._redrawLegend=function(){if(!0===this.showLegend&&this.style!==ha.STYLE.LINE&&this.style!==ha.STYLE.BARSIZE){var t=this.style===ha.STYLE.BARSIZE||this.style===ha.STYLE.DOTSIZE,e=this.style===ha.STYLE.DOTSIZE||this.style===ha.STYLE.DOTCOLOR||this.style===ha.STYLE.SURFACE||this.style===ha.STYLE.BARCOLOR,i=Math.max(.25*this.frame.clientHeight,100),r=this.margin,n=this._getLegendWidth(),o=this.frame.clientWidth-this.margin,a=o-n,s=r+i,l=this._getContext();if(l.lineWidth=1,l.font="14px arial",!1===t){var h,c=i;for(h=0;h<c;h++){var u=1-(h-0)/(c-0),f=this._colormap(u,1);l.strokeStyle=f,l.beginPath(),l.moveTo(a,r+h),l.lineTo(o,r+h),l.stroke()}l.strokeStyle=this.axisColor,l.strokeRect(a,r,n,i)}else{var d;this.style===ha.STYLE.DOTSIZE?d=n*(this.dotSizeMinFraction/this.dotSizeMaxFraction):(this.style,ha.STYLE.BARSIZE),l.strokeStyle=this.axisColor,l.fillStyle=mr(this.dataColor),l.beginPath(),l.moveTo(a,r),l.lineTo(o,r),l.lineTo(a+d,s),l.lineTo(a,s),l.closePath(),mr(l).call(l),l.stroke()}var p,y,v=e?this.valueRange.min:this.zRange.min,m=e?this.valueRange.max:this.zRange.max,g=new mo(v,m,(m-v)/5,!0);for(g.start(!0);!g.end();)h=s-(g.getCurrent()-v)/(m-v)*i,p=new po(a-5,h),y=new po(a,h),this._line(l,p,y),l.textAlign="right",l.textBaseline="middle",l.fillStyle=this.axisColor,l.fillText(g.getCurrent(),a-10,h),g.next();l.textAlign="right",l.textBaseline="top";var b=this.legendLabel;l.fillText(b,o,s+this.margin)}},ha.prototype._redrawFilter=function(){var t=this.dataGroup.dataFilter,e=Dr(this.frame);if(e.innerHTML="",t){var i=new yo(e,{visible:this.showAnimationControls});e.slider=i,e.style.padding="10px",i.setValues(pr(t)),i.setPlayInterval(this.animationInterval);var r=this;i.setOnChangeCallback((function(){var t=r.dataGroup.dataFilter,e=i.getIndex();t.selectValue(e),r.dataPoints=t._getDataPoints(),r.redraw()}))}else e.slider=void 0},ha.prototype._redrawSlider=function(){void 0!==Dr(this.frame).slider&&Dr(this.frame).slider.redraw()},ha.prototype._redrawInfo=function(){var t=this.dataGroup.getInfo();if(void 0!==t){var e=this._getContext();e.font="14px arial",e.lineStyle="gray",e.fillStyle="gray",e.textAlign="left",e.textBaseline="top";var i=this.margin,r=this.margin;e.fillText(t,i,r)}},ha.prototype._line=function(t,e,i,r){void 0!==r&&(t.strokeStyle=r),t.beginPath(),t.moveTo(e.x,e.y),t.lineTo(i.x,i.y),t.stroke()},ha.prototype.drawAxisLabelX=function(t,e,i,r,n){void 0===n&&(n=0);var o=this._convert3Dto2D(e);Math.cos(2*r)>0?(t.textAlign="center",t.textBaseline="top",o.y+=n):Math.sin(2*r)<0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y)},ha.prototype.drawAxisLabelY=function(t,e,i,r,n){void 0===n&&(n=0);var o=this._convert3Dto2D(e);Math.cos(2*r)<0?(t.textAlign="center",t.textBaseline="top",o.y+=n):Math.sin(2*r)>0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y)},ha.prototype.drawAxisLabelZ=function(t,e,i,r){void 0===r&&(r=0);var n=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,n.x-r,n.y)},ha.prototype.drawAxisLabelXRotate=function(t,e,i,r,n){var o=this._convert3Dto2D(e);Math.cos(2*r)>0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,0,0),t.restore()):Math.sin(2*r)<0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y))},ha.prototype.drawAxisLabelYRotate=function(t,e,i,r,n){var o=this._convert3Dto2D(e);Math.cos(2*r)<0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,0,0),t.restore()):Math.sin(2*r)>0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y))},ha.prototype.drawAxisLabelZRotate=function(t,e,i,r){void 0===r&&(r=0);var n=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,n.x-r,n.y)},ha.prototype._line3d=function(t,e,i,r){var n=this._convert3Dto2D(e),o=this._convert3Dto2D(i);this._line(t,n,o,r)},ha.prototype._redrawAxis=function(){var t,e,i,r,n,o,a,s,l,h,c=this._getContext();c.font=this.axisFontSize/this.camera.getArmLength()+"px "+this.axisFontType;var u,f,d,p=.025/this.scale.x,y=.025/this.scale.y,v=5/this.camera.getArmLength(),m=this.camera.getArmRotation().horizontal,g=new po(Math.cos(m),Math.sin(m)),b=this.xRange,x=this.yRange,w=this.zRange;for(c.lineWidth=1,r=void 0===this.defaultXStep,(i=new mo(b.min,b.max,this.xStep,r)).start(!0);!i.end();){var _=i.getCurrent();if(this.showGrid?(t=new fo(_,x.min,w.min),e=new fo(_,x.max,w.min),this._line3d(c,t,e,this.gridColor)):this.showXAxis&&(t=new fo(_,x.min,w.min),e=new fo(_,x.min+p,w.min),this._line3d(c,t,e,this.axisColor),t=new fo(_,x.max,w.min),e=new fo(_,x.max-p,w.min),this._line3d(c,t,e,this.axisColor)),this.showXAxis){a=g.x>0?x.min:x.max,u=new fo(_,a,w.min);var S="  "+this.xValueLabel(_)+"  ";this._drawAxisLabelX.call(this,c,u,S,m,v)}i.next()}for(c.lineWidth=1,r=void 0===this.defaultYStep,(i=new mo(x.min,x.max,this.yStep,r)).start(!0);!i.end();){var L=i.getCurrent();if(this.showGrid?(t=new fo(b.min,L,w.min),e=new fo(b.max,L,w.min),this._line3d(c,t,e,this.gridColor)):this.showYAxis&&(t=new fo(b.min,L,w.min),e=new fo(b.min+y,L,w.min),this._line3d(c,t,e,this.axisColor),t=new fo(b.max,L,w.min),e=new fo(b.max-y,L,w.min),this._line3d(c,t,e,this.axisColor)),this.showYAxis){o=g.y>0?b.min:b.max,u=new fo(o,L,w.min);var C="  "+this.yValueLabel(L)+"  ";this._drawAxisLabelY.call(this,c,u,C,m,v)}i.next()}if(this.showZAxis){for(c.lineWidth=1,r=void 0===this.defaultZStep,(i=new mo(w.min,w.max,this.zStep,r)).start(!0),o=g.x>0?b.min:b.max,a=g.y<0?x.min:x.max;!i.end();){var A=i.getCurrent(),T=new fo(o,a,A),O=this._convert3Dto2D(T);e=new po(O.x-v,O.y),this._line(c,O,e,this.axisColor);var M=this.zValueLabel(A)+" ";this._drawAxisLabelZ.call(this,c,T,M,5),i.next()}c.lineWidth=1,t=new fo(o,a,w.min),e=new fo(o,a,w.max),this._line3d(c,t,e,this.axisColor)}this.showXAxis&&(c.lineWidth=1,f=new fo(b.min,x.min,w.min),d=new fo(b.max,x.min,w.min),this._line3d(c,f,d,this.axisColor),f=new fo(b.min,x.max,w.min),d=new fo(b.max,x.max,w.min),this._line3d(c,f,d,this.axisColor));this.showYAxis&&(c.lineWidth=1,t=new fo(b.min,x.min,w.min),e=new fo(b.min,x.max,w.min),this._line3d(c,t,e,this.axisColor),t=new fo(b.max,x.min,w.min),e=new fo(b.max,x.max,w.min),this._line3d(c,t,e,this.axisColor));var P=this.xLabel;P.length>0&&this.showXAxis&&(h=.1/this.scale.y,o=(b.max+3*b.min)/4,a=g.x>0?x.min-h:x.max+h,n=new fo(o,a,w.min),this.drawAxisLabelX(c,n,P,m));var E=this.yLabel;E.length>0&&this.showYAxis&&(l=.1/this.scale.x,o=g.y>0?b.min-l:b.max+l,a=(x.max+3*x.min)/4,n=new fo(o,a,w.min),this.drawAxisLabelY(c,n,E,m));var R=this.zLabel;R.length>0&&this.showZAxis&&(30,o=g.x>0?b.min:b.max,a=g.y<0?x.min:x.max,s=(w.max+3*w.min)/4,n=new fo(o,a,s),this.drawAxisLabelZ(c,n,R,30))},ha.prototype._getStrokeWidth=function(t){return void 0!==t?this.showPerspective?1/-t.trans.z*this.dataColor.strokeWidth:-this.eye.z/this.camera.getArmLength()*this.dataColor.strokeWidth:this.dataColor.strokeWidth},ha.prototype._redrawBar=function(t,e,i,r,n,o){var a,s=this,l=e.point,h=this.zRange.min,c=[{point:new fo(l.x-i,l.y-r,l.z)},{point:new fo(l.x+i,l.y-r,l.z)},{point:new fo(l.x+i,l.y+r,l.z)},{point:new fo(l.x-i,l.y+r,l.z)}],u=[{point:new fo(l.x-i,l.y-r,h)},{point:new fo(l.x+i,l.y-r,h)},{point:new fo(l.x+i,l.y+r,h)},{point:new fo(l.x-i,l.y+r,h)}];cr(c).call(c,(function(t){t.screen=s._convert3Dto2D(t.point)})),cr(u).call(u,(function(t){t.screen=s._convert3Dto2D(t.point)}));var f=[{corners:c,center:fo.avg(u[0].point,u[2].point)},{corners:[c[0],c[1],u[1],u[0]],center:fo.avg(u[1].point,u[0].point)},{corners:[c[1],c[2],u[2],u[1]],center:fo.avg(u[2].point,u[1].point)},{corners:[c[2],c[3],u[3],u[2]],center:fo.avg(u[3].point,u[2].point)},{corners:[c[3],c[0],u[0],u[3]],center:fo.avg(u[0].point,u[3].point)}];e.surfaces=f;for(var d=0;d<f.length;d++){a=f[d];var p=this._convertPointToTranslation(a.center);a.dist=this.showPerspective?p.length():-p.z}$r(f).call(f,(function(t,e){var i=e.dist-t.dist;return i||(t.corners===c?1:e.corners===c?-1:0)})),t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=o,t.fillStyle=n;for(var y=2;y<f.length;y++)a=f[y],this._polygon(t,a.corners)},ha.prototype._polygon=function(t,e,i,r){if(!(e.length<2)){void 0!==i&&(t.fillStyle=i),void 0!==r&&(t.strokeStyle=r),t.beginPath(),t.moveTo(e[0].screen.x,e[0].screen.y);for(var n=1;n<e.length;++n){var o=e[n];t.lineTo(o.screen.x,o.screen.y)}t.closePath(),mr(t).call(t),t.stroke()}},ha.prototype._drawCircle=function(t,e,i,r,n){var o=this._calcRadius(e,n);t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=r,t.fillStyle=i,t.beginPath(),t.arc(e.screen.x,e.screen.y,o,0,2*Math.PI,!0),mr(t).call(t),t.stroke()},ha.prototype._getColorsRegular=function(t){var e=(t.point.value-this.valueRange.min)*this.scale.value;return{fill:this._colormap(e,1),border:this._colormap(e,.8)}},ha.prototype._getColorsColor=function(t){var e,i,r;if(t&&t.point&&t.point.data&&t.point.data.style&&(r=t.point.data.style),r&&"object"===qi(r)&&mr(r)&&r.stroke)return{fill:mr(r),border:r.stroke};if("string"==typeof t.point.value)e=t.point.value,i=t.point.value;else{var n=(t.point.value-this.valueRange.min)*this.scale.value;e=this._colormap(n,1),i=this._colormap(n,.8)}return{fill:e,border:i}},ha.prototype._getColorsSize=function(){return{fill:mr(this.dataColor),border:this.dataColor.stroke}},ha.prototype._colormap=function(t){var e,i,r,n,o,a,s,l,h,c=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,u=this.colormap;if(Kt(u)){var f=u.length-1,d=Math.max(Math.floor(t*f),0),p=Math.min(d+1,f),y=t*f-d,v=u[d],m=u[p];e=v.r+y*(m.r-v.r),i=v.g+y*(m.g-v.g),r=v.b+y*(m.b-v.b)}else if("function"==typeof u){var g=u(t);e=g.r,i=g.g,r=g.b,n=g.a}else{var b=240*(1-t),x=co(b/360,1,1);e=x.r,i=x.g,r=x.b}return"number"!=typeof n||Jt(n)?$t(o=$t(a="RGB(".concat(Math.round(e*c),", ")).call(a,Math.round(i*c),", ")).call(o,Math.round(r*c),")"):$t(s=$t(l=$t(h="RGBA(".concat(Math.round(e*c),", ")).call(h,Math.round(i*c),", ")).call(l,Math.round(r*c),", ")).call(s,n,")")},ha.prototype._calcRadius=function(t,e){var i;return void 0===e&&(e=this._dotSize()),(i=this.showPerspective?e/-t.trans.z:e*(-this.eye.z/this.camera.getArmLength()))<0&&(i=0),i},ha.prototype._redrawBarGraphPoint=function(t,e){var i=this.xBarWidth/2,r=this.yBarWidth/2,n=this._getColorsRegular(e);this._redrawBar(t,e,i,r,mr(n),n.border)},ha.prototype._redrawBarColorGraphPoint=function(t,e){var i=this.xBarWidth/2,r=this.yBarWidth/2,n=this._getColorsColor(e);this._redrawBar(t,e,i,r,mr(n),n.border)},ha.prototype._redrawBarSizeGraphPoint=function(t,e){var i=(e.point.value-this.valueRange.min)/this.valueRange.range(),r=this.xBarWidth/2*(.8*i+.2),n=this.yBarWidth/2*(.8*i+.2),o=this._getColorsSize();this._redrawBar(t,e,r,n,mr(o),o.border)},ha.prototype._redrawDotGraphPoint=function(t,e){var i=this._getColorsRegular(e);this._drawCircle(t,e,mr(i),i.border)},ha.prototype._redrawDotLineGraphPoint=function(t,e){var i=this._convert3Dto2D(e.bottom);t.lineWidth=1,this._line(t,i,e.screen,this.gridColor),this._redrawDotGraphPoint(t,e)},ha.prototype._redrawDotColorGraphPoint=function(t,e){var i=this._getColorsColor(e);this._drawCircle(t,e,mr(i),i.border)},ha.prototype._redrawDotSizeGraphPoint=function(t,e){var i=this._dotSize(),r=(e.point.value-this.valueRange.min)/this.valueRange.range(),n=i*this.dotSizeMinFraction,o=n+(i*this.dotSizeMaxFraction-n)*r,a=this._getColorsSize();this._drawCircle(t,e,mr(a),a.border,o)},ha.prototype._redrawSurfaceGraphPoint=function(t,e){var i=e.pointRight,r=e.pointTop,n=e.pointCross;if(void 0!==e&&void 0!==i&&void 0!==r&&void 0!==n){var o,a,s,l=!0;if(this.showGrayBottom||this.showShadow){var h=fo.subtract(n.trans,e.trans),c=fo.subtract(r.trans,i.trans),u=fo.crossProduct(h,c);if(this.showPerspective){var f=fo.avg(fo.avg(e.trans,n.trans),fo.avg(i.trans,r.trans));s=-fo.dotProduct(u.normalize(),f.normalize())}else s=u.z/u.length();l=s>0}if(l||!this.showGrayBottom){var d=((e.point.value+i.point.value+r.point.value+n.point.value)/4-this.valueRange.min)*this.scale.value,p=this.showShadow?(1+s)/2:1;o=this._colormap(d,p)}else o="gray";a=this.showSurfaceGrid?this.axisColor:o,t.lineWidth=this._getStrokeWidth(e);var y=[e,i,n,r];this._polygon(t,y,o,a)}},ha.prototype._drawGridLine=function(t,e,i){if(void 0!==e&&void 0!==i){var r=((e.point.value+i.point.value)/2-this.valueRange.min)*this.scale.value;t.lineWidth=2*this._getStrokeWidth(e),t.strokeStyle=this._colormap(r,1),this._line(t,e.screen,i.screen)}},ha.prototype._redrawGridGraphPoint=function(t,e){this._drawGridLine(t,e,e.pointRight),this._drawGridLine(t,e,e.pointTop)},ha.prototype._redrawLineGraphPoint=function(t,e){void 0!==e.pointNext&&(t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=this.dataColor.stroke,this._line(t,e.screen,e.pointNext.screen))},ha.prototype._redrawDataGraph=function(){var t,e=this._getContext();if(!(void 0===this.dataPoints||this.dataPoints.length<=0))for(this._calcTranslations(this.dataPoints),t=0;t<this.dataPoints.length;t++){var i=this.dataPoints[t];this._pointDrawingMethod.call(this,e,i)}},ha.prototype._storeMousePosition=function(t){this.startMouseX=ca(t),this.startMouseY=ua(t),this._startCameraOffset=this.camera.getOffset()},ha.prototype._onMouseDown=function(t){if(t=t||window.event,this.leftButtonDown&&this._onMouseUp(t),this.leftButtonDown=t.which?1===t.which:1===t.button,this.leftButtonDown||this.touchDown){this._storeMousePosition(t),this.startStart=new Date(this.start),this.startEnd=new Date(this.end),this.startArmRotation=this.camera.getArmRotation(),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},so(document,"mousemove",e.onmousemove),so(document,"mouseup",e.onmouseup),ho(t)}},ha.prototype._onMouseMove=function(t){this.moving=!0,t=t||window.event;var e=Tr(ca(t))-this.startMouseX,i=Tr(ua(t))-this.startMouseY;if(t&&!0===t.ctrlKey){var r=.5*this.frame.clientWidth,n=.5*this.frame.clientHeight,o=(this._startCameraOffset.x||0)-e/r*this.camera.armLength*.8,a=(this._startCameraOffset.y||0)+i/n*this.camera.armLength*.8;this.camera.setOffset(o,a),this._storeMousePosition(t)}else{var s=this.startArmRotation.horizontal+e/200,l=this.startArmRotation.vertical+i/200,h=Math.sin(4/360*2*Math.PI);Math.abs(Math.sin(s))<h&&(s=Math.round(s/Math.PI)*Math.PI-.001),Math.abs(Math.cos(s))<h&&(s=(Math.round(s/Math.PI-.5)+.5)*Math.PI-.001),Math.abs(Math.sin(l))<h&&(l=Math.round(l/Math.PI)*Math.PI),Math.abs(Math.cos(l))<h&&(l=(Math.round(l/Math.PI-.5)+.5)*Math.PI),this.camera.setArmRotation(s,l)}this.redraw();var c=this.getCameraPosition();this.emit("cameraPositionChange",c),ho(t)},ha.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",this.leftButtonDown=!1,lo(document,"mousemove",this.onmousemove),lo(document,"mouseup",this.onmouseup),ho(t)},ha.prototype._onClick=function(t){if(this.onclick_callback||this.hasListeners("click")){if(this.moving)this.moving=!1;else{var e=this.frame.getBoundingClientRect(),i=ca(t)-e.left,r=ua(t)-e.top,n=this._dataPointFromXY(i,r);n&&(this.onclick_callback&&this.onclick_callback(n.point.data),this.emit("click",n.point.data))}ho(t)}},ha.prototype._onTooltip=function(t){var e=this.tooltipDelay,i=this.frame.getBoundingClientRect(),r=ca(t)-i.left,n=ua(t)-i.top;if(this.showTooltip)if(this.tooltipTimeout&&clearTimeout(this.tooltipTimeout),this.leftButtonDown)this._hideTooltip();else if(this.tooltip&&this.tooltip.dataPoint){var o=this._dataPointFromXY(r,n);o!==this.tooltip.dataPoint&&(o?this._showTooltip(o):this._hideTooltip())}else{var a=this;this.tooltipTimeout=xt((function(){a.tooltipTimeout=null;var t=a._dataPointFromXY(r,n);t&&a._showTooltip(t)}),e)}},ha.prototype._onTouchStart=function(t){this.touchDown=!0;var e=this;this.ontouchmove=function(t){e._onTouchMove(t)},this.ontouchend=function(t){e._onTouchEnd(t)},so(document,"touchmove",e.ontouchmove),so(document,"touchend",e.ontouchend),this._onMouseDown(t)},ha.prototype._onTouchMove=function(t){this._onMouseMove(t)},ha.prototype._onTouchEnd=function(t){this.touchDown=!1,lo(document,"touchmove",this.ontouchmove),lo(document,"touchend",this.ontouchend),this._onMouseUp(t)},ha.prototype._onWheel=function(t){if(t||(t=window.event),this.zoomable&&(!this.ctrlToZoom||t.ctrlKey)){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail&&(e=-t.detail/3),e){var i=this.camera.getArmLength()*(1-e/10);this.camera.setArmLength(i),this.redraw(),this._hideTooltip()}var r=this.getCameraPosition();this.emit("cameraPositionChange",r),ho(t)}},ha.prototype._insideTriangle=function(t,e){var i=e[0],r=e[1],n=e[2];function o(t){return t>0?1:t<0?-1:0}var a=o((r.x-i.x)*(t.y-i.y)-(r.y-i.y)*(t.x-i.x)),s=o((n.x-r.x)*(t.y-r.y)-(n.y-r.y)*(t.x-r.x)),l=o((i.x-n.x)*(t.y-n.y)-(i.y-n.y)*(t.x-n.x));return!(0!=a&&0!=s&&a!=s||0!=s&&0!=l&&s!=l||0!=a&&0!=l&&a!=l)},ha.prototype._dataPointFromXY=function(t,e){var i,r=null,n=null,o=null,a=new po(t,e);if(this.style===ha.STYLE.BAR||this.style===ha.STYLE.BARCOLOR||this.style===ha.STYLE.BARSIZE)for(i=this.dataPoints.length-1;i>=0;i--){var s=(r=this.dataPoints[i]).surfaces;if(s)for(var l=s.length-1;l>=0;l--){var h=s[l].corners,c=[h[0].screen,h[1].screen,h[2].screen],u=[h[2].screen,h[3].screen,h[0].screen];if(this._insideTriangle(a,c)||this._insideTriangle(a,u))return r}}else for(i=0;i<this.dataPoints.length;i++){var f=(r=this.dataPoints[i]).screen;if(f){var d=Math.abs(t-f.x),p=Math.abs(e-f.y),y=Math.sqrt(d*d+p*p);(null===o||y<o)&&y<100&&(o=y,n=r)}}return n},ha.prototype.hasBars=function(t){return t==ha.STYLE.BAR||t==ha.STYLE.BARCOLOR||t==ha.STYLE.BARSIZE},ha.prototype._showTooltip=function(t){var e,i,r;this.tooltip?(e=this.tooltip.dom.content,i=this.tooltip.dom.line,r=this.tooltip.dom.dot):(e=document.createElement("div"),ut(e.style,{},this.tooltipStyle.content),e.style.position="absolute",i=document.createElement("div"),ut(i.style,{},this.tooltipStyle.line),i.style.position="absolute",r=document.createElement("div"),ut(r.style,{},this.tooltipStyle.dot),r.style.position="absolute",this.tooltip={dataPoint:null,dom:{content:e,line:i,dot:r}}),this._hideTooltip(),this.tooltip.dataPoint=t,"function"==typeof this.showTooltip?e.innerHTML=this.showTooltip(t.point):e.innerHTML="<table><tr><td>"+this.xLabel+":</td><td>"+t.point.x+"</td></tr><tr><td>"+this.yLabel+":</td><td>"+t.point.y+"</td></tr><tr><td>"+this.zLabel+":</td><td>"+t.point.z+"</td></tr></table>",e.style.left="0",e.style.top="0",this.frame.appendChild(e),this.frame.appendChild(i),this.frame.appendChild(r);var n=e.offsetWidth,o=e.offsetHeight,a=i.offsetHeight,s=r.offsetWidth,l=r.offsetHeight,h=t.screen.x-n/2;h=Math.min(Math.max(h,10),this.frame.clientWidth-10-n),i.style.left=t.screen.x+"px",i.style.top=t.screen.y-a+"px",e.style.left=h+"px",e.style.top=t.screen.y-a-o+"px",r.style.left=t.screen.x-s/2+"px",r.style.top=t.screen.y-l/2+"px"},ha.prototype._hideTooltip=function(){if(this.tooltip)for(var t in this.tooltip.dataPoint=null,this.tooltip.dom)if(this.tooltip.dom.hasOwnProperty(t)){var e=this.tooltip.dom[t];e&&e.parentNode&&e.parentNode.removeChild(e)}},ha.prototype.setCameraPosition=function(t){Bo(t,this),this.redraw()},ha.prototype.setSize=function(t,e){this._setSize(t,e),this.redraw()};export{ha as Graph3d,Co as Graph3dCamera,sa as Graph3dFilter,po as Graph3dPoint2d,fo as Graph3dPoint3d,yo as Graph3dSlider,mo as Graph3dStepNumber};
//# sourceMappingURL=vis-graph3d.min.js.map
