/**
 * vis-graph3d
 * https://visjs.github.io/vis-graph3d/
 *
 * Create interactive, animated 3d graphs. Surfaces, lines, dots and block styling out of the box.
 *
 * @version 6.0.1
 * @date    2020-12-16T19:56:54.897Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports,require("vis-data/peer/umd/vis-data.js")):"function"==typeof define&&define.amd?define(["exports","vis-data/peer/umd/vis-data.js"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).vis=t.vis||{},t.vis)}(this,(function(t,e){var i="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function r(t,e,i){return t(i={path:e,exports:{},require:function(t,e){return function(){throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs")}(null==e&&i.path)}},i.exports),i.exports}var n=function(t){return t&&t.Math==Math&&t},o=n("object"==typeof globalThis&&globalThis)||n("object"==typeof window&&window)||n("object"==typeof self&&self)||n("object"==typeof i&&i)||function(){return this}()||Function("return this")(),a=function(t){try{return!!t()}catch(t){return!0}},s=!a((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),l={}.propertyIsEnumerable,h=Object.getOwnPropertyDescriptor,c={f:h&&!l.call({1:2},1)?function(t){var e=h(this,t);return!!e&&e.enumerable}:l},u=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},f={}.toString,d=function(t){return f.call(t).slice(8,-1)},p="".split,y=a((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==d(t)?p.call(t,""):Object(t)}:Object,v=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},m=function(t){return y(v(t))},g=function(t){return"object"==typeof t?null!==t:"function"==typeof t},b=function(t,e){if(!g(t))return t;var i,r;if(e&&"function"==typeof(i=t.toString)&&!g(r=i.call(t)))return r;if("function"==typeof(i=t.valueOf)&&!g(r=i.call(t)))return r;if(!e&&"function"==typeof(i=t.toString)&&!g(r=i.call(t)))return r;throw TypeError("Can't convert object to primitive value")},x={}.hasOwnProperty,w=function(t,e){return x.call(t,e)},_=o.document,S=g(_)&&g(_.createElement),L=function(t){return S?_.createElement(t):{}},C=!s&&!a((function(){return 7!=Object.defineProperty(L("div"),"a",{get:function(){return 7}}).a})),A=Object.getOwnPropertyDescriptor,T={f:s?A:function(t,e){if(t=m(t),e=b(e,!0),C)try{return A(t,e)}catch(t){}if(w(t,e))return u(!c.f.call(t,e),t[e])}},O=/#|\.prototype\./,M=function(t,e){var i=E[P(t)];return i==D||i!=R&&("function"==typeof e?a(e):!!e)},P=M.normalize=function(t){return String(t).replace(O,".").toLowerCase()},E=M.data={},R=M.NATIVE="N",D=M.POLYFILL="P",k=M,z={},I=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},j=function(t,e,i){if(I(t),void 0===e)return t;switch(i){case 0:return function(){return t.call(e)};case 1:return function(i){return t.call(e,i)};case 2:return function(i,r){return t.call(e,i,r)};case 3:return function(i,r,n){return t.call(e,i,r,n)}}return function(){return t.apply(e,arguments)}},B=function(t){if(!g(t))throw TypeError(String(t)+" is not an object");return t},F=Object.defineProperty,W={f:s?F:function(t,e,i){if(B(t),e=b(e,!0),B(i),C)try{return F(t,e,i)}catch(t){}if("get"in i||"set"in i)throw TypeError("Accessors not supported");return"value"in i&&(t[e]=i.value),t}},G=s?function(t,e,i){return W.f(t,e,u(1,i))}:function(t,e,i){return t[e]=i,t},N=T.f,Y=function(t){var e=function(e,i,r){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,i)}return new t(e,i,r)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},V=function(t,e){var i,r,n,a,s,l,h,c,u=t.target,f=t.global,d=t.stat,p=t.proto,y=f?o:d?o[u]:(o[u]||{}).prototype,v=f?z:z[u]||(z[u]={}),m=v.prototype;for(n in e)i=!k(f?n:u+(d?".":"#")+n,t.forced)&&y&&w(y,n),s=v[n],i&&(l=t.noTargetGet?(c=N(y,n))&&c.value:y[n]),a=i&&l?l:e[n],i&&typeof s==typeof a||(h=t.bind&&i?j(a,o):t.wrap&&i?Y(a):p&&"function"==typeof a?j(Function.call,a):a,(t.sham||a&&a.sham||s&&s.sham)&&G(h,"sham",!0),v[n]=h,p&&(w(z,r=u+"Prototype")||G(z,r,{}),z[r][n]=a,t.real&&m&&!m[n]&&G(m,n,a)))},X=Math.ceil,Z=Math.floor,U=function(t){return isNaN(t=+t)?0:(t>0?Z:X)(t)},H=Math.min,$=function(t){return t>0?H(U(t),9007199254740991):0},J=Math.max,q=Math.min,K=function(t,e){var i=U(t);return i<0?J(i+e,0):q(i,e)},Q=function(t){return function(e,i,r){var n,o=m(e),a=$(o.length),s=K(r,a);if(t&&i!=i){for(;a>s;)if((n=o[s++])!=n)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===i)return t||s||0;return!t&&-1}},tt={includes:Q(!0),indexOf:Q(!1)},et={},it=tt.indexOf,rt=function(t,e){var i,r=m(t),n=0,o=[];for(i in r)!w(et,i)&&w(r,i)&&o.push(i);for(;e.length>n;)w(r,i=e[n++])&&(~it(o,i)||o.push(i));return o},nt=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],ot=Object.keys||function(t){return rt(t,nt)},at={f:Object.getOwnPropertySymbols},st=function(t){return Object(v(t))},lt=Object.assign,ht=Object.defineProperty,ct=!lt||a((function(){if(s&&1!==lt({b:1},lt(ht({},"a",{enumerable:!0,get:function(){ht(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},i=Symbol(),r="abcdefghijklmnopqrst";return t[i]=7,r.split("").forEach((function(t){e[t]=t})),7!=lt({},t)[i]||ot(lt({},e)).join("")!=r}))?function(t,e){for(var i=st(t),r=arguments.length,n=1,o=at.f,a=c.f;r>n;)for(var l,h=y(arguments[n++]),u=o?ot(h).concat(o(h)):ot(h),f=u.length,d=0;f>d;)l=u[d++],s&&!a.call(h,l)||(i[l]=h[l]);return i}:lt;V({target:"Object",stat:!0,forced:Object.assign!==ct},{assign:ct});var ut=z.Object.assign,ft=function(t){return"function"==typeof t?t:void 0},dt=function(t,e){return arguments.length<2?ft(z[t])||ft(o[t]):z[t]&&z[t][e]||o[t]&&o[t][e]},pt=dt("navigator","userAgent")||"",yt=[].slice,vt=/MSIE .\./.test(pt),mt=function(t){return function(e,i){var r=arguments.length>2,n=r?yt.call(arguments,2):void 0;return t(r?function(){("function"==typeof e?e:Function(e)).apply(this,n)}:e,i)}};V({global:!0,bind:!0,forced:vt},{setTimeout:mt(o.setTimeout),setInterval:mt(o.setInterval)});var gt,bt,xt=z.setTimeout,wt=Array.isArray||function(t){return"Array"==d(t)},_t=function(t,e,i){var r=b(e);r in t?W.f(t,r,u(0,i)):t[r]=i},St="__core-js_shared__",Lt=o[St]||function(t,e){try{G(o,t,e)}catch(i){o[t]=e}return e}(St,{}),Ct=r((function(t){(t.exports=function(t,e){return Lt[t]||(Lt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.8.1",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),At=0,Tt=Math.random(),Ot=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++At+Tt).toString(36)},Mt=!!Object.getOwnPropertySymbols&&!a((function(){return!String(Symbol())})),Pt=Mt&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Et=Ct("wks"),Rt=o.Symbol,Dt=Pt?Rt:Rt&&Rt.withoutSetter||Ot,kt=function(t){return w(Et,t)||(Mt&&w(Rt,t)?Et[t]=Rt[t]:Et[t]=Dt("Symbol."+t)),Et[t]},zt=kt("species"),It=function(t,e){var i;return wt(t)&&("function"!=typeof(i=t.constructor)||i!==Array&&!wt(i.prototype)?g(i)&&null===(i=i[zt])&&(i=void 0):i=void 0),new(void 0===i?Array:i)(0===e?0:e)},jt=o.process,Bt=jt&&jt.versions,Ft=Bt&&Bt.v8;Ft?bt=(gt=Ft.split("."))[0]+gt[1]:pt&&(!(gt=pt.match(/Edge\/(\d+)/))||gt[1]>=74)&&(gt=pt.match(/Chrome\/(\d+)/))&&(bt=gt[1]);var Wt=bt&&+bt,Gt=kt("species"),Nt=function(t){return Wt>=51||!a((function(){var e=[];return(e.constructor={})[Gt]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Yt=kt("isConcatSpreadable"),Vt=9007199254740991,Xt="Maximum allowed index exceeded",Zt=Wt>=51||!a((function(){var t=[];return t[Yt]=!1,t.concat()[0]!==t})),Ut=Nt("concat"),Ht=function(t){if(!g(t))return!1;var e=t[Yt];return void 0!==e?!!e:wt(t)};V({target:"Array",proto:!0,forced:!Zt||!Ut},{concat:function(t){var e,i,r,n,o,a=st(this),s=It(a,0),l=0;for(e=-1,r=arguments.length;e<r;e++)if(Ht(o=-1===e?a:arguments[e])){if(l+(n=$(o.length))>Vt)throw TypeError(Xt);for(i=0;i<n;i++,l++)i in o&&_t(s,l,o[i])}else{if(l>=Vt)throw TypeError(Xt);_t(s,l++,o)}return s.length=l,s}});var $t=function(t){return z[t+"Prototype"]},Jt=$t("Array").concat,qt=Array.prototype,Kt=function(t){var e=t.concat;return t===qt||t instanceof Array&&e===qt.concat?Jt:e};V({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var Qt=z.Number.isNaN;V({target:"Array",stat:!0},{isArray:wt});var te=z.Array.isArray,ee=te,ie={f:kt},re=W.f,ne=function(t){var e=z.Symbol||(z.Symbol={});w(e,t)||re(e,t,{value:ie.f(t)})};ne("iterator");var oe=function(t){return function(e,i){var r,n,o=String(v(e)),a=U(i),s=o.length;return a<0||a>=s?t?"":void 0:(r=o.charCodeAt(a))<55296||r>56319||a+1===s||(n=o.charCodeAt(a+1))<56320||n>57343?t?o.charAt(a):r:t?o.slice(a,a+2):n-56320+(r-55296<<10)+65536}},ae={codeAt:oe(!1),charAt:oe(!0)},se=Function.toString;"function"!=typeof Lt.inspectSource&&(Lt.inspectSource=function(t){return se.call(t)});var le,he,ce,ue=Lt.inspectSource,fe=o.WeakMap,de="function"==typeof fe&&/native code/.test(ue(fe)),pe=Ct("keys"),ye=function(t){return pe[t]||(pe[t]=Ot(t))},ve=o.WeakMap;if(de){var me=Lt.state||(Lt.state=new ve),ge=me.get,be=me.has,xe=me.set;le=function(t,e){return e.facade=t,xe.call(me,t,e),e},he=function(t){return ge.call(me,t)||{}},ce=function(t){return be.call(me,t)}}else{var we=ye("state");et[we]=!0,le=function(t,e){return e.facade=t,G(t,we,e),e},he=function(t){return w(t,we)?t[we]:{}},ce=function(t){return w(t,we)}}var _e,Se,Le,Ce={set:le,get:he,has:ce,enforce:function(t){return ce(t)?he(t):le(t,{})},getterFor:function(t){return function(e){var i;if(!g(e)||(i=he(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return i}}},Ae=!a((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Te=ye("IE_PROTO"),Oe=Object.prototype,Me=Ae?Object.getPrototypeOf:function(t){return t=st(t),w(t,Te)?t[Te]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?Oe:null},Pe=(kt("iterator"),!1);[].keys&&("next"in(Le=[].keys())?(Se=Me(Me(Le)))!==Object.prototype&&(_e=Se):Pe=!0),null==_e&&(_e={});var Ee,Re={IteratorPrototype:_e,BUGGY_SAFARI_ITERATORS:Pe},De=s?Object.defineProperties:function(t,e){B(t);for(var i,r=ot(e),n=r.length,o=0;n>o;)W.f(t,i=r[o++],e[i]);return t},ke=dt("document","documentElement"),ze=ye("IE_PROTO"),Ie=function(){},je=function(t){return"<script>"+t+"</"+"script>"},Be=function(){try{Ee=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;Be=Ee?function(t){t.write(je("")),t.close();var e=t.parentWindow.Object;return t=null,e}(Ee):((e=L("iframe")).style.display="none",ke.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(je("document.F=Object")),t.close(),t.F);for(var i=nt.length;i--;)delete Be.prototype[nt[i]];return Be()};et[ze]=!0;var Fe=Object.create||function(t,e){var i;return null!==t?(Ie.prototype=B(t),i=new Ie,Ie.prototype=null,i[ze]=t):i=Be(),void 0===e?i:De(i,e)},We={};We[kt("toStringTag")]="z";var Ge="[object z]"===String(We),Ne=kt("toStringTag"),Ye="Arguments"==d(function(){return arguments}()),Ve=Ge?d:function(t){var e,i,r;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(i=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),Ne))?i:Ye?d(e):"Object"==(r=d(e))&&"function"==typeof e.callee?"Arguments":r},Xe=Ge?{}.toString:function(){return"[object "+Ve(this)+"]"},Ze=W.f,Ue=kt("toStringTag"),He=function(t,e,i,r){if(t){var n=i?t:t.prototype;w(n,Ue)||Ze(n,Ue,{configurable:!0,value:e}),r&&!Ge&&G(n,"toString",Xe)}},$e={},Je=Re.IteratorPrototype,qe=function(){return this},Ke=(Object.setPrototypeOf||"__proto__"in{}&&function(){var t,e=!1,i={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(i,[]),e=i instanceof Array}catch(t){}}(),function(t,e,i,r){r&&r.enumerable?t[e]=i:G(t,e,i)}),Qe=Re.IteratorPrototype,ti=Re.BUGGY_SAFARI_ITERATORS,ei=kt("iterator"),ii="keys",ri="values",ni="entries",oi=function(){return this},ai=function(t,e,i,r,n,o,a){!function(t,e,i){var r=e+" Iterator";t.prototype=Fe(Je,{next:u(1,i)}),He(t,r,!1,!0),$e[r]=qe}(i,e,r);var s,l,h,c=function(t){if(t===n&&v)return v;if(!ti&&t in p)return p[t];switch(t){case ii:case ri:case ni:return function(){return new i(this,t)}}return function(){return new i(this)}},f=e+" Iterator",d=!1,p=t.prototype,y=p[ei]||p["@@iterator"]||n&&p[n],v=!ti&&y||c(n),m="Array"==e&&p.entries||y;if(m&&(s=Me(m.call(new t)),Qe!==Object.prototype&&s.next&&(He(s,f,!0,!0),$e[f]=oi)),n==ri&&y&&y.name!==ri&&(d=!0,v=function(){return y.call(this)}),a&&p[ei]!==v&&G(p,ei,v),$e[e]=v,n)if(l={values:c(ri),keys:o?v:c(ii),entries:c(ni)},a)for(h in l)(ti||d||!(h in p))&&Ke(p,h,l[h]);else V({target:e,proto:!0,forced:ti||d},l);return l},si=ae.charAt,li="String Iterator",hi=Ce.set,ci=Ce.getterFor(li);ai(String,"String",(function(t){hi(this,{type:li,string:String(t),index:0})}),(function(){var t,e=ci(this),i=e.string,r=e.index;return r>=i.length?{value:void 0,done:!0}:(t=si(i,r),e.index+=t.length,{value:t,done:!1})}));var ui="Array Iterator",fi=Ce.set,di=Ce.getterFor(ui);ai(Array,"Array",(function(t,e){fi(this,{type:ui,target:m(t),index:0,kind:e})}),(function(){var t=di(this),e=t.target,i=t.kind,r=t.index++;return!e||r>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==i?{value:r,done:!1}:"values"==i?{value:e[r],done:!1}:{value:[r,e[r]],done:!1}}),"values");$e.Arguments=$e.Array;var pi=kt("toStringTag");for(var yi in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var vi=o[yi],mi=vi&&vi.prototype;mi&&Ve(mi)!==pi&&G(mi,pi,yi),$e[yi]=$e.Array}var gi=ie.f("iterator"),bi=nt.concat("length","prototype"),xi={f:Object.getOwnPropertyNames||function(t){return rt(t,bi)}},wi=xi.f,_i={}.toString,Si="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],Li={f:function(t){return Si&&"[object Window]"==_i.call(t)?function(t){try{return wi(t)}catch(t){return Si.slice()}}(t):wi(m(t))}},Ci=[].push,Ai=function(t){var e=1==t,i=2==t,r=3==t,n=4==t,o=6==t,a=7==t,s=5==t||o;return function(l,h,c,u){for(var f,d,p=st(l),v=y(p),m=j(h,c,3),g=$(v.length),b=0,x=u||It,w=e?x(l,g):i||a?x(l,0):void 0;g>b;b++)if((s||b in v)&&(d=m(f=v[b],b,p),t))if(e)w[b]=d;else if(d)switch(t){case 3:return!0;case 5:return f;case 6:return b;case 2:Ci.call(w,f)}else switch(t){case 4:return!1;case 7:Ci.call(w,f)}return o?-1:r||n?n:w}},Ti={forEach:Ai(0),map:Ai(1),filter:Ai(2),some:Ai(3),every:Ai(4),find:Ai(5),findIndex:Ai(6),filterOut:Ai(7)},Oi=Ti.forEach,Mi=ye("hidden"),Pi="Symbol",Ei=kt("toPrimitive"),Ri=Ce.set,Di=Ce.getterFor(Pi),ki=Object.prototype,zi=o.Symbol,Ii=dt("JSON","stringify"),ji=T.f,Bi=W.f,Fi=Li.f,Wi=c.f,Gi=Ct("symbols"),Ni=Ct("op-symbols"),Yi=Ct("string-to-symbol-registry"),Vi=Ct("symbol-to-string-registry"),Xi=Ct("wks"),Zi=o.QObject,Ui=!Zi||!Zi.prototype||!Zi.prototype.findChild,Hi=s&&a((function(){return 7!=Fe(Bi({},"a",{get:function(){return Bi(this,"a",{value:7}).a}})).a}))?function(t,e,i){var r=ji(ki,e);r&&delete ki[e],Bi(t,e,i),r&&t!==ki&&Bi(ki,e,r)}:Bi,$i=function(t,e){var i=Gi[t]=Fe(zi.prototype);return Ri(i,{type:Pi,tag:t,description:e}),s||(i.description=e),i},Ji=Pt?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof zi},qi=function(t,e,i){t===ki&&qi(Ni,e,i),B(t);var r=b(e,!0);return B(i),w(Gi,r)?(i.enumerable?(w(t,Mi)&&t[Mi][r]&&(t[Mi][r]=!1),i=Fe(i,{enumerable:u(0,!1)})):(w(t,Mi)||Bi(t,Mi,u(1,{})),t[Mi][r]=!0),Hi(t,r,i)):Bi(t,r,i)},Ki=function(t,e){B(t);var i=m(e),r=ot(i).concat(ir(i));return Oi(r,(function(e){s&&!Qi.call(i,e)||qi(t,e,i[e])})),t},Qi=function(t){var e=b(t,!0),i=Wi.call(this,e);return!(this===ki&&w(Gi,e)&&!w(Ni,e))&&(!(i||!w(this,e)||!w(Gi,e)||w(this,Mi)&&this[Mi][e])||i)},tr=function(t,e){var i=m(t),r=b(e,!0);if(i!==ki||!w(Gi,r)||w(Ni,r)){var n=ji(i,r);return!n||!w(Gi,r)||w(i,Mi)&&i[Mi][r]||(n.enumerable=!0),n}},er=function(t){var e=Fi(m(t)),i=[];return Oi(e,(function(t){w(Gi,t)||w(et,t)||i.push(t)})),i},ir=function(t){var e=t===ki,i=Fi(e?Ni:m(t)),r=[];return Oi(i,(function(t){!w(Gi,t)||e&&!w(ki,t)||r.push(Gi[t])})),r};if(Mt||(Ke((zi=function(){if(this instanceof zi)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=Ot(t),i=function(t){this===ki&&i.call(Ni,t),w(this,Mi)&&w(this[Mi],e)&&(this[Mi][e]=!1),Hi(this,e,u(1,t))};return s&&Ui&&Hi(ki,e,{configurable:!0,set:i}),$i(e,t)}).prototype,"toString",(function(){return Di(this).tag})),Ke(zi,"withoutSetter",(function(t){return $i(Ot(t),t)})),c.f=Qi,W.f=qi,T.f=tr,xi.f=Li.f=er,at.f=ir,ie.f=function(t){return $i(kt(t),t)},s&&Bi(zi.prototype,"description",{configurable:!0,get:function(){return Di(this).description}})),V({global:!0,wrap:!0,forced:!Mt,sham:!Mt},{Symbol:zi}),Oi(ot(Xi),(function(t){ne(t)})),V({target:Pi,stat:!0,forced:!Mt},{for:function(t){var e=String(t);if(w(Yi,e))return Yi[e];var i=zi(e);return Yi[e]=i,Vi[i]=e,i},keyFor:function(t){if(!Ji(t))throw TypeError(t+" is not a symbol");if(w(Vi,t))return Vi[t]},useSetter:function(){Ui=!0},useSimple:function(){Ui=!1}}),V({target:"Object",stat:!0,forced:!Mt,sham:!s},{create:function(t,e){return void 0===e?Fe(t):Ki(Fe(t),e)},defineProperty:qi,defineProperties:Ki,getOwnPropertyDescriptor:tr}),V({target:"Object",stat:!0,forced:!Mt},{getOwnPropertyNames:er,getOwnPropertySymbols:ir}),V({target:"Object",stat:!0,forced:a((function(){at.f(1)}))},{getOwnPropertySymbols:function(t){return at.f(st(t))}}),Ii){var rr=!Mt||a((function(){var t=zi();return"[null]"!=Ii([t])||"{}"!=Ii({a:t})||"{}"!=Ii(Object(t))}));V({target:"JSON",stat:!0,forced:rr},{stringify:function(t,e,i){for(var r,n=[t],o=1;arguments.length>o;)n.push(arguments[o++]);if(r=e,(g(e)||void 0!==t)&&!Ji(t))return wt(e)||(e=function(t,e){if("function"==typeof r&&(e=r.call(this,t,e)),!Ji(e))return e}),n[1]=e,Ii.apply(null,n)}})}zi.prototype[Ei]||G(zi.prototype,Ei,zi.prototype.valueOf),He(zi,Pi),et[Mi]=!0,ne("asyncIterator"),ne("hasInstance"),ne("isConcatSpreadable"),ne("match"),ne("matchAll"),ne("replace"),ne("search"),ne("species"),ne("split"),ne("toPrimitive"),ne("toStringTag"),ne("unscopables"),He(o.JSON,"JSON",!0);var nr=z.Symbol;ne("asyncDispose"),ne("dispose"),ne("observable"),ne("patternMatch"),ne("replaceAll");var or=nr,ar=r((function(t){function e(i){return t.exports=e="function"==typeof or&&"symbol"==typeof gi?function(t){return typeof t}:function(t){return t&&"function"==typeof or&&t.constructor===or&&t!==or.prototype?"symbol":typeof t},e(i)}t.exports=e})),sr=function(t,e){var i=[][t];return!!i&&a((function(){i.call(null,e||function(){throw 1},1)}))},lr=Object.defineProperty,hr={},cr=function(t){throw t},ur=function(t,e){if(w(hr,t))return hr[t];e||(e={});var i=[][t],r=!!w(e,"ACCESSORS")&&e.ACCESSORS,n=w(e,0)?e[0]:cr,o=w(e,1)?e[1]:void 0;return hr[t]=!!i&&!a((function(){if(r&&!s)return!0;var t={length:-1};r?lr(t,1,{enumerable:!0,get:cr}):t[1]=1,i.call(t,n,o)}))},fr=Ti.forEach,dr=sr("forEach"),pr=ur("forEach"),yr=dr&&pr?[].forEach:function(t){return fr(this,t,arguments.length>1?arguments[1]:void 0)};V({target:"Array",proto:!0,forced:[].forEach!=yr},{forEach:yr});var vr=$t("Array").forEach,mr=Array.prototype,gr={DOMTokenList:!0,NodeList:!0},br=function(t){var e=t.forEach;return t===mr||t instanceof Array&&e===mr.forEach||gr.hasOwnProperty(Ve(t))?vr:e},xr=$t("Array").values,wr=Array.prototype,_r={DOMTokenList:!0,NodeList:!0},Sr=function(t){var e=t.values;return t===wr||t instanceof Array&&e===wr.values||_r.hasOwnProperty(Ve(t))?xr:e};V({target:"Array",proto:!0},{fill:function(t){for(var e=st(this),i=$(e.length),r=arguments.length,n=K(r>1?arguments[1]:void 0,i),o=r>2?arguments[2]:void 0,a=void 0===o?i:K(o,i);a>n;)e[n++]=t;return e}});var Lr=$t("Array").fill,Cr=Array.prototype,Ar=function(t){var e=t.fill;return t===Cr||t instanceof Array&&e===Cr.fill?Lr:e},Tr="\t\n\v\f\r                　\u2028\u2029\ufeff",Or="["+Tr+"]",Mr=RegExp("^"+Or+Or+"*"),Pr=RegExp(Or+Or+"*$"),Er=function(t){return function(e){var i=String(v(e));return 1&t&&(i=i.replace(Mr,"")),2&t&&(i=i.replace(Pr,"")),i}},Rr={start:Er(1),end:Er(2),trim:Er(3)},Dr=Rr.trim,kr=o.parseFloat,zr=1/kr(Tr+"-0")!=-1/0?function(t){var e=Dr(String(t)),i=kr(e);return 0===i&&"-"==e.charAt(0)?-0:i}:kr;V({global:!0,forced:parseFloat!=zr},{parseFloat:zr});var Ir=z.parseFloat,jr=Ti.filter,Br=Nt("filter"),Fr=ur("filter");V({target:"Array",proto:!0,forced:!Br||!Fr},{filter:function(t){return jr(this,t,arguments.length>1?arguments[1]:void 0)}});var Wr=$t("Array").filter,Gr=Array.prototype,Nr=function(t){var e=t.filter;return t===Gr||t instanceof Array&&e===Gr.filter?Wr:e},Yr=tt.indexOf,Vr=[].indexOf,Xr=!!Vr&&1/[1].indexOf(1,-0)<0,Zr=sr("indexOf"),Ur=ur("indexOf",{ACCESSORS:!0,1:0});V({target:"Array",proto:!0,forced:Xr||!Zr||!Ur},{indexOf:function(t){return Xr?Vr.apply(this,arguments)||0:Yr(this,t,arguments.length>1?arguments[1]:void 0)}});var Hr=$t("Array").indexOf,$r=Array.prototype,Jr=function(t){var e=t.indexOf;return t===$r||t instanceof Array&&e===$r.indexOf?Hr:e},qr=[],Kr=qr.sort,Qr=a((function(){qr.sort(void 0)})),tn=a((function(){qr.sort(null)})),en=sr("sort");V({target:"Array",proto:!0,forced:Qr||!tn||!en},{sort:function(t){return void 0===t?Kr.call(st(this)):Kr.call(st(this),I(t))}});var rn=$t("Array").sort,nn=Array.prototype,on=function(t){var e=t.sort;return t===nn||t instanceof Array&&e===nn.sort?rn:e},an=r((function(t){function e(t){if(t)return function(t){for(var i in e.prototype)t[i]=e.prototype[i];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function i(){this.off(t,i),e.apply(this,arguments)}return i.fn=e,this.on(t,i),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var i,r=this._callbacks["$"+t];if(!r)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var n=0;n<r.length;n++)if((i=r[n])===e||i.fn===e){r.splice(n,1);break}return 0===r.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),i=this._callbacks["$"+t],r=1;r<arguments.length;r++)e[r-1]=arguments[r];if(i){r=0;for(var n=(i=i.slice(0)).length;r<n;++r)i[r].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}));V({target:"Object",stat:!0,forced:!s,sham:!s},{defineProperty:W.f});var sn=r((function(t){var e=z.Object,i=t.exports=function(t,i,r){return e.defineProperty(t,i,r)};e.defineProperty.sham&&(i.sham=!0)}));V({target:"Object",stat:!0,forced:!s,sham:!s},{defineProperties:De});r((function(t){var e=z.Object,i=t.exports=function(t,i){return e.defineProperties(t,i)};e.defineProperties.sham&&(i.sham=!0)}));var ln=dt("Reflect","ownKeys")||function(t){var e=xi.f(B(t)),i=at.f;return i?e.concat(i(t)):e};V({target:"Object",stat:!0,sham:!s},{getOwnPropertyDescriptors:function(t){for(var e,i,r=m(t),n=T.f,o=ln(r),a={},s=0;o.length>s;)void 0!==(i=n(r,e=o[s++]))&&_t(a,e,i);return a}});z.Object.getOwnPropertyDescriptors;var hn=T.f,cn=a((function(){hn(1)}));V({target:"Object",stat:!0,forced:!s||cn,sham:!s},{getOwnPropertyDescriptor:function(t,e){return hn(m(t),e)}});r((function(t){var e=z.Object,i=t.exports=function(t,i){return e.getOwnPropertyDescriptor(t,i)};e.getOwnPropertyDescriptor.sham&&(i.sham=!0)})),z.Object.getOwnPropertySymbols;var un=kt("iterator"),fn=function(t){if(null!=t)return t[un]||t["@@iterator"]||$e[Ve(t)]},dn=function(t,e,i,r){try{return r?e(B(i)[0],i[1]):e(i)}catch(e){throw function(t){var e=t.return;if(void 0!==e)B(e.call(t)).value}(t),e}},pn=kt("iterator"),yn=Array.prototype,vn=function(t){return void 0!==t&&($e.Array===t||yn[pn]===t)},mn=kt("iterator"),gn=!1;try{var bn=0,xn={next:function(){return{done:!!bn++}},return:function(){gn=!0}};xn[mn]=function(){return this},Array.from(xn,(function(){throw 2}))}catch(t){}var wn=!function(t,e){if(!e&&!gn)return!1;var i=!1;try{var r={};r[mn]=function(){return{next:function(){return{done:i=!0}}}},t(r)}catch(t){}return i}((function(t){Array.from(t)}));V({target:"Array",stat:!0,forced:wn},{from:function(t){var e,i,r,n,o,a,s=st(t),l="function"==typeof this?this:Array,h=arguments.length,c=h>1?arguments[1]:void 0,u=void 0!==c,f=fn(s),d=0;if(u&&(c=j(c,h>2?arguments[2]:void 0,2)),null==f||l==Array&&vn(f))for(i=new l(e=$(s.length));e>d;d++)a=u?c(s[d],d):s[d],_t(i,d,a);else for(o=(n=f.call(s)).next,i=new l;!(r=o.call(n)).done;d++)a=u?dn(n,c,[r.value,d],!0):r.value,_t(i,d,a);return i.length=d,i}});var _n=z.Array.from;V({target:"Object",stat:!0,sham:!s},{create:Fe});var Sn,Ln=sn,Cn=Rr.trim;V({target:"String",proto:!0,forced:(Sn="trim",a((function(){return!!Tr[Sn]()||"​᠎"!="​᠎"[Sn]()||Tr[Sn].name!==Sn})))},{trim:function(){return Cn(this)}});$t("String").trim;var An=Rr.trim,Tn=o.parseInt,On=/^[+-]?0[Xx]/,Mn=8!==Tn(Tr+"08")||22!==Tn(Tr+"0x16")?function(t,e){var i=An(String(t));return Tn(i,e>>>0||(On.test(i)?16:10))}:Tn;V({global:!0,forced:parseInt!=Mn},{parseInt:Mn});var Pn=z.parseInt,En=c.f,Rn=function(t){return function(e){for(var i,r=m(e),n=ot(r),o=n.length,a=0,l=[];o>a;)i=n[a++],s&&!En.call(r,i)||l.push(t?[i,r[i]]:r[i]);return l}},Dn={entries:Rn(!0),values:Rn(!1)}.values;V({target:"Object",stat:!0},{values:function(t){return Dn(t)}});z.Object.values;var kn=a((function(){Me(1)}));V({target:"Object",stat:!0,forced:kn,sham:!Ae},{getPrototypeOf:function(t){return Me(st(t))}});var zn=z.Object.getPrototypeOf,In=te,jn=kt("iterator"),Bn=function(t){var e=Object(t);return void 0!==e[jn]||"@@iterator"in e||$e.hasOwnProperty(Ve(e))},Fn=_n,Wn=Nt("slice"),Gn=ur("slice",{ACCESSORS:!0,0:0,1:2}),Nn=kt("species"),Yn=[].slice,Vn=Math.max;V({target:"Array",proto:!0,forced:!Wn||!Gn},{slice:function(t,e){var i,r,n,o=m(this),a=$(o.length),s=K(t,a),l=K(void 0===e?a:e,a);if(wt(o)&&("function"!=typeof(i=o.constructor)||i!==Array&&!wt(i.prototype)?g(i)&&null===(i=i[Nn])&&(i=void 0):i=void 0,i===Array||void 0===i))return Yn.call(o,s,l);for(r=new(void 0===i?Array:i)(Vn(l-s,0)),n=0;s<l;s++,n++)s in o&&_t(r,n,o[s]);return r.length=n,r}});var Xn=$t("Array").slice,Zn=Array.prototype,Un=function(t){var e=t.slice;return t===Zn||t instanceof Array&&e===Zn.slice?Xn:e},Hn=Un;var $n=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,r=new Array(e);i<e;i++)r[i]=t[i];return r};var Jn=function(t,e){var i;if(t){if("string"==typeof t)return $n(t,e);var r=Hn(i=Object.prototype.toString.call(t)).call(i,8,-1);return"Object"===r&&t.constructor&&(r=t.constructor.name),"Map"===r||"Set"===r?Fn(t):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?$n(t,e):void 0}};V({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});z.Date.now;var qn=a((function(){ot(1)}));V({target:"Object",stat:!0,forced:qn},{keys:function(t){return ot(st(t))}});var Kn=z.Object.keys,Qn=Ti.map,to=Nt("map"),eo=ur("map");V({target:"Array",proto:!0,forced:!to||!eo},{map:function(t){return Qn(this,t,arguments.length>1?arguments[1]:void 0)}});var io=$t("Array").map,ro=Array.prototype,no=function(t){var e=t.map;return t===ro||t instanceof Array&&e===ro.map?io:e};V({target:"Reflect",stat:!0},{ownKeys:ln});z.Reflect.ownKeys;var oo=Un;var ao=function(t){if(In(t))return $n(t)};var so=function(t){if(void 0!==or&&Bn(Object(t)))return Fn(t)};var lo=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var ho=function(t){return ao(t)||so(t)||Jn(t)||lo()},co=(nr("DELETE"),/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i),uo=/^#?([a-f\d])([a-f\d])([a-f\d])$/i;function fo(t,e,i,r){var n=!1;!0===r&&(n=null===e[i]&&void 0!==t[i]),n?delete t[i]:t[i]=e[i]}function po(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var n in e)if(Object.prototype.hasOwnProperty.call(e,n)||!0===i)if("object"===ar(e[n])&&null!==e[n]&&zn(e[n])===Object.prototype)void 0===t[n]?t[n]=po({},e[n],i):"object"===ar(t[n])&&null!==t[n]&&zn(t[n])===Object.prototype?po(t[n],e[n],i):fo(t,e,n,r);else if(ee(e[n])){var o;t[n]=oo(o=e[n]).call(o)}else fo(t,e,n,r);return t}function yo(t,e){var i;return Kt(i=[]).call(i,ho(t),[e])}function vo(t){return oo(t).call(t)}function mo(t,e,i,r){var n;t.addEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&Jr(n=navigator.userAgent).call(n,"Firefox")>=0&&(e="DOMMouseScroll"),t.addEventListener(e,i,r)):t.attachEvent("on"+e,i)}function go(t,e,i,r){var n;t.removeEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&Jr(n=navigator.userAgent).call(n,"Firefox")>=0&&(e="DOMMouseScroll"),t.removeEventListener(e,i,r)):t.detachEvent("on"+e,i)}function bo(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)}function xo(t,e,i){var r,n,o,a=Math.floor(6*t),s=6*t-a,l=i*(1-e),h=i*(1-s*e),c=i*(1-(1-s)*e);switch(a%6){case 0:r=i,n=c,o=l;break;case 1:r=h,n=i,o=l;break;case 2:r=l,n=i,o=c;break;case 3:r=l,n=h,o=i;break;case 4:r=c,n=l,o=i;break;case 5:r=i,n=l,o=h}return{r:Math.floor(255*r),g:Math.floor(255*n),b:Math.floor(255*o)}}function wo(t,e,i){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0,this.z=void 0!==i?i:0}wo.subtract=function(t,e){var i=new wo;return i.x=t.x-e.x,i.y=t.y-e.y,i.z=t.z-e.z,i},wo.add=function(t,e){var i=new wo;return i.x=t.x+e.x,i.y=t.y+e.y,i.z=t.z+e.z,i},wo.avg=function(t,e){return new wo((t.x+e.x)/2,(t.y+e.y)/2,(t.z+e.z)/2)},wo.scalarProduct=function(t,e){return new wo(t.x*e,t.y*e,t.z*e)},wo.dotProduct=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},wo.crossProduct=function(t,e){var i=new wo;return i.x=t.y*e.z-t.z*e.y,i.y=t.z*e.x-t.x*e.z,i.z=t.x*e.y-t.y*e.x,i},wo.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},wo.prototype.normalize=function(){return wo.scalarProduct(this,1/this.length())};var _o=wo;var So=function(t,e){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0};function Lo(t,e){if(void 0===t)throw new Error("No container element defined");if(this.container=t,this.visible=!e||null==e.visible||e.visible,this.visible){this.frame=document.createElement("DIV"),this.frame.style.width="100%",this.frame.style.position="relative",this.container.appendChild(this.frame),this.frame.prev=document.createElement("INPUT"),this.frame.prev.type="BUTTON",this.frame.prev.value="Prev",this.frame.appendChild(this.frame.prev),this.frame.play=document.createElement("INPUT"),this.frame.play.type="BUTTON",this.frame.play.value="Play",this.frame.appendChild(this.frame.play),this.frame.next=document.createElement("INPUT"),this.frame.next.type="BUTTON",this.frame.next.value="Next",this.frame.appendChild(this.frame.next),this.frame.bar=document.createElement("INPUT"),this.frame.bar.type="BUTTON",this.frame.bar.style.position="absolute",this.frame.bar.style.border="1px solid red",this.frame.bar.style.width="100px",this.frame.bar.style.height="6px",this.frame.bar.style.borderRadius="2px",this.frame.bar.style.MozBorderRadius="2px",this.frame.bar.style.border="1px solid #7F7F7F",this.frame.bar.style.backgroundColor="#E5E5E5",this.frame.appendChild(this.frame.bar),this.frame.slide=document.createElement("INPUT"),this.frame.slide.type="BUTTON",this.frame.slide.style.margin="0px",this.frame.slide.value=" ",this.frame.slide.style.position="relative",this.frame.slide.style.left="-100px",this.frame.appendChild(this.frame.slide);var i=this;this.frame.slide.onmousedown=function(t){i._onMouseDown(t)},this.frame.prev.onclick=function(t){i.prev(t)},this.frame.play.onclick=function(t){i.togglePlay(t)},this.frame.next.onclick=function(t){i.next(t)}}this.onChangeCallback=void 0,this.values=[],this.index=void 0,this.playTimeout=void 0,this.playInterval=1e3,this.playLoop=!0}function Co(t,e,i,r){this._start=0,this._end=0,this._step=1,this.prettyStep=!0,this.precision=5,this._current=0,this.setRange(t,e,i,r)}Lo.prototype.prev=function(){var t=this.getIndex();t>0&&(t--,this.setIndex(t))},Lo.prototype.next=function(){var t=this.getIndex();t<Sr(this).length-1&&(t++,this.setIndex(t))},Lo.prototype.playNext=function(){var t=new Date,e=this.getIndex();e<Sr(this).length-1?(e++,this.setIndex(e)):this.playLoop&&(e=0,this.setIndex(e));var i=new Date-t,r=Math.max(this.playInterval-i,0),n=this;this.playTimeout=xt((function(){n.playNext()}),r)},Lo.prototype.togglePlay=function(){void 0===this.playTimeout?this.play():this.stop()},Lo.prototype.play=function(){this.playTimeout||(this.playNext(),this.frame&&(this.frame.play.value="Stop"))},Lo.prototype.stop=function(){clearInterval(this.playTimeout),this.playTimeout=void 0,this.frame&&(this.frame.play.value="Play")},Lo.prototype.setOnChangeCallback=function(t){this.onChangeCallback=t},Lo.prototype.setPlayInterval=function(t){this.playInterval=t},Lo.prototype.getPlayInterval=function(){return this.playInterval},Lo.prototype.setPlayLoop=function(t){this.playLoop=t},Lo.prototype.onChange=function(){void 0!==this.onChangeCallback&&this.onChangeCallback()},Lo.prototype.redraw=function(){if(this.frame){this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px",this.frame.bar.style.width=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30+"px";var t=this.indexToLeft(this.index);this.frame.slide.style.left=t+"px"}},Lo.prototype.setValues=function(t){this.values=t,Sr(this).length>0?this.setIndex(0):this.index=void 0},Lo.prototype.setIndex=function(t){if(!(t<Sr(this).length))throw new Error("Index out of range");this.index=t,this.redraw(),this.onChange()},Lo.prototype.getIndex=function(){return this.index},Lo.prototype.get=function(){return Sr(this)[this.index]},Lo.prototype._onMouseDown=function(t){if(t.which?1===t.which:1===t.button){this.startClientX=t.clientX,this.startSlideX=Ir(this.frame.slide.style.left),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},mo(document,"mousemove",this.onmousemove),mo(document,"mouseup",this.onmouseup),bo(t)}},Lo.prototype.leftToIndex=function(t){var e=Ir(this.frame.bar.style.width)-this.frame.slide.clientWidth-10,i=t-3,r=Math.round(i/e*(Sr(this).length-1));return r<0&&(r=0),r>Sr(this).length-1&&(r=Sr(this).length-1),r},Lo.prototype.indexToLeft=function(t){var e=Ir(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return t/(Sr(this).length-1)*e+3},Lo.prototype._onMouseMove=function(t){var e=t.clientX-this.startClientX,i=this.startSlideX+e,r=this.leftToIndex(i);this.setIndex(r),bo()},Lo.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",go(document,"mousemove",this.onmousemove),go(document,"mouseup",this.onmouseup),bo()},Co.prototype.isNumeric=function(t){return!isNaN(Ir(t))&&isFinite(t)},Co.prototype.setRange=function(t,e,i,r){if(!this.isNumeric(t))throw new Error("Parameter 'start' is not numeric; value: "+t);if(!this.isNumeric(e))throw new Error("Parameter 'end' is not numeric; value: "+t);if(!this.isNumeric(i))throw new Error("Parameter 'step' is not numeric; value: "+t);this._start=t||0,this._end=e||0,this.setStep(i,r)},Co.prototype.setStep=function(t,e){void 0===t||t<=0||(void 0!==e&&(this.prettyStep=e),!0===this.prettyStep?this._step=Co.calculatePrettyStep(t):this._step=t)},Co.calculatePrettyStep=function(t){var e=function(t){return Math.log(t)/Math.LN10},i=Math.pow(10,Math.round(e(t))),r=2*Math.pow(10,Math.round(e(t/2))),n=5*Math.pow(10,Math.round(e(t/5))),o=i;return Math.abs(r-t)<=Math.abs(o-t)&&(o=r),Math.abs(n-t)<=Math.abs(o-t)&&(o=n),o<=0&&(o=1),o},Co.prototype.getCurrent=function(){return Ir(this._current.toPrecision(this.precision))},Co.prototype.getStep=function(){return this._step},Co.prototype.start=function(t){void 0===t&&(t=!1),this._current=this._start-this._start%this._step,t&&this.getCurrent()<this._start&&this.next()},Co.prototype.next=function(){this._current+=this._step},Co.prototype.end=function(){return this._current>this._end};var Ao=Co,To=[].reverse,Oo=[1,2];V({target:"Array",proto:!0,forced:String(Oo)===String(Oo.reverse())},{reverse:function(){return wt(this)&&(this.length=this.length),To.call(this)}});var Mo=$t("Array").reverse,Po=Array.prototype,Eo=function(t){var e=t.reverse;return t===Po||t instanceof Array&&e===Po.reverse?Mo:e},Ro=Math.sign||function(t){return 0==(t=+t)||t!=t?t:t<0?-1:1};V({target:"Math",stat:!0},{sign:Ro});var Do=z.Math.sign;function ko(){this.armLocation=new _o,this.armRotation={},this.armRotation.horizontal=0,this.armRotation.vertical=0,this.armLength=1.7,this.cameraOffset=new _o,this.offsetMultiplier=.6,this.cameraLocation=new _o,this.cameraRotation=new _o(.5*Math.PI,0,0),this.calculateCameraOrientation()}ko.prototype.setOffset=function(t,e){var i=Math.abs,r=Do,n=this.offsetMultiplier,o=this.armLength*n;i(t)>o&&(t=r(t)*o),i(e)>o&&(e=r(e)*o),this.cameraOffset.x=t,this.cameraOffset.y=e,this.calculateCameraOrientation()},ko.prototype.getOffset=function(){return this.cameraOffset},ko.prototype.setArmLocation=function(t,e,i){this.armLocation.x=t,this.armLocation.y=e,this.armLocation.z=i,this.calculateCameraOrientation()},ko.prototype.setArmRotation=function(t,e){void 0!==t&&(this.armRotation.horizontal=t),void 0!==e&&(this.armRotation.vertical=e,this.armRotation.vertical<0&&(this.armRotation.vertical=0),this.armRotation.vertical>.5*Math.PI&&(this.armRotation.vertical=.5*Math.PI)),void 0===t&&void 0===e||this.calculateCameraOrientation()},ko.prototype.getArmRotation=function(){var t={};return t.horizontal=this.armRotation.horizontal,t.vertical=this.armRotation.vertical,t},ko.prototype.setArmLength=function(t){void 0!==t&&(this.armLength=t,this.armLength<.71&&(this.armLength=.71),this.armLength>5&&(this.armLength=5),this.setOffset(this.cameraOffset.x,this.cameraOffset.y),this.calculateCameraOrientation())},ko.prototype.getArmLength=function(){return this.armLength},ko.prototype.getCameraLocation=function(){return this.cameraLocation},ko.prototype.getCameraRotation=function(){return this.cameraRotation},ko.prototype.calculateCameraOrientation=function(){this.cameraLocation.x=this.armLocation.x-this.armLength*Math.sin(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.y=this.armLocation.y-this.armLength*Math.cos(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.z=this.armLocation.z+this.armLength*Math.sin(this.armRotation.vertical),this.cameraRotation.x=Math.PI/2-this.armRotation.vertical,this.cameraRotation.y=0,this.cameraRotation.z=-this.armRotation.horizontal;var t=this.cameraRotation.x,e=this.cameraRotation.z,i=this.cameraOffset.x,r=this.cameraOffset.y,n=Math.sin,o=Math.cos;this.cameraLocation.x=this.cameraLocation.x+i*o(e)+r*-n(e)*o(t),this.cameraLocation.y=this.cameraLocation.y+i*n(e)+r*o(e)*o(t),this.cameraLocation.z=this.cameraLocation.z+r*n(t)};var zo={BAR:0,BARCOLOR:1,BARSIZE:2,DOT:3,DOTLINE:4,DOTCOLOR:5,DOTSIZE:6,GRID:7,LINE:8,SURFACE:9},Io={dot:zo.DOT,"dot-line":zo.DOTLINE,"dot-color":zo.DOTCOLOR,"dot-size":zo.DOTSIZE,line:zo.LINE,grid:zo.GRID,surface:zo.SURFACE,bar:zo.BAR,"bar-color":zo.BARCOLOR,"bar-size":zo.BARSIZE},jo=["width","height","filterLabel","legendLabel","xLabel","yLabel","zLabel","xValueLabel","yValueLabel","zValueLabel","showXAxis","showYAxis","showZAxis","showGrayBottom","showGrid","showPerspective","showShadow","showSurfaceGrid","keepAspectRatio","rotateAxisLabels","verticalRatio","dotSizeRatio","dotSizeMinFraction","dotSizeMaxFraction","showAnimationControls","animationInterval","animationPreload","animationAutoStart","axisColor","axisFontSize","axisFontType","gridColor","xCenter","yCenter","zoomable","tooltipDelay","ctrlToZoom"],Bo=["xBarWidth","yBarWidth","valueMin","valueMax","xMin","xMax","xStep","yMin","yMax","yStep","zMin","zMax","zStep"],Fo=void 0;function Wo(t){for(var e in t)if(t.hasOwnProperty(e))return!1;return!0}function Go(t,e){return void 0===t||""===t?e:t+(void 0===(i=e)||""===i||"string"!=typeof i?i:i.charAt(0).toUpperCase()+oo(i).call(i,1));var i}function No(t,e,i,r){for(var n,o=0;o<i.length;++o)e[Go(r,n=i[o])]=t[n]}function Yo(t,e,i,r){for(var n,o=0;o<i.length;++o)void 0!==t[n=i[o]]&&(e[Go(r,n)]=t[n])}function Vo(t,e){if(void 0!==t.backgroundColor&&function(t,e){var i="white",r="gray",n=1;if("string"==typeof t)i=t,r="none",n=0;else{if("object"!==ar(t))throw new Error("Unsupported type of backgroundColor");void 0!==Ar(t)&&(i=Ar(t)),void 0!==t.stroke&&(r=t.stroke),void 0!==t.strokeWidth&&(n=t.strokeWidth)}e.frame.style.backgroundColor=i,e.frame.style.borderColor=r,e.frame.style.borderWidth=n+"px",e.frame.style.borderStyle="solid"}(t.backgroundColor,e),function(t,e){if(void 0===t)return;void 0===e.dataColor&&(e.dataColor={});"string"==typeof t?(e.dataColor.fill=t,e.dataColor.stroke=t):(Ar(t)&&(e.dataColor.fill=Ar(t)),t.stroke&&(e.dataColor.stroke=t.stroke),void 0!==t.strokeWidth&&(e.dataColor.strokeWidth=t.strokeWidth))}(t.dataColor,e),function(t,e){if(void 0===t)return;var i;if("string"==typeof t){if(-1===(i=function(t){var e=Io[t];if(void 0===e)return-1;return e}(t)))throw new Error("Style '"+t+"' is invalid")}else{if(!function(t){var e=!1;for(var i in zo)if(zo[i]===t){e=!0;break}return e}(t))throw new Error("Style '"+t+"' is invalid");i=t}e.style=i}(t.style,e),void 0!==t.surfaceColors){if(console.warn("`options.surfaceColors` is deprecated and may be removed in a future version. Please use `options.colormap` instead. Note that the `colormap` option uses the inverse array ordering (running from vMin to vMax)."),void 0!==t.colormap)throw new Error("The `colormap` and `surfaceColors` options are mutually exclusive.");"surface"!==e.style?console.warn("Ignoring `surfaceColors` in graph style `"+e.style+"` for backward compatibility (only effective in `surface` plots)."):function(t,e){if(void 0===t||!0===t)return;if(!1===t)return void(e.surfaceColors=void 0);void 0===e.surfaceColors&&(e.surfaceColors={});var i;if(ee(t))i=Xo(t);else{if("object"!==ar(t))throw new Error("Unsupported type of surfaceColors");i=Zo(t.hue)}Eo(i).call(i),e.colormap=i}(t.surfaceColors,e)}else!function(t,e){if(void 0===t)return;var i;if(ee(t))i=Xo(t);else if("object"===ar(t))i=Zo(t.hue);else{if("function"!=typeof t)throw new Error("Unsupported type of colormap");i=t}e.colormap=i}(t.colormap,e);!function(t,e){if(void 0===t){if(void 0===Fo.showLegend){var i=e.style===zo.DOTCOLOR||e.style===zo.DOTSIZE;e.showLegend=i}}else e.showLegend=t}(t.showLegend,e),Uo(t.cameraPosition,e),void 0!==t.tooltip&&(e.showTooltip=t.tooltip),null!=t.onclick&&(e.onclick_callback=t.onclick,console.warn("`options.onclick` is deprecated and may be removed in a future version. Please use `Graph3d.on('click', handler)` instead.")),void 0!==t.tooltipStyle&&function(t,e,i){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(ee(i))throw new TypeError("Arrays are not supported by deepExtend");for(var n=0;n<t.length;n++){var o=t[n];if(Object.prototype.hasOwnProperty.call(i,o))if(i[o]&&i[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?po(e[o],i[o],!1,r):fo(e,i,o,r);else{if(ee(i[o]))throw new TypeError("Arrays are not supported by deepExtend");fo(e,i,o,r)}}}(["tooltipStyle"],e,t)}function Xo(t){if(t.length<2)throw new Error("Colormap array length must be 2 or above.");return no(t).call(t,(function(t){if(!function(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}(t))throw new Error("Invalid hex color code supplied to colormap.");return function(t){var e;switch(t.length){case 3:case 4:return(e=uo.exec(t))?{r:Pn(e[1]+e[1],16),g:Pn(e[2]+e[2],16),b:Pn(e[3]+e[3],16)}:null;case 6:case 7:return(e=co.exec(t))?{r:Pn(e[1],16),g:Pn(e[2],16),b:Pn(e[3],16)}:null;default:return null}}(t)}))}function Zo(t){if(void 0===t)throw new Error("Unsupported type of colormap");if(!(t.saturation>=0&&t.saturation<=100))throw new Error("Saturation is out of bounds. Expected range is 0-100.");if(!(t.brightness>=0&&t.brightness<=100))throw new Error("Brightness is out of bounds. Expected range is 0-100.");if(!(t.colorStops>=2))throw new Error("colorStops is out of bounds. Expected 2 or above.");for(var e=(t.end-t.start)/(t.colorStops-1),i=[],r=0;r<t.colorStops;++r){var n=(t.start+e*r)%360/360;i.push(xo(n<0?n+1:n,t.saturation/100,t.brightness/100))}return i}function Uo(t,e){var i=t;void 0!==i&&(void 0===e.camera&&(e.camera=new ko),e.camera.setArmRotation(i.horizontal,i.vertical),e.camera.setArmLength(i.distance))}var Ho=dt("JSON","stringify"),$o=/[\uD800-\uDFFF]/g,Jo=/^[\uD800-\uDBFF]$/,qo=/^[\uDC00-\uDFFF]$/,Ko=function(t,e,i){var r=i.charAt(e-1),n=i.charAt(e+1);return Jo.test(t)&&!qo.test(n)||qo.test(t)&&!Jo.test(r)?"\\u"+t.charCodeAt(0).toString(16):t},Qo=a((function(){return'"\\udf06\\ud834"'!==Ho("\udf06\ud834")||'"\\udead"'!==Ho("\udead")}));Ho&&V({target:"JSON",stat:!0,forced:Qo},{stringify:function(t,e,i){var r=Ho.apply(null,arguments);return"string"==typeof r?r.replace($o,Ko):r}}),z.JSON||(z.JSON={stringify:JSON.stringify});var ta=function(t,e,i){return z.JSON.stringify.apply(null,arguments)};var ea=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};function ia(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Ln(t,r.key,r)}}var ra,na=function(t,e,i){return e&&ia(t.prototype,e),i&&ia(t,i),t},oa=!1,aa="background: #FFeeee; color: #dd0000",sa=function(){function t(){ea(this,t)}return na(t,null,[{key:"validate",value:function(e,i,r){oa=!1,ra=i;var n=i;return void 0!==r&&(n=i[r]),t.parse(e,n,[]),oa}},{key:"parse",value:function(e,i,r){for(var n in e)e.hasOwnProperty(n)&&t.check(n,e,i,r)}},{key:"check",value:function(e,i,r,n){if(void 0!==r[e]||void 0!==r.__any__){var o=e,a=!0;void 0===r[e]&&void 0!==r.__any__&&(o="__any__",a="object"===t.getType(i[e]));var s=r[o];a&&void 0!==s.__type__&&(s=s.__type__),t.checkFields(e,i,r,o,s,n)}else t.getSuggestion(e,r,n)}},{key:"checkFields",value:function(e,i,r,n,o,a){var s=function(i){console.log("%c"+i+t.printLocation(a,e),aa)},l=t.getType(i[e]),h=o[l];void 0!==h?"array"===t.getType(h)&&-1===Jr(h).call(h,i[e])?(s('Invalid option detected in "'+e+'". Allowed values are:'+t.print(h)+' not "'+i[e]+'". '),oa=!0):"object"===l&&"__any__"!==n&&(a=yo(a,e),t.parse(i[e],r[n],a)):void 0===o.any&&(s('Invalid type received for "'+e+'". Expected: '+t.print(Kn(o))+". Received ["+l+'] "'+i[e]+'"'),oa=!0)}},{key:"getType",value:function(t){var e=ar(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":ee(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,r){var n,o=t.findInOptions(e,i,r,!1),a=t.findInOptions(e,ra,[],!0);n=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':a.distance<=4&&o.distance>a.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(a.path,a.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(Kn(i))+t.printLocation(r,e),console.log('%cUnknown option detected: "'+e+'"'+n,aa),oa=!0}},{key:"findInOptions",value:function(e,i,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,a="",s=[],l=e.toLowerCase(),h=void 0;for(var c in i){var u=void 0;if(void 0!==i[c].__type__&&!0===n){var f=t.findInOptions(e,i[c],yo(r,c));o>f.distance&&(a=f.closestMatch,s=f.path,o=f.distance,h=f.indexMatch)}else{var d;-1!==Jr(d=c.toLowerCase()).call(d,l)&&(h=c),o>(u=t.levenshteinDistance(e,c))&&(a=c,s=vo(r),o=u)}}return{closestMatch:a,path:s,distance:o,indexMatch:h}}},{key:"printLocation",value:function(t,e){for(var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",r="\n\n"+i+"options = {\n",n=0;n<t.length;n++){for(var o=0;o<n+1;o++)r+="  ";r+=t[n]+": {\n"}for(var a=0;a<t.length+1;a++)r+="  ";r+=e+"\n";for(var s=0;s<t.length+1;s++){for(var l=0;l<t.length-s;l++)r+="  ";r+="}\n"}return r+"\n\n"}},{key:"print",value:function(t){return ta(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,r,n=[];for(i=0;i<=e.length;i++)n[i]=[i];for(r=0;r<=t.length;r++)n[0][r]=r;for(i=1;i<=e.length;i++)for(r=1;r<=t.length;r++)e.charAt(i-1)==t.charAt(r-1)?n[i][r]=n[i-1][r-1]:n[i][r]=Math.min(n[i-1][r-1]+1,Math.min(n[i][r-1]+1,n[i-1][r]+1));return n[e.length][t.length]}}]),t}(),la="string",ha="boolean",ca="number",ua="object",fa="array",da={fill:{string:la},stroke:{string:la},strokeWidth:{number:ca},__type__:{string:la,object:ua,undefined:"undefined"}},pa={animationAutoStart:{boolean:ha,undefined:"undefined"},animationInterval:{number:ca},animationPreload:{boolean:ha},axisColor:{string:la},axisFontSize:{number:ca},axisFontType:{string:la},backgroundColor:da,xBarWidth:{number:ca,undefined:"undefined"},yBarWidth:{number:ca,undefined:"undefined"},cameraPosition:{distance:{number:ca},horizontal:{number:ca},vertical:{number:ca},__type__:{object:ua}},zoomable:{boolean:ha},ctrlToZoom:{boolean:ha},xCenter:{string:la},yCenter:{string:la},colormap:{hue:{start:{number:ca},end:{number:ca},saturation:{number:ca},brightness:{number:ca},colorStops:{number:ca},__type__:{object:ua}},__type__:{array:fa,object:ua,function:"function",undefined:"undefined"}},dataColor:da,dotSizeMinFraction:{number:ca},dotSizeMaxFraction:{number:ca},dotSizeRatio:{number:ca},filterLabel:{string:la},gridColor:{string:la},onclick:{function:"function"},keepAspectRatio:{boolean:ha},xLabel:{string:la},yLabel:{string:la},zLabel:{string:la},legendLabel:{string:la},xMin:{number:ca,undefined:"undefined"},yMin:{number:ca,undefined:"undefined"},zMin:{number:ca,undefined:"undefined"},xMax:{number:ca,undefined:"undefined"},yMax:{number:ca,undefined:"undefined"},zMax:{number:ca,undefined:"undefined"},showAnimationControls:{boolean:ha,undefined:"undefined"},showGrayBottom:{boolean:ha},showGrid:{boolean:ha},showLegend:{boolean:ha,undefined:"undefined"},showPerspective:{boolean:ha},showShadow:{boolean:ha},showSurfaceGrid:{boolean:ha},showXAxis:{boolean:ha},showYAxis:{boolean:ha},showZAxis:{boolean:ha},rotateAxisLabels:{boolean:ha},surfaceColors:{hue:{start:{number:ca},end:{number:ca},saturation:{number:ca},brightness:{number:ca},colorStops:{number:ca},__type__:{object:ua}},__type__:{boolean:ha,array:fa,object:ua,undefined:"undefined"}},xStep:{number:ca,undefined:"undefined"},yStep:{number:ca,undefined:"undefined"},zStep:{number:ca,undefined:"undefined"},style:{number:ca,string:["bar","bar-color","bar-size","dot","dot-line","dot-color","dot-size","line","grid","surface"]},tooltip:{boolean:ha,function:"function"},tooltipDelay:{number:ca},tooltipStyle:{content:{color:{string:la},background:{string:la},border:{string:la},borderRadius:{string:la},boxShadow:{string:la},padding:{string:la},__type__:{object:ua}},line:{borderLeft:{string:la},height:{string:la},width:{string:la},pointerEvents:{string:la},__type__:{object:ua}},dot:{border:{string:la},borderRadius:{string:la},height:{string:la},width:{string:la},pointerEvents:{string:la},__type__:{object:ua}},__type__:{object:ua}},xValueLabel:{function:"function"},yValueLabel:{function:"function"},zValueLabel:{function:"function"},valueMax:{number:ca,undefined:"undefined"},valueMin:{number:ca,undefined:"undefined"},verticalRatio:{number:ca},height:{string:la},width:{string:la},__type__:{object:ua}};function ya(){this.min=void 0,this.max=void 0}ya.prototype.adjust=function(t){void 0!==t&&((void 0===this.min||this.min>t)&&(this.min=t),(void 0===this.max||this.max<t)&&(this.max=t))},ya.prototype.combine=function(t){this.add(t.min),this.add(t.max)},ya.prototype.expand=function(t){if(void 0!==t){var e=this.min-t,i=this.max+t;if(e>i)throw new Error("Passed expansion value makes range invalid");this.min=e,this.max=i}},ya.prototype.range=function(){return this.max-this.min},ya.prototype.center=function(){return(this.min+this.max)/2};var va=ya;function ma(t,e,i){this.dataGroup=t,this.column=e,this.graph=i,this.index=void 0,this.value=void 0,this.values=t.getDistinctValues(this.column),Sr(this).length>0&&this.selectValue(0),this.dataPoints=[],this.loaded=!1,this.onLoadCallback=void 0,i.animationPreload?(this.loaded=!1,this.loadInBackground()):this.loaded=!0}function ga(){this.dataTable=null}ma.prototype.isLoaded=function(){return this.loaded},ma.prototype.getLoadedProgress=function(){for(var t=Sr(this).length,e=0;this.dataPoints[e];)e++;return Math.round(e/t*100)},ma.prototype.getLabel=function(){return this.graph.filterLabel},ma.prototype.getColumn=function(){return this.column},ma.prototype.getSelectedValue=function(){if(void 0!==this.index)return Sr(this)[this.index]},ma.prototype.getValues=function(){return Sr(this)},ma.prototype.getValue=function(t){if(t>=Sr(this).length)throw new Error("Index out of range");return Sr(this)[t]},ma.prototype._getDataPoints=function(t){if(void 0===t&&(t=this.index),void 0===t)return[];var i;if(this.dataPoints[t])i=this.dataPoints[t];else{var r={};r.column=this.column,r.value=Sr(this)[t];var n=new e.DataView(this.dataGroup.getDataSet(),{filter:function(t){return t[r.column]==r.value}}).get();i=this.dataGroup._getDataPoints(n),this.dataPoints[t]=i}return i},ma.prototype.setOnLoadCallback=function(t){this.onLoadCallback=t},ma.prototype.selectValue=function(t){if(t>=Sr(this).length)throw new Error("Index out of range");this.index=t,this.value=Sr(this)[t]},ma.prototype.loadInBackground=function(t){void 0===t&&(t=0);var e=this.graph.frame;if(t<Sr(this).length){void 0===e.progress&&(e.progress=document.createElement("DIV"),e.progress.style.position="absolute",e.progress.style.color="gray",e.appendChild(e.progress));var i=this.getLoadedProgress();e.progress.innerHTML="Loading animation... "+i+"%",e.progress.style.bottom="60px",e.progress.style.left="10px";var r=this;xt((function(){r.loadInBackground(t+1)}),10),this.loaded=!1}else this.loaded=!0,void 0!==e.progress&&(e.removeChild(e.progress),e.progress=void 0),this.onLoadCallback&&this.onLoadCallback()},ga.prototype.initializeData=function(t,i,r){if(void 0!==i){var n;if(ee(i)&&(i=new e.DataSet(i)),!(i instanceof e.DataSet||i instanceof e.DataView))throw new Error("Array, DataSet, or DataView expected");if(0!=(n=i.get()).length){this.style=r,this.dataSet&&this.dataSet.off("*",this._onChange),this.dataSet=i,this.dataTable=n;var o=this;this._onChange=function(){t.setData(o.dataSet)},this.dataSet.on("*",this._onChange),this.colX="x",this.colY="y",this.colZ="z";var a=t.hasBars(r);if(a&&(void 0!==t.defaultXBarWidth?this.xBarWidth=t.defaultXBarWidth:this.xBarWidth=this.getSmallestDifference(n,this.colX)||1,void 0!==t.defaultYBarWidth?this.yBarWidth=t.defaultYBarWidth:this.yBarWidth=this.getSmallestDifference(n,this.colY)||1),this._initializeRange(n,this.colX,t,a),this._initializeRange(n,this.colY,t,a),this._initializeRange(n,this.colZ,t,!1),n[0].hasOwnProperty("style")){this.colValue="style";var s=this.getColumnRange(n,this.colValue);this._setRangeDefaults(s,t.defaultValueMin,t.defaultValueMax),this.valueRange=s}else this.colValue="z",this.valueRange=this.zRange;return this.getDataTable()[0].hasOwnProperty("filter")&&void 0===this.dataFilter&&(this.dataFilter=new ma(this,"filter",t),this.dataFilter.setOnLoadCallback((function(){t.redraw()}))),this.dataFilter?this.dataFilter._getDataPoints():this._getDataPoints(this.getDataTable())}}},ga.prototype._collectRangeSettings=function(t,e){var i;if(-1==Jr(i=["x","y","z"]).call(i,t))throw new Error("Column '"+t+"' invalid");var r=t.toUpperCase();return{barWidth:this[t+"BarWidth"],min:e["default"+r+"Min"],max:e["default"+r+"Max"],step:e["default"+r+"Step"],range_label:t+"Range",step_label:t+"Step"}},ga.prototype._initializeRange=function(t,e,i,r){var n=this._collectRangeSettings(e,i),o=this.getColumnRange(t,e);r&&"z"!=e&&o.expand(n.barWidth/2),this._setRangeDefaults(o,n.min,n.max),this[n.range_label]=o,this[n.step_label]=void 0!==n.step?n.step:o.range()/5},ga.prototype.getDistinctValues=function(t,e){void 0===e&&(e=this.dataTable);for(var i=[],r=0;r<e.length;r++){var n=e[r][t]||0;-1===Jr(i).call(i,n)&&i.push(n)}return on(i).call(i,(function(t,e){return t-e}))},ga.prototype.getSmallestDifference=function(t,e){for(var i=this.getDistinctValues(t,e),r=null,n=1;n<i.length;n++){var o=i[n]-i[n-1];(null==r||r>o)&&(r=o)}return r},ga.prototype.getColumnRange=function(t,e){for(var i=new va,r=0;r<t.length;r++){var n=t[r][e];i.adjust(n)}return i},ga.prototype.getNumberOfRows=function(){return this.dataTable.length},ga.prototype._setRangeDefaults=function(t,e,i){void 0!==e&&(t.min=e),void 0!==i&&(t.max=i),t.max<=t.min&&(t.max=t.min+1)},ga.prototype.getDataTable=function(){return this.dataTable},ga.prototype.getDataSet=function(){return this.dataSet},ga.prototype.getDataPoints=function(t){for(var e=[],i=0;i<t.length;i++){var r=new _o;r.x=t[i][this.colX]||0,r.y=t[i][this.colY]||0,r.z=t[i][this.colZ]||0,r.data=t[i],r.value=t[i][this.colValue]||0;var n={};n.point=r,n.bottom=new _o(r.x,r.y,this.zRange.min),n.trans=void 0,n.screen=void 0,e.push(n)}return e},ga.prototype.initDataAsMatrix=function(t){var e,i,r,n,o=this.getDistinctValues(this.colX,t),a=this.getDistinctValues(this.colY,t),s=this.getDataPoints(t),l=[];for(r=0;r<s.length;r++){n=s[r];var h=Jr(o).call(o,n.point.x),c=Jr(a).call(a,n.point.y);void 0===l[h]&&(l[h]=[]),l[h][c]=n}for(e=0;e<l.length;e++)for(i=0;i<l[e].length;i++)l[e][i]&&(l[e][i].pointRight=e<l.length-1?l[e+1][i]:void 0,l[e][i].pointTop=i<l[e].length-1?l[e][i+1]:void 0,l[e][i].pointCross=e<l.length-1&&i<l[e].length-1?l[e+1][i+1]:void 0);return s},ga.prototype.getInfo=function(){var t=this.dataFilter;if(t)return t.getLabel()+": "+t.getSelectedValue()},ga.prototype.reload=function(){this.dataTable&&this.setData(this.dataTable)},ga.prototype._getDataPoints=function(t){var e=[];if(this.style===zo.GRID||this.style===zo.SURFACE)e=this.initDataAsMatrix(t);else if(e=this.getDataPoints(t),this.style===zo.LINE)for(var i=0;i<e.length;i++)i>0&&(e[i-1].pointNext=e[i]);return e},xa.STYLE=zo;var ba=void 0;function xa(t,e,i){if(!(this instanceof xa))throw new SyntaxError("Constructor must be called with the new operator");this.containerElement=t,this.dataGroup=new ga,this.dataPoints=null,this.create(),function(t,e){if(void 0===t||Wo(t))throw new Error("No DEFAULTS passed");if(void 0===e)throw new Error("No dst passed");Fo=t,No(t,e,jo),No(t,e,Bo,"default"),Vo(t,e),e.margin=10,e.showTooltip=!1,e.onclick_callback=null,e.eye=new _o(0,0,-1)}(xa.DEFAULTS,this),this.colX=void 0,this.colY=void 0,this.colZ=void 0,this.colValue=void 0,this.setOptions(i),this.setData(e)}function wa(t){return"clientX"in t?t.clientX:t.targetTouches[0]&&t.targetTouches[0].clientX||0}function _a(t){return"clientY"in t?t.clientY:t.targetTouches[0]&&t.targetTouches[0].clientY||0}xa.DEFAULTS={width:"400px",height:"400px",filterLabel:"time",legendLabel:"value",xLabel:"x",yLabel:"y",zLabel:"z",xValueLabel:function(t){return t},yValueLabel:function(t){return t},zValueLabel:function(t){return t},showXAxis:!0,showYAxis:!0,showZAxis:!0,showGrayBottom:!1,showGrid:!0,showPerspective:!0,showShadow:!1,showSurfaceGrid:!0,keepAspectRatio:!0,rotateAxisLabels:!0,verticalRatio:.5,dotSizeRatio:.02,dotSizeMinFraction:.5,dotSizeMaxFraction:2.5,showAnimationControls:ba,animationInterval:1e3,animationPreload:!1,animationAutoStart:ba,axisFontSize:14,axisFontType:"arial",axisColor:"#4D4D4D",gridColor:"#D3D3D3",xCenter:"55%",yCenter:"50%",style:xa.STYLE.DOT,tooltip:!1,tooltipDelay:300,tooltipStyle:{content:{padding:"10px",border:"1px solid #4d4d4d",color:"#1a1a1a",background:"rgba(255,255,255,0.7)",borderRadius:"2px",boxShadow:"5px 5px 10px rgba(128,128,128,0.5)"},line:{height:"40px",width:"0",borderLeft:"1px solid #4d4d4d",pointerEvents:"none"},dot:{height:"0",width:"0",border:"5px solid #4d4d4d",borderRadius:"5px",pointerEvents:"none"}},dataColor:{fill:"#7DC1FF",stroke:"#3267D2",strokeWidth:1},surfaceColors:ba,colormap:ba,cameraPosition:{horizontal:1,vertical:.5,distance:1.7},zoomable:!0,ctrlToZoom:!1,showLegend:ba,backgroundColor:ba,xBarWidth:ba,yBarWidth:ba,valueMin:ba,valueMax:ba,xMin:ba,xMax:ba,xStep:ba,yMin:ba,yMax:ba,yStep:ba,zMin:ba,zMax:ba,zStep:ba},an(xa.prototype),xa.prototype._setScale=function(){this.scale=new _o(1/this.xRange.range(),1/this.yRange.range(),1/this.zRange.range()),this.keepAspectRatio&&(this.scale.x<this.scale.y?this.scale.y=this.scale.x:this.scale.x=this.scale.y),this.scale.z*=this.verticalRatio,void 0!==this.valueRange&&(this.scale.value=1/this.valueRange.range());var t=this.xRange.center()*this.scale.x,e=this.yRange.center()*this.scale.y,i=this.zRange.center()*this.scale.z;this.camera.setArmLocation(t,e,i)},xa.prototype._convert3Dto2D=function(t){var e=this._convertPointToTranslation(t);return this._convertTranslationToScreen(e)},xa.prototype._convertPointToTranslation=function(t){var e=this.camera.getCameraLocation(),i=this.camera.getCameraRotation(),r=t.x*this.scale.x,n=t.y*this.scale.y,o=t.z*this.scale.z,a=e.x,s=e.y,l=e.z,h=Math.sin(i.x),c=Math.cos(i.x),u=Math.sin(i.y),f=Math.cos(i.y),d=Math.sin(i.z),p=Math.cos(i.z);return new _o(f*(d*(n-s)+p*(r-a))-u*(o-l),h*(f*(o-l)+u*(d*(n-s)+p*(r-a)))+c*(p*(n-s)-d*(r-a)),c*(f*(o-l)+u*(d*(n-s)+p*(r-a)))-h*(p*(n-s)-d*(r-a)))},xa.prototype._convertTranslationToScreen=function(t){var e,i,r=this.eye.x,n=this.eye.y,o=this.eye.z,a=t.x,s=t.y,l=t.z;return this.showPerspective?(e=o/l*(a-r),i=o/l*(s-n)):(e=a*(-o/this.camera.getArmLength()),i=s*(-o/this.camera.getArmLength())),new So(this.currentXCenter+e*this.frame.canvas.clientWidth,this.currentYCenter-i*this.frame.canvas.clientWidth)},xa.prototype._calcTranslations=function(t){for(var e=0;e<t.length;e++){var i=t[e];i.trans=this._convertPointToTranslation(i.point),i.screen=this._convertTranslationToScreen(i.trans);var r=this._convertPointToTranslation(i.bottom);i.dist=this.showPerspective?r.length():-r.z}on(t).call(t,(function(t,e){return e.dist-t.dist}))},xa.prototype._initializeRanges=function(){var t=this.dataGroup;this.xRange=t.xRange,this.yRange=t.yRange,this.zRange=t.zRange,this.valueRange=t.valueRange,this.xStep=t.xStep,this.yStep=t.yStep,this.zStep=t.zStep,this.xBarWidth=t.xBarWidth,this.yBarWidth=t.yBarWidth,this.colX=t.colX,this.colY=t.colY,this.colZ=t.colZ,this.colValue=t.colValue,this._setScale()},xa.prototype.getDataPoints=function(t){for(var e=[],i=0;i<t.length;i++){var r=new _o;r.x=t[i][this.colX]||0,r.y=t[i][this.colY]||0,r.z=t[i][this.colZ]||0,r.data=t[i],r.value=t[i][this.colValue]||0;var n={};n.point=r,n.bottom=new _o(r.x,r.y,this.zRange.min),n.trans=void 0,n.screen=void 0,e.push(n)}return e},xa.prototype._getDataPoints=function(t){var e,i,r,n,o=[];if(this.style===xa.STYLE.GRID||this.style===xa.STYLE.SURFACE){var a=this.dataGroup.getDistinctValues(this.colX,t),s=this.dataGroup.getDistinctValues(this.colY,t);o=this.getDataPoints(t);var l=[];for(r=0;r<o.length;r++){n=o[r];var h=Jr(a).call(a,n.point.x),c=Jr(s).call(s,n.point.y);void 0===l[h]&&(l[h]=[]),l[h][c]=n}for(e=0;e<l.length;e++)for(i=0;i<l[e].length;i++)l[e][i]&&(l[e][i].pointRight=e<l.length-1?l[e+1][i]:void 0,l[e][i].pointTop=i<l[e].length-1?l[e][i+1]:void 0,l[e][i].pointCross=e<l.length-1&&i<l[e].length-1?l[e+1][i+1]:void 0)}else if(o=this.getDataPoints(t),this.style===xa.STYLE.LINE)for(r=0;r<o.length;r++)r>0&&(o[r-1].pointNext=o[r]);return o},xa.prototype.create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div"),this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas);var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t),this.frame.filter=document.createElement("div"),Nr(this.frame).style.position="absolute",Nr(this.frame).style.bottom="0px",Nr(this.frame).style.left="0px",Nr(this.frame).style.width="100%",this.frame.appendChild(Nr(this.frame));var e=this;mo(this.frame.canvas,"mousedown",(function(t){e._onMouseDown(t)})),mo(this.frame.canvas,"touchstart",(function(t){e._onTouchStart(t)})),mo(this.frame.canvas,"mousewheel",(function(t){e._onWheel(t)})),mo(this.frame.canvas,"mousemove",(function(t){e._onTooltip(t)})),mo(this.frame.canvas,"click",(function(t){e._onClick(t)})),this.containerElement.appendChild(this.frame)},xa.prototype._setSize=function(t,e){this.frame.style.width=t,this.frame.style.height=e,this._resizeCanvas()},xa.prototype._resizeCanvas=function(){this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=this.frame.canvas.clientWidth,this.frame.canvas.height=this.frame.canvas.clientHeight,Nr(this.frame).style.width=this.frame.canvas.clientWidth-20+"px"},xa.prototype.animationStart=function(){if(this.animationAutoStart&&this.dataGroup.dataFilter){if(!Nr(this.frame)||!Nr(this.frame).slider)throw new Error("No animation available");Nr(this.frame).slider.play()}},xa.prototype.animationStop=function(){Nr(this.frame)&&Nr(this.frame).slider&&Nr(this.frame).slider.stop()},xa.prototype._resizeCenter=function(){"%"===this.xCenter.charAt(this.xCenter.length-1)?this.currentXCenter=Ir(this.xCenter)/100*this.frame.canvas.clientWidth:this.currentXCenter=Ir(this.xCenter),"%"===this.yCenter.charAt(this.yCenter.length-1)?this.currentYCenter=Ir(this.yCenter)/100*(this.frame.canvas.clientHeight-Nr(this.frame).clientHeight):this.currentYCenter=Ir(this.yCenter)},xa.prototype.getCameraPosition=function(){var t=this.camera.getArmRotation();return t.distance=this.camera.getArmLength(),t},xa.prototype._readData=function(t){this.dataPoints=this.dataGroup.initializeData(this,t,this.style),this._initializeRanges(),this._redrawFilter()},xa.prototype.setData=function(t){null!=t&&(this._readData(t),this.redraw(),this.animationStart())},xa.prototype.setOptions=function(t){void 0!==t&&(!0===sa.validate(t,pa)&&console.log("%cErrors have been found in the supplied options object.",aa),this.animationStop(),function(t,e){if(void 0!==t){if(void 0===e)throw new Error("No dst passed");if(void 0===Fo||Wo(Fo))throw new Error("DEFAULTS not set for module Settings");Yo(t,e,jo),Yo(t,e,Bo,"default"),Vo(t,e)}}(t,this),this.setPointDrawingMethod(),this._setSize(this.width,this.height),this.setAxisLabelMethod(),this.setData(this.dataGroup.getDataTable()),this.animationStart())},xa.prototype.setPointDrawingMethod=function(){var t=void 0;switch(this.style){case xa.STYLE.BAR:t=this._redrawBarGraphPoint;break;case xa.STYLE.BARCOLOR:t=this._redrawBarColorGraphPoint;break;case xa.STYLE.BARSIZE:t=this._redrawBarSizeGraphPoint;break;case xa.STYLE.DOT:t=this._redrawDotGraphPoint;break;case xa.STYLE.DOTLINE:t=this._redrawDotLineGraphPoint;break;case xa.STYLE.DOTCOLOR:t=this._redrawDotColorGraphPoint;break;case xa.STYLE.DOTSIZE:t=this._redrawDotSizeGraphPoint;break;case xa.STYLE.SURFACE:t=this._redrawSurfaceGraphPoint;break;case xa.STYLE.GRID:t=this._redrawGridGraphPoint;break;case xa.STYLE.LINE:t=this._redrawLineGraphPoint;break;default:throw new Error("Can not determine point drawing method for graph style '"+this.style+"'")}this._pointDrawingMethod=t},xa.prototype.setAxisLabelMethod=function(){this.rotateAxisLabels?(this._drawAxisLabelX=this.drawAxisLabelXRotate,this._drawAxisLabelY=this.drawAxisLabelYRotate,this._drawAxisLabelZ=this.drawAxisLabelZRotate):(this._drawAxisLabelX=this.drawAxisLabelX,this._drawAxisLabelY=this.drawAxisLabelY,this._drawAxisLabelZ=this.drawAxisLabelZ)},xa.prototype.redraw=function(){if(void 0===this.dataPoints)throw new Error("Graph data not initialized");this._resizeCanvas(),this._resizeCenter(),this._redrawSlider(),this._redrawClear(),this._redrawAxis(),this._redrawDataGraph(),this._redrawInfo(),this._redrawLegend()},xa.prototype._getContext=function(){var t=this.frame.canvas.getContext("2d");return t.lineJoin="round",t.lineCap="round",t},xa.prototype._redrawClear=function(){var t=this.frame.canvas;t.getContext("2d").clearRect(0,0,t.width,t.height)},xa.prototype._dotSize=function(){return this.frame.clientWidth*this.dotSizeRatio},xa.prototype._getLegendWidth=function(){var t;this.style===xa.STYLE.DOTSIZE?t=this._dotSize()*this.dotSizeMaxFraction:t=this.style===xa.STYLE.BARSIZE?this.xBarWidth:20;return t},xa.prototype._redrawLegend=function(){if(!0===this.showLegend&&this.style!==xa.STYLE.LINE&&this.style!==xa.STYLE.BARSIZE){var t=this.style===xa.STYLE.BARSIZE||this.style===xa.STYLE.DOTSIZE,e=this.style===xa.STYLE.DOTSIZE||this.style===xa.STYLE.DOTCOLOR||this.style===xa.STYLE.SURFACE||this.style===xa.STYLE.BARCOLOR,i=Math.max(.25*this.frame.clientHeight,100),r=this.margin,n=this._getLegendWidth(),o=this.frame.clientWidth-this.margin,a=o-n,s=r+i,l=this._getContext();if(l.lineWidth=1,l.font="14px arial",!1===t){var h,c=i;for(h=0;h<c;h++){var u=1-(h-0)/(c-0),f=this._colormap(u,1);l.strokeStyle=f,l.beginPath(),l.moveTo(a,r+h),l.lineTo(o,r+h),l.stroke()}l.strokeStyle=this.axisColor,l.strokeRect(a,r,n,i)}else{var d;this.style===xa.STYLE.DOTSIZE?d=n*(this.dotSizeMinFraction/this.dotSizeMaxFraction):(this.style,xa.STYLE.BARSIZE),l.strokeStyle=this.axisColor,l.fillStyle=Ar(this.dataColor),l.beginPath(),l.moveTo(a,r),l.lineTo(o,r),l.lineTo(a+d,s),l.lineTo(a,s),l.closePath(),Ar(l).call(l),l.stroke()}var p,y,v=e?this.valueRange.min:this.zRange.min,m=e?this.valueRange.max:this.zRange.max,g=new Ao(v,m,(m-v)/5,!0);for(g.start(!0);!g.end();)h=s-(g.getCurrent()-v)/(m-v)*i,p=new So(a-5,h),y=new So(a,h),this._line(l,p,y),l.textAlign="right",l.textBaseline="middle",l.fillStyle=this.axisColor,l.fillText(g.getCurrent(),a-10,h),g.next();l.textAlign="right",l.textBaseline="top";var b=this.legendLabel;l.fillText(b,o,s+this.margin)}},xa.prototype._redrawFilter=function(){var t=this.dataGroup.dataFilter,e=Nr(this.frame);if(e.innerHTML="",t){var i=new Lo(e,{visible:this.showAnimationControls});e.slider=i,e.style.padding="10px",i.setValues(Sr(t)),i.setPlayInterval(this.animationInterval);var r=this;i.setOnChangeCallback((function(){var t=r.dataGroup.dataFilter,e=i.getIndex();t.selectValue(e),r.dataPoints=t._getDataPoints(),r.redraw()}))}else e.slider=void 0},xa.prototype._redrawSlider=function(){void 0!==Nr(this.frame).slider&&Nr(this.frame).slider.redraw()},xa.prototype._redrawInfo=function(){var t=this.dataGroup.getInfo();if(void 0!==t){var e=this._getContext();e.font="14px arial",e.lineStyle="gray",e.fillStyle="gray",e.textAlign="left",e.textBaseline="top";var i=this.margin,r=this.margin;e.fillText(t,i,r)}},xa.prototype._line=function(t,e,i,r){void 0!==r&&(t.strokeStyle=r),t.beginPath(),t.moveTo(e.x,e.y),t.lineTo(i.x,i.y),t.stroke()},xa.prototype.drawAxisLabelX=function(t,e,i,r,n){void 0===n&&(n=0);var o=this._convert3Dto2D(e);Math.cos(2*r)>0?(t.textAlign="center",t.textBaseline="top",o.y+=n):Math.sin(2*r)<0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y)},xa.prototype.drawAxisLabelY=function(t,e,i,r,n){void 0===n&&(n=0);var o=this._convert3Dto2D(e);Math.cos(2*r)<0?(t.textAlign="center",t.textBaseline="top",o.y+=n):Math.sin(2*r)>0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y)},xa.prototype.drawAxisLabelZ=function(t,e,i,r){void 0===r&&(r=0);var n=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,n.x-r,n.y)},xa.prototype.drawAxisLabelXRotate=function(t,e,i,r,n){var o=this._convert3Dto2D(e);Math.cos(2*r)>0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,0,0),t.restore()):Math.sin(2*r)<0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y))},xa.prototype.drawAxisLabelYRotate=function(t,e,i,r,n){var o=this._convert3Dto2D(e);Math.cos(2*r)<0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,0,0),t.restore()):Math.sin(2*r)>0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y))},xa.prototype.drawAxisLabelZRotate=function(t,e,i,r){void 0===r&&(r=0);var n=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,n.x-r,n.y)},xa.prototype._line3d=function(t,e,i,r){var n=this._convert3Dto2D(e),o=this._convert3Dto2D(i);this._line(t,n,o,r)},xa.prototype._redrawAxis=function(){var t,e,i,r,n,o,a,s,l,h,c=this._getContext();c.font=this.axisFontSize/this.camera.getArmLength()+"px "+this.axisFontType;var u,f,d,p=.025/this.scale.x,y=.025/this.scale.y,v=5/this.camera.getArmLength(),m=this.camera.getArmRotation().horizontal,g=new So(Math.cos(m),Math.sin(m)),b=this.xRange,x=this.yRange,w=this.zRange;for(c.lineWidth=1,r=void 0===this.defaultXStep,(i=new Ao(b.min,b.max,this.xStep,r)).start(!0);!i.end();){var _=i.getCurrent();if(this.showGrid?(t=new _o(_,x.min,w.min),e=new _o(_,x.max,w.min),this._line3d(c,t,e,this.gridColor)):this.showXAxis&&(t=new _o(_,x.min,w.min),e=new _o(_,x.min+p,w.min),this._line3d(c,t,e,this.axisColor),t=new _o(_,x.max,w.min),e=new _o(_,x.max-p,w.min),this._line3d(c,t,e,this.axisColor)),this.showXAxis){a=g.x>0?x.min:x.max,u=new _o(_,a,w.min);var S="  "+this.xValueLabel(_)+"  ";this._drawAxisLabelX.call(this,c,u,S,m,v)}i.next()}for(c.lineWidth=1,r=void 0===this.defaultYStep,(i=new Ao(x.min,x.max,this.yStep,r)).start(!0);!i.end();){var L=i.getCurrent();if(this.showGrid?(t=new _o(b.min,L,w.min),e=new _o(b.max,L,w.min),this._line3d(c,t,e,this.gridColor)):this.showYAxis&&(t=new _o(b.min,L,w.min),e=new _o(b.min+y,L,w.min),this._line3d(c,t,e,this.axisColor),t=new _o(b.max,L,w.min),e=new _o(b.max-y,L,w.min),this._line3d(c,t,e,this.axisColor)),this.showYAxis){o=g.y>0?b.min:b.max,u=new _o(o,L,w.min);var C="  "+this.yValueLabel(L)+"  ";this._drawAxisLabelY.call(this,c,u,C,m,v)}i.next()}if(this.showZAxis){for(c.lineWidth=1,r=void 0===this.defaultZStep,(i=new Ao(w.min,w.max,this.zStep,r)).start(!0),o=g.x>0?b.min:b.max,a=g.y<0?x.min:x.max;!i.end();){var A=i.getCurrent(),T=new _o(o,a,A),O=this._convert3Dto2D(T);e=new So(O.x-v,O.y),this._line(c,O,e,this.axisColor);var M=this.zValueLabel(A)+" ";this._drawAxisLabelZ.call(this,c,T,M,5),i.next()}c.lineWidth=1,t=new _o(o,a,w.min),e=new _o(o,a,w.max),this._line3d(c,t,e,this.axisColor)}this.showXAxis&&(c.lineWidth=1,f=new _o(b.min,x.min,w.min),d=new _o(b.max,x.min,w.min),this._line3d(c,f,d,this.axisColor),f=new _o(b.min,x.max,w.min),d=new _o(b.max,x.max,w.min),this._line3d(c,f,d,this.axisColor));this.showYAxis&&(c.lineWidth=1,t=new _o(b.min,x.min,w.min),e=new _o(b.min,x.max,w.min),this._line3d(c,t,e,this.axisColor),t=new _o(b.max,x.min,w.min),e=new _o(b.max,x.max,w.min),this._line3d(c,t,e,this.axisColor));var P=this.xLabel;P.length>0&&this.showXAxis&&(h=.1/this.scale.y,o=(b.max+3*b.min)/4,a=g.x>0?x.min-h:x.max+h,n=new _o(o,a,w.min),this.drawAxisLabelX(c,n,P,m));var E=this.yLabel;E.length>0&&this.showYAxis&&(l=.1/this.scale.x,o=g.y>0?b.min-l:b.max+l,a=(x.max+3*x.min)/4,n=new _o(o,a,w.min),this.drawAxisLabelY(c,n,E,m));var R=this.zLabel;R.length>0&&this.showZAxis&&(30,o=g.x>0?b.min:b.max,a=g.y<0?x.min:x.max,s=(w.max+3*w.min)/4,n=new _o(o,a,s),this.drawAxisLabelZ(c,n,R,30))},xa.prototype._getStrokeWidth=function(t){return void 0!==t?this.showPerspective?1/-t.trans.z*this.dataColor.strokeWidth:-this.eye.z/this.camera.getArmLength()*this.dataColor.strokeWidth:this.dataColor.strokeWidth},xa.prototype._redrawBar=function(t,e,i,r,n,o){var a,s=this,l=e.point,h=this.zRange.min,c=[{point:new _o(l.x-i,l.y-r,l.z)},{point:new _o(l.x+i,l.y-r,l.z)},{point:new _o(l.x+i,l.y+r,l.z)},{point:new _o(l.x-i,l.y+r,l.z)}],u=[{point:new _o(l.x-i,l.y-r,h)},{point:new _o(l.x+i,l.y-r,h)},{point:new _o(l.x+i,l.y+r,h)},{point:new _o(l.x-i,l.y+r,h)}];br(c).call(c,(function(t){t.screen=s._convert3Dto2D(t.point)})),br(u).call(u,(function(t){t.screen=s._convert3Dto2D(t.point)}));var f=[{corners:c,center:_o.avg(u[0].point,u[2].point)},{corners:[c[0],c[1],u[1],u[0]],center:_o.avg(u[1].point,u[0].point)},{corners:[c[1],c[2],u[2],u[1]],center:_o.avg(u[2].point,u[1].point)},{corners:[c[2],c[3],u[3],u[2]],center:_o.avg(u[3].point,u[2].point)},{corners:[c[3],c[0],u[0],u[3]],center:_o.avg(u[0].point,u[3].point)}];e.surfaces=f;for(var d=0;d<f.length;d++){a=f[d];var p=this._convertPointToTranslation(a.center);a.dist=this.showPerspective?p.length():-p.z}on(f).call(f,(function(t,e){var i=e.dist-t.dist;return i||(t.corners===c?1:e.corners===c?-1:0)})),t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=o,t.fillStyle=n;for(var y=2;y<f.length;y++)a=f[y],this._polygon(t,a.corners)},xa.prototype._polygon=function(t,e,i,r){if(!(e.length<2)){void 0!==i&&(t.fillStyle=i),void 0!==r&&(t.strokeStyle=r),t.beginPath(),t.moveTo(e[0].screen.x,e[0].screen.y);for(var n=1;n<e.length;++n){var o=e[n];t.lineTo(o.screen.x,o.screen.y)}t.closePath(),Ar(t).call(t),t.stroke()}},xa.prototype._drawCircle=function(t,e,i,r,n){var o=this._calcRadius(e,n);t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=r,t.fillStyle=i,t.beginPath(),t.arc(e.screen.x,e.screen.y,o,0,2*Math.PI,!0),Ar(t).call(t),t.stroke()},xa.prototype._getColorsRegular=function(t){var e=(t.point.value-this.valueRange.min)*this.scale.value;return{fill:this._colormap(e,1),border:this._colormap(e,.8)}},xa.prototype._getColorsColor=function(t){var e,i,r;if(t&&t.point&&t.point.data&&t.point.data.style&&(r=t.point.data.style),r&&"object"===ar(r)&&Ar(r)&&r.stroke)return{fill:Ar(r),border:r.stroke};if("string"==typeof t.point.value)e=t.point.value,i=t.point.value;else{var n=(t.point.value-this.valueRange.min)*this.scale.value;e=this._colormap(n,1),i=this._colormap(n,.8)}return{fill:e,border:i}},xa.prototype._getColorsSize=function(){return{fill:Ar(this.dataColor),border:this.dataColor.stroke}},xa.prototype._colormap=function(t){var e,i,r,n,o,a,s,l,h,c=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,u=this.colormap;if(ee(u)){var f=u.length-1,d=Math.max(Math.floor(t*f),0),p=Math.min(d+1,f),y=t*f-d,v=u[d],m=u[p];e=v.r+y*(m.r-v.r),i=v.g+y*(m.g-v.g),r=v.b+y*(m.b-v.b)}else if("function"==typeof u){var g=u(t);e=g.r,i=g.g,r=g.b,n=g.a}else{var b=240*(1-t),x=xo(b/360,1,1);e=x.r,i=x.g,r=x.b}return"number"!=typeof n||Qt(n)?Kt(o=Kt(a="RGB(".concat(Math.round(e*c),", ")).call(a,Math.round(i*c),", ")).call(o,Math.round(r*c),")"):Kt(s=Kt(l=Kt(h="RGBA(".concat(Math.round(e*c),", ")).call(h,Math.round(i*c),", ")).call(l,Math.round(r*c),", ")).call(s,n,")")},xa.prototype._calcRadius=function(t,e){var i;return void 0===e&&(e=this._dotSize()),(i=this.showPerspective?e/-t.trans.z:e*(-this.eye.z/this.camera.getArmLength()))<0&&(i=0),i},xa.prototype._redrawBarGraphPoint=function(t,e){var i=this.xBarWidth/2,r=this.yBarWidth/2,n=this._getColorsRegular(e);this._redrawBar(t,e,i,r,Ar(n),n.border)},xa.prototype._redrawBarColorGraphPoint=function(t,e){var i=this.xBarWidth/2,r=this.yBarWidth/2,n=this._getColorsColor(e);this._redrawBar(t,e,i,r,Ar(n),n.border)},xa.prototype._redrawBarSizeGraphPoint=function(t,e){var i=(e.point.value-this.valueRange.min)/this.valueRange.range(),r=this.xBarWidth/2*(.8*i+.2),n=this.yBarWidth/2*(.8*i+.2),o=this._getColorsSize();this._redrawBar(t,e,r,n,Ar(o),o.border)},xa.prototype._redrawDotGraphPoint=function(t,e){var i=this._getColorsRegular(e);this._drawCircle(t,e,Ar(i),i.border)},xa.prototype._redrawDotLineGraphPoint=function(t,e){var i=this._convert3Dto2D(e.bottom);t.lineWidth=1,this._line(t,i,e.screen,this.gridColor),this._redrawDotGraphPoint(t,e)},xa.prototype._redrawDotColorGraphPoint=function(t,e){var i=this._getColorsColor(e);this._drawCircle(t,e,Ar(i),i.border)},xa.prototype._redrawDotSizeGraphPoint=function(t,e){var i=this._dotSize(),r=(e.point.value-this.valueRange.min)/this.valueRange.range(),n=i*this.dotSizeMinFraction,o=n+(i*this.dotSizeMaxFraction-n)*r,a=this._getColorsSize();this._drawCircle(t,e,Ar(a),a.border,o)},xa.prototype._redrawSurfaceGraphPoint=function(t,e){var i=e.pointRight,r=e.pointTop,n=e.pointCross;if(void 0!==e&&void 0!==i&&void 0!==r&&void 0!==n){var o,a,s,l=!0;if(this.showGrayBottom||this.showShadow){var h=_o.subtract(n.trans,e.trans),c=_o.subtract(r.trans,i.trans),u=_o.crossProduct(h,c);if(this.showPerspective){var f=_o.avg(_o.avg(e.trans,n.trans),_o.avg(i.trans,r.trans));s=-_o.dotProduct(u.normalize(),f.normalize())}else s=u.z/u.length();l=s>0}if(l||!this.showGrayBottom){var d=((e.point.value+i.point.value+r.point.value+n.point.value)/4-this.valueRange.min)*this.scale.value,p=this.showShadow?(1+s)/2:1;o=this._colormap(d,p)}else o="gray";a=this.showSurfaceGrid?this.axisColor:o,t.lineWidth=this._getStrokeWidth(e);var y=[e,i,n,r];this._polygon(t,y,o,a)}},xa.prototype._drawGridLine=function(t,e,i){if(void 0!==e&&void 0!==i){var r=((e.point.value+i.point.value)/2-this.valueRange.min)*this.scale.value;t.lineWidth=2*this._getStrokeWidth(e),t.strokeStyle=this._colormap(r,1),this._line(t,e.screen,i.screen)}},xa.prototype._redrawGridGraphPoint=function(t,e){this._drawGridLine(t,e,e.pointRight),this._drawGridLine(t,e,e.pointTop)},xa.prototype._redrawLineGraphPoint=function(t,e){void 0!==e.pointNext&&(t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=this.dataColor.stroke,this._line(t,e.screen,e.pointNext.screen))},xa.prototype._redrawDataGraph=function(){var t,e=this._getContext();if(!(void 0===this.dataPoints||this.dataPoints.length<=0))for(this._calcTranslations(this.dataPoints),t=0;t<this.dataPoints.length;t++){var i=this.dataPoints[t];this._pointDrawingMethod.call(this,e,i)}},xa.prototype._storeMousePosition=function(t){this.startMouseX=wa(t),this.startMouseY=_a(t),this._startCameraOffset=this.camera.getOffset()},xa.prototype._onMouseDown=function(t){if(t=t||window.event,this.leftButtonDown&&this._onMouseUp(t),this.leftButtonDown=t.which?1===t.which:1===t.button,this.leftButtonDown||this.touchDown){this._storeMousePosition(t),this.startStart=new Date(this.start),this.startEnd=new Date(this.end),this.startArmRotation=this.camera.getArmRotation(),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},mo(document,"mousemove",e.onmousemove),mo(document,"mouseup",e.onmouseup),bo(t)}},xa.prototype._onMouseMove=function(t){this.moving=!0,t=t||window.event;var e=Ir(wa(t))-this.startMouseX,i=Ir(_a(t))-this.startMouseY;if(t&&!0===t.ctrlKey){var r=.5*this.frame.clientWidth,n=.5*this.frame.clientHeight,o=(this._startCameraOffset.x||0)-e/r*this.camera.armLength*.8,a=(this._startCameraOffset.y||0)+i/n*this.camera.armLength*.8;this.camera.setOffset(o,a),this._storeMousePosition(t)}else{var s=this.startArmRotation.horizontal+e/200,l=this.startArmRotation.vertical+i/200,h=Math.sin(4/360*2*Math.PI);Math.abs(Math.sin(s))<h&&(s=Math.round(s/Math.PI)*Math.PI-.001),Math.abs(Math.cos(s))<h&&(s=(Math.round(s/Math.PI-.5)+.5)*Math.PI-.001),Math.abs(Math.sin(l))<h&&(l=Math.round(l/Math.PI)*Math.PI),Math.abs(Math.cos(l))<h&&(l=(Math.round(l/Math.PI-.5)+.5)*Math.PI),this.camera.setArmRotation(s,l)}this.redraw();var c=this.getCameraPosition();this.emit("cameraPositionChange",c),bo(t)},xa.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",this.leftButtonDown=!1,go(document,"mousemove",this.onmousemove),go(document,"mouseup",this.onmouseup),bo(t)},xa.prototype._onClick=function(t){if(this.onclick_callback||this.hasListeners("click")){if(this.moving)this.moving=!1;else{var e=this.frame.getBoundingClientRect(),i=wa(t)-e.left,r=_a(t)-e.top,n=this._dataPointFromXY(i,r);n&&(this.onclick_callback&&this.onclick_callback(n.point.data),this.emit("click",n.point.data))}bo(t)}},xa.prototype._onTooltip=function(t){var e=this.tooltipDelay,i=this.frame.getBoundingClientRect(),r=wa(t)-i.left,n=_a(t)-i.top;if(this.showTooltip)if(this.tooltipTimeout&&clearTimeout(this.tooltipTimeout),this.leftButtonDown)this._hideTooltip();else if(this.tooltip&&this.tooltip.dataPoint){var o=this._dataPointFromXY(r,n);o!==this.tooltip.dataPoint&&(o?this._showTooltip(o):this._hideTooltip())}else{var a=this;this.tooltipTimeout=xt((function(){a.tooltipTimeout=null;var t=a._dataPointFromXY(r,n);t&&a._showTooltip(t)}),e)}},xa.prototype._onTouchStart=function(t){this.touchDown=!0;var e=this;this.ontouchmove=function(t){e._onTouchMove(t)},this.ontouchend=function(t){e._onTouchEnd(t)},mo(document,"touchmove",e.ontouchmove),mo(document,"touchend",e.ontouchend),this._onMouseDown(t)},xa.prototype._onTouchMove=function(t){this._onMouseMove(t)},xa.prototype._onTouchEnd=function(t){this.touchDown=!1,go(document,"touchmove",this.ontouchmove),go(document,"touchend",this.ontouchend),this._onMouseUp(t)},xa.prototype._onWheel=function(t){if(t||(t=window.event),this.zoomable&&(!this.ctrlToZoom||t.ctrlKey)){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail&&(e=-t.detail/3),e){var i=this.camera.getArmLength()*(1-e/10);this.camera.setArmLength(i),this.redraw(),this._hideTooltip()}var r=this.getCameraPosition();this.emit("cameraPositionChange",r),bo(t)}},xa.prototype._insideTriangle=function(t,e){var i=e[0],r=e[1],n=e[2];function o(t){return t>0?1:t<0?-1:0}var a=o((r.x-i.x)*(t.y-i.y)-(r.y-i.y)*(t.x-i.x)),s=o((n.x-r.x)*(t.y-r.y)-(n.y-r.y)*(t.x-r.x)),l=o((i.x-n.x)*(t.y-n.y)-(i.y-n.y)*(t.x-n.x));return!(0!=a&&0!=s&&a!=s||0!=s&&0!=l&&s!=l||0!=a&&0!=l&&a!=l)},xa.prototype._dataPointFromXY=function(t,e){var i,r=null,n=null,o=null,a=new So(t,e);if(this.style===xa.STYLE.BAR||this.style===xa.STYLE.BARCOLOR||this.style===xa.STYLE.BARSIZE)for(i=this.dataPoints.length-1;i>=0;i--){var s=(r=this.dataPoints[i]).surfaces;if(s)for(var l=s.length-1;l>=0;l--){var h=s[l].corners,c=[h[0].screen,h[1].screen,h[2].screen],u=[h[2].screen,h[3].screen,h[0].screen];if(this._insideTriangle(a,c)||this._insideTriangle(a,u))return r}}else for(i=0;i<this.dataPoints.length;i++){var f=(r=this.dataPoints[i]).screen;if(f){var d=Math.abs(t-f.x),p=Math.abs(e-f.y),y=Math.sqrt(d*d+p*p);(null===o||y<o)&&y<100&&(o=y,n=r)}}return n},xa.prototype.hasBars=function(t){return t==xa.STYLE.BAR||t==xa.STYLE.BARCOLOR||t==xa.STYLE.BARSIZE},xa.prototype._showTooltip=function(t){var e,i,r;this.tooltip?(e=this.tooltip.dom.content,i=this.tooltip.dom.line,r=this.tooltip.dom.dot):(e=document.createElement("div"),ut(e.style,{},this.tooltipStyle.content),e.style.position="absolute",i=document.createElement("div"),ut(i.style,{},this.tooltipStyle.line),i.style.position="absolute",r=document.createElement("div"),ut(r.style,{},this.tooltipStyle.dot),r.style.position="absolute",this.tooltip={dataPoint:null,dom:{content:e,line:i,dot:r}}),this._hideTooltip(),this.tooltip.dataPoint=t,"function"==typeof this.showTooltip?e.innerHTML=this.showTooltip(t.point):e.innerHTML="<table><tr><td>"+this.xLabel+":</td><td>"+t.point.x+"</td></tr><tr><td>"+this.yLabel+":</td><td>"+t.point.y+"</td></tr><tr><td>"+this.zLabel+":</td><td>"+t.point.z+"</td></tr></table>",e.style.left="0",e.style.top="0",this.frame.appendChild(e),this.frame.appendChild(i),this.frame.appendChild(r);var n=e.offsetWidth,o=e.offsetHeight,a=i.offsetHeight,s=r.offsetWidth,l=r.offsetHeight,h=t.screen.x-n/2;h=Math.min(Math.max(h,10),this.frame.clientWidth-10-n),i.style.left=t.screen.x+"px",i.style.top=t.screen.y-a+"px",e.style.left=h+"px",e.style.top=t.screen.y-a-o+"px",r.style.left=t.screen.x-s/2+"px",r.style.top=t.screen.y-l/2+"px"},xa.prototype._hideTooltip=function(){if(this.tooltip)for(var t in this.tooltip.dataPoint=null,this.tooltip.dom)if(this.tooltip.dom.hasOwnProperty(t)){var e=this.tooltip.dom[t];e&&e.parentNode&&e.parentNode.removeChild(e)}},xa.prototype.setCameraPosition=function(t){Uo(t,this),this.redraw()},xa.prototype.setSize=function(t,e){this._setSize(t,e),this.redraw()},t.Graph3d=xa,t.Graph3dCamera=ko,t.Graph3dFilter=ma,t.Graph3dPoint2d=So,t.Graph3dPoint3d=_o,t.Graph3dSlider=Lo,t.Graph3dStepNumber=Ao,Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-graph3d.min.js.map
