/**
 * vis-graph3d
 * https://visjs.github.io/vis-graph3d/
 *
 * Create interactive, animated 3d graphs. Surfaces, lines, dots and block styling out of the box.
 *
 * @version 6.0.1
 * @date    2020-12-16T19:56:54.897Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
var t="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function e(t,e,r){return t(r={path:e,exports:{},require:function(t,e){return function(){throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs")}(null==e&&r.path)}},r.exports),r.exports}var r=function(t){return t&&t.Math==Math&&t},n=r("object"==typeof globalThis&&globalThis)||r("object"==typeof window&&window)||r("object"==typeof self&&self)||r("object"==typeof t&&t)||function(){return this}()||Function("return this")(),i=function(t){try{return!!t()}catch(t){return!0}},o=!i((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),a={}.propertyIsEnumerable,s=Object.getOwnPropertyDescriptor,l={f:s&&!a.call({1:2},1)?function(t){var e=s(this,t);return!!e&&e.enumerable}:a},u=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},c={}.toString,h=function(t){return c.call(t).slice(8,-1)},f="".split,d=i((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==h(t)?f.call(t,""):Object(t)}:Object,p=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},v=function(t){return d(p(t))},y=function(t){return"object"==typeof t?null!==t:"function"==typeof t},m=function(t,e){if(!y(t))return t;var r,n;if(e&&"function"==typeof(r=t.toString)&&!y(n=r.call(t)))return n;if("function"==typeof(r=t.valueOf)&&!y(n=r.call(t)))return n;if(!e&&"function"==typeof(r=t.toString)&&!y(n=r.call(t)))return n;throw TypeError("Can't convert object to primitive value")},g={}.hasOwnProperty,b=function(t,e){return g.call(t,e)},x=n.document,w=y(x)&&y(x.createElement),_=function(t){return w?x.createElement(t):{}},S=!o&&!i((function(){return 7!=Object.defineProperty(_("div"),"a",{get:function(){return 7}}).a})),k=Object.getOwnPropertyDescriptor,L={f:o?k:function(t,e){if(t=v(t),e=m(e,!0),S)try{return k(t,e)}catch(t){}if(b(t,e))return u(!l.f.call(t,e),t[e])}},A=/#|\.prototype\./,C=function(t,e){var r=E[O(t)];return r==P||r!=T&&("function"==typeof e?i(e):!!e)},O=C.normalize=function(t){return String(t).replace(A,".").toLowerCase()},E=C.data={},T=C.NATIVE="N",P=C.POLYFILL="P",M=C,D={},R=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},I=function(t,e,r){if(R(t),void 0===e)return t;switch(r){case 0:return function(){return t.call(e)};case 1:return function(r){return t.call(e,r)};case 2:return function(r,n){return t.call(e,r,n)};case 3:return function(r,n,i){return t.call(e,r,n,i)}}return function(){return t.apply(e,arguments)}},z=function(t){if(!y(t))throw TypeError(String(t)+" is not an object");return t},j=Object.defineProperty,F={f:o?j:function(t,e,r){if(z(t),e=m(e,!0),z(r),S)try{return j(t,e,r)}catch(t){}if("get"in r||"set"in r)throw TypeError("Accessors not supported");return"value"in r&&(t[e]=r.value),t}},B=o?function(t,e,r){return F.f(t,e,u(1,r))}:function(t,e,r){return t[e]=r,t},N=L.f,G=function(t){var e=function(e,r,n){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,r)}return new t(e,r,n)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},W=function(t,e){var r,i,o,a,s,l,u,c,h=t.target,f=t.global,d=t.stat,p=t.proto,v=f?n:d?n[h]:(n[h]||{}).prototype,y=f?D:D[h]||(D[h]={}),m=y.prototype;for(o in e)r=!M(f?o:h+(d?".":"#")+o,t.forced)&&v&&b(v,o),s=y[o],r&&(l=t.noTargetGet?(c=N(v,o))&&c.value:v[o]),a=r&&l?l:e[o],r&&typeof s==typeof a||(u=t.bind&&r?I(a,n):t.wrap&&r?G(a):p&&"function"==typeof a?I(Function.call,a):a,(t.sham||a&&a.sham||s&&s.sham)&&B(u,"sham",!0),y[o]=u,p&&(b(D,i=h+"Prototype")||B(D,i,{}),D[i][o]=a,t.real&&m&&!m[o]&&B(m,o,a)))},Y=Math.ceil,V=Math.floor,U=function(t){return isNaN(t=+t)?0:(t>0?V:Y)(t)},X=Math.min,Z=function(t){return t>0?X(U(t),9007199254740991):0},q=Math.max,H=Math.min,$=function(t,e){var r=U(t);return r<0?q(r+e,0):H(r,e)},J=function(t){return function(e,r,n){var i,o=v(e),a=Z(o.length),s=$(n,a);if(t&&r!=r){for(;a>s;)if((i=o[s++])!=i)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===r)return t||s||0;return!t&&-1}},K={includes:J(!0),indexOf:J(!1)},Q={},tt=K.indexOf,et=function(t,e){var r,n=v(t),i=0,o=[];for(r in n)!b(Q,r)&&b(n,r)&&o.push(r);for(;e.length>i;)b(n,r=e[i++])&&(~tt(o,r)||o.push(r));return o},rt=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],nt=Object.keys||function(t){return et(t,rt)},it={f:Object.getOwnPropertySymbols},ot=function(t){return Object(p(t))},at=Object.assign,st=Object.defineProperty,lt=!at||i((function(){if(o&&1!==at({b:1},at(st({},"a",{enumerable:!0,get:function(){st(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=at({},t)[r]||nt(at({},e)).join("")!=n}))?function(t,e){for(var r=ot(t),n=arguments.length,i=1,a=it.f,s=l.f;n>i;)for(var u,c=d(arguments[i++]),h=a?nt(c).concat(a(c)):nt(c),f=h.length,p=0;f>p;)u=h[p++],o&&!s.call(c,u)||(r[u]=c[u]);return r}:at;W({target:"Object",stat:!0,forced:Object.assign!==lt},{assign:lt});var ut=D.Object.assign,ct=function(t){return"function"==typeof t?t:void 0},ht=function(t,e){return arguments.length<2?ct(D[t])||ct(n[t]):D[t]&&D[t][e]||n[t]&&n[t][e]},ft=ht("navigator","userAgent")||"",dt=[].slice,pt=/MSIE .\./.test(ft),vt=function(t){return function(e,r){var n=arguments.length>2,i=n?dt.call(arguments,2):void 0;return t(n?function(){("function"==typeof e?e:Function(e)).apply(this,i)}:e,r)}};W({global:!0,bind:!0,forced:pt},{setTimeout:vt(n.setTimeout),setInterval:vt(n.setInterval)});var yt,mt,gt=D.setTimeout,bt=Array.isArray||function(t){return"Array"==h(t)},xt=function(t,e,r){var n=m(e);n in t?F.f(t,n,u(0,r)):t[n]=r},wt=n["__core-js_shared__"]||function(t,e){try{B(n,t,e)}catch(r){n[t]=e}return e}("__core-js_shared__",{}),_t=e((function(t){(t.exports=function(t,e){return wt[t]||(wt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.8.1",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),St=0,kt=Math.random(),Lt=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++St+kt).toString(36)},At=!!Object.getOwnPropertySymbols&&!i((function(){return!String(Symbol())})),Ct=At&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Ot=_t("wks"),Et=n.Symbol,Tt=Ct?Et:Et&&Et.withoutSetter||Lt,Pt=function(t){return b(Ot,t)||(At&&b(Et,t)?Ot[t]=Et[t]:Ot[t]=Tt("Symbol."+t)),Ot[t]},Mt=Pt("species"),Dt=function(t,e){var r;return bt(t)&&("function"!=typeof(r=t.constructor)||r!==Array&&!bt(r.prototype)?y(r)&&null===(r=r[Mt])&&(r=void 0):r=void 0),new(void 0===r?Array:r)(0===e?0:e)},Rt=n.process,It=Rt&&Rt.versions,zt=It&&It.v8;zt?mt=(yt=zt.split("."))[0]+yt[1]:ft&&(!(yt=ft.match(/Edge\/(\d+)/))||yt[1]>=74)&&(yt=ft.match(/Chrome\/(\d+)/))&&(mt=yt[1]);var jt=mt&&+mt,Ft=Pt("species"),Bt=function(t){return jt>=51||!i((function(){var e=[];return(e.constructor={})[Ft]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Nt=Pt("isConcatSpreadable"),Gt=jt>=51||!i((function(){var t=[];return t[Nt]=!1,t.concat()[0]!==t})),Wt=Bt("concat"),Yt=function(t){if(!y(t))return!1;var e=t[Nt];return void 0!==e?!!e:bt(t)};W({target:"Array",proto:!0,forced:!Gt||!Wt},{concat:function(t){var e,r,n,i,o,a=ot(this),s=Dt(a,0),l=0;for(e=-1,n=arguments.length;e<n;e++)if(Yt(o=-1===e?a:arguments[e])){if(l+(i=Z(o.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(r=0;r<i;r++,l++)r in o&&xt(s,l,o[r])}else{if(l>=9007199254740991)throw TypeError("Maximum allowed index exceeded");xt(s,l++,o)}return s.length=l,s}});var Vt=function(t){return D[t+"Prototype"]},Ut=Vt("Array").concat,Xt=Array.prototype,Zt=function(t){var e=t.concat;return t===Xt||t instanceof Array&&e===Xt.concat?Ut:e};W({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var qt=D.Number.isNaN;W({target:"Array",stat:!0},{isArray:bt});var Ht=D.Array.isArray,$t=Ht,Jt={f:Pt},Kt=F.f,Qt=function(t){var e=D.Symbol||(D.Symbol={});b(e,t)||Kt(e,t,{value:Jt.f(t)})};Qt("iterator");var te=function(t){return function(e,r){var n,i,o=String(p(e)),a=U(r),s=o.length;return a<0||a>=s?t?"":void 0:(n=o.charCodeAt(a))<55296||n>56319||a+1===s||(i=o.charCodeAt(a+1))<56320||i>57343?t?o.charAt(a):n:t?o.slice(a,a+2):i-56320+(n-55296<<10)+65536}},ee={codeAt:te(!1),charAt:te(!0)},re=Function.toString;"function"!=typeof wt.inspectSource&&(wt.inspectSource=function(t){return re.call(t)});var ne,ie,oe,ae=wt.inspectSource,se=n.WeakMap,le="function"==typeof se&&/native code/.test(ae(se)),ue=_t("keys"),ce=function(t){return ue[t]||(ue[t]=Lt(t))},he=n.WeakMap;if(le){var fe=wt.state||(wt.state=new he),de=fe.get,pe=fe.has,ve=fe.set;ne=function(t,e){return e.facade=t,ve.call(fe,t,e),e},ie=function(t){return de.call(fe,t)||{}},oe=function(t){return pe.call(fe,t)}}else{var ye=ce("state");Q[ye]=!0,ne=function(t,e){return e.facade=t,B(t,ye,e),e},ie=function(t){return b(t,ye)?t[ye]:{}},oe=function(t){return b(t,ye)}}var me,ge,be,xe={set:ne,get:ie,has:oe,enforce:function(t){return oe(t)?ie(t):ne(t,{})},getterFor:function(t){return function(e){var r;if(!y(e)||(r=ie(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return r}}},we=!i((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),_e=ce("IE_PROTO"),Se=Object.prototype,ke=we?Object.getPrototypeOf:function(t){return t=ot(t),b(t,_e)?t[_e]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?Se:null},Le=(Pt("iterator"),!1);[].keys&&("next"in(be=[].keys())?(ge=ke(ke(be)))!==Object.prototype&&(me=ge):Le=!0),null==me&&(me={});var Ae,Ce={IteratorPrototype:me,BUGGY_SAFARI_ITERATORS:Le},Oe=o?Object.defineProperties:function(t,e){z(t);for(var r,n=nt(e),i=n.length,o=0;i>o;)F.f(t,r=n[o++],e[r]);return t},Ee=ht("document","documentElement"),Te=ce("IE_PROTO"),Pe=function(){},Me=function(t){return"<script>"+t+"<\/script>"},De=function(){try{Ae=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;De=Ae?function(t){t.write(Me("")),t.close();var e=t.parentWindow.Object;return t=null,e}(Ae):((e=_("iframe")).style.display="none",Ee.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(Me("document.F=Object")),t.close(),t.F);for(var r=rt.length;r--;)delete De.prototype[rt[r]];return De()};Q[Te]=!0;var Re=Object.create||function(t,e){var r;return null!==t?(Pe.prototype=z(t),r=new Pe,Pe.prototype=null,r[Te]=t):r=De(),void 0===e?r:Oe(r,e)},Ie={};Ie[Pt("toStringTag")]="z";var ze="[object z]"===String(Ie),je=Pt("toStringTag"),Fe="Arguments"==h(function(){return arguments}()),Be=ze?h:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),je))?r:Fe?h(e):"Object"==(n=h(e))&&"function"==typeof e.callee?"Arguments":n},Ne=ze?{}.toString:function(){return"[object "+Be(this)+"]"},Ge=F.f,We=Pt("toStringTag"),Ye=function(t,e,r,n){if(t){var i=r?t:t.prototype;b(i,We)||Ge(i,We,{configurable:!0,value:e}),n&&!ze&&B(i,"toString",Ne)}},Ve={},Ue=Ce.IteratorPrototype,Xe=function(){return this},Ze=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return z(r),function(t){if(!y(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(n),e?t.call(r,n):r.__proto__=n,r}}():void 0),qe=function(t,e,r,n){n&&n.enumerable?t[e]=r:B(t,e,r)},He=Ce.IteratorPrototype,$e=Ce.BUGGY_SAFARI_ITERATORS,Je=Pt("iterator"),Ke=function(){return this},Qe=function(t,e,r,n,i,o,a){!function(t,e,r){var n=e+" Iterator";t.prototype=Re(Ue,{next:u(1,r)}),Ye(t,n,!1,!0),Ve[n]=Xe}(r,e,n);var s,l,c,h=function(t){if(t===i&&y)return y;if(!$e&&t in p)return p[t];switch(t){case"keys":case"values":case"entries":return function(){return new r(this,t)}}return function(){return new r(this)}},f=e+" Iterator",d=!1,p=t.prototype,v=p[Je]||p["@@iterator"]||i&&p[i],y=!$e&&v||h(i),m="Array"==e&&p.entries||v;if(m&&(s=ke(m.call(new t)),He!==Object.prototype&&s.next&&(Ye(s,f,!0,!0),Ve[f]=Ke)),"values"==i&&v&&"values"!==v.name&&(d=!0,y=function(){return v.call(this)}),a&&p[Je]!==y&&B(p,Je,y),Ve[e]=y,i)if(l={values:h("values"),keys:o?y:h("keys"),entries:h("entries")},a)for(c in l)($e||d||!(c in p))&&qe(p,c,l[c]);else W({target:e,proto:!0,forced:$e||d},l);return l},tr=ee.charAt,er=xe.set,rr=xe.getterFor("String Iterator");Qe(String,"String",(function(t){er(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=rr(this),r=e.string,n=e.index;return n>=r.length?{value:void 0,done:!0}:(t=tr(r,n),e.index+=t.length,{value:t,done:!1})}));var nr=xe.set,ir=xe.getterFor("Array Iterator");Qe(Array,"Array",(function(t,e){nr(this,{type:"Array Iterator",target:v(t),index:0,kind:e})}),(function(){var t=ir(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==r?{value:n,done:!1}:"values"==r?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values");Ve.Arguments=Ve.Array;var or=Pt("toStringTag");for(var ar in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var sr=n[ar],lr=sr&&sr.prototype;lr&&Be(lr)!==or&&B(lr,or,ar),Ve[ar]=Ve.Array}var ur=Jt.f("iterator"),cr=ur,hr=rt.concat("length","prototype"),fr={f:Object.getOwnPropertyNames||function(t){return et(t,hr)}},dr=fr.f,pr={}.toString,vr="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],yr={f:function(t){return vr&&"[object Window]"==pr.call(t)?function(t){try{return dr(t)}catch(t){return vr.slice()}}(t):dr(v(t))}},mr=[].push,gr=function(t){var e=1==t,r=2==t,n=3==t,i=4==t,o=6==t,a=7==t,s=5==t||o;return function(l,u,c,h){for(var f,p,v=ot(l),y=d(v),m=I(u,c,3),g=Z(y.length),b=0,x=h||Dt,w=e?x(l,g):r||a?x(l,0):void 0;g>b;b++)if((s||b in y)&&(p=m(f=y[b],b,v),t))if(e)w[b]=p;else if(p)switch(t){case 3:return!0;case 5:return f;case 6:return b;case 2:mr.call(w,f)}else switch(t){case 4:return!1;case 7:mr.call(w,f)}return o?-1:n||i?i:w}},br={forEach:gr(0),map:gr(1),filter:gr(2),some:gr(3),every:gr(4),find:gr(5),findIndex:gr(6),filterOut:gr(7)},xr=br.forEach,wr=ce("hidden"),_r=Pt("toPrimitive"),Sr=xe.set,kr=xe.getterFor("Symbol"),Lr=Object.prototype,Ar=n.Symbol,Cr=ht("JSON","stringify"),Or=L.f,Er=F.f,Tr=yr.f,Pr=l.f,Mr=_t("symbols"),Dr=_t("op-symbols"),Rr=_t("string-to-symbol-registry"),Ir=_t("symbol-to-string-registry"),zr=_t("wks"),jr=n.QObject,Fr=!jr||!jr.prototype||!jr.prototype.findChild,Br=o&&i((function(){return 7!=Re(Er({},"a",{get:function(){return Er(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=Or(Lr,e);n&&delete Lr[e],Er(t,e,r),n&&t!==Lr&&Er(Lr,e,n)}:Er,Nr=function(t,e){var r=Mr[t]=Re(Ar.prototype);return Sr(r,{type:"Symbol",tag:t,description:e}),o||(r.description=e),r},Gr=Ct?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof Ar},Wr=function(t,e,r){t===Lr&&Wr(Dr,e,r),z(t);var n=m(e,!0);return z(r),b(Mr,n)?(r.enumerable?(b(t,wr)&&t[wr][n]&&(t[wr][n]=!1),r=Re(r,{enumerable:u(0,!1)})):(b(t,wr)||Er(t,wr,u(1,{})),t[wr][n]=!0),Br(t,n,r)):Er(t,n,r)},Yr=function(t,e){z(t);var r=v(e),n=nt(r).concat(Zr(r));return xr(n,(function(e){o&&!Vr.call(r,e)||Wr(t,e,r[e])})),t},Vr=function(t){var e=m(t,!0),r=Pr.call(this,e);return!(this===Lr&&b(Mr,e)&&!b(Dr,e))&&(!(r||!b(this,e)||!b(Mr,e)||b(this,wr)&&this[wr][e])||r)},Ur=function(t,e){var r=v(t),n=m(e,!0);if(r!==Lr||!b(Mr,n)||b(Dr,n)){var i=Or(r,n);return!i||!b(Mr,n)||b(r,wr)&&r[wr][n]||(i.enumerable=!0),i}},Xr=function(t){var e=Tr(v(t)),r=[];return xr(e,(function(t){b(Mr,t)||b(Q,t)||r.push(t)})),r},Zr=function(t){var e=t===Lr,r=Tr(e?Dr:v(t)),n=[];return xr(r,(function(t){!b(Mr,t)||e&&!b(Lr,t)||n.push(Mr[t])})),n};if(At||(qe((Ar=function(){if(this instanceof Ar)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=Lt(t),r=function(t){this===Lr&&r.call(Dr,t),b(this,wr)&&b(this[wr],e)&&(this[wr][e]=!1),Br(this,e,u(1,t))};return o&&Fr&&Br(Lr,e,{configurable:!0,set:r}),Nr(e,t)}).prototype,"toString",(function(){return kr(this).tag})),qe(Ar,"withoutSetter",(function(t){return Nr(Lt(t),t)})),l.f=Vr,F.f=Wr,L.f=Ur,fr.f=yr.f=Xr,it.f=Zr,Jt.f=function(t){return Nr(Pt(t),t)},o&&Er(Ar.prototype,"description",{configurable:!0,get:function(){return kr(this).description}})),W({global:!0,wrap:!0,forced:!At,sham:!At},{Symbol:Ar}),xr(nt(zr),(function(t){Qt(t)})),W({target:"Symbol",stat:!0,forced:!At},{for:function(t){var e=String(t);if(b(Rr,e))return Rr[e];var r=Ar(e);return Rr[e]=r,Ir[r]=e,r},keyFor:function(t){if(!Gr(t))throw TypeError(t+" is not a symbol");if(b(Ir,t))return Ir[t]},useSetter:function(){Fr=!0},useSimple:function(){Fr=!1}}),W({target:"Object",stat:!0,forced:!At,sham:!o},{create:function(t,e){return void 0===e?Re(t):Yr(Re(t),e)},defineProperty:Wr,defineProperties:Yr,getOwnPropertyDescriptor:Ur}),W({target:"Object",stat:!0,forced:!At},{getOwnPropertyNames:Xr,getOwnPropertySymbols:Zr}),W({target:"Object",stat:!0,forced:i((function(){it.f(1)}))},{getOwnPropertySymbols:function(t){return it.f(ot(t))}}),Cr){var qr=!At||i((function(){var t=Ar();return"[null]"!=Cr([t])||"{}"!=Cr({a:t})||"{}"!=Cr(Object(t))}));W({target:"JSON",stat:!0,forced:qr},{stringify:function(t,e,r){for(var n,i=[t],o=1;arguments.length>o;)i.push(arguments[o++]);if(n=e,(y(e)||void 0!==t)&&!Gr(t))return bt(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!Gr(e))return e}),i[1]=e,Cr.apply(null,i)}})}Ar.prototype[_r]||B(Ar.prototype,_r,Ar.prototype.valueOf),Ye(Ar,"Symbol"),Q[wr]=!0,Qt("asyncIterator"),Qt("hasInstance"),Qt("isConcatSpreadable"),Qt("match"),Qt("matchAll"),Qt("replace"),Qt("search"),Qt("species"),Qt("split"),Qt("toPrimitive"),Qt("toStringTag"),Qt("unscopables"),Ye(n.JSON,"JSON",!0);var Hr=D.Symbol;Qt("asyncDispose"),Qt("dispose"),Qt("observable"),Qt("patternMatch"),Qt("replaceAll");var $r=Hr,Jr=e((function(t){function e(r){return t.exports=e="function"==typeof $r&&"symbol"==typeof cr?function(t){return typeof t}:function(t){return t&&"function"==typeof $r&&t.constructor===$r&&t!==$r.prototype?"symbol":typeof t},e(r)}t.exports=e})),Kr=function(t,e){var r=[][t];return!!r&&i((function(){r.call(null,e||function(){throw 1},1)}))},Qr=Object.defineProperty,tn={},en=function(t){throw t},rn=function(t,e){if(b(tn,t))return tn[t];e||(e={});var r=[][t],n=!!b(e,"ACCESSORS")&&e.ACCESSORS,a=b(e,0)?e[0]:en,s=b(e,1)?e[1]:void 0;return tn[t]=!!r&&!i((function(){if(n&&!o)return!0;var t={length:-1};n?Qr(t,1,{enumerable:!0,get:en}):t[1]=1,r.call(t,a,s)}))},nn=br.forEach,on=Kr("forEach"),an=rn("forEach"),sn=on&&an?[].forEach:function(t){return nn(this,t,arguments.length>1?arguments[1]:void 0)};W({target:"Array",proto:!0,forced:[].forEach!=sn},{forEach:sn});var ln=Vt("Array").forEach,un=Array.prototype,cn={DOMTokenList:!0,NodeList:!0},hn=function(t){var e=t.forEach;return t===un||t instanceof Array&&e===un.forEach||cn.hasOwnProperty(Be(t))?ln:e},fn=Vt("Array").values,dn=Array.prototype,pn={DOMTokenList:!0,NodeList:!0},vn=function(t){var e=t.values;return t===dn||t instanceof Array&&e===dn.values||pn.hasOwnProperty(Be(t))?fn:e};W({target:"Array",proto:!0},{fill:function(t){for(var e=ot(this),r=Z(e.length),n=arguments.length,i=$(n>1?arguments[1]:void 0,r),o=n>2?arguments[2]:void 0,a=void 0===o?r:$(o,r);a>i;)e[i++]=t;return e}});var yn=Vt("Array").fill,mn=Array.prototype,gn=function(t){var e=t.fill;return t===mn||t instanceof Array&&e===mn.fill?yn:e},bn="\t\n\v\f\r                　\u2028\u2029\ufeff",xn="["+bn+"]",wn=RegExp("^"+xn+xn+"*"),_n=RegExp(xn+xn+"*$"),Sn=function(t){return function(e){var r=String(p(e));return 1&t&&(r=r.replace(wn,"")),2&t&&(r=r.replace(_n,"")),r}},kn={start:Sn(1),end:Sn(2),trim:Sn(3)},Ln=kn.trim,An=n.parseFloat,Cn=1/An(bn+"-0")!=-1/0?function(t){var e=Ln(String(t)),r=An(e);return 0===r&&"-"==e.charAt(0)?-0:r}:An;W({global:!0,forced:parseFloat!=Cn},{parseFloat:Cn});var On=D.parseFloat,En=br.filter,Tn=Bt("filter"),Pn=rn("filter");W({target:"Array",proto:!0,forced:!Tn||!Pn},{filter:function(t){return En(this,t,arguments.length>1?arguments[1]:void 0)}});var Mn=Vt("Array").filter,Dn=Array.prototype,Rn=function(t){var e=t.filter;return t===Dn||t instanceof Array&&e===Dn.filter?Mn:e},In=K.indexOf,zn=[].indexOf,jn=!!zn&&1/[1].indexOf(1,-0)<0,Fn=Kr("indexOf"),Bn=rn("indexOf",{ACCESSORS:!0,1:0});W({target:"Array",proto:!0,forced:jn||!Fn||!Bn},{indexOf:function(t){return jn?zn.apply(this,arguments)||0:In(this,t,arguments.length>1?arguments[1]:void 0)}});var Nn=Vt("Array").indexOf,Gn=Array.prototype,Wn=function(t){var e=t.indexOf;return t===Gn||t instanceof Array&&e===Gn.indexOf?Nn:e},Yn=[],Vn=Yn.sort,Un=i((function(){Yn.sort(void 0)})),Xn=i((function(){Yn.sort(null)})),Zn=Kr("sort");W({target:"Array",proto:!0,forced:Un||!Xn||!Zn},{sort:function(t){return void 0===t?Vn.call(ot(this)):Vn.call(ot(this),R(t))}});var qn=Vt("Array").sort,Hn=Array.prototype,$n=function(t){var e=t.sort;return t===Hn||t instanceof Array&&e===Hn.sort?qn:e},Jn=e((function(t){function e(t){if(t)return function(t){for(var r in e.prototype)t[r]=e.prototype[r];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i=0;i<n.length;i++)if((r=n[i])===e||r.fn===e){n.splice(i,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),r=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(r){n=0;for(var i=(r=r.slice(0)).length;n<i;++n)r[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}));W({target:"Object",stat:!0,forced:!o,sham:!o},{defineProperty:F.f});var Kn=e((function(t){var e=D.Object,r=t.exports=function(t,r,n){return e.defineProperty(t,r,n)};e.defineProperty.sham&&(r.sham=!0)})),Qn=Kn;W({target:"Object",stat:!0,forced:!o,sham:!o},{defineProperties:Oe});var ti=e((function(t){var e=D.Object,r=t.exports=function(t,r){return e.defineProperties(t,r)};e.defineProperties.sham&&(r.sham=!0)})),ei=ht("Reflect","ownKeys")||function(t){var e=fr.f(z(t)),r=it.f;return r?e.concat(r(t)):e};W({target:"Object",stat:!0,sham:!o},{getOwnPropertyDescriptors:function(t){for(var e,r,n=v(t),i=L.f,o=ei(n),a={},s=0;o.length>s;)void 0!==(r=i(n,e=o[s++]))&&xt(a,e,r);return a}});var ri=D.Object.getOwnPropertyDescriptors,ni=L.f,ii=i((function(){ni(1)}));W({target:"Object",stat:!0,forced:!o||ii,sham:!o},{getOwnPropertyDescriptor:function(t,e){return ni(v(t),e)}});var oi=e((function(t){var e=D.Object,r=t.exports=function(t,r){return e.getOwnPropertyDescriptor(t,r)};e.getOwnPropertyDescriptor.sham&&(r.sham=!0)})),ai=D.Object.getOwnPropertySymbols,si=Pt("iterator"),li=function(t){if(null!=t)return t[si]||t["@@iterator"]||Ve[Be(t)]},ui=function(t){var e=li(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return z(e.call(t))},ci=li,hi=function(t){var e=t.return;if(void 0!==e)return z(e.call(t)).value},fi=function(t,e,r,n){try{return n?e(z(r)[0],r[1]):e(r)}catch(e){throw hi(t),e}},di=Pt("iterator"),pi=Array.prototype,vi=function(t){return void 0!==t&&(Ve.Array===t||pi[di]===t)},yi=Pt("iterator"),mi=!1;try{var gi=0,bi={next:function(){return{done:!!gi++}},return:function(){mi=!0}};bi[yi]=function(){return this},Array.from(bi,(function(){throw 2}))}catch(t){}var xi=!function(t,e){if(!e&&!mi)return!1;var r=!1;try{var n={};n[yi]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r}((function(t){Array.from(t)}));W({target:"Array",stat:!0,forced:xi},{from:function(t){var e,r,n,i,o,a,s=ot(t),l="function"==typeof this?this:Array,u=arguments.length,c=u>1?arguments[1]:void 0,h=void 0!==c,f=li(s),d=0;if(h&&(c=I(c,u>2?arguments[2]:void 0,2)),null==f||l==Array&&vi(f))for(r=new l(e=Z(s.length));e>d;d++)a=h?c(s[d],d):s[d],xt(r,d,a);else for(o=(i=f.call(s)).next,r=new l;!(n=o.call(i)).done;d++)a=h?fi(i,c,[n.value,d],!0):n.value,xt(r,d,a);return r.length=d,r}});var wi=D.Array.from,_i=wi;W({target:"Object",stat:!0,sham:!o},{create:Re});var Si=D.Object,ki=function(t,e){return Si.create(t,e)},Li=ki,Ai=Kn;var Ci,Oi=function(t,e,r){return e in t?Ai(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t},Ei=kn.trim;W({target:"String",proto:!0,forced:(Ci="trim",i((function(){return!!bn[Ci]()||"​᠎"!="​᠎"[Ci]()||bn[Ci].name!==Ci})))},{trim:function(){return Ei(this)}});Vt("String").trim;var Ti=kn.trim,Pi=n.parseInt,Mi=/^[+-]?0[Xx]/,Di=8!==Pi(bn+"08")||22!==Pi(bn+"0x16")?function(t,e){var r=Ti(String(t));return Pi(r,e>>>0||(Mi.test(r)?16:10))}:Pi;W({global:!0,forced:parseInt!=Di},{parseInt:Di});var Ri=D.parseInt,Ii=l.f,zi=function(t){return function(e){for(var r,n=v(e),i=nt(n),a=i.length,s=0,l=[];a>s;)r=i[s++],o&&!Ii.call(n,r)||l.push(t?[r,n[r]]:n[r]);return l}},ji={entries:zi(!0),values:zi(!1)}.values;W({target:"Object",stat:!0},{values:function(t){return ji(t)}});D.Object.values;var Fi=i((function(){ke(1)}));W({target:"Object",stat:!0,forced:Fi,sham:!we},{getPrototypeOf:function(t){return ke(ot(t))}});var Bi=D.Object.getPrototypeOf,Ni=Bi,Gi=Ht;var Wi=function(t){if(Gi(t))return t},Yi=Pt("iterator"),Vi=function(t){var e=Object(t);return void 0!==e[Yi]||"@@iterator"in e||Ve.hasOwnProperty(Be(e))};var Ui=function(t,e){if(void 0!==$r&&Vi(Object(t))){var r=[],n=!0,i=!1,o=void 0;try{for(var a,s=ui(t);!(n=(a=s.next()).done)&&(r.push(a.value),!e||r.length!==e);n=!0);}catch(t){i=!0,o=t}finally{try{n||null==s.return||s.return()}finally{if(i)throw o}}return r}},Xi=wi,Zi=Bt("slice"),qi=rn("slice",{ACCESSORS:!0,0:0,1:2}),Hi=Pt("species"),$i=[].slice,Ji=Math.max;W({target:"Array",proto:!0,forced:!Zi||!qi},{slice:function(t,e){var r,n,i,o=v(this),a=Z(o.length),s=$(t,a),l=$(void 0===e?a:e,a);if(bt(o)&&("function"!=typeof(r=o.constructor)||r!==Array&&!bt(r.prototype)?y(r)&&null===(r=r[Hi])&&(r=void 0):r=void 0,r===Array||void 0===r))return $i.call(o,s,l);for(n=new(void 0===r?Array:r)(Ji(l-s,0)),i=0;s<l;s++,i++)s in o&&xt(n,i,o[s]);return n.length=i,n}});var Ki=Vt("Array").slice,Qi=Array.prototype,to=function(t){var e=t.slice;return t===Qi||t instanceof Array&&e===Qi.slice?Ki:e},eo=to;var ro=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n};var no=function(t,e){var r;if(t){if("string"==typeof t)return ro(t,e);var n=eo(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Xi(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?ro(t,e):void 0}};var io=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var oo=function(t,e){return Wi(t)||Ui(t,e)||no(t,e)||io()};W({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});D.Date.now;var ao=i((function(){nt(1)}));W({target:"Object",stat:!0,forced:ao},{keys:function(t){return nt(ot(t))}});var so=D.Object.keys,lo=br.map,uo=Bt("map"),co=rn("map");W({target:"Array",proto:!0,forced:!uo||!co},{map:function(t){return lo(this,t,arguments.length>1?arguments[1]:void 0)}});var ho=Vt("Array").map,fo=Array.prototype,po=function(t){var e=t.map;return t===fo||t instanceof Array&&e===fo.map?ho:e};W({target:"Reflect",stat:!0},{ownKeys:ei});var vo=D.Reflect.ownKeys,yo=to;var mo=function(t){if(Gi(t))return ro(t)};var go=function(t){if(void 0!==$r&&Vi(Object(t)))return Xi(t)};var bo=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var xo=function(t){return mo(t)||go(t)||no(t)||bo()},wo=Hr;function _o(t,e){var r;if(void 0===wo||null==ci(t)){if($t(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return So(t,e);var n=yo(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return _i(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return So(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){r=ui(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw o}}}}function So(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}
/**
 * vis-util
 * https://github.com/visjs/vis-util
 *
 * utilitie collection for visjs
 *
 * @version 4.3.4
 * @date    2020-08-01T15:11:53.524Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */var ko=wo("DELETE");function Lo(){var t=Ao.apply(void 0,arguments);return Oo(t),t}function Ao(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return Ao.apply(void 0,Zt(n=[Lo(e[0],e[1])]).call(n,xo(yo(e).call(e,2))));var i,o=e[0],a=e[1],s=_o(vo(a));try{for(s.s();!(i=s.n()).done;){var l=i.value;Object.prototype.propertyIsEnumerable.call(a,l)&&(a[l]===ko?delete o[l]:null===o[l]||null===a[l]||"object"!==Jr(o[l])||"object"!==Jr(a[l])||$t(o[l])||$t(a[l])?o[l]=Co(a[l]):o[l]=Ao(o[l],a[l]))}}catch(t){s.e(t)}finally{s.f()}return o}function Co(t){return $t(t)?po(t).call(t,(function(t){return Co(t)})):"object"===Jr(t)&&null!==t?Ao({},t):t}function Oo(t){for(var e=0,r=so(t);e<r.length;e++){var n=r[e];t[n]===ko?delete t[n]:"object"===Jr(t[n])&&null!==t[n]&&Oo(t[n])}}var Eo=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,To=/^#?([a-f\d])([a-f\d])([a-f\d])$/i;function Po(t,e,r,n){var i=!1;!0===n&&(i=null===e[r]&&void 0!==t[r]),i?delete t[r]:t[r]=e[r]}function Mo(t,e){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var i in e)if(Object.prototype.hasOwnProperty.call(e,i)||!0===r)if("object"===Jr(e[i])&&null!==e[i]&&Ni(e[i])===Object.prototype)void 0===t[i]?t[i]=Mo({},e[i],r):"object"===Jr(t[i])&&null!==t[i]&&Ni(t[i])===Object.prototype?Mo(t[i],e[i],r):Po(t,e,i,n);else if($t(e[i])){var o;t[i]=yo(o=e[i]).call(o)}else Po(t,e,i,n);return t}function Do(t,e){var r;return Zt(r=[]).call(r,xo(t),[e])}function Ro(t){return yo(t).call(t)}function Io(t,e,r,n){var i;t.addEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Wn(i=navigator.userAgent).call(i,"Firefox")>=0&&(e="DOMMouseScroll"),t.addEventListener(e,r,n)):t.attachEvent("on"+e,r)}function zo(t,e,r,n){var i;t.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Wn(i=navigator.userAgent).call(i,"Firefox")>=0&&(e="DOMMouseScroll"),t.removeEventListener(e,r,n)):t.detachEvent("on"+e,r)}function jo(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)}function Fo(t,e,r){var n,i,o,a=Math.floor(6*t),s=6*t-a,l=r*(1-e),u=r*(1-s*e),c=r*(1-(1-s)*e);switch(a%6){case 0:n=r,i=c,o=l;break;case 1:n=u,i=r,o=l;break;case 2:n=l,i=r,o=c;break;case 3:n=l,i=u,o=r;break;case 4:n=c,i=l,o=r;break;case 5:n=r,i=l,o=u}return{r:Math.floor(255*n),g:Math.floor(255*i),b:Math.floor(255*o)}}function Bo(t,e,r){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0,this.z=void 0!==r?r:0}Bo.subtract=function(t,e){var r=new Bo;return r.x=t.x-e.x,r.y=t.y-e.y,r.z=t.z-e.z,r},Bo.add=function(t,e){var r=new Bo;return r.x=t.x+e.x,r.y=t.y+e.y,r.z=t.z+e.z,r},Bo.avg=function(t,e){return new Bo((t.x+e.x)/2,(t.y+e.y)/2,(t.z+e.z)/2)},Bo.scalarProduct=function(t,e){return new Bo(t.x*e,t.y*e,t.z*e)},Bo.dotProduct=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},Bo.crossProduct=function(t,e){var r=new Bo;return r.x=t.y*e.z-t.z*e.y,r.y=t.z*e.x-t.x*e.z,r.z=t.x*e.y-t.y*e.x,r},Bo.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},Bo.prototype.normalize=function(){return Bo.scalarProduct(this,1/this.length())};var No=Bo;var Go=function(t,e){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0};function Wo(t,e){if(void 0===t)throw new Error("No container element defined");if(this.container=t,this.visible=!e||null==e.visible||e.visible,this.visible){this.frame=document.createElement("DIV"),this.frame.style.width="100%",this.frame.style.position="relative",this.container.appendChild(this.frame),this.frame.prev=document.createElement("INPUT"),this.frame.prev.type="BUTTON",this.frame.prev.value="Prev",this.frame.appendChild(this.frame.prev),this.frame.play=document.createElement("INPUT"),this.frame.play.type="BUTTON",this.frame.play.value="Play",this.frame.appendChild(this.frame.play),this.frame.next=document.createElement("INPUT"),this.frame.next.type="BUTTON",this.frame.next.value="Next",this.frame.appendChild(this.frame.next),this.frame.bar=document.createElement("INPUT"),this.frame.bar.type="BUTTON",this.frame.bar.style.position="absolute",this.frame.bar.style.border="1px solid red",this.frame.bar.style.width="100px",this.frame.bar.style.height="6px",this.frame.bar.style.borderRadius="2px",this.frame.bar.style.MozBorderRadius="2px",this.frame.bar.style.border="1px solid #7F7F7F",this.frame.bar.style.backgroundColor="#E5E5E5",this.frame.appendChild(this.frame.bar),this.frame.slide=document.createElement("INPUT"),this.frame.slide.type="BUTTON",this.frame.slide.style.margin="0px",this.frame.slide.value=" ",this.frame.slide.style.position="relative",this.frame.slide.style.left="-100px",this.frame.appendChild(this.frame.slide);var r=this;this.frame.slide.onmousedown=function(t){r._onMouseDown(t)},this.frame.prev.onclick=function(t){r.prev(t)},this.frame.play.onclick=function(t){r.togglePlay(t)},this.frame.next.onclick=function(t){r.next(t)}}this.onChangeCallback=void 0,this.values=[],this.index=void 0,this.playTimeout=void 0,this.playInterval=1e3,this.playLoop=!0}function Yo(t,e,r,n){this._start=0,this._end=0,this._step=1,this.prettyStep=!0,this.precision=5,this._current=0,this.setRange(t,e,r,n)}Wo.prototype.prev=function(){var t=this.getIndex();t>0&&(t--,this.setIndex(t))},Wo.prototype.next=function(){var t=this.getIndex();t<vn(this).length-1&&(t++,this.setIndex(t))},Wo.prototype.playNext=function(){var t=new Date,e=this.getIndex();e<vn(this).length-1?(e++,this.setIndex(e)):this.playLoop&&(e=0,this.setIndex(e));var r=new Date-t,n=Math.max(this.playInterval-r,0),i=this;this.playTimeout=gt((function(){i.playNext()}),n)},Wo.prototype.togglePlay=function(){void 0===this.playTimeout?this.play():this.stop()},Wo.prototype.play=function(){this.playTimeout||(this.playNext(),this.frame&&(this.frame.play.value="Stop"))},Wo.prototype.stop=function(){clearInterval(this.playTimeout),this.playTimeout=void 0,this.frame&&(this.frame.play.value="Play")},Wo.prototype.setOnChangeCallback=function(t){this.onChangeCallback=t},Wo.prototype.setPlayInterval=function(t){this.playInterval=t},Wo.prototype.getPlayInterval=function(){return this.playInterval},Wo.prototype.setPlayLoop=function(t){this.playLoop=t},Wo.prototype.onChange=function(){void 0!==this.onChangeCallback&&this.onChangeCallback()},Wo.prototype.redraw=function(){if(this.frame){this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px",this.frame.bar.style.width=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30+"px";var t=this.indexToLeft(this.index);this.frame.slide.style.left=t+"px"}},Wo.prototype.setValues=function(t){this.values=t,vn(this).length>0?this.setIndex(0):this.index=void 0},Wo.prototype.setIndex=function(t){if(!(t<vn(this).length))throw new Error("Index out of range");this.index=t,this.redraw(),this.onChange()},Wo.prototype.getIndex=function(){return this.index},Wo.prototype.get=function(){return vn(this)[this.index]},Wo.prototype._onMouseDown=function(t){if(t.which?1===t.which:1===t.button){this.startClientX=t.clientX,this.startSlideX=On(this.frame.slide.style.left),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},Io(document,"mousemove",this.onmousemove),Io(document,"mouseup",this.onmouseup),jo(t)}},Wo.prototype.leftToIndex=function(t){var e=On(this.frame.bar.style.width)-this.frame.slide.clientWidth-10,r=t-3,n=Math.round(r/e*(vn(this).length-1));return n<0&&(n=0),n>vn(this).length-1&&(n=vn(this).length-1),n},Wo.prototype.indexToLeft=function(t){var e=On(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return t/(vn(this).length-1)*e+3},Wo.prototype._onMouseMove=function(t){var e=t.clientX-this.startClientX,r=this.startSlideX+e,n=this.leftToIndex(r);this.setIndex(n),jo()},Wo.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",zo(document,"mousemove",this.onmousemove),zo(document,"mouseup",this.onmouseup),jo()},Yo.prototype.isNumeric=function(t){return!isNaN(On(t))&&isFinite(t)},Yo.prototype.setRange=function(t,e,r,n){if(!this.isNumeric(t))throw new Error("Parameter 'start' is not numeric; value: "+t);if(!this.isNumeric(e))throw new Error("Parameter 'end' is not numeric; value: "+t);if(!this.isNumeric(r))throw new Error("Parameter 'step' is not numeric; value: "+t);this._start=t||0,this._end=e||0,this.setStep(r,n)},Yo.prototype.setStep=function(t,e){void 0===t||t<=0||(void 0!==e&&(this.prettyStep=e),!0===this.prettyStep?this._step=Yo.calculatePrettyStep(t):this._step=t)},Yo.calculatePrettyStep=function(t){var e=function(t){return Math.log(t)/Math.LN10},r=Math.pow(10,Math.round(e(t))),n=2*Math.pow(10,Math.round(e(t/2))),i=5*Math.pow(10,Math.round(e(t/5))),o=r;return Math.abs(n-t)<=Math.abs(o-t)&&(o=n),Math.abs(i-t)<=Math.abs(o-t)&&(o=i),o<=0&&(o=1),o},Yo.prototype.getCurrent=function(){return On(this._current.toPrecision(this.precision))},Yo.prototype.getStep=function(){return this._step},Yo.prototype.start=function(t){void 0===t&&(t=!1),this._current=this._start-this._start%this._step,t&&this.getCurrent()<this._start&&this.next()},Yo.prototype.next=function(){this._current+=this._step},Yo.prototype.end=function(){return this._current>this._end};var Vo=Yo,Uo=[].reverse,Xo=[1,2];W({target:"Array",proto:!0,forced:String(Xo)===String(Xo.reverse())},{reverse:function(){return bt(this)&&(this.length=this.length),Uo.call(this)}});var Zo=Vt("Array").reverse,qo=Array.prototype,Ho=function(t){var e=t.reverse;return t===qo||t instanceof Array&&e===qo.reverse?Zo:e},$o=Math.sign||function(t){return 0==(t=+t)||t!=t?t:t<0?-1:1};W({target:"Math",stat:!0},{sign:$o});var Jo=D.Math.sign;function Ko(){this.armLocation=new No,this.armRotation={},this.armRotation.horizontal=0,this.armRotation.vertical=0,this.armLength=1.7,this.cameraOffset=new No,this.offsetMultiplier=.6,this.cameraLocation=new No,this.cameraRotation=new No(.5*Math.PI,0,0),this.calculateCameraOrientation()}Ko.prototype.setOffset=function(t,e){var r=Math.abs,n=Jo,i=this.offsetMultiplier,o=this.armLength*i;r(t)>o&&(t=n(t)*o),r(e)>o&&(e=n(e)*o),this.cameraOffset.x=t,this.cameraOffset.y=e,this.calculateCameraOrientation()},Ko.prototype.getOffset=function(){return this.cameraOffset},Ko.prototype.setArmLocation=function(t,e,r){this.armLocation.x=t,this.armLocation.y=e,this.armLocation.z=r,this.calculateCameraOrientation()},Ko.prototype.setArmRotation=function(t,e){void 0!==t&&(this.armRotation.horizontal=t),void 0!==e&&(this.armRotation.vertical=e,this.armRotation.vertical<0&&(this.armRotation.vertical=0),this.armRotation.vertical>.5*Math.PI&&(this.armRotation.vertical=.5*Math.PI)),void 0===t&&void 0===e||this.calculateCameraOrientation()},Ko.prototype.getArmRotation=function(){var t={};return t.horizontal=this.armRotation.horizontal,t.vertical=this.armRotation.vertical,t},Ko.prototype.setArmLength=function(t){void 0!==t&&(this.armLength=t,this.armLength<.71&&(this.armLength=.71),this.armLength>5&&(this.armLength=5),this.setOffset(this.cameraOffset.x,this.cameraOffset.y),this.calculateCameraOrientation())},Ko.prototype.getArmLength=function(){return this.armLength},Ko.prototype.getCameraLocation=function(){return this.cameraLocation},Ko.prototype.getCameraRotation=function(){return this.cameraRotation},Ko.prototype.calculateCameraOrientation=function(){this.cameraLocation.x=this.armLocation.x-this.armLength*Math.sin(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.y=this.armLocation.y-this.armLength*Math.cos(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.z=this.armLocation.z+this.armLength*Math.sin(this.armRotation.vertical),this.cameraRotation.x=Math.PI/2-this.armRotation.vertical,this.cameraRotation.y=0,this.cameraRotation.z=-this.armRotation.horizontal;var t=this.cameraRotation.x,e=this.cameraRotation.z,r=this.cameraOffset.x,n=this.cameraOffset.y,i=Math.sin,o=Math.cos;this.cameraLocation.x=this.cameraLocation.x+r*o(e)+n*-i(e)*o(t),this.cameraLocation.y=this.cameraLocation.y+r*i(e)+n*o(e)*o(t),this.cameraLocation.z=this.cameraLocation.z+n*i(t)};var Qo={BAR:0,BARCOLOR:1,BARSIZE:2,DOT:3,DOTLINE:4,DOTCOLOR:5,DOTSIZE:6,GRID:7,LINE:8,SURFACE:9},ta={dot:Qo.DOT,"dot-line":Qo.DOTLINE,"dot-color":Qo.DOTCOLOR,"dot-size":Qo.DOTSIZE,line:Qo.LINE,grid:Qo.GRID,surface:Qo.SURFACE,bar:Qo.BAR,"bar-color":Qo.BARCOLOR,"bar-size":Qo.BARSIZE},ea=["width","height","filterLabel","legendLabel","xLabel","yLabel","zLabel","xValueLabel","yValueLabel","zValueLabel","showXAxis","showYAxis","showZAxis","showGrayBottom","showGrid","showPerspective","showShadow","showSurfaceGrid","keepAspectRatio","rotateAxisLabels","verticalRatio","dotSizeRatio","dotSizeMinFraction","dotSizeMaxFraction","showAnimationControls","animationInterval","animationPreload","animationAutoStart","axisColor","axisFontSize","axisFontType","gridColor","xCenter","yCenter","zoomable","tooltipDelay","ctrlToZoom"],ra=["xBarWidth","yBarWidth","valueMin","valueMax","xMin","xMax","xStep","yMin","yMax","yStep","zMin","zMax","zStep"],na=void 0;function ia(t){for(var e in t)if(t.hasOwnProperty(e))return!1;return!0}function oa(t,e){return void 0===t||""===t?e:t+(void 0===(r=e)||""===r||"string"!=typeof r?r:r.charAt(0).toUpperCase()+yo(r).call(r,1));var r}function aa(t,e,r,n){for(var i,o=0;o<r.length;++o)e[oa(n,i=r[o])]=t[i]}function sa(t,e,r,n){for(var i,o=0;o<r.length;++o)void 0!==t[i=r[o]]&&(e[oa(n,i)]=t[i])}function la(t,e){if(void 0!==t.backgroundColor&&function(t,e){var r="white",n="gray",i=1;if("string"==typeof t)r=t,n="none",i=0;else{if("object"!==Jr(t))throw new Error("Unsupported type of backgroundColor");void 0!==gn(t)&&(r=gn(t)),void 0!==t.stroke&&(n=t.stroke),void 0!==t.strokeWidth&&(i=t.strokeWidth)}e.frame.style.backgroundColor=r,e.frame.style.borderColor=n,e.frame.style.borderWidth=i+"px",e.frame.style.borderStyle="solid"}(t.backgroundColor,e),function(t,e){if(void 0===t)return;void 0===e.dataColor&&(e.dataColor={});"string"==typeof t?(e.dataColor.fill=t,e.dataColor.stroke=t):(gn(t)&&(e.dataColor.fill=gn(t)),t.stroke&&(e.dataColor.stroke=t.stroke),void 0!==t.strokeWidth&&(e.dataColor.strokeWidth=t.strokeWidth))}(t.dataColor,e),function(t,e){if(void 0===t)return;var r;if("string"==typeof t){if(-1===(r=function(t){var e=ta[t];if(void 0===e)return-1;return e}(t)))throw new Error("Style '"+t+"' is invalid")}else{if(!function(t){var e=!1;for(var r in Qo)if(Qo[r]===t){e=!0;break}return e}(t))throw new Error("Style '"+t+"' is invalid");r=t}e.style=r}(t.style,e),void 0!==t.surfaceColors){if(console.warn("`options.surfaceColors` is deprecated and may be removed in a future version. Please use `options.colormap` instead. Note that the `colormap` option uses the inverse array ordering (running from vMin to vMax)."),void 0!==t.colormap)throw new Error("The `colormap` and `surfaceColors` options are mutually exclusive.");"surface"!==e.style?console.warn("Ignoring `surfaceColors` in graph style `"+e.style+"` for backward compatibility (only effective in `surface` plots)."):function(t,e){if(void 0===t||!0===t)return;if(!1===t)return void(e.surfaceColors=void 0);void 0===e.surfaceColors&&(e.surfaceColors={});var r;if($t(t))r=ua(t);else{if("object"!==Jr(t))throw new Error("Unsupported type of surfaceColors");r=ca(t.hue)}Ho(r).call(r),e.colormap=r}(t.surfaceColors,e)}else!function(t,e){if(void 0===t)return;var r;if($t(t))r=ua(t);else if("object"===Jr(t))r=ca(t.hue);else{if("function"!=typeof t)throw new Error("Unsupported type of colormap");r=t}e.colormap=r}(t.colormap,e);!function(t,e){if(void 0===t){if(void 0===na.showLegend){var r=e.style===Qo.DOTCOLOR||e.style===Qo.DOTSIZE;e.showLegend=r}}else e.showLegend=t}(t.showLegend,e),ha(t.cameraPosition,e),void 0!==t.tooltip&&(e.showTooltip=t.tooltip),null!=t.onclick&&(e.onclick_callback=t.onclick,console.warn("`options.onclick` is deprecated and may be removed in a future version. Please use `Graph3d.on('click', handler)` instead.")),void 0!==t.tooltipStyle&&function(t,e,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if($t(r))throw new TypeError("Arrays are not supported by deepExtend");for(var i=0;i<t.length;i++){var o=t[i];if(Object.prototype.hasOwnProperty.call(r,o))if(r[o]&&r[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?Mo(e[o],r[o],!1,n):Po(e,r,o,n);else{if($t(r[o]))throw new TypeError("Arrays are not supported by deepExtend");Po(e,r,o,n)}}}(["tooltipStyle"],e,t)}function ua(t){if(t.length<2)throw new Error("Colormap array length must be 2 or above.");return po(t).call(t,(function(t){if(!function(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}(t))throw new Error("Invalid hex color code supplied to colormap.");return function(t){var e;switch(t.length){case 3:case 4:return(e=To.exec(t))?{r:Ri(e[1]+e[1],16),g:Ri(e[2]+e[2],16),b:Ri(e[3]+e[3],16)}:null;case 6:case 7:return(e=Eo.exec(t))?{r:Ri(e[1],16),g:Ri(e[2],16),b:Ri(e[3],16)}:null;default:return null}}(t)}))}function ca(t){if(void 0===t)throw new Error("Unsupported type of colormap");if(!(t.saturation>=0&&t.saturation<=100))throw new Error("Saturation is out of bounds. Expected range is 0-100.");if(!(t.brightness>=0&&t.brightness<=100))throw new Error("Brightness is out of bounds. Expected range is 0-100.");if(!(t.colorStops>=2))throw new Error("colorStops is out of bounds. Expected 2 or above.");for(var e=(t.end-t.start)/(t.colorStops-1),r=[],n=0;n<t.colorStops;++n){var i=(t.start+e*n)%360/360;r.push(Fo(i<0?i+1:i,t.saturation/100,t.brightness/100))}return r}function ha(t,e){var r=t;void 0!==r&&(void 0===e.camera&&(e.camera=new Ko),e.camera.setArmRotation(r.horizontal,r.vertical),e.camera.setArmLength(r.distance))}var fa=ht("JSON","stringify"),da=/[\uD800-\uDFFF]/g,pa=/^[\uD800-\uDBFF]$/,va=/^[\uDC00-\uDFFF]$/,ya=function(t,e,r){var n=r.charAt(e-1),i=r.charAt(e+1);return pa.test(t)&&!va.test(i)||va.test(t)&&!pa.test(n)?"\\u"+t.charCodeAt(0).toString(16):t},ma=i((function(){return'"\\udf06\\ud834"'!==fa("\udf06\ud834")||'"\\udead"'!==fa("\udead")}));fa&&W({target:"JSON",stat:!0,forced:ma},{stringify:function(t,e,r){var n=fa.apply(null,arguments);return"string"==typeof n?n.replace(da,ya):n}}),D.JSON||(D.JSON={stringify:JSON.stringify});var ga=function(t,e,r){return D.JSON.stringify.apply(null,arguments)};var ba=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};function xa(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Ai(t,n.key,n)}}var wa,_a=function(t,e,r){return e&&xa(t.prototype,e),r&&xa(t,r),t},Sa=!1,ka="background: #FFeeee; color: #dd0000",La=function(){function t(){ba(this,t)}return _a(t,null,[{key:"validate",value:function(e,r,n){Sa=!1,wa=r;var i=r;return void 0!==n&&(i=r[n]),t.parse(e,i,[]),Sa}},{key:"parse",value:function(e,r,n){for(var i in e)e.hasOwnProperty(i)&&t.check(i,e,r,n)}},{key:"check",value:function(e,r,n,i){if(void 0!==n[e]||void 0!==n.__any__){var o=e,a=!0;void 0===n[e]&&void 0!==n.__any__&&(o="__any__",a="object"===t.getType(r[e]));var s=n[o];a&&void 0!==s.__type__&&(s=s.__type__),t.checkFields(e,r,n,o,s,i)}else t.getSuggestion(e,n,i)}},{key:"checkFields",value:function(e,r,n,i,o,a){var s=function(r){console.log("%c"+r+t.printLocation(a,e),ka)},l=t.getType(r[e]),u=o[l];void 0!==u?"array"===t.getType(u)&&-1===Wn(u).call(u,r[e])?(s('Invalid option detected in "'+e+'". Allowed values are:'+t.print(u)+' not "'+r[e]+'". '),Sa=!0):"object"===l&&"__any__"!==i&&(a=Do(a,e),t.parse(r[e],n[i],a)):void 0===o.any&&(s('Invalid type received for "'+e+'". Expected: '+t.print(so(o))+". Received ["+l+'] "'+r[e]+'"'),Sa=!0)}},{key:"getType",value:function(t){var e=Jr(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":$t(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,r,n){var i,o=t.findInOptions(e,r,n,!1),a=t.findInOptions(e,wa,[],!0);i=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':a.distance<=4&&o.distance>a.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(a.path,a.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(so(r))+t.printLocation(n,e),console.log('%cUnknown option detected: "'+e+'"'+i,ka),Sa=!0}},{key:"findInOptions",value:function(e,r,n){var i=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,a="",s=[],l=e.toLowerCase(),u=void 0;for(var c in r){var h=void 0;if(void 0!==r[c].__type__&&!0===i){var f=t.findInOptions(e,r[c],Do(n,c));o>f.distance&&(a=f.closestMatch,s=f.path,o=f.distance,u=f.indexMatch)}else{var d;-1!==Wn(d=c.toLowerCase()).call(d,l)&&(u=c),o>(h=t.levenshteinDistance(e,c))&&(a=c,s=Ro(n),o=h)}}return{closestMatch:a,path:s,distance:o,indexMatch:u}}},{key:"printLocation",value:function(t,e){for(var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",n="\n\n"+r+"options = {\n",i=0;i<t.length;i++){for(var o=0;o<i+1;o++)n+="  ";n+=t[i]+": {\n"}for(var a=0;a<t.length+1;a++)n+="  ";n+=e+"\n";for(var s=0;s<t.length+1;s++){for(var l=0;l<t.length-s;l++)n+="  ";n+="}\n"}return n+"\n\n"}},{key:"print",value:function(t){return ga(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var r,n,i=[];for(r=0;r<=e.length;r++)i[r]=[r];for(n=0;n<=t.length;n++)i[0][n]=n;for(r=1;r<=e.length;r++)for(n=1;n<=t.length;n++)e.charAt(r-1)==t.charAt(n-1)?i[r][n]=i[r-1][n-1]:i[r][n]=Math.min(i[r-1][n-1]+1,Math.min(i[r][n-1]+1,i[r-1][n]+1));return i[e.length][t.length]}}]),t}(),Aa="string",Ca="boolean",Oa="number",Ea="object",Ta={fill:{string:Aa},stroke:{string:Aa},strokeWidth:{number:Oa},__type__:{string:Aa,object:Ea,undefined:"undefined"}},Pa={animationAutoStart:{boolean:Ca,undefined:"undefined"},animationInterval:{number:Oa},animationPreload:{boolean:Ca},axisColor:{string:Aa},axisFontSize:{number:Oa},axisFontType:{string:Aa},backgroundColor:Ta,xBarWidth:{number:Oa,undefined:"undefined"},yBarWidth:{number:Oa,undefined:"undefined"},cameraPosition:{distance:{number:Oa},horizontal:{number:Oa},vertical:{number:Oa},__type__:{object:Ea}},zoomable:{boolean:Ca},ctrlToZoom:{boolean:Ca},xCenter:{string:Aa},yCenter:{string:Aa},colormap:{hue:{start:{number:Oa},end:{number:Oa},saturation:{number:Oa},brightness:{number:Oa},colorStops:{number:Oa},__type__:{object:Ea}},__type__:{array:"array",object:Ea,function:"function",undefined:"undefined"}},dataColor:Ta,dotSizeMinFraction:{number:Oa},dotSizeMaxFraction:{number:Oa},dotSizeRatio:{number:Oa},filterLabel:{string:Aa},gridColor:{string:Aa},onclick:{function:"function"},keepAspectRatio:{boolean:Ca},xLabel:{string:Aa},yLabel:{string:Aa},zLabel:{string:Aa},legendLabel:{string:Aa},xMin:{number:Oa,undefined:"undefined"},yMin:{number:Oa,undefined:"undefined"},zMin:{number:Oa,undefined:"undefined"},xMax:{number:Oa,undefined:"undefined"},yMax:{number:Oa,undefined:"undefined"},zMax:{number:Oa,undefined:"undefined"},showAnimationControls:{boolean:Ca,undefined:"undefined"},showGrayBottom:{boolean:Ca},showGrid:{boolean:Ca},showLegend:{boolean:Ca,undefined:"undefined"},showPerspective:{boolean:Ca},showShadow:{boolean:Ca},showSurfaceGrid:{boolean:Ca},showXAxis:{boolean:Ca},showYAxis:{boolean:Ca},showZAxis:{boolean:Ca},rotateAxisLabels:{boolean:Ca},surfaceColors:{hue:{start:{number:Oa},end:{number:Oa},saturation:{number:Oa},brightness:{number:Oa},colorStops:{number:Oa},__type__:{object:Ea}},__type__:{boolean:Ca,array:"array",object:Ea,undefined:"undefined"}},xStep:{number:Oa,undefined:"undefined"},yStep:{number:Oa,undefined:"undefined"},zStep:{number:Oa,undefined:"undefined"},style:{number:Oa,string:["bar","bar-color","bar-size","dot","dot-line","dot-color","dot-size","line","grid","surface"]},tooltip:{boolean:Ca,function:"function"},tooltipDelay:{number:Oa},tooltipStyle:{content:{color:{string:Aa},background:{string:Aa},border:{string:Aa},borderRadius:{string:Aa},boxShadow:{string:Aa},padding:{string:Aa},__type__:{object:Ea}},line:{borderLeft:{string:Aa},height:{string:Aa},width:{string:Aa},pointerEvents:{string:Aa},__type__:{object:Ea}},dot:{border:{string:Aa},borderRadius:{string:Aa},height:{string:Aa},width:{string:Aa},pointerEvents:{string:Aa},__type__:{object:Ea}},__type__:{object:Ea}},xValueLabel:{function:"function"},yValueLabel:{function:"function"},zValueLabel:{function:"function"},valueMax:{number:Oa,undefined:"undefined"},valueMin:{number:Oa,undefined:"undefined"},verticalRatio:{number:Oa},height:{string:Aa},width:{string:Aa},__type__:{object:Ea}};var Ma=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t},Da=[].slice,Ra={},Ia=function(t,e,r){if(!(e in Ra)){for(var n=[],i=0;i<e;i++)n[i]="a["+i+"]";Ra[e]=Function("C,a","return new C("+n.join(",")+")")}return Ra[e](t,r)},za=Function.bind||function(t){var e=R(this),r=Da.call(arguments,1),n=function(){var i=r.concat(Da.call(arguments));return this instanceof n?Ia(e,i.length,i):e.apply(t,i)};return y(e.prototype)&&(n.prototype=e.prototype),n},ja=ht("Reflect","construct"),Fa=i((function(){function t(){}return!(ja((function(){}),[],t)instanceof t)})),Ba=!i((function(){ja((function(){}))})),Na=Fa||Ba;W({target:"Reflect",stat:!0,forced:Na,sham:Na},{construct:function(t,e){R(t),z(e);var r=arguments.length<3?t:R(arguments[2]);if(Ba&&!Fa)return ja(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return n.push.apply(n,e),new(za.apply(t,n))}var i=r.prototype,o=Re(y(i)?i:Object.prototype),a=Function.apply.call(t,o,e);return y(a)?a:o}});var Ga=D.Reflect.construct,Wa=Vt("Array").entries,Ya=Array.prototype,Va={DOMTokenList:!0,NodeList:!0},Ua=function(t){var e=t.entries;return t===Ya||t instanceof Array&&e===Ya.entries||Va.hasOwnProperty(Be(t))?Wa:e},Xa=Vt("Array").keys,Za=Array.prototype,qa={DOMTokenList:!0,NodeList:!0},Ha=function(t){var e=t.keys;return t===Za||t instanceof Array&&e===Za.keys||qa.hasOwnProperty(Be(t))?Xa:e},$a=br.some,Ja=Kr("some"),Ka=rn("some");W({target:"Array",proto:!0,forced:!Ja||!Ka},{some:function(t){return $a(this,t,arguments.length>1?arguments[1]:void 0)}});var Qa=Vt("Array").some,ts=Array.prototype,es=function(t){var e=t.some;return t===ts||t instanceof Array&&e===ts.some?Qa:e},rs=ki;W({target:"Object",stat:!0},{setPrototypeOf:Ze});var ns=D.Object.setPrototypeOf,is=e((function(t){function e(r,n){return t.exports=e=ns||function(t,e){return t.__proto__=e,t},e(r,n)}t.exports=e}));var os=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=rs(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&is(t,e)};var as=function(t,e){return!e||"object"!==Jr(e)&&"function"!=typeof e?Ma(t):e},ss=Bi,ls=e((function(t){function e(r){return t.exports=e=ns?ss:function(t){return t.__proto__||ss(t)},e(r)}t.exports=e})),us=!i((function(){return Object.isExtensible(Object.preventExtensions({}))})),cs=e((function(t){var e=F.f,r=Lt("meta"),n=0,i=Object.isExtensible||function(){return!0},o=function(t){e(t,r,{value:{objectID:"O"+ ++n,weakData:{}}})},a=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!y(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!b(t,r)){if(!i(t))return"F";if(!e)return"E";o(t)}return t[r].objectID},getWeakData:function(t,e){if(!b(t,r)){if(!i(t))return!0;if(!e)return!1;o(t)}return t[r].weakData},onFreeze:function(t){return us&&a.REQUIRED&&i(t)&&!b(t,r)&&o(t),t}};Q[r]=!0})),hs=function(t,e){this.stopped=t,this.result=e},fs=function(t,e,r){var n,i,o,a,s,l,u,c=r&&r.that,h=!(!r||!r.AS_ENTRIES),f=!(!r||!r.IS_ITERATOR),d=!(!r||!r.INTERRUPTED),p=I(e,c,1+h+d),v=function(t){return n&&hi(n),new hs(!0,t)},y=function(t){return h?(z(t),d?p(t[0],t[1],v):p(t[0],t[1])):d?p(t,v):p(t)};if(f)n=t;else{if("function"!=typeof(i=li(t)))throw TypeError("Target is not iterable");if(vi(i)){for(o=0,a=Z(t.length);a>o;o++)if((s=y(t[o]))&&s instanceof hs)return s;return new hs(!1)}n=i.call(t)}for(l=n.next;!(u=l.call(n)).done;){try{s=y(u.value)}catch(t){throw hi(n),t}if("object"==typeof s&&s&&s instanceof hs)return s}return new hs(!1)},ds=function(t,e,r){if(!(t instanceof e))throw TypeError("Incorrect "+(r?r+" ":"")+"invocation");return t},ps=F.f,vs=br.forEach,ys=xe.set,ms=xe.getterFor,gs=function(t,e,r){var a,s=-1!==t.indexOf("Map"),l=-1!==t.indexOf("Weak"),u=s?"set":"add",c=n[t],h=c&&c.prototype,f={};if(o&&"function"==typeof c&&(l||h.forEach&&!i((function(){(new c).entries().next()})))){a=e((function(e,r){ys(ds(e,a,t),{type:t,collection:new c}),null!=r&&fs(r,e[u],{that:e,AS_ENTRIES:s})}));var d=ms(t);vs(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in h)||l&&"clear"==t||B(a.prototype,t,(function(r,n){var i=d(this).collection;if(!e&&l&&!y(r))return"get"==t&&void 0;var o=i[t](0===r?0:r,n);return e?this:o}))})),l||ps(a.prototype,"size",{configurable:!0,get:function(){return d(this).collection.size}})}else a=r.getConstructor(e,t,s,u),cs.REQUIRED=!0;return Ye(a,t,!1,!0),f[t]=a,W({global:!0,forced:!0},f),l||r.setStrong(a,t,s),a},bs=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:qe(t,n,e[n],r);return t},xs=Pt("species"),ws=F.f,_s=cs.fastKey,Ss=xe.set,ks=xe.getterFor,Ls={getConstructor:function(t,e,r,n){var i=t((function(t,a){ds(t,i,e),Ss(t,{type:e,index:Re(null),first:void 0,last:void 0,size:0}),o||(t.size=0),null!=a&&fs(a,t[n],{that:t,AS_ENTRIES:r})})),a=ks(e),s=function(t,e,r){var n,i,s=a(t),u=l(t,e);return u?u.value=r:(s.last=u={index:i=_s(e,!0),key:e,value:r,previous:n=s.last,next:void 0,removed:!1},s.first||(s.first=u),n&&(n.next=u),o?s.size++:t.size++,"F"!==i&&(s.index[i]=u)),t},l=function(t,e){var r,n=a(t),i=_s(e);if("F"!==i)return n.index[i];for(r=n.first;r;r=r.next)if(r.key==e)return r};return bs(i.prototype,{clear:function(){for(var t=a(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,o?t.size=0:this.size=0},delete:function(t){var e=this,r=a(e),n=l(e,t);if(n){var i=n.next,s=n.previous;delete r.index[n.index],n.removed=!0,s&&(s.next=i),i&&(i.previous=s),r.first==n&&(r.first=i),r.last==n&&(r.last=s),o?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=a(this),n=I(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!l(this,t)}}),bs(i.prototype,r?{get:function(t){var e=l(this,t);return e&&e.value},set:function(t,e){return s(this,0===t?0:t,e)}}:{add:function(t){return s(this,t=0===t?0:t,t)}}),o&&ws(i.prototype,"size",{get:function(){return a(this).size}}),i},setStrong:function(t,e,r){var n=e+" Iterator",i=ks(e),a=ks(n);Qe(t,e,(function(t,e){Ss(this,{type:n,target:t,state:i(t),kind:e,last:void 0})}),(function(){for(var t=a(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?"keys"==e?{value:r.key,done:!1}:"values"==e?{value:r.value,done:!1}:{value:[r.key,r.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),r?"entries":"values",!r,!0),function(t){var e=ht(t),r=F.f;o&&e&&!e[xs]&&r(e,xs,{configurable:!0,get:function(){return this}})}(e)}},As=(gs("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Ls),D.Set),Cs=(gs("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Ls),D.Map),Os=e((function(t){var e=function(t){var e,r=Object.prototype,n=r.hasOwnProperty,i="function"==typeof Symbol?Symbol:{},o=i.iterator||"@@iterator",a=i.asyncIterator||"@@asyncIterator",s=i.toStringTag||"@@toStringTag";function l(t,e,r){return Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{l({},"")}catch(t){l=function(t,e,r){return t[e]=r}}function u(t,e,r,n){var i=e&&e.prototype instanceof y?e:y,o=Object.create(i.prototype),a=new O(n||[]);return o._invoke=function(t,e,r){var n=h;return function(i,o){if(n===d)throw new Error("Generator is already running");if(n===p){if("throw"===i)throw o;return T()}for(r.method=i,r.arg=o;;){var a=r.delegate;if(a){var s=L(a,r);if(s){if(s===v)continue;return s}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if(n===h)throw n=p,r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n=d;var l=c(t,e,r);if("normal"===l.type){if(n=r.done?p:f,l.arg===v)continue;return{value:l.arg,done:r.done}}"throw"===l.type&&(n=p,r.method="throw",r.arg=l.arg)}}}(t,r,a),o}function c(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}t.wrap=u;var h="suspendedStart",f="suspendedYield",d="executing",p="completed",v={};function y(){}function m(){}function g(){}var b={};b[o]=function(){return this};var x=Object.getPrototypeOf,w=x&&x(x(E([])));w&&w!==r&&n.call(w,o)&&(b=w);var _=g.prototype=y.prototype=Object.create(b);function S(t){["next","throw","return"].forEach((function(e){l(t,e,(function(t){return this._invoke(e,t)}))}))}function k(t,e){var r;this._invoke=function(i,o){function a(){return new e((function(r,a){!function r(i,o,a,s){var l=c(t[i],t,o);if("throw"!==l.type){var u=l.arg,h=u.value;return h&&"object"==typeof h&&n.call(h,"__await")?e.resolve(h.__await).then((function(t){r("next",t,a,s)}),(function(t){r("throw",t,a,s)})):e.resolve(h).then((function(t){u.value=t,a(u)}),(function(t){return r("throw",t,a,s)}))}s(l.arg)}(i,o,r,a)}))}return r=r?r.then(a,a):a()}}function L(t,r){var n=t.iterator[r.method];if(n===e){if(r.delegate=null,"throw"===r.method){if(t.iterator.return&&(r.method="return",r.arg=e,L(t,r),"throw"===r.method))return v;r.method="throw",r.arg=new TypeError("The iterator does not provide a 'throw' method")}return v}var i=c(n,t.iterator,r.arg);if("throw"===i.type)return r.method="throw",r.arg=i.arg,r.delegate=null,v;var o=i.arg;return o?o.done?(r[t.resultName]=o.value,r.next=t.nextLoc,"return"!==r.method&&(r.method="next",r.arg=e),r.delegate=null,v):o:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,v)}function A(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function C(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function O(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(A,this),this.reset(!0)}function E(t){if(t){var r=t[o];if(r)return r.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var i=-1,a=function r(){for(;++i<t.length;)if(n.call(t,i))return r.value=t[i],r.done=!1,r;return r.value=e,r.done=!0,r};return a.next=a}}return{next:T}}function T(){return{value:e,done:!0}}return m.prototype=_.constructor=g,g.constructor=m,m.displayName=l(g,s,"GeneratorFunction"),t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===m||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,g):(t.__proto__=g,l(t,s,"GeneratorFunction")),t.prototype=Object.create(_),t},t.awrap=function(t){return{__await:t}},S(k.prototype),k.prototype[a]=function(){return this},t.AsyncIterator=k,t.async=function(e,r,n,i,o){void 0===o&&(o=Promise);var a=new k(u(e,r,n,i),o);return t.isGeneratorFunction(r)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},S(_),l(_,s,"Generator"),_[o]=function(){return this},_.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var r in t)e.push(r);return e.reverse(),function r(){for(;e.length;){var n=e.pop();if(n in t)return r.value=n,r.done=!1,r}return r.done=!0,r}},t.values=E,O.prototype={constructor:O,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=e,this.done=!1,this.delegate=null,this.method="next",this.arg=e,this.tryEntries.forEach(C),!t)for(var r in this)"t"===r.charAt(0)&&n.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=e)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var r=this;function i(n,i){return s.type="throw",s.arg=t,r.next=n,i&&(r.method="next",r.arg=e),!!i}for(var o=this.tryEntries.length-1;o>=0;--o){var a=this.tryEntries[o],s=a.completion;if("root"===a.tryLoc)return i("end");if(a.tryLoc<=this.prev){var l=n.call(a,"catchLoc"),u=n.call(a,"finallyLoc");if(l&&u){if(this.prev<a.catchLoc)return i(a.catchLoc,!0);if(this.prev<a.finallyLoc)return i(a.finallyLoc)}else if(l){if(this.prev<a.catchLoc)return i(a.catchLoc,!0)}else{if(!u)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return i(a.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var i=this.tryEntries[r];if(i.tryLoc<=this.prev&&n.call(i,"finallyLoc")&&this.prev<i.finallyLoc){var o=i;break}}o&&("break"===t||"continue"===t)&&o.tryLoc<=e&&e<=o.finallyLoc&&(o=null);var a=o?o.completion:{};return a.type=t,a.arg=e,o?(this.method="next",this.next=o.finallyLoc,v):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),v},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),C(r),v}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var i=n.arg;C(r)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(t,r,n){return this.delegate={iterator:E(t),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=e),v}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}})),Es=ur,Ts=Bt("splice"),Ps=rn("splice",{ACCESSORS:!0,0:0,1:2}),Ms=Math.max,Ds=Math.min;W({target:"Array",proto:!0,forced:!Ts||!Ps},{splice:function(t,e){var r,n,i,o,a,s,l=ot(this),u=Z(l.length),c=$(t,u),h=arguments.length;if(0===h?r=n=0:1===h?(r=0,n=u-c):(r=h-2,n=Ds(Ms(U(e),0),u-c)),u+r-n>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(i=Dt(l,n),o=0;o<n;o++)(a=c+o)in l&&xt(i,o,l[a]);if(i.length=n,r<n){for(o=c;o<u-n;o++)s=o+r,(a=o+n)in l?l[s]=l[a]:delete l[s];for(o=u;o>u-n+r;o--)delete l[o-1]}else if(r>n)for(o=u-n;o>c;o--)s=o+r-1,(a=o+n-1)in l?l[s]=l[a]:delete l[s];for(o=0;o<r;o++)l[o+c]=arguments[o+2];return l.length=u-n+r,i}});var Rs=Vt("Array").splice,Is=Array.prototype,zs=function(t){var e=t.splice;return t===Is||t instanceof Array&&e===Is.splice?Rs:e},js=function(t,e,r,n,i,o,a,s){for(var l,u=i,c=0,h=!!a&&I(a,s,3);c<n;){if(c in r){if(l=h?h(r[c],c,e):r[c],o>0&&bt(l))u=js(t,e,l,Z(l.length),u,o-1)-1;else{if(u>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[u]=l}u++}c++}return u},Fs=js;W({target:"Array",proto:!0},{flatMap:function(t){var e,r=ot(this),n=Z(r.length);return R(t),(e=Dt(r,0)).length=Fs(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var Bs=Vt("Array").flatMap,Ns=Array.prototype,Gs=function(t){var e=t.flatMap;return t===Ns||t instanceof Array&&e===Ns.flatMap?Bs:e},Ws=function(t){return function(e,r,n,i){R(r);var o=ot(e),a=d(o),s=Z(o.length),l=t?s-1:0,u=t?-1:1;if(n<2)for(;;){if(l in a){i=a[l],l+=u;break}if(l+=u,t?l<0:s<=l)throw TypeError("Reduce of empty array with no initial value")}for(;t?l>=0:s>l;l+=u)l in a&&(i=r(i,a[l],l,o));return i}},Ys={left:Ws(!1),right:Ws(!0)},Vs="process"==h(n.process),Us=Ys.left,Xs=Kr("reduce"),Zs=rn("reduce",{1:0});W({target:"Array",proto:!0,forced:!Xs||!Zs||!Vs&&jt>79&&jt<83},{reduce:function(t){return Us(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var qs=Vt("Array").reduce,Hs=Array.prototype,$s=function(t){var e=t.reduce;return t===Hs||t instanceof Array&&e===Hs.reduce?qs:e};W({target:"Function",proto:!0},{bind:za});var Js,Ks=Vt("Function").bind,Qs=Function.prototype,tl=function(t){var e=t.bind;return t===Qs||t instanceof Function&&e===Qs.bind?Ks:e},el=new Uint8Array(16);function rl(){if(!Js&&!(Js="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto)))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return Js(el)}var nl=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;function il(t){return"string"==typeof t&&nl.test(t)}for(var ol=[],al=0;al<256;++al)ol.push((al+256).toString(16).substr(1));function sl(t,e,r){var n=(t=t||{}).random||(t.rng||rl)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(var i=0;i<16;++i)e[r+i]=n[i];return e}return function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(ol[t[e+0]]+ol[t[e+1]]+ol[t[e+2]]+ol[t[e+3]]+"-"+ol[t[e+4]]+ol[t[e+5]]+"-"+ol[t[e+6]]+ol[t[e+7]]+"-"+ol[t[e+8]]+ol[t[e+9]]+"-"+ol[t[e+10]]+ol[t[e+11]]+ol[t[e+12]]+ol[t[e+13]]+ol[t[e+14]]+ol[t[e+15]]).toLowerCase();if(!il(r))throw TypeError("Stringified UUID is invalid");return r}(n)}function ll(t,e){var r=so(t);if(ai){var n=ai(t);e&&(n=Rn(n).call(n,(function(e){return oi(t,e).enumerable}))),r.push.apply(r,n)}return r}function ul(t){for(var e=1;e<arguments.length;e++){var r,n=null!=arguments[e]?arguments[e]:{};if(e%2)hn(r=ll(Object(n),!0)).call(r,(function(e){Oi(t,e,n[e])}));else if(ri)ti(t,ri(n));else{var i;hn(i=ll(Object(n))).call(i,(function(e){Qn(t,e,oi(n,e))}))}}return t}function cl(t){var e=function(){if("undefined"==typeof Reflect||!Ga)return!1;if(Ga.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Ga(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=ls(t);if(e){var i=ls(this).constructor;r=Ga(n,arguments,i)}else r=n.apply(this,arguments);return as(this,r)}}function hl(t,e){var r;if(void 0===wo||null==ci(t)){if($t(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return fl(t,e);var n=yo(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return _i(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return fl(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){r=ui(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw o}}}}function fl(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function dl(t){return new vl(t)}var pl=function(){function t(e,r,n){var i,o,a;ba(this,t),this._source=e,this._transformers=r,this._target=n,this._listeners={add:tl(i=this._add).call(i,this),remove:tl(o=this._remove).call(o,this),update:tl(a=this._update).call(a,this)}}return _a(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return $s(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),vl=function(){function t(e){ba(this,t),this._source=e,this._transformers=[]}return _a(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return Rn(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return po(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return Gs(e).call(e,t)})),this}},{key:"to",value:function(t){return new pl(this._source,this._transformers,t)}}]),t}();function yl(t){return"string"==typeof t||"number"==typeof t}var ml=function(){function t(e){ba(this,t),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(e)}return _a(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=gt((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;hn(t=zs(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var i=[{name:"flush",original:void 0}];if(r&&r.replace)for(var o=0;o<r.replace.length;o++){var a=r.replace[o];i.push({name:a,original:e[a]}),n.replace(e,a)}return n._extended={object:e,methods:i},n}}]),t}(),gl=function(){function t(){ba(this,t),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return _a(t,[{key:"_trigger",value:function(t,e,r){var n,i;if("*"===t)throw new Error("Cannot trigger event *");hn(n=Zt(i=[]).call(i,xo(this._subscribers[t]),xo(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=Rn(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),t}(),bl=function(){function t(e){ba(this,t),this._pairs=e}return _a(t,[{key:Es,value:Os.mark((function t(){var e,r,n,i,o;return Os.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=hl(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=oo(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:Os.mark((function t(){var e,r,n,i,o;return Os.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=hl(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=oo(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:Os.mark((function t(){var e,r,n,i;return Os.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=hl(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=oo(r.value,1),i=n[0],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:Os.mark((function t(){var e,r,n,i;return Os.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=hl(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=oo(r.value,2),i=n[1],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return po(t=xo(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return po(t=xo(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return xo(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=Li(null),r=hl(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=oo(t.value,2),i=n[0],o=n[1];e[i]=o}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new Cs(this._pairs)}},{key:"toIdSet",value:function(){return new As(this.toIdArray())}},{key:"toItemSet",value:function(){return new As(this.toItemArray())}},{key:"cache",value:function(){return new t(xo(this._pairs))}},{key:"distinct",value:function(t){var e,r=new As,n=hl(this._pairs);try{for(n.s();!(e=n.n()).done;){var i=oo(e.value,2),o=i[0],a=i[1];r.add(t(a,o))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(e){var r=this._pairs;return new t(Oi({},Es,Os.mark((function t(){var n,i,o,a,s;return Os.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=hl(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=10;break}if(o=oo(i.value,2),a=o[0],s=o[1],!e(s,a)){t.next=8;break}return t.next=8,[a,s];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=hl(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=oo(e.value,2),i=n[0];t(n[1],i)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(e){var r=this._pairs;return new t(Oi({},Es,Os.mark((function t(){var n,i,o,a,s;return Os.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=hl(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=9;break}return o=oo(i.value,2),a=o[0],s=o[1],t.next=7,[a,e(s,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=ui(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=oo(r.value,2),a=o[0],s=o[1],l=t(s,a);l>i&&(i=l,n=s)}return n}},{key:"min",value:function(t){var e=ui(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=oo(r.value,2),a=o[0],s=o[1],l=t(s,a);l<i&&(i=l,n=s)}return n}},{key:"reduce",value:function(t,e){var r,n=hl(this._pairs);try{for(n.s();!(r=n.n()).done;){var i=oo(r.value,2),o=i[0];e=t(e,i[1],o)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var r=this;return new t(Oi({},Es,(function(){var t;return ui($n(t=xo(r._pairs)).call(t,(function(t,r){var n=oo(t,2),i=n[0],o=n[1],a=oo(r,2),s=a[0],l=a[1];return e(o,l,i,s)})))})))}}]),t}();var xl=function(t){os(r,gl);var e=cl(r);function r(t,n){var i;return ba(this,r),(i=e.call(this))._queue=null,t&&!$t(t)&&(n=t,t=[]),i._options=n||{},i._data=new Cs,i.length=0,i._idProp=i._options.fieldId||"id",t&&t.length&&i.add(t),i.setOptions(n),i}return _a(r,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=ml.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Jr(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,i=[];if($t(t)){var o=po(t).call(t,(function(t){return t[n._idProp]}));if(es(o).call(o,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,s=t.length;a<s;a++)r=this._addItem(t[a]),i.push(r)}else{if(!t||"object"!==Jr(t))throw new Error("Unknown dataType");r=this._addItem(t),i.push(r)}return i.length&&this._trigger("add",{items:i},e),i}},{key:"update",value:function(t,e){var r=this,n=[],i=[],o=[],a=[],s=this._idProp,l=function(t){var e=t[s];if(null!=e&&r._data.has(e)){var l=t,u=ut({},r._data.get(e)),c=r._updateItem(l);i.push(c),a.push(l),o.push(u)}else{var h=r._addItem(t);n.push(h)}};if($t(t))for(var u=0,c=t.length;u<c;u++)t[u]&&"object"===Jr(t[u])?l(t[u]):console.warn("Ignoring input item, which is not an object at index "+u);else{if(!t||"object"!==Jr(t))throw new Error("Unknown dataType");l(t)}if(n.length&&this._trigger("add",{items:n},e),i.length){var h={items:i,oldData:o,data:a};this._trigger("update",h,e)}return Zt(n).call(n,i)}},{key:"updateOnly",value:function(t,e){var r,n=this;$t(t)||(t=[t]);var i=po(r=po(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,i=e[n._idProp],o=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),i=1;i<r;i++)n[i-1]=arguments[i];return Lo.apply(void 0,Zt(e=[{},t]).call(e,n))}(e,r);return n._data.set(i,o),{id:i,oldData:e,updatedData:o}}));if(i.length){var o={items:po(i).call(i,(function(t){return t.id})),oldData:po(i).call(i,(function(t){return t.oldData})),data:po(i).call(i,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,i=void 0;yl(t)?(r=t,i=e):$t(t)?(n=t,i=e):i=t;var o,a=i&&"Object"===i.returnType?"Object":"Array",s=i&&Rn(i),l=[],u=void 0,c=void 0,h=void 0;if(null!=r)(u=this._data.get(r))&&s&&!s(u)&&(u=void 0);else if(null!=n)for(var f=0,d=n.length;f<d;f++)null==(u=this._data.get(n[f]))||s&&!s(u)||l.push(u);else for(var p,v=0,y=(c=xo(Ha(p=this._data).call(p))).length;v<y;v++)h=c[v],null==(u=this._data.get(h))||s&&!s(u)||l.push(u);if(i&&i.order&&null==r&&this._sort(l,i.order),i&&i.fields){var m=i.fields;if(null!=r&&null!=u)u=this._filterFields(u,m);else for(var g=0,b=l.length;g<b;g++)l[g]=this._filterFields(l[g],m)}if("Object"==a){for(var x={},w=0,_=l.length;w<_;w++){var S=l[w];x[S[this._idProp]]=S}return x}return null!=r?null!==(o=u)&&void 0!==o?o:null:l}},{key:"getIds",value:function(t){var e=this._data,r=t&&Rn(t),n=t&&t.order,i=xo(Ha(e).call(e)),o=[];if(r)if(n){for(var a=[],s=0,l=i.length;s<l;s++){var u=i[s],c=this._data.get(u);null!=c&&r(c)&&a.push(c)}this._sort(a,n);for(var h=0,f=a.length;h<f;h++)o.push(a[h][this._idProp])}else for(var d=0,p=i.length;d<p;d++){var v=i[d],y=this._data.get(v);null!=y&&r(y)&&o.push(y[this._idProp])}else if(n){for(var m=[],g=0,b=i.length;g<b;g++){var x=i[g];m.push(e.get(x))}this._sort(m,n);for(var w=0,_=m.length;w<_;w++)o.push(m[w][this._idProp])}else for(var S=0,k=i.length;S<k;S++){var L=i[S],A=e.get(L);null!=A&&o.push(A[this._idProp])}return o}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&Rn(e),n=this._data,i=xo(Ha(n).call(n));if(e&&e.order)for(var o=this.get(e),a=0,s=o.length;a<s;a++){var l=o[a];t(l,l[this._idProp])}else for(var u=0,c=i.length;u<c;u++){var h=i[u],f=this._data.get(h);null==f||r&&!r(f)||t(f,h)}}},{key:"map",value:function(t,e){for(var r=e&&Rn(e),n=[],i=this._data,o=xo(Ha(i).call(i)),a=0,s=o.length;a<s;a++){var l=o[a],u=this._data.get(l);null==u||r&&!r(u)||n.push(t(u,l))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?$s(r=$t(e)?e:so(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;$n(t).call(t,(function(t,e){var n=t[r],i=e[r];return n>i?1:n<i?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");$n(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],i=$t(t)?t:[t],o=0,a=i.length;o<a;o++){var s=this._remove(i[o]);if(s){var l=s[this._idProp];null!=l&&(r.push(l),n.push(s))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(yl(t)?e=t:t&&"object"===Jr(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=xo(Ha(e=this._data).call(e)),n=[],i=0,o=r.length;i<o;i++)n.push(this._data.get(r[i]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,i=null,o=hl(vn(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,s=a[t];"number"==typeof s&&(null==i||s>i)&&(n=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,i=null,o=hl(vn(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,s=a[t];"number"==typeof s&&(null==i||s<i)&&(n=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=xo(Ha(e).call(e)),n=[],i=0,o=0,a=r.length;o<a;o++){for(var s=r[o],l=e.get(s)[t],u=!1,c=0;c<i;c++)if(n[c]==l){u=!0;break}u||void 0===l||(n[i]=l,i++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=sl()),t}(t,this._idProp),r=e[this._idProp];if(this._data.has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return this._data.set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+ga(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,ul(ul({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new bl(Oi({},Es,Os.mark((function r(){var n,i,o,a;return Os.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=hl(t),r.prev=1,n.s();case 3:if((i=n.n()).done){r.next=11;break}if(o=i.value,null==(a=e.get(o))){r.next=9;break}return r.next=9,[o,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new bl(Oi({},Es,tl(r=Ua(this._data)).call(r,this._data)))}},{key:"idProp",get:function(){return this._idProp}}]),r}(),wl=function(t){os(r,gl);var e=cl(r);function r(t,n){var i,o;return ba(this,r),(o=e.call(this)).length=0,o._ids=new As,o._options=n||{},o._listener=tl(i=o._onEvent).call(i,Ma(o)),o.setData(t),o}return _a(r,[{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:Rn(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:Rn(this._options)}),i=0,o=n.length;i<o;i++){var a=n[i];this._ids.add(a)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new xl;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:Rn(this._options)}),e=xo(this._ids),r={},n=[],i=[],o=[],a=0,s=t.length;a<s;a++){var l=t[a];r[l]=!0,this._ids.has(l)||(n.push(l),this._ids.add(l))}for(var u=0,c=e.length;u<c;u++){var h=e[u],f=this._data.get(h);null==f?console.error("If you see this, report it please."):r[h]||(i.push(h),o.push(f),this._ids.delete(h))}this.length+=n.length-i.length,n.length&&this._trigger("add",{items:n}),i.length&&this._trigger("remove",{items:i,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;yl(t)||$t(t)?(n=t,r=e):r=t;var i=ut({},this._options,r),o=Rn(this._options),a=r&&Rn(r);return o&&a&&(i.filter=function(t){return o(t)&&a(t)}),null==n?this._data.get(i):this._data.get(n,i)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=Rn(this._options),n=null!=t?Rn(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,i=Rn(this._options),o=e&&Rn(e);n=o?i?function(t){return i(t)&&o(t)}:o:i,hn(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,i=Rn(this._options),o=e&&Rn(e);return n=o?i?function(t){return i(t)&&o(t)}:o:i,po(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||Oi({},Es,tl(e=Ha(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,n="This data view has already been disposed of.",i={get:function(){throw new Error(n)},set:function(){throw new Error(n)},configurable:!1},o=hl(vo(r.prototype));try{for(o.s();!(e=o.n()).done;){var a=e.value;Qn(this,a,i)}}catch(t){o.e(t)}finally{o.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,i=[],o=[],a=[],s=[],l=[],u=[];switch(t){case"add":for(var c=0,h=n.length;c<h;c++){var f=n[c];this.get(f)&&(this._ids.add(f),i.push(f))}break;case"update":for(var d=0,p=n.length;d<p;d++){var v=n[d];this.get(v)?this._ids.has(v)?(o.push(v),l.push(e.data[d]),s.push(e.oldData[d])):(this._ids.add(v),i.push(v)):this._ids.has(v)&&(this._ids.delete(v),a.push(v),u.push(e.oldData[d]))}break;case"remove":for(var y=0,m=n.length;y<m;y++){var g=n[y];this._ids.has(g)&&(this._ids.delete(g),a.push(g),u.push(e.oldData[y]))}}this.length+=i.length-a.length,i.length&&this._trigger("add",{items:i},r),o.length&&this._trigger("update",{items:o,oldData:s,data:l},r),a.length&&this._trigger("remove",{items:a,oldData:u},r)}}},{key:"idProp",get:function(){return this.getDataSet().idProp}}]),r}();function _l(t,e){return"object"===Jr(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof hn(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof po(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}function Sl(t,e){return"object"===Jr(e)&&null!==e&&t===e.idProp&&"function"==typeof hn(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof po(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&_l(t,e.getDataSet())}function kl(){this.min=void 0,this.max=void 0}kl.prototype.adjust=function(t){void 0!==t&&((void 0===this.min||this.min>t)&&(this.min=t),(void 0===this.max||this.max<t)&&(this.max=t))},kl.prototype.combine=function(t){this.add(t.min),this.add(t.max)},kl.prototype.expand=function(t){if(void 0!==t){var e=this.min-t,r=this.max+t;if(e>r)throw new Error("Passed expansion value makes range invalid");this.min=e,this.max=r}},kl.prototype.range=function(){return this.max-this.min},kl.prototype.center=function(){return(this.min+this.max)/2};var Ll=kl;function Al(t,e,r){this.dataGroup=t,this.column=e,this.graph=r,this.index=void 0,this.value=void 0,this.values=t.getDistinctValues(this.column),vn(this).length>0&&this.selectValue(0),this.dataPoints=[],this.loaded=!1,this.onLoadCallback=void 0,r.animationPreload?(this.loaded=!1,this.loadInBackground()):this.loaded=!0}function Cl(){this.dataTable=null}Al.prototype.isLoaded=function(){return this.loaded},Al.prototype.getLoadedProgress=function(){for(var t=vn(this).length,e=0;this.dataPoints[e];)e++;return Math.round(e/t*100)},Al.prototype.getLabel=function(){return this.graph.filterLabel},Al.prototype.getColumn=function(){return this.column},Al.prototype.getSelectedValue=function(){if(void 0!==this.index)return vn(this)[this.index]},Al.prototype.getValues=function(){return vn(this)},Al.prototype.getValue=function(t){if(t>=vn(this).length)throw new Error("Index out of range");return vn(this)[t]},Al.prototype._getDataPoints=function(t){if(void 0===t&&(t=this.index),void 0===t)return[];var e;if(this.dataPoints[t])e=this.dataPoints[t];else{var r={};r.column=this.column,r.value=vn(this)[t];var n=new wl(this.dataGroup.getDataSet(),{filter:function(t){return t[r.column]==r.value}}).get();e=this.dataGroup._getDataPoints(n),this.dataPoints[t]=e}return e},Al.prototype.setOnLoadCallback=function(t){this.onLoadCallback=t},Al.prototype.selectValue=function(t){if(t>=vn(this).length)throw new Error("Index out of range");this.index=t,this.value=vn(this)[t]},Al.prototype.loadInBackground=function(t){void 0===t&&(t=0);var e=this.graph.frame;if(t<vn(this).length){void 0===e.progress&&(e.progress=document.createElement("DIV"),e.progress.style.position="absolute",e.progress.style.color="gray",e.appendChild(e.progress));var r=this.getLoadedProgress();e.progress.innerHTML="Loading animation... "+r+"%",e.progress.style.bottom="60px",e.progress.style.left="10px";var n=this;gt((function(){n.loadInBackground(t+1)}),10),this.loaded=!1}else this.loaded=!0,void 0!==e.progress&&(e.removeChild(e.progress),e.progress=void 0),this.onLoadCallback&&this.onLoadCallback()},Cl.prototype.initializeData=function(t,e,r){if(void 0!==e){var n;if($t(e)&&(e=new xl(e)),!(e instanceof xl||e instanceof wl))throw new Error("Array, DataSet, or DataView expected");if(0!=(n=e.get()).length){this.style=r,this.dataSet&&this.dataSet.off("*",this._onChange),this.dataSet=e,this.dataTable=n;var i=this;this._onChange=function(){t.setData(i.dataSet)},this.dataSet.on("*",this._onChange),this.colX="x",this.colY="y",this.colZ="z";var o=t.hasBars(r);if(o&&(void 0!==t.defaultXBarWidth?this.xBarWidth=t.defaultXBarWidth:this.xBarWidth=this.getSmallestDifference(n,this.colX)||1,void 0!==t.defaultYBarWidth?this.yBarWidth=t.defaultYBarWidth:this.yBarWidth=this.getSmallestDifference(n,this.colY)||1),this._initializeRange(n,this.colX,t,o),this._initializeRange(n,this.colY,t,o),this._initializeRange(n,this.colZ,t,!1),n[0].hasOwnProperty("style")){this.colValue="style";var a=this.getColumnRange(n,this.colValue);this._setRangeDefaults(a,t.defaultValueMin,t.defaultValueMax),this.valueRange=a}else this.colValue="z",this.valueRange=this.zRange;return this.getDataTable()[0].hasOwnProperty("filter")&&void 0===this.dataFilter&&(this.dataFilter=new Al(this,"filter",t),this.dataFilter.setOnLoadCallback((function(){t.redraw()}))),this.dataFilter?this.dataFilter._getDataPoints():this._getDataPoints(this.getDataTable())}}},Cl.prototype._collectRangeSettings=function(t,e){var r;if(-1==Wn(r=["x","y","z"]).call(r,t))throw new Error("Column '"+t+"' invalid");var n=t.toUpperCase();return{barWidth:this[t+"BarWidth"],min:e["default"+n+"Min"],max:e["default"+n+"Max"],step:e["default"+n+"Step"],range_label:t+"Range",step_label:t+"Step"}},Cl.prototype._initializeRange=function(t,e,r,n){var i=this._collectRangeSettings(e,r),o=this.getColumnRange(t,e);n&&"z"!=e&&o.expand(i.barWidth/2),this._setRangeDefaults(o,i.min,i.max),this[i.range_label]=o,this[i.step_label]=void 0!==i.step?i.step:o.range()/5},Cl.prototype.getDistinctValues=function(t,e){void 0===e&&(e=this.dataTable);for(var r=[],n=0;n<e.length;n++){var i=e[n][t]||0;-1===Wn(r).call(r,i)&&r.push(i)}return $n(r).call(r,(function(t,e){return t-e}))},Cl.prototype.getSmallestDifference=function(t,e){for(var r=this.getDistinctValues(t,e),n=null,i=1;i<r.length;i++){var o=r[i]-r[i-1];(null==n||n>o)&&(n=o)}return n},Cl.prototype.getColumnRange=function(t,e){for(var r=new Ll,n=0;n<t.length;n++){var i=t[n][e];r.adjust(i)}return r},Cl.prototype.getNumberOfRows=function(){return this.dataTable.length},Cl.prototype._setRangeDefaults=function(t,e,r){void 0!==e&&(t.min=e),void 0!==r&&(t.max=r),t.max<=t.min&&(t.max=t.min+1)},Cl.prototype.getDataTable=function(){return this.dataTable},Cl.prototype.getDataSet=function(){return this.dataSet},Cl.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var n=new No;n.x=t[r][this.colX]||0,n.y=t[r][this.colY]||0,n.z=t[r][this.colZ]||0,n.data=t[r],n.value=t[r][this.colValue]||0;var i={};i.point=n,i.bottom=new No(n.x,n.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},Cl.prototype.initDataAsMatrix=function(t){var e,r,n,i,o=this.getDistinctValues(this.colX,t),a=this.getDistinctValues(this.colY,t),s=this.getDataPoints(t),l=[];for(n=0;n<s.length;n++){i=s[n];var u=Wn(o).call(o,i.point.x),c=Wn(a).call(a,i.point.y);void 0===l[u]&&(l[u]=[]),l[u][c]=i}for(e=0;e<l.length;e++)for(r=0;r<l[e].length;r++)l[e][r]&&(l[e][r].pointRight=e<l.length-1?l[e+1][r]:void 0,l[e][r].pointTop=r<l[e].length-1?l[e][r+1]:void 0,l[e][r].pointCross=e<l.length-1&&r<l[e].length-1?l[e+1][r+1]:void 0);return s},Cl.prototype.getInfo=function(){var t=this.dataFilter;if(t)return t.getLabel()+": "+t.getSelectedValue()},Cl.prototype.reload=function(){this.dataTable&&this.setData(this.dataTable)},Cl.prototype._getDataPoints=function(t){var e=[];if(this.style===Qo.GRID||this.style===Qo.SURFACE)e=this.initDataAsMatrix(t);else if(e=this.getDataPoints(t),this.style===Qo.LINE)for(var r=0;r<e.length;r++)r>0&&(e[r-1].pointNext=e[r]);return e},Ol.STYLE=Qo;function Ol(t,e,r){if(!(this instanceof Ol))throw new SyntaxError("Constructor must be called with the new operator");this.containerElement=t,this.dataGroup=new Cl,this.dataPoints=null,this.create(),function(t,e){if(void 0===t||ia(t))throw new Error("No DEFAULTS passed");if(void 0===e)throw new Error("No dst passed");na=t,aa(t,e,ea),aa(t,e,ra,"default"),la(t,e),e.margin=10,e.showTooltip=!1,e.onclick_callback=null,e.eye=new No(0,0,-1)}(Ol.DEFAULTS,this),this.colX=void 0,this.colY=void 0,this.colZ=void 0,this.colValue=void 0,this.setOptions(r),this.setData(e)}function El(t){return"clientX"in t?t.clientX:t.targetTouches[0]&&t.targetTouches[0].clientX||0}function Tl(t){return"clientY"in t?t.clientY:t.targetTouches[0]&&t.targetTouches[0].clientY||0}Ol.DEFAULTS={width:"400px",height:"400px",filterLabel:"time",legendLabel:"value",xLabel:"x",yLabel:"y",zLabel:"z",xValueLabel:function(t){return t},yValueLabel:function(t){return t},zValueLabel:function(t){return t},showXAxis:!0,showYAxis:!0,showZAxis:!0,showGrayBottom:!1,showGrid:!0,showPerspective:!0,showShadow:!1,showSurfaceGrid:!0,keepAspectRatio:!0,rotateAxisLabels:!0,verticalRatio:.5,dotSizeRatio:.02,dotSizeMinFraction:.5,dotSizeMaxFraction:2.5,showAnimationControls:undefined,animationInterval:1e3,animationPreload:!1,animationAutoStart:undefined,axisFontSize:14,axisFontType:"arial",axisColor:"#4D4D4D",gridColor:"#D3D3D3",xCenter:"55%",yCenter:"50%",style:Ol.STYLE.DOT,tooltip:!1,tooltipDelay:300,tooltipStyle:{content:{padding:"10px",border:"1px solid #4d4d4d",color:"#1a1a1a",background:"rgba(255,255,255,0.7)",borderRadius:"2px",boxShadow:"5px 5px 10px rgba(128,128,128,0.5)"},line:{height:"40px",width:"0",borderLeft:"1px solid #4d4d4d",pointerEvents:"none"},dot:{height:"0",width:"0",border:"5px solid #4d4d4d",borderRadius:"5px",pointerEvents:"none"}},dataColor:{fill:"#7DC1FF",stroke:"#3267D2",strokeWidth:1},surfaceColors:undefined,colormap:undefined,cameraPosition:{horizontal:1,vertical:.5,distance:1.7},zoomable:!0,ctrlToZoom:!1,showLegend:undefined,backgroundColor:undefined,xBarWidth:undefined,yBarWidth:undefined,valueMin:undefined,valueMax:undefined,xMin:undefined,xMax:undefined,xStep:undefined,yMin:undefined,yMax:undefined,yStep:undefined,zMin:undefined,zMax:undefined,zStep:undefined},Jn(Ol.prototype),Ol.prototype._setScale=function(){this.scale=new No(1/this.xRange.range(),1/this.yRange.range(),1/this.zRange.range()),this.keepAspectRatio&&(this.scale.x<this.scale.y?this.scale.y=this.scale.x:this.scale.x=this.scale.y),this.scale.z*=this.verticalRatio,void 0!==this.valueRange&&(this.scale.value=1/this.valueRange.range());var t=this.xRange.center()*this.scale.x,e=this.yRange.center()*this.scale.y,r=this.zRange.center()*this.scale.z;this.camera.setArmLocation(t,e,r)},Ol.prototype._convert3Dto2D=function(t){var e=this._convertPointToTranslation(t);return this._convertTranslationToScreen(e)},Ol.prototype._convertPointToTranslation=function(t){var e=this.camera.getCameraLocation(),r=this.camera.getCameraRotation(),n=t.x*this.scale.x,i=t.y*this.scale.y,o=t.z*this.scale.z,a=e.x,s=e.y,l=e.z,u=Math.sin(r.x),c=Math.cos(r.x),h=Math.sin(r.y),f=Math.cos(r.y),d=Math.sin(r.z),p=Math.cos(r.z);return new No(f*(d*(i-s)+p*(n-a))-h*(o-l),u*(f*(o-l)+h*(d*(i-s)+p*(n-a)))+c*(p*(i-s)-d*(n-a)),c*(f*(o-l)+h*(d*(i-s)+p*(n-a)))-u*(p*(i-s)-d*(n-a)))},Ol.prototype._convertTranslationToScreen=function(t){var e,r,n=this.eye.x,i=this.eye.y,o=this.eye.z,a=t.x,s=t.y,l=t.z;return this.showPerspective?(e=o/l*(a-n),r=o/l*(s-i)):(e=a*(-o/this.camera.getArmLength()),r=s*(-o/this.camera.getArmLength())),new Go(this.currentXCenter+e*this.frame.canvas.clientWidth,this.currentYCenter-r*this.frame.canvas.clientWidth)},Ol.prototype._calcTranslations=function(t){for(var e=0;e<t.length;e++){var r=t[e];r.trans=this._convertPointToTranslation(r.point),r.screen=this._convertTranslationToScreen(r.trans);var n=this._convertPointToTranslation(r.bottom);r.dist=this.showPerspective?n.length():-n.z}$n(t).call(t,(function(t,e){return e.dist-t.dist}))},Ol.prototype._initializeRanges=function(){var t=this.dataGroup;this.xRange=t.xRange,this.yRange=t.yRange,this.zRange=t.zRange,this.valueRange=t.valueRange,this.xStep=t.xStep,this.yStep=t.yStep,this.zStep=t.zStep,this.xBarWidth=t.xBarWidth,this.yBarWidth=t.yBarWidth,this.colX=t.colX,this.colY=t.colY,this.colZ=t.colZ,this.colValue=t.colValue,this._setScale()},Ol.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var n=new No;n.x=t[r][this.colX]||0,n.y=t[r][this.colY]||0,n.z=t[r][this.colZ]||0,n.data=t[r],n.value=t[r][this.colValue]||0;var i={};i.point=n,i.bottom=new No(n.x,n.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},Ol.prototype._getDataPoints=function(t){var e,r,n,i,o=[];if(this.style===Ol.STYLE.GRID||this.style===Ol.STYLE.SURFACE){var a=this.dataGroup.getDistinctValues(this.colX,t),s=this.dataGroup.getDistinctValues(this.colY,t);o=this.getDataPoints(t);var l=[];for(n=0;n<o.length;n++){i=o[n];var u=Wn(a).call(a,i.point.x),c=Wn(s).call(s,i.point.y);void 0===l[u]&&(l[u]=[]),l[u][c]=i}for(e=0;e<l.length;e++)for(r=0;r<l[e].length;r++)l[e][r]&&(l[e][r].pointRight=e<l.length-1?l[e+1][r]:void 0,l[e][r].pointTop=r<l[e].length-1?l[e][r+1]:void 0,l[e][r].pointCross=e<l.length-1&&r<l[e].length-1?l[e+1][r+1]:void 0)}else if(o=this.getDataPoints(t),this.style===Ol.STYLE.LINE)for(n=0;n<o.length;n++)n>0&&(o[n-1].pointNext=o[n]);return o},Ol.prototype.create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div"),this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas);var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t),this.frame.filter=document.createElement("div"),Rn(this.frame).style.position="absolute",Rn(this.frame).style.bottom="0px",Rn(this.frame).style.left="0px",Rn(this.frame).style.width="100%",this.frame.appendChild(Rn(this.frame));var e=this;Io(this.frame.canvas,"mousedown",(function(t){e._onMouseDown(t)})),Io(this.frame.canvas,"touchstart",(function(t){e._onTouchStart(t)})),Io(this.frame.canvas,"mousewheel",(function(t){e._onWheel(t)})),Io(this.frame.canvas,"mousemove",(function(t){e._onTooltip(t)})),Io(this.frame.canvas,"click",(function(t){e._onClick(t)})),this.containerElement.appendChild(this.frame)},Ol.prototype._setSize=function(t,e){this.frame.style.width=t,this.frame.style.height=e,this._resizeCanvas()},Ol.prototype._resizeCanvas=function(){this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=this.frame.canvas.clientWidth,this.frame.canvas.height=this.frame.canvas.clientHeight,Rn(this.frame).style.width=this.frame.canvas.clientWidth-20+"px"},Ol.prototype.animationStart=function(){if(this.animationAutoStart&&this.dataGroup.dataFilter){if(!Rn(this.frame)||!Rn(this.frame).slider)throw new Error("No animation available");Rn(this.frame).slider.play()}},Ol.prototype.animationStop=function(){Rn(this.frame)&&Rn(this.frame).slider&&Rn(this.frame).slider.stop()},Ol.prototype._resizeCenter=function(){"%"===this.xCenter.charAt(this.xCenter.length-1)?this.currentXCenter=On(this.xCenter)/100*this.frame.canvas.clientWidth:this.currentXCenter=On(this.xCenter),"%"===this.yCenter.charAt(this.yCenter.length-1)?this.currentYCenter=On(this.yCenter)/100*(this.frame.canvas.clientHeight-Rn(this.frame).clientHeight):this.currentYCenter=On(this.yCenter)},Ol.prototype.getCameraPosition=function(){var t=this.camera.getArmRotation();return t.distance=this.camera.getArmLength(),t},Ol.prototype._readData=function(t){this.dataPoints=this.dataGroup.initializeData(this,t,this.style),this._initializeRanges(),this._redrawFilter()},Ol.prototype.setData=function(t){null!=t&&(this._readData(t),this.redraw(),this.animationStart())},Ol.prototype.setOptions=function(t){void 0!==t&&(!0===La.validate(t,Pa)&&console.log("%cErrors have been found in the supplied options object.",ka),this.animationStop(),function(t,e){if(void 0!==t){if(void 0===e)throw new Error("No dst passed");if(void 0===na||ia(na))throw new Error("DEFAULTS not set for module Settings");sa(t,e,ea),sa(t,e,ra,"default"),la(t,e)}}(t,this),this.setPointDrawingMethod(),this._setSize(this.width,this.height),this.setAxisLabelMethod(),this.setData(this.dataGroup.getDataTable()),this.animationStart())},Ol.prototype.setPointDrawingMethod=function(){var t=void 0;switch(this.style){case Ol.STYLE.BAR:t=this._redrawBarGraphPoint;break;case Ol.STYLE.BARCOLOR:t=this._redrawBarColorGraphPoint;break;case Ol.STYLE.BARSIZE:t=this._redrawBarSizeGraphPoint;break;case Ol.STYLE.DOT:t=this._redrawDotGraphPoint;break;case Ol.STYLE.DOTLINE:t=this._redrawDotLineGraphPoint;break;case Ol.STYLE.DOTCOLOR:t=this._redrawDotColorGraphPoint;break;case Ol.STYLE.DOTSIZE:t=this._redrawDotSizeGraphPoint;break;case Ol.STYLE.SURFACE:t=this._redrawSurfaceGraphPoint;break;case Ol.STYLE.GRID:t=this._redrawGridGraphPoint;break;case Ol.STYLE.LINE:t=this._redrawLineGraphPoint;break;default:throw new Error("Can not determine point drawing method for graph style '"+this.style+"'")}this._pointDrawingMethod=t},Ol.prototype.setAxisLabelMethod=function(){this.rotateAxisLabels?(this._drawAxisLabelX=this.drawAxisLabelXRotate,this._drawAxisLabelY=this.drawAxisLabelYRotate,this._drawAxisLabelZ=this.drawAxisLabelZRotate):(this._drawAxisLabelX=this.drawAxisLabelX,this._drawAxisLabelY=this.drawAxisLabelY,this._drawAxisLabelZ=this.drawAxisLabelZ)},Ol.prototype.redraw=function(){if(void 0===this.dataPoints)throw new Error("Graph data not initialized");this._resizeCanvas(),this._resizeCenter(),this._redrawSlider(),this._redrawClear(),this._redrawAxis(),this._redrawDataGraph(),this._redrawInfo(),this._redrawLegend()},Ol.prototype._getContext=function(){var t=this.frame.canvas.getContext("2d");return t.lineJoin="round",t.lineCap="round",t},Ol.prototype._redrawClear=function(){var t=this.frame.canvas;t.getContext("2d").clearRect(0,0,t.width,t.height)},Ol.prototype._dotSize=function(){return this.frame.clientWidth*this.dotSizeRatio},Ol.prototype._getLegendWidth=function(){var t;this.style===Ol.STYLE.DOTSIZE?t=this._dotSize()*this.dotSizeMaxFraction:t=this.style===Ol.STYLE.BARSIZE?this.xBarWidth:20;return t},Ol.prototype._redrawLegend=function(){if(!0===this.showLegend&&this.style!==Ol.STYLE.LINE&&this.style!==Ol.STYLE.BARSIZE){var t=this.style===Ol.STYLE.BARSIZE||this.style===Ol.STYLE.DOTSIZE,e=this.style===Ol.STYLE.DOTSIZE||this.style===Ol.STYLE.DOTCOLOR||this.style===Ol.STYLE.SURFACE||this.style===Ol.STYLE.BARCOLOR,r=Math.max(.25*this.frame.clientHeight,100),n=this.margin,i=this._getLegendWidth(),o=this.frame.clientWidth-this.margin,a=o-i,s=n+r,l=this._getContext();if(l.lineWidth=1,l.font="14px arial",!1===t){var u,c=r;for(u=0;u<c;u++){var h=1-(u-0)/(c-0),f=this._colormap(h,1);l.strokeStyle=f,l.beginPath(),l.moveTo(a,n+u),l.lineTo(o,n+u),l.stroke()}l.strokeStyle=this.axisColor,l.strokeRect(a,n,i,r)}else{var d;this.style===Ol.STYLE.DOTSIZE?d=i*(this.dotSizeMinFraction/this.dotSizeMaxFraction):(this.style,Ol.STYLE.BARSIZE),l.strokeStyle=this.axisColor,l.fillStyle=gn(this.dataColor),l.beginPath(),l.moveTo(a,n),l.lineTo(o,n),l.lineTo(a+d,s),l.lineTo(a,s),l.closePath(),gn(l).call(l),l.stroke()}var p,v,y=e?this.valueRange.min:this.zRange.min,m=e?this.valueRange.max:this.zRange.max,g=new Vo(y,m,(m-y)/5,!0);for(g.start(!0);!g.end();)u=s-(g.getCurrent()-y)/(m-y)*r,p=new Go(a-5,u),v=new Go(a,u),this._line(l,p,v),l.textAlign="right",l.textBaseline="middle",l.fillStyle=this.axisColor,l.fillText(g.getCurrent(),a-10,u),g.next();l.textAlign="right",l.textBaseline="top";var b=this.legendLabel;l.fillText(b,o,s+this.margin)}},Ol.prototype._redrawFilter=function(){var t=this.dataGroup.dataFilter,e=Rn(this.frame);if(e.innerHTML="",t){var r=new Wo(e,{visible:this.showAnimationControls});e.slider=r,e.style.padding="10px",r.setValues(vn(t)),r.setPlayInterval(this.animationInterval);var n=this;r.setOnChangeCallback((function(){var t=n.dataGroup.dataFilter,e=r.getIndex();t.selectValue(e),n.dataPoints=t._getDataPoints(),n.redraw()}))}else e.slider=void 0},Ol.prototype._redrawSlider=function(){void 0!==Rn(this.frame).slider&&Rn(this.frame).slider.redraw()},Ol.prototype._redrawInfo=function(){var t=this.dataGroup.getInfo();if(void 0!==t){var e=this._getContext();e.font="14px arial",e.lineStyle="gray",e.fillStyle="gray",e.textAlign="left",e.textBaseline="top";var r=this.margin,n=this.margin;e.fillText(t,r,n)}},Ol.prototype._line=function(t,e,r,n){void 0!==n&&(t.strokeStyle=n),t.beginPath(),t.moveTo(e.x,e.y),t.lineTo(r.x,r.y),t.stroke()},Ol.prototype.drawAxisLabelX=function(t,e,r,n,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*n)>0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*n)<0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},Ol.prototype.drawAxisLabelY=function(t,e,r,n,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*n)<0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*n)>0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},Ol.prototype.drawAxisLabelZ=function(t,e,r,n){void 0===n&&(n=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,i.x-n,i.y)},Ol.prototype.drawAxisLabelXRotate=function(t,e,r,n,i){var o=this._convert3Dto2D(e);Math.cos(2*n)>0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*n)<0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},Ol.prototype.drawAxisLabelYRotate=function(t,e,r,n,i){var o=this._convert3Dto2D(e);Math.cos(2*n)<0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*n)>0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},Ol.prototype.drawAxisLabelZRotate=function(t,e,r,n){void 0===n&&(n=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,i.x-n,i.y)},Ol.prototype._line3d=function(t,e,r,n){var i=this._convert3Dto2D(e),o=this._convert3Dto2D(r);this._line(t,i,o,n)},Ol.prototype._redrawAxis=function(){var t,e,r,n,i,o,a,s,l,u,c=this._getContext();c.font=this.axisFontSize/this.camera.getArmLength()+"px "+this.axisFontType;var h,f,d,p=.025/this.scale.x,v=.025/this.scale.y,y=5/this.camera.getArmLength(),m=this.camera.getArmRotation().horizontal,g=new Go(Math.cos(m),Math.sin(m)),b=this.xRange,x=this.yRange,w=this.zRange;for(c.lineWidth=1,n=void 0===this.defaultXStep,(r=new Vo(b.min,b.max,this.xStep,n)).start(!0);!r.end();){var _=r.getCurrent();if(this.showGrid?(t=new No(_,x.min,w.min),e=new No(_,x.max,w.min),this._line3d(c,t,e,this.gridColor)):this.showXAxis&&(t=new No(_,x.min,w.min),e=new No(_,x.min+p,w.min),this._line3d(c,t,e,this.axisColor),t=new No(_,x.max,w.min),e=new No(_,x.max-p,w.min),this._line3d(c,t,e,this.axisColor)),this.showXAxis){a=g.x>0?x.min:x.max,h=new No(_,a,w.min);var S="  "+this.xValueLabel(_)+"  ";this._drawAxisLabelX.call(this,c,h,S,m,y)}r.next()}for(c.lineWidth=1,n=void 0===this.defaultYStep,(r=new Vo(x.min,x.max,this.yStep,n)).start(!0);!r.end();){var k=r.getCurrent();if(this.showGrid?(t=new No(b.min,k,w.min),e=new No(b.max,k,w.min),this._line3d(c,t,e,this.gridColor)):this.showYAxis&&(t=new No(b.min,k,w.min),e=new No(b.min+v,k,w.min),this._line3d(c,t,e,this.axisColor),t=new No(b.max,k,w.min),e=new No(b.max-v,k,w.min),this._line3d(c,t,e,this.axisColor)),this.showYAxis){o=g.y>0?b.min:b.max,h=new No(o,k,w.min);var L="  "+this.yValueLabel(k)+"  ";this._drawAxisLabelY.call(this,c,h,L,m,y)}r.next()}if(this.showZAxis){for(c.lineWidth=1,n=void 0===this.defaultZStep,(r=new Vo(w.min,w.max,this.zStep,n)).start(!0),o=g.x>0?b.min:b.max,a=g.y<0?x.min:x.max;!r.end();){var A=r.getCurrent(),C=new No(o,a,A),O=this._convert3Dto2D(C);e=new Go(O.x-y,O.y),this._line(c,O,e,this.axisColor);var E=this.zValueLabel(A)+" ";this._drawAxisLabelZ.call(this,c,C,E,5),r.next()}c.lineWidth=1,t=new No(o,a,w.min),e=new No(o,a,w.max),this._line3d(c,t,e,this.axisColor)}this.showXAxis&&(c.lineWidth=1,f=new No(b.min,x.min,w.min),d=new No(b.max,x.min,w.min),this._line3d(c,f,d,this.axisColor),f=new No(b.min,x.max,w.min),d=new No(b.max,x.max,w.min),this._line3d(c,f,d,this.axisColor));this.showYAxis&&(c.lineWidth=1,t=new No(b.min,x.min,w.min),e=new No(b.min,x.max,w.min),this._line3d(c,t,e,this.axisColor),t=new No(b.max,x.min,w.min),e=new No(b.max,x.max,w.min),this._line3d(c,t,e,this.axisColor));var T=this.xLabel;T.length>0&&this.showXAxis&&(u=.1/this.scale.y,o=(b.max+3*b.min)/4,a=g.x>0?x.min-u:x.max+u,i=new No(o,a,w.min),this.drawAxisLabelX(c,i,T,m));var P=this.yLabel;P.length>0&&this.showYAxis&&(l=.1/this.scale.x,o=g.y>0?b.min-l:b.max+l,a=(x.max+3*x.min)/4,i=new No(o,a,w.min),this.drawAxisLabelY(c,i,P,m));var M=this.zLabel;M.length>0&&this.showZAxis&&(30,o=g.x>0?b.min:b.max,a=g.y<0?x.min:x.max,s=(w.max+3*w.min)/4,i=new No(o,a,s),this.drawAxisLabelZ(c,i,M,30))},Ol.prototype._getStrokeWidth=function(t){return void 0!==t?this.showPerspective?1/-t.trans.z*this.dataColor.strokeWidth:-this.eye.z/this.camera.getArmLength()*this.dataColor.strokeWidth:this.dataColor.strokeWidth},Ol.prototype._redrawBar=function(t,e,r,n,i,o){var a,s=this,l=e.point,u=this.zRange.min,c=[{point:new No(l.x-r,l.y-n,l.z)},{point:new No(l.x+r,l.y-n,l.z)},{point:new No(l.x+r,l.y+n,l.z)},{point:new No(l.x-r,l.y+n,l.z)}],h=[{point:new No(l.x-r,l.y-n,u)},{point:new No(l.x+r,l.y-n,u)},{point:new No(l.x+r,l.y+n,u)},{point:new No(l.x-r,l.y+n,u)}];hn(c).call(c,(function(t){t.screen=s._convert3Dto2D(t.point)})),hn(h).call(h,(function(t){t.screen=s._convert3Dto2D(t.point)}));var f=[{corners:c,center:No.avg(h[0].point,h[2].point)},{corners:[c[0],c[1],h[1],h[0]],center:No.avg(h[1].point,h[0].point)},{corners:[c[1],c[2],h[2],h[1]],center:No.avg(h[2].point,h[1].point)},{corners:[c[2],c[3],h[3],h[2]],center:No.avg(h[3].point,h[2].point)},{corners:[c[3],c[0],h[0],h[3]],center:No.avg(h[0].point,h[3].point)}];e.surfaces=f;for(var d=0;d<f.length;d++){a=f[d];var p=this._convertPointToTranslation(a.center);a.dist=this.showPerspective?p.length():-p.z}$n(f).call(f,(function(t,e){var r=e.dist-t.dist;return r||(t.corners===c?1:e.corners===c?-1:0)})),t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=o,t.fillStyle=i;for(var v=2;v<f.length;v++)a=f[v],this._polygon(t,a.corners)},Ol.prototype._polygon=function(t,e,r,n){if(!(e.length<2)){void 0!==r&&(t.fillStyle=r),void 0!==n&&(t.strokeStyle=n),t.beginPath(),t.moveTo(e[0].screen.x,e[0].screen.y);for(var i=1;i<e.length;++i){var o=e[i];t.lineTo(o.screen.x,o.screen.y)}t.closePath(),gn(t).call(t),t.stroke()}},Ol.prototype._drawCircle=function(t,e,r,n,i){var o=this._calcRadius(e,i);t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=n,t.fillStyle=r,t.beginPath(),t.arc(e.screen.x,e.screen.y,o,0,2*Math.PI,!0),gn(t).call(t),t.stroke()},Ol.prototype._getColorsRegular=function(t){var e=(t.point.value-this.valueRange.min)*this.scale.value;return{fill:this._colormap(e,1),border:this._colormap(e,.8)}},Ol.prototype._getColorsColor=function(t){var e,r,n;if(t&&t.point&&t.point.data&&t.point.data.style&&(n=t.point.data.style),n&&"object"===Jr(n)&&gn(n)&&n.stroke)return{fill:gn(n),border:n.stroke};if("string"==typeof t.point.value)e=t.point.value,r=t.point.value;else{var i=(t.point.value-this.valueRange.min)*this.scale.value;e=this._colormap(i,1),r=this._colormap(i,.8)}return{fill:e,border:r}},Ol.prototype._getColorsSize=function(){return{fill:gn(this.dataColor),border:this.dataColor.stroke}},Ol.prototype._colormap=function(t){var e,r,n,i,o,a,s,l,u,c=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,h=this.colormap;if($t(h)){var f=h.length-1,d=Math.max(Math.floor(t*f),0),p=Math.min(d+1,f),v=t*f-d,y=h[d],m=h[p];e=y.r+v*(m.r-y.r),r=y.g+v*(m.g-y.g),n=y.b+v*(m.b-y.b)}else if("function"==typeof h){var g=h(t);e=g.r,r=g.g,n=g.b,i=g.a}else{var b=240*(1-t),x=Fo(b/360,1,1);e=x.r,r=x.g,n=x.b}return"number"!=typeof i||qt(i)?Zt(o=Zt(a="RGB(".concat(Math.round(e*c),", ")).call(a,Math.round(r*c),", ")).call(o,Math.round(n*c),")"):Zt(s=Zt(l=Zt(u="RGBA(".concat(Math.round(e*c),", ")).call(u,Math.round(r*c),", ")).call(l,Math.round(n*c),", ")).call(s,i,")")},Ol.prototype._calcRadius=function(t,e){var r;return void 0===e&&(e=this._dotSize()),(r=this.showPerspective?e/-t.trans.z:e*(-this.eye.z/this.camera.getArmLength()))<0&&(r=0),r},Ol.prototype._redrawBarGraphPoint=function(t,e){var r=this.xBarWidth/2,n=this.yBarWidth/2,i=this._getColorsRegular(e);this._redrawBar(t,e,r,n,gn(i),i.border)},Ol.prototype._redrawBarColorGraphPoint=function(t,e){var r=this.xBarWidth/2,n=this.yBarWidth/2,i=this._getColorsColor(e);this._redrawBar(t,e,r,n,gn(i),i.border)},Ol.prototype._redrawBarSizeGraphPoint=function(t,e){var r=(e.point.value-this.valueRange.min)/this.valueRange.range(),n=this.xBarWidth/2*(.8*r+.2),i=this.yBarWidth/2*(.8*r+.2),o=this._getColorsSize();this._redrawBar(t,e,n,i,gn(o),o.border)},Ol.prototype._redrawDotGraphPoint=function(t,e){var r=this._getColorsRegular(e);this._drawCircle(t,e,gn(r),r.border)},Ol.prototype._redrawDotLineGraphPoint=function(t,e){var r=this._convert3Dto2D(e.bottom);t.lineWidth=1,this._line(t,r,e.screen,this.gridColor),this._redrawDotGraphPoint(t,e)},Ol.prototype._redrawDotColorGraphPoint=function(t,e){var r=this._getColorsColor(e);this._drawCircle(t,e,gn(r),r.border)},Ol.prototype._redrawDotSizeGraphPoint=function(t,e){var r=this._dotSize(),n=(e.point.value-this.valueRange.min)/this.valueRange.range(),i=r*this.dotSizeMinFraction,o=i+(r*this.dotSizeMaxFraction-i)*n,a=this._getColorsSize();this._drawCircle(t,e,gn(a),a.border,o)},Ol.prototype._redrawSurfaceGraphPoint=function(t,e){var r=e.pointRight,n=e.pointTop,i=e.pointCross;if(void 0!==e&&void 0!==r&&void 0!==n&&void 0!==i){var o,a,s,l=!0;if(this.showGrayBottom||this.showShadow){var u=No.subtract(i.trans,e.trans),c=No.subtract(n.trans,r.trans),h=No.crossProduct(u,c);if(this.showPerspective){var f=No.avg(No.avg(e.trans,i.trans),No.avg(r.trans,n.trans));s=-No.dotProduct(h.normalize(),f.normalize())}else s=h.z/h.length();l=s>0}if(l||!this.showGrayBottom){var d=((e.point.value+r.point.value+n.point.value+i.point.value)/4-this.valueRange.min)*this.scale.value,p=this.showShadow?(1+s)/2:1;o=this._colormap(d,p)}else o="gray";a=this.showSurfaceGrid?this.axisColor:o,t.lineWidth=this._getStrokeWidth(e);var v=[e,r,i,n];this._polygon(t,v,o,a)}},Ol.prototype._drawGridLine=function(t,e,r){if(void 0!==e&&void 0!==r){var n=((e.point.value+r.point.value)/2-this.valueRange.min)*this.scale.value;t.lineWidth=2*this._getStrokeWidth(e),t.strokeStyle=this._colormap(n,1),this._line(t,e.screen,r.screen)}},Ol.prototype._redrawGridGraphPoint=function(t,e){this._drawGridLine(t,e,e.pointRight),this._drawGridLine(t,e,e.pointTop)},Ol.prototype._redrawLineGraphPoint=function(t,e){void 0!==e.pointNext&&(t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=this.dataColor.stroke,this._line(t,e.screen,e.pointNext.screen))},Ol.prototype._redrawDataGraph=function(){var t,e=this._getContext();if(!(void 0===this.dataPoints||this.dataPoints.length<=0))for(this._calcTranslations(this.dataPoints),t=0;t<this.dataPoints.length;t++){var r=this.dataPoints[t];this._pointDrawingMethod.call(this,e,r)}},Ol.prototype._storeMousePosition=function(t){this.startMouseX=El(t),this.startMouseY=Tl(t),this._startCameraOffset=this.camera.getOffset()},Ol.prototype._onMouseDown=function(t){if(t=t||window.event,this.leftButtonDown&&this._onMouseUp(t),this.leftButtonDown=t.which?1===t.which:1===t.button,this.leftButtonDown||this.touchDown){this._storeMousePosition(t),this.startStart=new Date(this.start),this.startEnd=new Date(this.end),this.startArmRotation=this.camera.getArmRotation(),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},Io(document,"mousemove",e.onmousemove),Io(document,"mouseup",e.onmouseup),jo(t)}},Ol.prototype._onMouseMove=function(t){this.moving=!0,t=t||window.event;var e=On(El(t))-this.startMouseX,r=On(Tl(t))-this.startMouseY;if(t&&!0===t.ctrlKey){var n=.5*this.frame.clientWidth,i=.5*this.frame.clientHeight,o=(this._startCameraOffset.x||0)-e/n*this.camera.armLength*.8,a=(this._startCameraOffset.y||0)+r/i*this.camera.armLength*.8;this.camera.setOffset(o,a),this._storeMousePosition(t)}else{var s=this.startArmRotation.horizontal+e/200,l=this.startArmRotation.vertical+r/200,u=Math.sin(4/360*2*Math.PI);Math.abs(Math.sin(s))<u&&(s=Math.round(s/Math.PI)*Math.PI-.001),Math.abs(Math.cos(s))<u&&(s=(Math.round(s/Math.PI-.5)+.5)*Math.PI-.001),Math.abs(Math.sin(l))<u&&(l=Math.round(l/Math.PI)*Math.PI),Math.abs(Math.cos(l))<u&&(l=(Math.round(l/Math.PI-.5)+.5)*Math.PI),this.camera.setArmRotation(s,l)}this.redraw();var c=this.getCameraPosition();this.emit("cameraPositionChange",c),jo(t)},Ol.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",this.leftButtonDown=!1,zo(document,"mousemove",this.onmousemove),zo(document,"mouseup",this.onmouseup),jo(t)},Ol.prototype._onClick=function(t){if(this.onclick_callback||this.hasListeners("click")){if(this.moving)this.moving=!1;else{var e=this.frame.getBoundingClientRect(),r=El(t)-e.left,n=Tl(t)-e.top,i=this._dataPointFromXY(r,n);i&&(this.onclick_callback&&this.onclick_callback(i.point.data),this.emit("click",i.point.data))}jo(t)}},Ol.prototype._onTooltip=function(t){var e=this.tooltipDelay,r=this.frame.getBoundingClientRect(),n=El(t)-r.left,i=Tl(t)-r.top;if(this.showTooltip)if(this.tooltipTimeout&&clearTimeout(this.tooltipTimeout),this.leftButtonDown)this._hideTooltip();else if(this.tooltip&&this.tooltip.dataPoint){var o=this._dataPointFromXY(n,i);o!==this.tooltip.dataPoint&&(o?this._showTooltip(o):this._hideTooltip())}else{var a=this;this.tooltipTimeout=gt((function(){a.tooltipTimeout=null;var t=a._dataPointFromXY(n,i);t&&a._showTooltip(t)}),e)}},Ol.prototype._onTouchStart=function(t){this.touchDown=!0;var e=this;this.ontouchmove=function(t){e._onTouchMove(t)},this.ontouchend=function(t){e._onTouchEnd(t)},Io(document,"touchmove",e.ontouchmove),Io(document,"touchend",e.ontouchend),this._onMouseDown(t)},Ol.prototype._onTouchMove=function(t){this._onMouseMove(t)},Ol.prototype._onTouchEnd=function(t){this.touchDown=!1,zo(document,"touchmove",this.ontouchmove),zo(document,"touchend",this.ontouchend),this._onMouseUp(t)},Ol.prototype._onWheel=function(t){if(t||(t=window.event),this.zoomable&&(!this.ctrlToZoom||t.ctrlKey)){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail&&(e=-t.detail/3),e){var r=this.camera.getArmLength()*(1-e/10);this.camera.setArmLength(r),this.redraw(),this._hideTooltip()}var n=this.getCameraPosition();this.emit("cameraPositionChange",n),jo(t)}},Ol.prototype._insideTriangle=function(t,e){var r=e[0],n=e[1],i=e[2];function o(t){return t>0?1:t<0?-1:0}var a=o((n.x-r.x)*(t.y-r.y)-(n.y-r.y)*(t.x-r.x)),s=o((i.x-n.x)*(t.y-n.y)-(i.y-n.y)*(t.x-n.x)),l=o((r.x-i.x)*(t.y-i.y)-(r.y-i.y)*(t.x-i.x));return!(0!=a&&0!=s&&a!=s||0!=s&&0!=l&&s!=l||0!=a&&0!=l&&a!=l)},Ol.prototype._dataPointFromXY=function(t,e){var r,n=null,i=null,o=null,a=new Go(t,e);if(this.style===Ol.STYLE.BAR||this.style===Ol.STYLE.BARCOLOR||this.style===Ol.STYLE.BARSIZE)for(r=this.dataPoints.length-1;r>=0;r--){var s=(n=this.dataPoints[r]).surfaces;if(s)for(var l=s.length-1;l>=0;l--){var u=s[l].corners,c=[u[0].screen,u[1].screen,u[2].screen],h=[u[2].screen,u[3].screen,u[0].screen];if(this._insideTriangle(a,c)||this._insideTriangle(a,h))return n}}else for(r=0;r<this.dataPoints.length;r++){var f=(n=this.dataPoints[r]).screen;if(f){var d=Math.abs(t-f.x),p=Math.abs(e-f.y),v=Math.sqrt(d*d+p*p);(null===o||v<o)&&v<100&&(o=v,i=n)}}return i},Ol.prototype.hasBars=function(t){return t==Ol.STYLE.BAR||t==Ol.STYLE.BARCOLOR||t==Ol.STYLE.BARSIZE},Ol.prototype._showTooltip=function(t){var e,r,n;this.tooltip?(e=this.tooltip.dom.content,r=this.tooltip.dom.line,n=this.tooltip.dom.dot):(e=document.createElement("div"),ut(e.style,{},this.tooltipStyle.content),e.style.position="absolute",r=document.createElement("div"),ut(r.style,{},this.tooltipStyle.line),r.style.position="absolute",n=document.createElement("div"),ut(n.style,{},this.tooltipStyle.dot),n.style.position="absolute",this.tooltip={dataPoint:null,dom:{content:e,line:r,dot:n}}),this._hideTooltip(),this.tooltip.dataPoint=t,"function"==typeof this.showTooltip?e.innerHTML=this.showTooltip(t.point):e.innerHTML="<table><tr><td>"+this.xLabel+":</td><td>"+t.point.x+"</td></tr><tr><td>"+this.yLabel+":</td><td>"+t.point.y+"</td></tr><tr><td>"+this.zLabel+":</td><td>"+t.point.z+"</td></tr></table>",e.style.left="0",e.style.top="0",this.frame.appendChild(e),this.frame.appendChild(r),this.frame.appendChild(n);var i=e.offsetWidth,o=e.offsetHeight,a=r.offsetHeight,s=n.offsetWidth,l=n.offsetHeight,u=t.screen.x-i/2;u=Math.min(Math.max(u,10),this.frame.clientWidth-10-i),r.style.left=t.screen.x+"px",r.style.top=t.screen.y-a+"px",e.style.left=u+"px",e.style.top=t.screen.y-a-o+"px",n.style.left=t.screen.x-s/2+"px",n.style.top=t.screen.y-l/2+"px"},Ol.prototype._hideTooltip=function(){if(this.tooltip)for(var t in this.tooltip.dataPoint=null,this.tooltip.dom)if(this.tooltip.dom.hasOwnProperty(t)){var e=this.tooltip.dom[t];e&&e.parentNode&&e.parentNode.removeChild(e)}},Ol.prototype.setCameraPosition=function(t){ha(t,this),this.redraw()},Ol.prototype.setSize=function(t,e){this._setSize(t,e),this.redraw()};export{ko as DELETE,xl as DataSet,bl as DataStream,wl as DataView,Ol as Graph3d,Ko as Graph3dCamera,Al as Graph3dFilter,Go as Graph3dPoint2d,No as Graph3dPoint3d,Wo as Graph3dSlider,Vo as Graph3dStepNumber,ml as Queue,dl as createNewDataPipeFrom,_l as isDataSetLike,Sl as isDataViewLike};
//# sourceMappingURL=vis-graph3d.min.js.map
