/**
 * vis-graph3d
 * https://visjs.github.io/vis-graph3d/
 *
 * Create interactive, animated 3d graphs. Surfaces, lines, dots and block styling out of the box.
 *
 * @version 6.0.1
 * @date    2020-12-16T19:56:54.897Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).vis=t.vis||{})}(this,(function(t){var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function r(t,e,r){return t(r={path:e,exports:{},require:function(t,e){return function(){throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs")}(null==e&&r.path)}},r.exports),r.exports}var n=function(t){return t&&t.Math==Math&&t},i=n("object"==typeof globalThis&&globalThis)||n("object"==typeof window&&window)||n("object"==typeof self&&self)||n("object"==typeof e&&e)||function(){return this}()||Function("return this")(),o=function(t){try{return!!t()}catch(t){return!0}},a=!o((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),s={}.propertyIsEnumerable,l=Object.getOwnPropertyDescriptor,u={f:l&&!s.call({1:2},1)?function(t){var e=l(this,t);return!!e&&e.enumerable}:s},c=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},h={}.toString,f=function(t){return h.call(t).slice(8,-1)},d="".split,p=o((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==f(t)?d.call(t,""):Object(t)}:Object,v=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},y=function(t){return p(v(t))},m=function(t){return"object"==typeof t?null!==t:"function"==typeof t},g=function(t,e){if(!m(t))return t;var r,n;if(e&&"function"==typeof(r=t.toString)&&!m(n=r.call(t)))return n;if("function"==typeof(r=t.valueOf)&&!m(n=r.call(t)))return n;if(!e&&"function"==typeof(r=t.toString)&&!m(n=r.call(t)))return n;throw TypeError("Can't convert object to primitive value")},b={}.hasOwnProperty,w=function(t,e){return b.call(t,e)},x=i.document,_=m(x)&&m(x.createElement),S=function(t){return _?x.createElement(t):{}},k=!a&&!o((function(){return 7!=Object.defineProperty(S("div"),"a",{get:function(){return 7}}).a})),L=Object.getOwnPropertyDescriptor,A={f:a?L:function(t,e){if(t=y(t),e=g(e,!0),k)try{return L(t,e)}catch(t){}if(w(t,e))return c(!u.f.call(t,e),t[e])}},C=/#|\.prototype\./,O=function(t,e){var r=T[E(t)];return r==M||r!=P&&("function"==typeof e?o(e):!!e)},E=O.normalize=function(t){return String(t).replace(C,".").toLowerCase()},T=O.data={},P=O.NATIVE="N",M=O.POLYFILL="P",D=O,R={},I=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},z=function(t,e,r){if(I(t),void 0===e)return t;switch(r){case 0:return function(){return t.call(e)};case 1:return function(r){return t.call(e,r)};case 2:return function(r,n){return t.call(e,r,n)};case 3:return function(r,n,i){return t.call(e,r,n,i)}}return function(){return t.apply(e,arguments)}},j=function(t){if(!m(t))throw TypeError(String(t)+" is not an object");return t},F=Object.defineProperty,B={f:a?F:function(t,e,r){if(j(t),e=g(e,!0),j(r),k)try{return F(t,e,r)}catch(t){}if("get"in r||"set"in r)throw TypeError("Accessors not supported");return"value"in r&&(t[e]=r.value),t}},N=a?function(t,e,r){return B.f(t,e,c(1,r))}:function(t,e,r){return t[e]=r,t},G=A.f,W=function(t){var e=function(e,r,n){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,r)}return new t(e,r,n)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},Y=function(t,e){var r,n,o,a,s,l,u,c,h=t.target,f=t.global,d=t.stat,p=t.proto,v=f?i:d?i[h]:(i[h]||{}).prototype,y=f?R:R[h]||(R[h]={}),m=y.prototype;for(o in e)r=!D(f?o:h+(d?".":"#")+o,t.forced)&&v&&w(v,o),s=y[o],r&&(l=t.noTargetGet?(c=G(v,o))&&c.value:v[o]),a=r&&l?l:e[o],r&&typeof s==typeof a||(u=t.bind&&r?z(a,i):t.wrap&&r?W(a):p&&"function"==typeof a?z(Function.call,a):a,(t.sham||a&&a.sham||s&&s.sham)&&N(u,"sham",!0),y[o]=u,p&&(w(R,n=h+"Prototype")||N(R,n,{}),R[n][o]=a,t.real&&m&&!m[o]&&N(m,o,a)))},V=Math.ceil,U=Math.floor,X=function(t){return isNaN(t=+t)?0:(t>0?U:V)(t)},Z=Math.min,q=function(t){return t>0?Z(X(t),9007199254740991):0},H=Math.max,$=Math.min,J=function(t,e){var r=X(t);return r<0?H(r+e,0):$(r,e)},K=function(t){return function(e,r,n){var i,o=y(e),a=q(o.length),s=J(n,a);if(t&&r!=r){for(;a>s;)if((i=o[s++])!=i)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===r)return t||s||0;return!t&&-1}},Q={includes:K(!0),indexOf:K(!1)},tt={},et=Q.indexOf,rt=function(t,e){var r,n=y(t),i=0,o=[];for(r in n)!w(tt,r)&&w(n,r)&&o.push(r);for(;e.length>i;)w(n,r=e[i++])&&(~et(o,r)||o.push(r));return o},nt=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],it=Object.keys||function(t){return rt(t,nt)},ot={f:Object.getOwnPropertySymbols},at=function(t){return Object(v(t))},st=Object.assign,lt=Object.defineProperty,ut=!st||o((function(){if(a&&1!==st({b:1},st(lt({},"a",{enumerable:!0,get:function(){lt(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=st({},t)[r]||it(st({},e)).join("")!=n}))?function(t,e){for(var r=at(t),n=arguments.length,i=1,o=ot.f,s=u.f;n>i;)for(var l,c=p(arguments[i++]),h=o?it(c).concat(o(c)):it(c),f=h.length,d=0;f>d;)l=h[d++],a&&!s.call(c,l)||(r[l]=c[l]);return r}:st;Y({target:"Object",stat:!0,forced:Object.assign!==ut},{assign:ut});var ct=R.Object.assign,ht=function(t){return"function"==typeof t?t:void 0},ft=function(t,e){return arguments.length<2?ht(R[t])||ht(i[t]):R[t]&&R[t][e]||i[t]&&i[t][e]},dt=ft("navigator","userAgent")||"",pt=[].slice,vt=/MSIE .\./.test(dt),yt=function(t){return function(e,r){var n=arguments.length>2,i=n?pt.call(arguments,2):void 0;return t(n?function(){("function"==typeof e?e:Function(e)).apply(this,i)}:e,r)}};Y({global:!0,bind:!0,forced:vt},{setTimeout:yt(i.setTimeout),setInterval:yt(i.setInterval)});var mt,gt,bt=R.setTimeout,wt=Array.isArray||function(t){return"Array"==f(t)},xt=function(t,e,r){var n=g(e);n in t?B.f(t,n,c(0,r)):t[n]=r},_t="__core-js_shared__",St=i[_t]||function(t,e){try{N(i,t,e)}catch(r){i[t]=e}return e}(_t,{}),kt=r((function(t){(t.exports=function(t,e){return St[t]||(St[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.8.1",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),Lt=0,At=Math.random(),Ct=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++Lt+At).toString(36)},Ot=!!Object.getOwnPropertySymbols&&!o((function(){return!String(Symbol())})),Et=Ot&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Tt=kt("wks"),Pt=i.Symbol,Mt=Et?Pt:Pt&&Pt.withoutSetter||Ct,Dt=function(t){return w(Tt,t)||(Ot&&w(Pt,t)?Tt[t]=Pt[t]:Tt[t]=Mt("Symbol."+t)),Tt[t]},Rt=Dt("species"),It=function(t,e){var r;return wt(t)&&("function"!=typeof(r=t.constructor)||r!==Array&&!wt(r.prototype)?m(r)&&null===(r=r[Rt])&&(r=void 0):r=void 0),new(void 0===r?Array:r)(0===e?0:e)},zt=i.process,jt=zt&&zt.versions,Ft=jt&&jt.v8;Ft?gt=(mt=Ft.split("."))[0]+mt[1]:dt&&(!(mt=dt.match(/Edge\/(\d+)/))||mt[1]>=74)&&(mt=dt.match(/Chrome\/(\d+)/))&&(gt=mt[1]);var Bt=gt&&+gt,Nt=Dt("species"),Gt=function(t){return Bt>=51||!o((function(){var e=[];return(e.constructor={})[Nt]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Wt=Dt("isConcatSpreadable"),Yt=9007199254740991,Vt="Maximum allowed index exceeded",Ut=Bt>=51||!o((function(){var t=[];return t[Wt]=!1,t.concat()[0]!==t})),Xt=Gt("concat"),Zt=function(t){if(!m(t))return!1;var e=t[Wt];return void 0!==e?!!e:wt(t)};Y({target:"Array",proto:!0,forced:!Ut||!Xt},{concat:function(t){var e,r,n,i,o,a=at(this),s=It(a,0),l=0;for(e=-1,n=arguments.length;e<n;e++)if(Zt(o=-1===e?a:arguments[e])){if(l+(i=q(o.length))>Yt)throw TypeError(Vt);for(r=0;r<i;r++,l++)r in o&&xt(s,l,o[r])}else{if(l>=Yt)throw TypeError(Vt);xt(s,l++,o)}return s.length=l,s}});var qt=function(t){return R[t+"Prototype"]},Ht=qt("Array").concat,$t=Array.prototype,Jt=function(t){var e=t.concat;return t===$t||t instanceof Array&&e===$t.concat?Ht:e};Y({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var Kt=R.Number.isNaN;Y({target:"Array",stat:!0},{isArray:wt});var Qt=R.Array.isArray,te=Qt,ee={f:Dt},re=B.f,ne=function(t){var e=R.Symbol||(R.Symbol={});w(e,t)||re(e,t,{value:ee.f(t)})};ne("iterator");var ie=function(t){return function(e,r){var n,i,o=String(v(e)),a=X(r),s=o.length;return a<0||a>=s?t?"":void 0:(n=o.charCodeAt(a))<55296||n>56319||a+1===s||(i=o.charCodeAt(a+1))<56320||i>57343?t?o.charAt(a):n:t?o.slice(a,a+2):i-56320+(n-55296<<10)+65536}},oe={codeAt:ie(!1),charAt:ie(!0)},ae=Function.toString;"function"!=typeof St.inspectSource&&(St.inspectSource=function(t){return ae.call(t)});var se,le,ue,ce=St.inspectSource,he=i.WeakMap,fe="function"==typeof he&&/native code/.test(ce(he)),de=kt("keys"),pe=function(t){return de[t]||(de[t]=Ct(t))},ve=i.WeakMap;if(fe){var ye=St.state||(St.state=new ve),me=ye.get,ge=ye.has,be=ye.set;se=function(t,e){return e.facade=t,be.call(ye,t,e),e},le=function(t){return me.call(ye,t)||{}},ue=function(t){return ge.call(ye,t)}}else{var we=pe("state");tt[we]=!0,se=function(t,e){return e.facade=t,N(t,we,e),e},le=function(t){return w(t,we)?t[we]:{}},ue=function(t){return w(t,we)}}var xe,_e,Se,ke={set:se,get:le,has:ue,enforce:function(t){return ue(t)?le(t):se(t,{})},getterFor:function(t){return function(e){var r;if(!m(e)||(r=le(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return r}}},Le=!o((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Ae=pe("IE_PROTO"),Ce=Object.prototype,Oe=Le?Object.getPrototypeOf:function(t){return t=at(t),w(t,Ae)?t[Ae]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?Ce:null},Ee=(Dt("iterator"),!1);[].keys&&("next"in(Se=[].keys())?(_e=Oe(Oe(Se)))!==Object.prototype&&(xe=_e):Ee=!0),null==xe&&(xe={});var Te,Pe={IteratorPrototype:xe,BUGGY_SAFARI_ITERATORS:Ee},Me=a?Object.defineProperties:function(t,e){j(t);for(var r,n=it(e),i=n.length,o=0;i>o;)B.f(t,r=n[o++],e[r]);return t},De=ft("document","documentElement"),Re=pe("IE_PROTO"),Ie=function(){},ze=function(t){return"<script>"+t+"</"+"script>"},je=function(){try{Te=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;je=Te?function(t){t.write(ze("")),t.close();var e=t.parentWindow.Object;return t=null,e}(Te):((e=S("iframe")).style.display="none",De.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(ze("document.F=Object")),t.close(),t.F);for(var r=nt.length;r--;)delete je.prototype[nt[r]];return je()};tt[Re]=!0;var Fe=Object.create||function(t,e){var r;return null!==t?(Ie.prototype=j(t),r=new Ie,Ie.prototype=null,r[Re]=t):r=je(),void 0===e?r:Me(r,e)},Be={};Be[Dt("toStringTag")]="z";var Ne="[object z]"===String(Be),Ge=Dt("toStringTag"),We="Arguments"==f(function(){return arguments}()),Ye=Ne?f:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),Ge))?r:We?f(e):"Object"==(n=f(e))&&"function"==typeof e.callee?"Arguments":n},Ve=Ne?{}.toString:function(){return"[object "+Ye(this)+"]"},Ue=B.f,Xe=Dt("toStringTag"),Ze=function(t,e,r,n){if(t){var i=r?t:t.prototype;w(i,Xe)||Ue(i,Xe,{configurable:!0,value:e}),n&&!Ne&&N(i,"toString",Ve)}},qe={},He=Pe.IteratorPrototype,$e=function(){return this},Je=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return j(r),function(t){if(!m(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(n),e?t.call(r,n):r.__proto__=n,r}}():void 0),Ke=function(t,e,r,n){n&&n.enumerable?t[e]=r:N(t,e,r)},Qe=Pe.IteratorPrototype,tr=Pe.BUGGY_SAFARI_ITERATORS,er=Dt("iterator"),rr="keys",nr="values",ir="entries",or=function(){return this},ar=function(t,e,r,n,i,o,a){!function(t,e,r){var n=e+" Iterator";t.prototype=Fe(He,{next:c(1,r)}),Ze(t,n,!1,!0),qe[n]=$e}(r,e,n);var s,l,u,h=function(t){if(t===i&&y)return y;if(!tr&&t in p)return p[t];switch(t){case rr:case nr:case ir:return function(){return new r(this,t)}}return function(){return new r(this)}},f=e+" Iterator",d=!1,p=t.prototype,v=p[er]||p["@@iterator"]||i&&p[i],y=!tr&&v||h(i),m="Array"==e&&p.entries||v;if(m&&(s=Oe(m.call(new t)),Qe!==Object.prototype&&s.next&&(Ze(s,f,!0,!0),qe[f]=or)),i==nr&&v&&v.name!==nr&&(d=!0,y=function(){return v.call(this)}),a&&p[er]!==y&&N(p,er,y),qe[e]=y,i)if(l={values:h(nr),keys:o?y:h(rr),entries:h(ir)},a)for(u in l)(tr||d||!(u in p))&&Ke(p,u,l[u]);else Y({target:e,proto:!0,forced:tr||d},l);return l},sr=oe.charAt,lr="String Iterator",ur=ke.set,cr=ke.getterFor(lr);ar(String,"String",(function(t){ur(this,{type:lr,string:String(t),index:0})}),(function(){var t,e=cr(this),r=e.string,n=e.index;return n>=r.length?{value:void 0,done:!0}:(t=sr(r,n),e.index+=t.length,{value:t,done:!1})}));var hr="Array Iterator",fr=ke.set,dr=ke.getterFor(hr);ar(Array,"Array",(function(t,e){fr(this,{type:hr,target:y(t),index:0,kind:e})}),(function(){var t=dr(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==r?{value:n,done:!1}:"values"==r?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values");qe.Arguments=qe.Array;var pr=Dt("toStringTag");for(var vr in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var yr=i[vr],mr=yr&&yr.prototype;mr&&Ye(mr)!==pr&&N(mr,pr,vr),qe[vr]=qe.Array}var gr=ee.f("iterator"),br=gr,wr=nt.concat("length","prototype"),xr={f:Object.getOwnPropertyNames||function(t){return rt(t,wr)}},_r=xr.f,Sr={}.toString,kr="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],Lr={f:function(t){return kr&&"[object Window]"==Sr.call(t)?function(t){try{return _r(t)}catch(t){return kr.slice()}}(t):_r(y(t))}},Ar=[].push,Cr=function(t){var e=1==t,r=2==t,n=3==t,i=4==t,o=6==t,a=7==t,s=5==t||o;return function(l,u,c,h){for(var f,d,v=at(l),y=p(v),m=z(u,c,3),g=q(y.length),b=0,w=h||It,x=e?w(l,g):r||a?w(l,0):void 0;g>b;b++)if((s||b in y)&&(d=m(f=y[b],b,v),t))if(e)x[b]=d;else if(d)switch(t){case 3:return!0;case 5:return f;case 6:return b;case 2:Ar.call(x,f)}else switch(t){case 4:return!1;case 7:Ar.call(x,f)}return o?-1:n||i?i:x}},Or={forEach:Cr(0),map:Cr(1),filter:Cr(2),some:Cr(3),every:Cr(4),find:Cr(5),findIndex:Cr(6),filterOut:Cr(7)},Er=Or.forEach,Tr=pe("hidden"),Pr="Symbol",Mr=Dt("toPrimitive"),Dr=ke.set,Rr=ke.getterFor(Pr),Ir=Object.prototype,zr=i.Symbol,jr=ft("JSON","stringify"),Fr=A.f,Br=B.f,Nr=Lr.f,Gr=u.f,Wr=kt("symbols"),Yr=kt("op-symbols"),Vr=kt("string-to-symbol-registry"),Ur=kt("symbol-to-string-registry"),Xr=kt("wks"),Zr=i.QObject,qr=!Zr||!Zr.prototype||!Zr.prototype.findChild,Hr=a&&o((function(){return 7!=Fe(Br({},"a",{get:function(){return Br(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=Fr(Ir,e);n&&delete Ir[e],Br(t,e,r),n&&t!==Ir&&Br(Ir,e,n)}:Br,$r=function(t,e){var r=Wr[t]=Fe(zr.prototype);return Dr(r,{type:Pr,tag:t,description:e}),a||(r.description=e),r},Jr=Et?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof zr},Kr=function(t,e,r){t===Ir&&Kr(Yr,e,r),j(t);var n=g(e,!0);return j(r),w(Wr,n)?(r.enumerable?(w(t,Tr)&&t[Tr][n]&&(t[Tr][n]=!1),r=Fe(r,{enumerable:c(0,!1)})):(w(t,Tr)||Br(t,Tr,c(1,{})),t[Tr][n]=!0),Hr(t,n,r)):Br(t,n,r)},Qr=function(t,e){j(t);var r=y(e),n=it(r).concat(nn(r));return Er(n,(function(e){a&&!tn.call(r,e)||Kr(t,e,r[e])})),t},tn=function(t){var e=g(t,!0),r=Gr.call(this,e);return!(this===Ir&&w(Wr,e)&&!w(Yr,e))&&(!(r||!w(this,e)||!w(Wr,e)||w(this,Tr)&&this[Tr][e])||r)},en=function(t,e){var r=y(t),n=g(e,!0);if(r!==Ir||!w(Wr,n)||w(Yr,n)){var i=Fr(r,n);return!i||!w(Wr,n)||w(r,Tr)&&r[Tr][n]||(i.enumerable=!0),i}},rn=function(t){var e=Nr(y(t)),r=[];return Er(e,(function(t){w(Wr,t)||w(tt,t)||r.push(t)})),r},nn=function(t){var e=t===Ir,r=Nr(e?Yr:y(t)),n=[];return Er(r,(function(t){!w(Wr,t)||e&&!w(Ir,t)||n.push(Wr[t])})),n};if(Ot||(Ke((zr=function(){if(this instanceof zr)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=Ct(t),r=function(t){this===Ir&&r.call(Yr,t),w(this,Tr)&&w(this[Tr],e)&&(this[Tr][e]=!1),Hr(this,e,c(1,t))};return a&&qr&&Hr(Ir,e,{configurable:!0,set:r}),$r(e,t)}).prototype,"toString",(function(){return Rr(this).tag})),Ke(zr,"withoutSetter",(function(t){return $r(Ct(t),t)})),u.f=tn,B.f=Kr,A.f=en,xr.f=Lr.f=rn,ot.f=nn,ee.f=function(t){return $r(Dt(t),t)},a&&Br(zr.prototype,"description",{configurable:!0,get:function(){return Rr(this).description}})),Y({global:!0,wrap:!0,forced:!Ot,sham:!Ot},{Symbol:zr}),Er(it(Xr),(function(t){ne(t)})),Y({target:Pr,stat:!0,forced:!Ot},{for:function(t){var e=String(t);if(w(Vr,e))return Vr[e];var r=zr(e);return Vr[e]=r,Ur[r]=e,r},keyFor:function(t){if(!Jr(t))throw TypeError(t+" is not a symbol");if(w(Ur,t))return Ur[t]},useSetter:function(){qr=!0},useSimple:function(){qr=!1}}),Y({target:"Object",stat:!0,forced:!Ot,sham:!a},{create:function(t,e){return void 0===e?Fe(t):Qr(Fe(t),e)},defineProperty:Kr,defineProperties:Qr,getOwnPropertyDescriptor:en}),Y({target:"Object",stat:!0,forced:!Ot},{getOwnPropertyNames:rn,getOwnPropertySymbols:nn}),Y({target:"Object",stat:!0,forced:o((function(){ot.f(1)}))},{getOwnPropertySymbols:function(t){return ot.f(at(t))}}),jr){var on=!Ot||o((function(){var t=zr();return"[null]"!=jr([t])||"{}"!=jr({a:t})||"{}"!=jr(Object(t))}));Y({target:"JSON",stat:!0,forced:on},{stringify:function(t,e,r){for(var n,i=[t],o=1;arguments.length>o;)i.push(arguments[o++]);if(n=e,(m(e)||void 0!==t)&&!Jr(t))return wt(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!Jr(e))return e}),i[1]=e,jr.apply(null,i)}})}zr.prototype[Mr]||N(zr.prototype,Mr,zr.prototype.valueOf),Ze(zr,Pr),tt[Tr]=!0,ne("asyncIterator"),ne("hasInstance"),ne("isConcatSpreadable"),ne("match"),ne("matchAll"),ne("replace"),ne("search"),ne("species"),ne("split"),ne("toPrimitive"),ne("toStringTag"),ne("unscopables"),Ze(i.JSON,"JSON",!0);var an=R.Symbol;ne("asyncDispose"),ne("dispose"),ne("observable"),ne("patternMatch"),ne("replaceAll");var sn=an,ln=r((function(t){function e(r){return t.exports=e="function"==typeof sn&&"symbol"==typeof br?function(t){return typeof t}:function(t){return t&&"function"==typeof sn&&t.constructor===sn&&t!==sn.prototype?"symbol":typeof t},e(r)}t.exports=e})),un=function(t,e){var r=[][t];return!!r&&o((function(){r.call(null,e||function(){throw 1},1)}))},cn=Object.defineProperty,hn={},fn=function(t){throw t},dn=function(t,e){if(w(hn,t))return hn[t];e||(e={});var r=[][t],n=!!w(e,"ACCESSORS")&&e.ACCESSORS,i=w(e,0)?e[0]:fn,s=w(e,1)?e[1]:void 0;return hn[t]=!!r&&!o((function(){if(n&&!a)return!0;var t={length:-1};n?cn(t,1,{enumerable:!0,get:fn}):t[1]=1,r.call(t,i,s)}))},pn=Or.forEach,vn=un("forEach"),yn=dn("forEach"),mn=vn&&yn?[].forEach:function(t){return pn(this,t,arguments.length>1?arguments[1]:void 0)};Y({target:"Array",proto:!0,forced:[].forEach!=mn},{forEach:mn});var gn=qt("Array").forEach,bn=Array.prototype,wn={DOMTokenList:!0,NodeList:!0},xn=function(t){var e=t.forEach;return t===bn||t instanceof Array&&e===bn.forEach||wn.hasOwnProperty(Ye(t))?gn:e},_n=qt("Array").values,Sn=Array.prototype,kn={DOMTokenList:!0,NodeList:!0},Ln=function(t){var e=t.values;return t===Sn||t instanceof Array&&e===Sn.values||kn.hasOwnProperty(Ye(t))?_n:e};Y({target:"Array",proto:!0},{fill:function(t){for(var e=at(this),r=q(e.length),n=arguments.length,i=J(n>1?arguments[1]:void 0,r),o=n>2?arguments[2]:void 0,a=void 0===o?r:J(o,r);a>i;)e[i++]=t;return e}});var An=qt("Array").fill,Cn=Array.prototype,On=function(t){var e=t.fill;return t===Cn||t instanceof Array&&e===Cn.fill?An:e},En="\t\n\v\f\r                　\u2028\u2029\ufeff",Tn="["+En+"]",Pn=RegExp("^"+Tn+Tn+"*"),Mn=RegExp(Tn+Tn+"*$"),Dn=function(t){return function(e){var r=String(v(e));return 1&t&&(r=r.replace(Pn,"")),2&t&&(r=r.replace(Mn,"")),r}},Rn={start:Dn(1),end:Dn(2),trim:Dn(3)},In=Rn.trim,zn=i.parseFloat,jn=1/zn(En+"-0")!=-1/0?function(t){var e=In(String(t)),r=zn(e);return 0===r&&"-"==e.charAt(0)?-0:r}:zn;Y({global:!0,forced:parseFloat!=jn},{parseFloat:jn});var Fn=R.parseFloat,Bn=Or.filter,Nn=Gt("filter"),Gn=dn("filter");Y({target:"Array",proto:!0,forced:!Nn||!Gn},{filter:function(t){return Bn(this,t,arguments.length>1?arguments[1]:void 0)}});var Wn=qt("Array").filter,Yn=Array.prototype,Vn=function(t){var e=t.filter;return t===Yn||t instanceof Array&&e===Yn.filter?Wn:e},Un=Q.indexOf,Xn=[].indexOf,Zn=!!Xn&&1/[1].indexOf(1,-0)<0,qn=un("indexOf"),Hn=dn("indexOf",{ACCESSORS:!0,1:0});Y({target:"Array",proto:!0,forced:Zn||!qn||!Hn},{indexOf:function(t){return Zn?Xn.apply(this,arguments)||0:Un(this,t,arguments.length>1?arguments[1]:void 0)}});var $n=qt("Array").indexOf,Jn=Array.prototype,Kn=function(t){var e=t.indexOf;return t===Jn||t instanceof Array&&e===Jn.indexOf?$n:e},Qn=[],ti=Qn.sort,ei=o((function(){Qn.sort(void 0)})),ri=o((function(){Qn.sort(null)})),ni=un("sort");Y({target:"Array",proto:!0,forced:ei||!ri||!ni},{sort:function(t){return void 0===t?ti.call(at(this)):ti.call(at(this),I(t))}});var ii=qt("Array").sort,oi=Array.prototype,ai=function(t){var e=t.sort;return t===oi||t instanceof Array&&e===oi.sort?ii:e},si=r((function(t){function e(t){if(t)return function(t){for(var r in e.prototype)t[r]=e.prototype[r];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i=0;i<n.length;i++)if((r=n[i])===e||r.fn===e){n.splice(i,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),r=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(r){n=0;for(var i=(r=r.slice(0)).length;n<i;++n)r[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}));Y({target:"Object",stat:!0,forced:!a,sham:!a},{defineProperty:B.f});var li=r((function(t){var e=R.Object,r=t.exports=function(t,r,n){return e.defineProperty(t,r,n)};e.defineProperty.sham&&(r.sham=!0)})),ui=li;Y({target:"Object",stat:!0,forced:!a,sham:!a},{defineProperties:Me});var ci=r((function(t){var e=R.Object,r=t.exports=function(t,r){return e.defineProperties(t,r)};e.defineProperties.sham&&(r.sham=!0)})),hi=ft("Reflect","ownKeys")||function(t){var e=xr.f(j(t)),r=ot.f;return r?e.concat(r(t)):e};Y({target:"Object",stat:!0,sham:!a},{getOwnPropertyDescriptors:function(t){for(var e,r,n=y(t),i=A.f,o=hi(n),a={},s=0;o.length>s;)void 0!==(r=i(n,e=o[s++]))&&xt(a,e,r);return a}});var fi=R.Object.getOwnPropertyDescriptors,di=A.f,pi=o((function(){di(1)}));Y({target:"Object",stat:!0,forced:!a||pi,sham:!a},{getOwnPropertyDescriptor:function(t,e){return di(y(t),e)}});var vi=r((function(t){var e=R.Object,r=t.exports=function(t,r){return e.getOwnPropertyDescriptor(t,r)};e.getOwnPropertyDescriptor.sham&&(r.sham=!0)})),yi=R.Object.getOwnPropertySymbols,mi=Dt("iterator"),gi=function(t){if(null!=t)return t[mi]||t["@@iterator"]||qe[Ye(t)]},bi=function(t){var e=gi(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return j(e.call(t))},wi=gi,xi=function(t){var e=t.return;if(void 0!==e)return j(e.call(t)).value},_i=function(t,e,r,n){try{return n?e(j(r)[0],r[1]):e(r)}catch(e){throw xi(t),e}},Si=Dt("iterator"),ki=Array.prototype,Li=function(t){return void 0!==t&&(qe.Array===t||ki[Si]===t)},Ai=Dt("iterator"),Ci=!1;try{var Oi=0,Ei={next:function(){return{done:!!Oi++}},return:function(){Ci=!0}};Ei[Ai]=function(){return this},Array.from(Ei,(function(){throw 2}))}catch(t){}var Ti=!function(t,e){if(!e&&!Ci)return!1;var r=!1;try{var n={};n[Ai]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r}((function(t){Array.from(t)}));Y({target:"Array",stat:!0,forced:Ti},{from:function(t){var e,r,n,i,o,a,s=at(t),l="function"==typeof this?this:Array,u=arguments.length,c=u>1?arguments[1]:void 0,h=void 0!==c,f=gi(s),d=0;if(h&&(c=z(c,u>2?arguments[2]:void 0,2)),null==f||l==Array&&Li(f))for(r=new l(e=q(s.length));e>d;d++)a=h?c(s[d],d):s[d],xt(r,d,a);else for(o=(i=f.call(s)).next,r=new l;!(n=o.call(i)).done;d++)a=h?_i(i,c,[n.value,d],!0):n.value,xt(r,d,a);return r.length=d,r}});var Pi=R.Array.from,Mi=Pi;Y({target:"Object",stat:!0,sham:!a},{create:Fe});var Di=R.Object,Ri=function(t,e){return Di.create(t,e)},Ii=Ri,zi=li;var ji,Fi=function(t,e,r){return e in t?zi(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t},Bi=Rn.trim;Y({target:"String",proto:!0,forced:(ji="trim",o((function(){return!!En[ji]()||"​᠎"!="​᠎"[ji]()||En[ji].name!==ji})))},{trim:function(){return Bi(this)}});qt("String").trim;var Ni=Rn.trim,Gi=i.parseInt,Wi=/^[+-]?0[Xx]/,Yi=8!==Gi(En+"08")||22!==Gi(En+"0x16")?function(t,e){var r=Ni(String(t));return Gi(r,e>>>0||(Wi.test(r)?16:10))}:Gi;Y({global:!0,forced:parseInt!=Yi},{parseInt:Yi});var Vi=R.parseInt,Ui=u.f,Xi=function(t){return function(e){for(var r,n=y(e),i=it(n),o=i.length,s=0,l=[];o>s;)r=i[s++],a&&!Ui.call(n,r)||l.push(t?[r,n[r]]:n[r]);return l}},Zi={entries:Xi(!0),values:Xi(!1)}.values;Y({target:"Object",stat:!0},{values:function(t){return Zi(t)}});R.Object.values;var qi=o((function(){Oe(1)}));Y({target:"Object",stat:!0,forced:qi,sham:!Le},{getPrototypeOf:function(t){return Oe(at(t))}});var Hi=R.Object.getPrototypeOf,$i=Hi,Ji=Qt;var Ki=function(t){if(Ji(t))return t},Qi=Dt("iterator"),to=function(t){var e=Object(t);return void 0!==e[Qi]||"@@iterator"in e||qe.hasOwnProperty(Ye(e))};var eo=function(t,e){if(void 0!==sn&&to(Object(t))){var r=[],n=!0,i=!1,o=void 0;try{for(var a,s=bi(t);!(n=(a=s.next()).done)&&(r.push(a.value),!e||r.length!==e);n=!0);}catch(t){i=!0,o=t}finally{try{n||null==s.return||s.return()}finally{if(i)throw o}}return r}},ro=Pi,no=Gt("slice"),io=dn("slice",{ACCESSORS:!0,0:0,1:2}),oo=Dt("species"),ao=[].slice,so=Math.max;Y({target:"Array",proto:!0,forced:!no||!io},{slice:function(t,e){var r,n,i,o=y(this),a=q(o.length),s=J(t,a),l=J(void 0===e?a:e,a);if(wt(o)&&("function"!=typeof(r=o.constructor)||r!==Array&&!wt(r.prototype)?m(r)&&null===(r=r[oo])&&(r=void 0):r=void 0,r===Array||void 0===r))return ao.call(o,s,l);for(n=new(void 0===r?Array:r)(so(l-s,0)),i=0;s<l;s++,i++)s in o&&xt(n,i,o[s]);return n.length=i,n}});var lo=qt("Array").slice,uo=Array.prototype,co=function(t){var e=t.slice;return t===uo||t instanceof Array&&e===uo.slice?lo:e},ho=co;var fo=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n};var po=function(t,e){var r;if(t){if("string"==typeof t)return fo(t,e);var n=ho(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?ro(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?fo(t,e):void 0}};var vo=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var yo=function(t,e){return Ki(t)||eo(t,e)||po(t,e)||vo()};Y({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});R.Date.now;var mo=o((function(){it(1)}));Y({target:"Object",stat:!0,forced:mo},{keys:function(t){return it(at(t))}});var go=R.Object.keys,bo=Or.map,wo=Gt("map"),xo=dn("map");Y({target:"Array",proto:!0,forced:!wo||!xo},{map:function(t){return bo(this,t,arguments.length>1?arguments[1]:void 0)}});var _o=qt("Array").map,So=Array.prototype,ko=function(t){var e=t.map;return t===So||t instanceof Array&&e===So.map?_o:e};Y({target:"Reflect",stat:!0},{ownKeys:hi});var Lo=R.Reflect.ownKeys,Ao=co;var Co=function(t){if(Ji(t))return fo(t)};var Oo=function(t){if(void 0!==sn&&to(Object(t)))return ro(t)};var Eo=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var To=function(t){return Co(t)||Oo(t)||po(t)||Eo()},Po=an;function Mo(t,e){var r;if(void 0===Po||null==wi(t)){if(te(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Do(t,e);var n=Ao(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Mi(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Do(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){r=bi(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw o}}}}function Do(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}
/**
	 * vis-util
	 * https://github.com/visjs/vis-util
	 *
	 * utilitie collection for visjs
	 *
	 * @version 4.3.4
	 * @date    2020-08-01T15:11:53.524Z
	 *
	 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
	 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
	 *
	 * @license
	 * vis.js is dual licensed under both
	 *
	 *   1. The Apache 2.0 License
	 *      http://www.apache.org/licenses/LICENSE-2.0
	 *
	 *   and
	 *
	 *   2. The MIT License
	 *      http://opensource.org/licenses/MIT
	 *
	 * vis.js may be distributed under either license.
	 */var Ro=Po("DELETE");function Io(){var t=zo.apply(void 0,arguments);return Fo(t),t}function zo(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return zo.apply(void 0,Jt(n=[Io(e[0],e[1])]).call(n,To(Ao(e).call(e,2))));var i,o=e[0],a=e[1],s=Mo(Lo(a));try{for(s.s();!(i=s.n()).done;){var l=i.value;Object.prototype.propertyIsEnumerable.call(a,l)&&(a[l]===Ro?delete o[l]:null===o[l]||null===a[l]||"object"!==ln(o[l])||"object"!==ln(a[l])||te(o[l])||te(a[l])?o[l]=jo(a[l]):o[l]=zo(o[l],a[l]))}}catch(t){s.e(t)}finally{s.f()}return o}function jo(t){return te(t)?ko(t).call(t,(function(t){return jo(t)})):"object"===ln(t)&&null!==t?zo({},t):t}function Fo(t){for(var e=0,r=go(t);e<r.length;e++){var n=r[e];t[n]===Ro?delete t[n]:"object"===ln(t[n])&&null!==t[n]&&Fo(t[n])}}var Bo=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,No=/^#?([a-f\d])([a-f\d])([a-f\d])$/i;function Go(t,e,r,n){var i=!1;!0===n&&(i=null===e[r]&&void 0!==t[r]),i?delete t[r]:t[r]=e[r]}function Wo(t,e){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var i in e)if(Object.prototype.hasOwnProperty.call(e,i)||!0===r)if("object"===ln(e[i])&&null!==e[i]&&$i(e[i])===Object.prototype)void 0===t[i]?t[i]=Wo({},e[i],r):"object"===ln(t[i])&&null!==t[i]&&$i(t[i])===Object.prototype?Wo(t[i],e[i],r):Go(t,e,i,n);else if(te(e[i])){var o;t[i]=Ao(o=e[i]).call(o)}else Go(t,e,i,n);return t}function Yo(t,e){var r;return Jt(r=[]).call(r,To(t),[e])}function Vo(t){return Ao(t).call(t)}function Uo(t,e,r,n){var i;t.addEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Kn(i=navigator.userAgent).call(i,"Firefox")>=0&&(e="DOMMouseScroll"),t.addEventListener(e,r,n)):t.attachEvent("on"+e,r)}function Xo(t,e,r,n){var i;t.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Kn(i=navigator.userAgent).call(i,"Firefox")>=0&&(e="DOMMouseScroll"),t.removeEventListener(e,r,n)):t.detachEvent("on"+e,r)}function Zo(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)}function qo(t,e,r){var n,i,o,a=Math.floor(6*t),s=6*t-a,l=r*(1-e),u=r*(1-s*e),c=r*(1-(1-s)*e);switch(a%6){case 0:n=r,i=c,o=l;break;case 1:n=u,i=r,o=l;break;case 2:n=l,i=r,o=c;break;case 3:n=l,i=u,o=r;break;case 4:n=c,i=l,o=r;break;case 5:n=r,i=l,o=u}return{r:Math.floor(255*n),g:Math.floor(255*i),b:Math.floor(255*o)}}function Ho(t,e,r){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0,this.z=void 0!==r?r:0}Ho.subtract=function(t,e){var r=new Ho;return r.x=t.x-e.x,r.y=t.y-e.y,r.z=t.z-e.z,r},Ho.add=function(t,e){var r=new Ho;return r.x=t.x+e.x,r.y=t.y+e.y,r.z=t.z+e.z,r},Ho.avg=function(t,e){return new Ho((t.x+e.x)/2,(t.y+e.y)/2,(t.z+e.z)/2)},Ho.scalarProduct=function(t,e){return new Ho(t.x*e,t.y*e,t.z*e)},Ho.dotProduct=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},Ho.crossProduct=function(t,e){var r=new Ho;return r.x=t.y*e.z-t.z*e.y,r.y=t.z*e.x-t.x*e.z,r.z=t.x*e.y-t.y*e.x,r},Ho.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},Ho.prototype.normalize=function(){return Ho.scalarProduct(this,1/this.length())};var $o=Ho;var Jo=function(t,e){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0};function Ko(t,e){if(void 0===t)throw new Error("No container element defined");if(this.container=t,this.visible=!e||null==e.visible||e.visible,this.visible){this.frame=document.createElement("DIV"),this.frame.style.width="100%",this.frame.style.position="relative",this.container.appendChild(this.frame),this.frame.prev=document.createElement("INPUT"),this.frame.prev.type="BUTTON",this.frame.prev.value="Prev",this.frame.appendChild(this.frame.prev),this.frame.play=document.createElement("INPUT"),this.frame.play.type="BUTTON",this.frame.play.value="Play",this.frame.appendChild(this.frame.play),this.frame.next=document.createElement("INPUT"),this.frame.next.type="BUTTON",this.frame.next.value="Next",this.frame.appendChild(this.frame.next),this.frame.bar=document.createElement("INPUT"),this.frame.bar.type="BUTTON",this.frame.bar.style.position="absolute",this.frame.bar.style.border="1px solid red",this.frame.bar.style.width="100px",this.frame.bar.style.height="6px",this.frame.bar.style.borderRadius="2px",this.frame.bar.style.MozBorderRadius="2px",this.frame.bar.style.border="1px solid #7F7F7F",this.frame.bar.style.backgroundColor="#E5E5E5",this.frame.appendChild(this.frame.bar),this.frame.slide=document.createElement("INPUT"),this.frame.slide.type="BUTTON",this.frame.slide.style.margin="0px",this.frame.slide.value=" ",this.frame.slide.style.position="relative",this.frame.slide.style.left="-100px",this.frame.appendChild(this.frame.slide);var r=this;this.frame.slide.onmousedown=function(t){r._onMouseDown(t)},this.frame.prev.onclick=function(t){r.prev(t)},this.frame.play.onclick=function(t){r.togglePlay(t)},this.frame.next.onclick=function(t){r.next(t)}}this.onChangeCallback=void 0,this.values=[],this.index=void 0,this.playTimeout=void 0,this.playInterval=1e3,this.playLoop=!0}function Qo(t,e,r,n){this._start=0,this._end=0,this._step=1,this.prettyStep=!0,this.precision=5,this._current=0,this.setRange(t,e,r,n)}Ko.prototype.prev=function(){var t=this.getIndex();t>0&&(t--,this.setIndex(t))},Ko.prototype.next=function(){var t=this.getIndex();t<Ln(this).length-1&&(t++,this.setIndex(t))},Ko.prototype.playNext=function(){var t=new Date,e=this.getIndex();e<Ln(this).length-1?(e++,this.setIndex(e)):this.playLoop&&(e=0,this.setIndex(e));var r=new Date-t,n=Math.max(this.playInterval-r,0),i=this;this.playTimeout=bt((function(){i.playNext()}),n)},Ko.prototype.togglePlay=function(){void 0===this.playTimeout?this.play():this.stop()},Ko.prototype.play=function(){this.playTimeout||(this.playNext(),this.frame&&(this.frame.play.value="Stop"))},Ko.prototype.stop=function(){clearInterval(this.playTimeout),this.playTimeout=void 0,this.frame&&(this.frame.play.value="Play")},Ko.prototype.setOnChangeCallback=function(t){this.onChangeCallback=t},Ko.prototype.setPlayInterval=function(t){this.playInterval=t},Ko.prototype.getPlayInterval=function(){return this.playInterval},Ko.prototype.setPlayLoop=function(t){this.playLoop=t},Ko.prototype.onChange=function(){void 0!==this.onChangeCallback&&this.onChangeCallback()},Ko.prototype.redraw=function(){if(this.frame){this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px",this.frame.bar.style.width=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30+"px";var t=this.indexToLeft(this.index);this.frame.slide.style.left=t+"px"}},Ko.prototype.setValues=function(t){this.values=t,Ln(this).length>0?this.setIndex(0):this.index=void 0},Ko.prototype.setIndex=function(t){if(!(t<Ln(this).length))throw new Error("Index out of range");this.index=t,this.redraw(),this.onChange()},Ko.prototype.getIndex=function(){return this.index},Ko.prototype.get=function(){return Ln(this)[this.index]},Ko.prototype._onMouseDown=function(t){if(t.which?1===t.which:1===t.button){this.startClientX=t.clientX,this.startSlideX=Fn(this.frame.slide.style.left),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},Uo(document,"mousemove",this.onmousemove),Uo(document,"mouseup",this.onmouseup),Zo(t)}},Ko.prototype.leftToIndex=function(t){var e=Fn(this.frame.bar.style.width)-this.frame.slide.clientWidth-10,r=t-3,n=Math.round(r/e*(Ln(this).length-1));return n<0&&(n=0),n>Ln(this).length-1&&(n=Ln(this).length-1),n},Ko.prototype.indexToLeft=function(t){var e=Fn(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return t/(Ln(this).length-1)*e+3},Ko.prototype._onMouseMove=function(t){var e=t.clientX-this.startClientX,r=this.startSlideX+e,n=this.leftToIndex(r);this.setIndex(n),Zo()},Ko.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",Xo(document,"mousemove",this.onmousemove),Xo(document,"mouseup",this.onmouseup),Zo()},Qo.prototype.isNumeric=function(t){return!isNaN(Fn(t))&&isFinite(t)},Qo.prototype.setRange=function(t,e,r,n){if(!this.isNumeric(t))throw new Error("Parameter 'start' is not numeric; value: "+t);if(!this.isNumeric(e))throw new Error("Parameter 'end' is not numeric; value: "+t);if(!this.isNumeric(r))throw new Error("Parameter 'step' is not numeric; value: "+t);this._start=t||0,this._end=e||0,this.setStep(r,n)},Qo.prototype.setStep=function(t,e){void 0===t||t<=0||(void 0!==e&&(this.prettyStep=e),!0===this.prettyStep?this._step=Qo.calculatePrettyStep(t):this._step=t)},Qo.calculatePrettyStep=function(t){var e=function(t){return Math.log(t)/Math.LN10},r=Math.pow(10,Math.round(e(t))),n=2*Math.pow(10,Math.round(e(t/2))),i=5*Math.pow(10,Math.round(e(t/5))),o=r;return Math.abs(n-t)<=Math.abs(o-t)&&(o=n),Math.abs(i-t)<=Math.abs(o-t)&&(o=i),o<=0&&(o=1),o},Qo.prototype.getCurrent=function(){return Fn(this._current.toPrecision(this.precision))},Qo.prototype.getStep=function(){return this._step},Qo.prototype.start=function(t){void 0===t&&(t=!1),this._current=this._start-this._start%this._step,t&&this.getCurrent()<this._start&&this.next()},Qo.prototype.next=function(){this._current+=this._step},Qo.prototype.end=function(){return this._current>this._end};var ta=Qo,ea=[].reverse,ra=[1,2];Y({target:"Array",proto:!0,forced:String(ra)===String(ra.reverse())},{reverse:function(){return wt(this)&&(this.length=this.length),ea.call(this)}});var na=qt("Array").reverse,ia=Array.prototype,oa=function(t){var e=t.reverse;return t===ia||t instanceof Array&&e===ia.reverse?na:e},aa=Math.sign||function(t){return 0==(t=+t)||t!=t?t:t<0?-1:1};Y({target:"Math",stat:!0},{sign:aa});var sa=R.Math.sign;function la(){this.armLocation=new $o,this.armRotation={},this.armRotation.horizontal=0,this.armRotation.vertical=0,this.armLength=1.7,this.cameraOffset=new $o,this.offsetMultiplier=.6,this.cameraLocation=new $o,this.cameraRotation=new $o(.5*Math.PI,0,0),this.calculateCameraOrientation()}la.prototype.setOffset=function(t,e){var r=Math.abs,n=sa,i=this.offsetMultiplier,o=this.armLength*i;r(t)>o&&(t=n(t)*o),r(e)>o&&(e=n(e)*o),this.cameraOffset.x=t,this.cameraOffset.y=e,this.calculateCameraOrientation()},la.prototype.getOffset=function(){return this.cameraOffset},la.prototype.setArmLocation=function(t,e,r){this.armLocation.x=t,this.armLocation.y=e,this.armLocation.z=r,this.calculateCameraOrientation()},la.prototype.setArmRotation=function(t,e){void 0!==t&&(this.armRotation.horizontal=t),void 0!==e&&(this.armRotation.vertical=e,this.armRotation.vertical<0&&(this.armRotation.vertical=0),this.armRotation.vertical>.5*Math.PI&&(this.armRotation.vertical=.5*Math.PI)),void 0===t&&void 0===e||this.calculateCameraOrientation()},la.prototype.getArmRotation=function(){var t={};return t.horizontal=this.armRotation.horizontal,t.vertical=this.armRotation.vertical,t},la.prototype.setArmLength=function(t){void 0!==t&&(this.armLength=t,this.armLength<.71&&(this.armLength=.71),this.armLength>5&&(this.armLength=5),this.setOffset(this.cameraOffset.x,this.cameraOffset.y),this.calculateCameraOrientation())},la.prototype.getArmLength=function(){return this.armLength},la.prototype.getCameraLocation=function(){return this.cameraLocation},la.prototype.getCameraRotation=function(){return this.cameraRotation},la.prototype.calculateCameraOrientation=function(){this.cameraLocation.x=this.armLocation.x-this.armLength*Math.sin(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.y=this.armLocation.y-this.armLength*Math.cos(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.z=this.armLocation.z+this.armLength*Math.sin(this.armRotation.vertical),this.cameraRotation.x=Math.PI/2-this.armRotation.vertical,this.cameraRotation.y=0,this.cameraRotation.z=-this.armRotation.horizontal;var t=this.cameraRotation.x,e=this.cameraRotation.z,r=this.cameraOffset.x,n=this.cameraOffset.y,i=Math.sin,o=Math.cos;this.cameraLocation.x=this.cameraLocation.x+r*o(e)+n*-i(e)*o(t),this.cameraLocation.y=this.cameraLocation.y+r*i(e)+n*o(e)*o(t),this.cameraLocation.z=this.cameraLocation.z+n*i(t)};var ua={BAR:0,BARCOLOR:1,BARSIZE:2,DOT:3,DOTLINE:4,DOTCOLOR:5,DOTSIZE:6,GRID:7,LINE:8,SURFACE:9},ca={dot:ua.DOT,"dot-line":ua.DOTLINE,"dot-color":ua.DOTCOLOR,"dot-size":ua.DOTSIZE,line:ua.LINE,grid:ua.GRID,surface:ua.SURFACE,bar:ua.BAR,"bar-color":ua.BARCOLOR,"bar-size":ua.BARSIZE},ha=["width","height","filterLabel","legendLabel","xLabel","yLabel","zLabel","xValueLabel","yValueLabel","zValueLabel","showXAxis","showYAxis","showZAxis","showGrayBottom","showGrid","showPerspective","showShadow","showSurfaceGrid","keepAspectRatio","rotateAxisLabels","verticalRatio","dotSizeRatio","dotSizeMinFraction","dotSizeMaxFraction","showAnimationControls","animationInterval","animationPreload","animationAutoStart","axisColor","axisFontSize","axisFontType","gridColor","xCenter","yCenter","zoomable","tooltipDelay","ctrlToZoom"],fa=["xBarWidth","yBarWidth","valueMin","valueMax","xMin","xMax","xStep","yMin","yMax","yStep","zMin","zMax","zStep"],da=void 0;function pa(t){for(var e in t)if(t.hasOwnProperty(e))return!1;return!0}function va(t,e){return void 0===t||""===t?e:t+(void 0===(r=e)||""===r||"string"!=typeof r?r:r.charAt(0).toUpperCase()+Ao(r).call(r,1));var r}function ya(t,e,r,n){for(var i,o=0;o<r.length;++o)e[va(n,i=r[o])]=t[i]}function ma(t,e,r,n){for(var i,o=0;o<r.length;++o)void 0!==t[i=r[o]]&&(e[va(n,i)]=t[i])}function ga(t,e){if(void 0!==t.backgroundColor&&function(t,e){var r="white",n="gray",i=1;if("string"==typeof t)r=t,n="none",i=0;else{if("object"!==ln(t))throw new Error("Unsupported type of backgroundColor");void 0!==On(t)&&(r=On(t)),void 0!==t.stroke&&(n=t.stroke),void 0!==t.strokeWidth&&(i=t.strokeWidth)}e.frame.style.backgroundColor=r,e.frame.style.borderColor=n,e.frame.style.borderWidth=i+"px",e.frame.style.borderStyle="solid"}(t.backgroundColor,e),function(t,e){if(void 0===t)return;void 0===e.dataColor&&(e.dataColor={});"string"==typeof t?(e.dataColor.fill=t,e.dataColor.stroke=t):(On(t)&&(e.dataColor.fill=On(t)),t.stroke&&(e.dataColor.stroke=t.stroke),void 0!==t.strokeWidth&&(e.dataColor.strokeWidth=t.strokeWidth))}(t.dataColor,e),function(t,e){if(void 0===t)return;var r;if("string"==typeof t){if(-1===(r=function(t){var e=ca[t];if(void 0===e)return-1;return e}(t)))throw new Error("Style '"+t+"' is invalid")}else{if(!function(t){var e=!1;for(var r in ua)if(ua[r]===t){e=!0;break}return e}(t))throw new Error("Style '"+t+"' is invalid");r=t}e.style=r}(t.style,e),void 0!==t.surfaceColors){if(console.warn("`options.surfaceColors` is deprecated and may be removed in a future version. Please use `options.colormap` instead. Note that the `colormap` option uses the inverse array ordering (running from vMin to vMax)."),void 0!==t.colormap)throw new Error("The `colormap` and `surfaceColors` options are mutually exclusive.");"surface"!==e.style?console.warn("Ignoring `surfaceColors` in graph style `"+e.style+"` for backward compatibility (only effective in `surface` plots)."):function(t,e){if(void 0===t||!0===t)return;if(!1===t)return void(e.surfaceColors=void 0);void 0===e.surfaceColors&&(e.surfaceColors={});var r;if(te(t))r=ba(t);else{if("object"!==ln(t))throw new Error("Unsupported type of surfaceColors");r=wa(t.hue)}oa(r).call(r),e.colormap=r}(t.surfaceColors,e)}else!function(t,e){if(void 0===t)return;var r;if(te(t))r=ba(t);else if("object"===ln(t))r=wa(t.hue);else{if("function"!=typeof t)throw new Error("Unsupported type of colormap");r=t}e.colormap=r}(t.colormap,e);!function(t,e){if(void 0===t){if(void 0===da.showLegend){var r=e.style===ua.DOTCOLOR||e.style===ua.DOTSIZE;e.showLegend=r}}else e.showLegend=t}(t.showLegend,e),xa(t.cameraPosition,e),void 0!==t.tooltip&&(e.showTooltip=t.tooltip),null!=t.onclick&&(e.onclick_callback=t.onclick,console.warn("`options.onclick` is deprecated and may be removed in a future version. Please use `Graph3d.on('click', handler)` instead.")),void 0!==t.tooltipStyle&&function(t,e,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(te(r))throw new TypeError("Arrays are not supported by deepExtend");for(var i=0;i<t.length;i++){var o=t[i];if(Object.prototype.hasOwnProperty.call(r,o))if(r[o]&&r[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?Wo(e[o],r[o],!1,n):Go(e,r,o,n);else{if(te(r[o]))throw new TypeError("Arrays are not supported by deepExtend");Go(e,r,o,n)}}}(["tooltipStyle"],e,t)}function ba(t){if(t.length<2)throw new Error("Colormap array length must be 2 or above.");return ko(t).call(t,(function(t){if(!function(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}(t))throw new Error("Invalid hex color code supplied to colormap.");return function(t){var e;switch(t.length){case 3:case 4:return(e=No.exec(t))?{r:Vi(e[1]+e[1],16),g:Vi(e[2]+e[2],16),b:Vi(e[3]+e[3],16)}:null;case 6:case 7:return(e=Bo.exec(t))?{r:Vi(e[1],16),g:Vi(e[2],16),b:Vi(e[3],16)}:null;default:return null}}(t)}))}function wa(t){if(void 0===t)throw new Error("Unsupported type of colormap");if(!(t.saturation>=0&&t.saturation<=100))throw new Error("Saturation is out of bounds. Expected range is 0-100.");if(!(t.brightness>=0&&t.brightness<=100))throw new Error("Brightness is out of bounds. Expected range is 0-100.");if(!(t.colorStops>=2))throw new Error("colorStops is out of bounds. Expected 2 or above.");for(var e=(t.end-t.start)/(t.colorStops-1),r=[],n=0;n<t.colorStops;++n){var i=(t.start+e*n)%360/360;r.push(qo(i<0?i+1:i,t.saturation/100,t.brightness/100))}return r}function xa(t,e){var r=t;void 0!==r&&(void 0===e.camera&&(e.camera=new la),e.camera.setArmRotation(r.horizontal,r.vertical),e.camera.setArmLength(r.distance))}var _a=ft("JSON","stringify"),Sa=/[\uD800-\uDFFF]/g,ka=/^[\uD800-\uDBFF]$/,La=/^[\uDC00-\uDFFF]$/,Aa=function(t,e,r){var n=r.charAt(e-1),i=r.charAt(e+1);return ka.test(t)&&!La.test(i)||La.test(t)&&!ka.test(n)?"\\u"+t.charCodeAt(0).toString(16):t},Ca=o((function(){return'"\\udf06\\ud834"'!==_a("\udf06\ud834")||'"\\udead"'!==_a("\udead")}));_a&&Y({target:"JSON",stat:!0,forced:Ca},{stringify:function(t,e,r){var n=_a.apply(null,arguments);return"string"==typeof n?n.replace(Sa,Aa):n}}),R.JSON||(R.JSON={stringify:JSON.stringify});var Oa=function(t,e,r){return R.JSON.stringify.apply(null,arguments)};var Ea=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};function Ta(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),zi(t,n.key,n)}}var Pa,Ma=function(t,e,r){return e&&Ta(t.prototype,e),r&&Ta(t,r),t},Da=!1,Ra="background: #FFeeee; color: #dd0000",Ia=function(){function t(){Ea(this,t)}return Ma(t,null,[{key:"validate",value:function(e,r,n){Da=!1,Pa=r;var i=r;return void 0!==n&&(i=r[n]),t.parse(e,i,[]),Da}},{key:"parse",value:function(e,r,n){for(var i in e)e.hasOwnProperty(i)&&t.check(i,e,r,n)}},{key:"check",value:function(e,r,n,i){if(void 0!==n[e]||void 0!==n.__any__){var o=e,a=!0;void 0===n[e]&&void 0!==n.__any__&&(o="__any__",a="object"===t.getType(r[e]));var s=n[o];a&&void 0!==s.__type__&&(s=s.__type__),t.checkFields(e,r,n,o,s,i)}else t.getSuggestion(e,n,i)}},{key:"checkFields",value:function(e,r,n,i,o,a){var s=function(r){console.log("%c"+r+t.printLocation(a,e),Ra)},l=t.getType(r[e]),u=o[l];void 0!==u?"array"===t.getType(u)&&-1===Kn(u).call(u,r[e])?(s('Invalid option detected in "'+e+'". Allowed values are:'+t.print(u)+' not "'+r[e]+'". '),Da=!0):"object"===l&&"__any__"!==i&&(a=Yo(a,e),t.parse(r[e],n[i],a)):void 0===o.any&&(s('Invalid type received for "'+e+'". Expected: '+t.print(go(o))+". Received ["+l+'] "'+r[e]+'"'),Da=!0)}},{key:"getType",value:function(t){var e=ln(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":te(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,r,n){var i,o=t.findInOptions(e,r,n,!1),a=t.findInOptions(e,Pa,[],!0);i=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':a.distance<=4&&o.distance>a.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(a.path,a.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(go(r))+t.printLocation(n,e),console.log('%cUnknown option detected: "'+e+'"'+i,Ra),Da=!0}},{key:"findInOptions",value:function(e,r,n){var i=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,a="",s=[],l=e.toLowerCase(),u=void 0;for(var c in r){var h=void 0;if(void 0!==r[c].__type__&&!0===i){var f=t.findInOptions(e,r[c],Yo(n,c));o>f.distance&&(a=f.closestMatch,s=f.path,o=f.distance,u=f.indexMatch)}else{var d;-1!==Kn(d=c.toLowerCase()).call(d,l)&&(u=c),o>(h=t.levenshteinDistance(e,c))&&(a=c,s=Vo(n),o=h)}}return{closestMatch:a,path:s,distance:o,indexMatch:u}}},{key:"printLocation",value:function(t,e){for(var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",n="\n\n"+r+"options = {\n",i=0;i<t.length;i++){for(var o=0;o<i+1;o++)n+="  ";n+=t[i]+": {\n"}for(var a=0;a<t.length+1;a++)n+="  ";n+=e+"\n";for(var s=0;s<t.length+1;s++){for(var l=0;l<t.length-s;l++)n+="  ";n+="}\n"}return n+"\n\n"}},{key:"print",value:function(t){return Oa(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var r,n,i=[];for(r=0;r<=e.length;r++)i[r]=[r];for(n=0;n<=t.length;n++)i[0][n]=n;for(r=1;r<=e.length;r++)for(n=1;n<=t.length;n++)e.charAt(r-1)==t.charAt(n-1)?i[r][n]=i[r-1][n-1]:i[r][n]=Math.min(i[r-1][n-1]+1,Math.min(i[r][n-1]+1,i[r-1][n]+1));return i[e.length][t.length]}}]),t}(),za="string",ja="boolean",Fa="number",Ba="object",Na="array",Ga={fill:{string:za},stroke:{string:za},strokeWidth:{number:Fa},__type__:{string:za,object:Ba,undefined:"undefined"}},Wa={animationAutoStart:{boolean:ja,undefined:"undefined"},animationInterval:{number:Fa},animationPreload:{boolean:ja},axisColor:{string:za},axisFontSize:{number:Fa},axisFontType:{string:za},backgroundColor:Ga,xBarWidth:{number:Fa,undefined:"undefined"},yBarWidth:{number:Fa,undefined:"undefined"},cameraPosition:{distance:{number:Fa},horizontal:{number:Fa},vertical:{number:Fa},__type__:{object:Ba}},zoomable:{boolean:ja},ctrlToZoom:{boolean:ja},xCenter:{string:za},yCenter:{string:za},colormap:{hue:{start:{number:Fa},end:{number:Fa},saturation:{number:Fa},brightness:{number:Fa},colorStops:{number:Fa},__type__:{object:Ba}},__type__:{array:Na,object:Ba,function:"function",undefined:"undefined"}},dataColor:Ga,dotSizeMinFraction:{number:Fa},dotSizeMaxFraction:{number:Fa},dotSizeRatio:{number:Fa},filterLabel:{string:za},gridColor:{string:za},onclick:{function:"function"},keepAspectRatio:{boolean:ja},xLabel:{string:za},yLabel:{string:za},zLabel:{string:za},legendLabel:{string:za},xMin:{number:Fa,undefined:"undefined"},yMin:{number:Fa,undefined:"undefined"},zMin:{number:Fa,undefined:"undefined"},xMax:{number:Fa,undefined:"undefined"},yMax:{number:Fa,undefined:"undefined"},zMax:{number:Fa,undefined:"undefined"},showAnimationControls:{boolean:ja,undefined:"undefined"},showGrayBottom:{boolean:ja},showGrid:{boolean:ja},showLegend:{boolean:ja,undefined:"undefined"},showPerspective:{boolean:ja},showShadow:{boolean:ja},showSurfaceGrid:{boolean:ja},showXAxis:{boolean:ja},showYAxis:{boolean:ja},showZAxis:{boolean:ja},rotateAxisLabels:{boolean:ja},surfaceColors:{hue:{start:{number:Fa},end:{number:Fa},saturation:{number:Fa},brightness:{number:Fa},colorStops:{number:Fa},__type__:{object:Ba}},__type__:{boolean:ja,array:Na,object:Ba,undefined:"undefined"}},xStep:{number:Fa,undefined:"undefined"},yStep:{number:Fa,undefined:"undefined"},zStep:{number:Fa,undefined:"undefined"},style:{number:Fa,string:["bar","bar-color","bar-size","dot","dot-line","dot-color","dot-size","line","grid","surface"]},tooltip:{boolean:ja,function:"function"},tooltipDelay:{number:Fa},tooltipStyle:{content:{color:{string:za},background:{string:za},border:{string:za},borderRadius:{string:za},boxShadow:{string:za},padding:{string:za},__type__:{object:Ba}},line:{borderLeft:{string:za},height:{string:za},width:{string:za},pointerEvents:{string:za},__type__:{object:Ba}},dot:{border:{string:za},borderRadius:{string:za},height:{string:za},width:{string:za},pointerEvents:{string:za},__type__:{object:Ba}},__type__:{object:Ba}},xValueLabel:{function:"function"},yValueLabel:{function:"function"},zValueLabel:{function:"function"},valueMax:{number:Fa,undefined:"undefined"},valueMin:{number:Fa,undefined:"undefined"},verticalRatio:{number:Fa},height:{string:za},width:{string:za},__type__:{object:Ba}};var Ya=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t},Va=[].slice,Ua={},Xa=function(t,e,r){if(!(e in Ua)){for(var n=[],i=0;i<e;i++)n[i]="a["+i+"]";Ua[e]=Function("C,a","return new C("+n.join(",")+")")}return Ua[e](t,r)},Za=Function.bind||function(t){var e=I(this),r=Va.call(arguments,1),n=function(){var i=r.concat(Va.call(arguments));return this instanceof n?Xa(e,i.length,i):e.apply(t,i)};return m(e.prototype)&&(n.prototype=e.prototype),n},qa=ft("Reflect","construct"),Ha=o((function(){function t(){}return!(qa((function(){}),[],t)instanceof t)})),$a=!o((function(){qa((function(){}))})),Ja=Ha||$a;Y({target:"Reflect",stat:!0,forced:Ja,sham:Ja},{construct:function(t,e){I(t),j(e);var r=arguments.length<3?t:I(arguments[2]);if($a&&!Ha)return qa(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return n.push.apply(n,e),new(Za.apply(t,n))}var i=r.prototype,o=Fe(m(i)?i:Object.prototype),a=Function.apply.call(t,o,e);return m(a)?a:o}});var Ka=R.Reflect.construct,Qa=qt("Array").entries,ts=Array.prototype,es={DOMTokenList:!0,NodeList:!0},rs=function(t){var e=t.entries;return t===ts||t instanceof Array&&e===ts.entries||es.hasOwnProperty(Ye(t))?Qa:e},ns=qt("Array").keys,is=Array.prototype,os={DOMTokenList:!0,NodeList:!0},as=function(t){var e=t.keys;return t===is||t instanceof Array&&e===is.keys||os.hasOwnProperty(Ye(t))?ns:e},ss=Or.some,ls=un("some"),us=dn("some");Y({target:"Array",proto:!0,forced:!ls||!us},{some:function(t){return ss(this,t,arguments.length>1?arguments[1]:void 0)}});var cs=qt("Array").some,hs=Array.prototype,fs=function(t){var e=t.some;return t===hs||t instanceof Array&&e===hs.some?cs:e},ds=Ri;Y({target:"Object",stat:!0},{setPrototypeOf:Je});var ps=R.Object.setPrototypeOf,vs=r((function(t){function e(r,n){return t.exports=e=ps||function(t,e){return t.__proto__=e,t},e(r,n)}t.exports=e}));var ys=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=ds(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&vs(t,e)};var ms=function(t,e){return!e||"object"!==ln(e)&&"function"!=typeof e?Ya(t):e},gs=Hi,bs=r((function(t){function e(r){return t.exports=e=ps?gs:function(t){return t.__proto__||gs(t)},e(r)}t.exports=e})),ws=!o((function(){return Object.isExtensible(Object.preventExtensions({}))})),xs=r((function(t){var e=B.f,r=Ct("meta"),n=0,i=Object.isExtensible||function(){return!0},o=function(t){e(t,r,{value:{objectID:"O"+ ++n,weakData:{}}})},a=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!m(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!w(t,r)){if(!i(t))return"F";if(!e)return"E";o(t)}return t[r].objectID},getWeakData:function(t,e){if(!w(t,r)){if(!i(t))return!0;if(!e)return!1;o(t)}return t[r].weakData},onFreeze:function(t){return ws&&a.REQUIRED&&i(t)&&!w(t,r)&&o(t),t}};tt[r]=!0})),_s=function(t,e){this.stopped=t,this.result=e},Ss=function(t,e,r){var n,i,o,a,s,l,u,c=r&&r.that,h=!(!r||!r.AS_ENTRIES),f=!(!r||!r.IS_ITERATOR),d=!(!r||!r.INTERRUPTED),p=z(e,c,1+h+d),v=function(t){return n&&xi(n),new _s(!0,t)},y=function(t){return h?(j(t),d?p(t[0],t[1],v):p(t[0],t[1])):d?p(t,v):p(t)};if(f)n=t;else{if("function"!=typeof(i=gi(t)))throw TypeError("Target is not iterable");if(Li(i)){for(o=0,a=q(t.length);a>o;o++)if((s=y(t[o]))&&s instanceof _s)return s;return new _s(!1)}n=i.call(t)}for(l=n.next;!(u=l.call(n)).done;){try{s=y(u.value)}catch(t){throw xi(n),t}if("object"==typeof s&&s&&s instanceof _s)return s}return new _s(!1)},ks=function(t,e,r){if(!(t instanceof e))throw TypeError("Incorrect "+(r?r+" ":"")+"invocation");return t},Ls=B.f,As=Or.forEach,Cs=ke.set,Os=ke.getterFor,Es=function(t,e,r){var n,s=-1!==t.indexOf("Map"),l=-1!==t.indexOf("Weak"),u=s?"set":"add",c=i[t],h=c&&c.prototype,f={};if(a&&"function"==typeof c&&(l||h.forEach&&!o((function(){(new c).entries().next()})))){n=e((function(e,r){Cs(ks(e,n,t),{type:t,collection:new c}),null!=r&&Ss(r,e[u],{that:e,AS_ENTRIES:s})}));var d=Os(t);As(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in h)||l&&"clear"==t||N(n.prototype,t,(function(r,n){var i=d(this).collection;if(!e&&l&&!m(r))return"get"==t&&void 0;var o=i[t](0===r?0:r,n);return e?this:o}))})),l||Ls(n.prototype,"size",{configurable:!0,get:function(){return d(this).collection.size}})}else n=r.getConstructor(e,t,s,u),xs.REQUIRED=!0;return Ze(n,t,!1,!0),f[t]=n,Y({global:!0,forced:!0},f),l||r.setStrong(n,t,s),n},Ts=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:Ke(t,n,e[n],r);return t},Ps=Dt("species"),Ms=B.f,Ds=xs.fastKey,Rs=ke.set,Is=ke.getterFor,zs={getConstructor:function(t,e,r,n){var i=t((function(t,o){ks(t,i,e),Rs(t,{type:e,index:Fe(null),first:void 0,last:void 0,size:0}),a||(t.size=0),null!=o&&Ss(o,t[n],{that:t,AS_ENTRIES:r})})),o=Is(e),s=function(t,e,r){var n,i,s=o(t),u=l(t,e);return u?u.value=r:(s.last=u={index:i=Ds(e,!0),key:e,value:r,previous:n=s.last,next:void 0,removed:!1},s.first||(s.first=u),n&&(n.next=u),a?s.size++:t.size++,"F"!==i&&(s.index[i]=u)),t},l=function(t,e){var r,n=o(t),i=Ds(e);if("F"!==i)return n.index[i];for(r=n.first;r;r=r.next)if(r.key==e)return r};return Ts(i.prototype,{clear:function(){for(var t=o(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,a?t.size=0:this.size=0},delete:function(t){var e=this,r=o(e),n=l(e,t);if(n){var i=n.next,s=n.previous;delete r.index[n.index],n.removed=!0,s&&(s.next=i),i&&(i.previous=s),r.first==n&&(r.first=i),r.last==n&&(r.last=s),a?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=o(this),n=z(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!l(this,t)}}),Ts(i.prototype,r?{get:function(t){var e=l(this,t);return e&&e.value},set:function(t,e){return s(this,0===t?0:t,e)}}:{add:function(t){return s(this,t=0===t?0:t,t)}}),a&&Ms(i.prototype,"size",{get:function(){return o(this).size}}),i},setStrong:function(t,e,r){var n=e+" Iterator",i=Is(e),o=Is(n);ar(t,e,(function(t,e){Rs(this,{type:n,target:t,state:i(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?"keys"==e?{value:r.key,done:!1}:"values"==e?{value:r.value,done:!1}:{value:[r.key,r.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),r?"entries":"values",!r,!0),function(t){var e=ft(t),r=B.f;a&&e&&!e[Ps]&&r(e,Ps,{configurable:!0,get:function(){return this}})}(e)}},js=(Es("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),zs),R.Set),Fs=(Es("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),zs),R.Map),Bs=r((function(t){var e=function(t){var e,r=Object.prototype,n=r.hasOwnProperty,i="function"==typeof Symbol?Symbol:{},o=i.iterator||"@@iterator",a=i.asyncIterator||"@@asyncIterator",s=i.toStringTag||"@@toStringTag";function l(t,e,r){return Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{l({},"")}catch(t){l=function(t,e,r){return t[e]=r}}function u(t,e,r,n){var i=e&&e.prototype instanceof y?e:y,o=Object.create(i.prototype),a=new O(n||[]);return o._invoke=function(t,e,r){var n=h;return function(i,o){if(n===d)throw new Error("Generator is already running");if(n===p){if("throw"===i)throw o;return T()}for(r.method=i,r.arg=o;;){var a=r.delegate;if(a){var s=L(a,r);if(s){if(s===v)continue;return s}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if(n===h)throw n=p,r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n=d;var l=c(t,e,r);if("normal"===l.type){if(n=r.done?p:f,l.arg===v)continue;return{value:l.arg,done:r.done}}"throw"===l.type&&(n=p,r.method="throw",r.arg=l.arg)}}}(t,r,a),o}function c(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}t.wrap=u;var h="suspendedStart",f="suspendedYield",d="executing",p="completed",v={};function y(){}function m(){}function g(){}var b={};b[o]=function(){return this};var w=Object.getPrototypeOf,x=w&&w(w(E([])));x&&x!==r&&n.call(x,o)&&(b=x);var _=g.prototype=y.prototype=Object.create(b);function S(t){["next","throw","return"].forEach((function(e){l(t,e,(function(t){return this._invoke(e,t)}))}))}function k(t,e){var r;this._invoke=function(i,o){function a(){return new e((function(r,a){!function r(i,o,a,s){var l=c(t[i],t,o);if("throw"!==l.type){var u=l.arg,h=u.value;return h&&"object"==typeof h&&n.call(h,"__await")?e.resolve(h.__await).then((function(t){r("next",t,a,s)}),(function(t){r("throw",t,a,s)})):e.resolve(h).then((function(t){u.value=t,a(u)}),(function(t){return r("throw",t,a,s)}))}s(l.arg)}(i,o,r,a)}))}return r=r?r.then(a,a):a()}}function L(t,r){var n=t.iterator[r.method];if(n===e){if(r.delegate=null,"throw"===r.method){if(t.iterator.return&&(r.method="return",r.arg=e,L(t,r),"throw"===r.method))return v;r.method="throw",r.arg=new TypeError("The iterator does not provide a 'throw' method")}return v}var i=c(n,t.iterator,r.arg);if("throw"===i.type)return r.method="throw",r.arg=i.arg,r.delegate=null,v;var o=i.arg;return o?o.done?(r[t.resultName]=o.value,r.next=t.nextLoc,"return"!==r.method&&(r.method="next",r.arg=e),r.delegate=null,v):o:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,v)}function A(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function C(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function O(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(A,this),this.reset(!0)}function E(t){if(t){var r=t[o];if(r)return r.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var i=-1,a=function r(){for(;++i<t.length;)if(n.call(t,i))return r.value=t[i],r.done=!1,r;return r.value=e,r.done=!0,r};return a.next=a}}return{next:T}}function T(){return{value:e,done:!0}}return m.prototype=_.constructor=g,g.constructor=m,m.displayName=l(g,s,"GeneratorFunction"),t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===m||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,g):(t.__proto__=g,l(t,s,"GeneratorFunction")),t.prototype=Object.create(_),t},t.awrap=function(t){return{__await:t}},S(k.prototype),k.prototype[a]=function(){return this},t.AsyncIterator=k,t.async=function(e,r,n,i,o){void 0===o&&(o=Promise);var a=new k(u(e,r,n,i),o);return t.isGeneratorFunction(r)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},S(_),l(_,s,"Generator"),_[o]=function(){return this},_.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var r in t)e.push(r);return e.reverse(),function r(){for(;e.length;){var n=e.pop();if(n in t)return r.value=n,r.done=!1,r}return r.done=!0,r}},t.values=E,O.prototype={constructor:O,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=e,this.done=!1,this.delegate=null,this.method="next",this.arg=e,this.tryEntries.forEach(C),!t)for(var r in this)"t"===r.charAt(0)&&n.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=e)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var r=this;function i(n,i){return s.type="throw",s.arg=t,r.next=n,i&&(r.method="next",r.arg=e),!!i}for(var o=this.tryEntries.length-1;o>=0;--o){var a=this.tryEntries[o],s=a.completion;if("root"===a.tryLoc)return i("end");if(a.tryLoc<=this.prev){var l=n.call(a,"catchLoc"),u=n.call(a,"finallyLoc");if(l&&u){if(this.prev<a.catchLoc)return i(a.catchLoc,!0);if(this.prev<a.finallyLoc)return i(a.finallyLoc)}else if(l){if(this.prev<a.catchLoc)return i(a.catchLoc,!0)}else{if(!u)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return i(a.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var i=this.tryEntries[r];if(i.tryLoc<=this.prev&&n.call(i,"finallyLoc")&&this.prev<i.finallyLoc){var o=i;break}}o&&("break"===t||"continue"===t)&&o.tryLoc<=e&&e<=o.finallyLoc&&(o=null);var a=o?o.completion:{};return a.type=t,a.arg=e,o?(this.method="next",this.next=o.finallyLoc,v):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),v},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),C(r),v}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var i=n.arg;C(r)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(t,r,n){return this.delegate={iterator:E(t),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=e),v}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}})),Ns=gr,Gs=Gt("splice"),Ws=dn("splice",{ACCESSORS:!0,0:0,1:2}),Ys=Math.max,Vs=Math.min,Us=9007199254740991,Xs="Maximum allowed length exceeded";Y({target:"Array",proto:!0,forced:!Gs||!Ws},{splice:function(t,e){var r,n,i,o,a,s,l=at(this),u=q(l.length),c=J(t,u),h=arguments.length;if(0===h?r=n=0:1===h?(r=0,n=u-c):(r=h-2,n=Vs(Ys(X(e),0),u-c)),u+r-n>Us)throw TypeError(Xs);for(i=It(l,n),o=0;o<n;o++)(a=c+o)in l&&xt(i,o,l[a]);if(i.length=n,r<n){for(o=c;o<u-n;o++)s=o+r,(a=o+n)in l?l[s]=l[a]:delete l[s];for(o=u;o>u-n+r;o--)delete l[o-1]}else if(r>n)for(o=u-n;o>c;o--)s=o+r-1,(a=o+n-1)in l?l[s]=l[a]:delete l[s];for(o=0;o<r;o++)l[o+c]=arguments[o+2];return l.length=u-n+r,i}});var Zs=qt("Array").splice,qs=Array.prototype,Hs=function(t){var e=t.splice;return t===qs||t instanceof Array&&e===qs.splice?Zs:e},$s=function(t,e,r,n,i,o,a,s){for(var l,u=i,c=0,h=!!a&&z(a,s,3);c<n;){if(c in r){if(l=h?h(r[c],c,e):r[c],o>0&&wt(l))u=$s(t,e,l,q(l.length),u,o-1)-1;else{if(u>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[u]=l}u++}c++}return u},Js=$s;Y({target:"Array",proto:!0},{flatMap:function(t){var e,r=at(this),n=q(r.length);return I(t),(e=It(r,0)).length=Js(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var Ks=qt("Array").flatMap,Qs=Array.prototype,tl=function(t){var e=t.flatMap;return t===Qs||t instanceof Array&&e===Qs.flatMap?Ks:e},el=function(t){return function(e,r,n,i){I(r);var o=at(e),a=p(o),s=q(o.length),l=t?s-1:0,u=t?-1:1;if(n<2)for(;;){if(l in a){i=a[l],l+=u;break}if(l+=u,t?l<0:s<=l)throw TypeError("Reduce of empty array with no initial value")}for(;t?l>=0:s>l;l+=u)l in a&&(i=r(i,a[l],l,o));return i}},rl={left:el(!1),right:el(!0)},nl="process"==f(i.process),il=rl.left,ol=un("reduce"),al=dn("reduce",{1:0});Y({target:"Array",proto:!0,forced:!ol||!al||!nl&&Bt>79&&Bt<83},{reduce:function(t){return il(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var sl=qt("Array").reduce,ll=Array.prototype,ul=function(t){var e=t.reduce;return t===ll||t instanceof Array&&e===ll.reduce?sl:e};Y({target:"Function",proto:!0},{bind:Za});var cl,hl=qt("Function").bind,fl=Function.prototype,dl=function(t){var e=t.bind;return t===fl||t instanceof Function&&e===fl.bind?hl:e},pl=new Uint8Array(16);function vl(){if(!cl&&!(cl="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto)))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return cl(pl)}var yl=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;function ml(t){return"string"==typeof t&&yl.test(t)}for(var gl=[],bl=0;bl<256;++bl)gl.push((bl+256).toString(16).substr(1));function wl(t,e,r){var n=(t=t||{}).random||(t.rng||vl)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(var i=0;i<16;++i)e[r+i]=n[i];return e}return function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(gl[t[e+0]]+gl[t[e+1]]+gl[t[e+2]]+gl[t[e+3]]+"-"+gl[t[e+4]]+gl[t[e+5]]+"-"+gl[t[e+6]]+gl[t[e+7]]+"-"+gl[t[e+8]]+gl[t[e+9]]+"-"+gl[t[e+10]]+gl[t[e+11]]+gl[t[e+12]]+gl[t[e+13]]+gl[t[e+14]]+gl[t[e+15]]).toLowerCase();if(!ml(r))throw TypeError("Stringified UUID is invalid");return r}(n)}function xl(t,e){var r=go(t);if(yi){var n=yi(t);e&&(n=Vn(n).call(n,(function(e){return vi(t,e).enumerable}))),r.push.apply(r,n)}return r}function _l(t){for(var e=1;e<arguments.length;e++){var r,n=null!=arguments[e]?arguments[e]:{};if(e%2)xn(r=xl(Object(n),!0)).call(r,(function(e){Fi(t,e,n[e])}));else if(fi)ci(t,fi(n));else{var i;xn(i=xl(Object(n))).call(i,(function(e){ui(t,e,vi(n,e))}))}}return t}function Sl(t){var e=function(){if("undefined"==typeof Reflect||!Ka)return!1;if(Ka.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Ka(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=bs(t);if(e){var i=bs(this).constructor;r=Ka(n,arguments,i)}else r=n.apply(this,arguments);return ms(this,r)}}function kl(t,e){var r;if(void 0===Po||null==wi(t)){if(te(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Ll(t,e);var n=Ao(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Mi(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ll(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){r=bi(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw o}}}}function Ll(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var Al=function(){function t(e,r,n){var i,o,a;Ea(this,t),this._source=e,this._transformers=r,this._target=n,this._listeners={add:dl(i=this._add).call(i,this),remove:dl(o=this._remove).call(o,this),update:dl(a=this._update).call(a,this)}}return Ma(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return ul(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),Cl=function(){function t(e){Ea(this,t),this._source=e,this._transformers=[]}return Ma(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return Vn(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return ko(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return tl(e).call(e,t)})),this}},{key:"to",value:function(t){return new Al(this._source,this._transformers,t)}}]),t}();function Ol(t){return"string"==typeof t||"number"==typeof t}var El=function(){function t(e){Ea(this,t),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(e)}return Ma(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=bt((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;xn(t=Hs(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var i=[{name:"flush",original:void 0}];if(r&&r.replace)for(var o=0;o<r.replace.length;o++){var a=r.replace[o];i.push({name:a,original:e[a]}),n.replace(e,a)}return n._extended={object:e,methods:i},n}}]),t}(),Tl=function(){function t(){Ea(this,t),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return Ma(t,[{key:"_trigger",value:function(t,e,r){var n,i;if("*"===t)throw new Error("Cannot trigger event *");xn(n=Jt(i=[]).call(i,To(this._subscribers[t]),To(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=Vn(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),t}(),Pl=function(){function t(e){Ea(this,t),this._pairs=e}return Ma(t,[{key:Ns,value:Bs.mark((function t(){var e,r,n,i,o;return Bs.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=kl(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=yo(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:Bs.mark((function t(){var e,r,n,i,o;return Bs.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=kl(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=yo(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:Bs.mark((function t(){var e,r,n,i;return Bs.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=kl(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=yo(r.value,1),i=n[0],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:Bs.mark((function t(){var e,r,n,i;return Bs.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=kl(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=yo(r.value,2),i=n[1],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return ko(t=To(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return ko(t=To(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return To(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=Ii(null),r=kl(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=yo(t.value,2),i=n[0],o=n[1];e[i]=o}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new Fs(this._pairs)}},{key:"toIdSet",value:function(){return new js(this.toIdArray())}},{key:"toItemSet",value:function(){return new js(this.toItemArray())}},{key:"cache",value:function(){return new t(To(this._pairs))}},{key:"distinct",value:function(t){var e,r=new js,n=kl(this._pairs);try{for(n.s();!(e=n.n()).done;){var i=yo(e.value,2),o=i[0],a=i[1];r.add(t(a,o))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(e){var r=this._pairs;return new t(Fi({},Ns,Bs.mark((function t(){var n,i,o,a,s;return Bs.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=kl(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=10;break}if(o=yo(i.value,2),a=o[0],s=o[1],!e(s,a)){t.next=8;break}return t.next=8,[a,s];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=kl(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=yo(e.value,2),i=n[0];t(n[1],i)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(e){var r=this._pairs;return new t(Fi({},Ns,Bs.mark((function t(){var n,i,o,a,s;return Bs.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=kl(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=9;break}return o=yo(i.value,2),a=o[0],s=o[1],t.next=7,[a,e(s,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=bi(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=yo(r.value,2),a=o[0],s=o[1],l=t(s,a);l>i&&(i=l,n=s)}return n}},{key:"min",value:function(t){var e=bi(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=yo(r.value,2),a=o[0],s=o[1],l=t(s,a);l<i&&(i=l,n=s)}return n}},{key:"reduce",value:function(t,e){var r,n=kl(this._pairs);try{for(n.s();!(r=n.n()).done;){var i=yo(r.value,2),o=i[0];e=t(e,i[1],o)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var r=this;return new t(Fi({},Ns,(function(){var t;return bi(ai(t=To(r._pairs)).call(t,(function(t,r){var n=yo(t,2),i=n[0],o=n[1],a=yo(r,2),s=a[0],l=a[1];return e(o,l,i,s)})))})))}}]),t}();var Ml=function(t){ys(r,t);var e=Sl(r);function r(t,n){var i;return Ea(this,r),(i=e.call(this))._queue=null,t&&!te(t)&&(n=t,t=[]),i._options=n||{},i._data=new Fs,i.length=0,i._idProp=i._options.fieldId||"id",t&&t.length&&i.add(t),i.setOptions(n),i}return Ma(r,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=El.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===ln(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,i=[];if(te(t)){var o=ko(t).call(t,(function(t){return t[n._idProp]}));if(fs(o).call(o,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,s=t.length;a<s;a++)r=this._addItem(t[a]),i.push(r)}else{if(!t||"object"!==ln(t))throw new Error("Unknown dataType");r=this._addItem(t),i.push(r)}return i.length&&this._trigger("add",{items:i},e),i}},{key:"update",value:function(t,e){var r=this,n=[],i=[],o=[],a=[],s=this._idProp,l=function(t){var e=t[s];if(null!=e&&r._data.has(e)){var l=t,u=ct({},r._data.get(e)),c=r._updateItem(l);i.push(c),a.push(l),o.push(u)}else{var h=r._addItem(t);n.push(h)}};if(te(t))for(var u=0,c=t.length;u<c;u++)t[u]&&"object"===ln(t[u])?l(t[u]):console.warn("Ignoring input item, which is not an object at index "+u);else{if(!t||"object"!==ln(t))throw new Error("Unknown dataType");l(t)}if(n.length&&this._trigger("add",{items:n},e),i.length){var h={items:i,oldData:o,data:a};this._trigger("update",h,e)}return Jt(n).call(n,i)}},{key:"updateOnly",value:function(t,e){var r,n=this;te(t)||(t=[t]);var i=ko(r=ko(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,i=e[n._idProp],o=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),i=1;i<r;i++)n[i-1]=arguments[i];return Io.apply(void 0,Jt(e=[{},t]).call(e,n))}(e,r);return n._data.set(i,o),{id:i,oldData:e,updatedData:o}}));if(i.length){var o={items:ko(i).call(i,(function(t){return t.id})),oldData:ko(i).call(i,(function(t){return t.oldData})),data:ko(i).call(i,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,i=void 0;Ol(t)?(r=t,i=e):te(t)?(n=t,i=e):i=t;var o,a=i&&"Object"===i.returnType?"Object":"Array",s=i&&Vn(i),l=[],u=void 0,c=void 0,h=void 0;if(null!=r)(u=this._data.get(r))&&s&&!s(u)&&(u=void 0);else if(null!=n)for(var f=0,d=n.length;f<d;f++)null==(u=this._data.get(n[f]))||s&&!s(u)||l.push(u);else for(var p,v=0,y=(c=To(as(p=this._data).call(p))).length;v<y;v++)h=c[v],null==(u=this._data.get(h))||s&&!s(u)||l.push(u);if(i&&i.order&&null==r&&this._sort(l,i.order),i&&i.fields){var m=i.fields;if(null!=r&&null!=u)u=this._filterFields(u,m);else for(var g=0,b=l.length;g<b;g++)l[g]=this._filterFields(l[g],m)}if("Object"==a){for(var w={},x=0,_=l.length;x<_;x++){var S=l[x];w[S[this._idProp]]=S}return w}return null!=r?null!==(o=u)&&void 0!==o?o:null:l}},{key:"getIds",value:function(t){var e=this._data,r=t&&Vn(t),n=t&&t.order,i=To(as(e).call(e)),o=[];if(r)if(n){for(var a=[],s=0,l=i.length;s<l;s++){var u=i[s],c=this._data.get(u);null!=c&&r(c)&&a.push(c)}this._sort(a,n);for(var h=0,f=a.length;h<f;h++)o.push(a[h][this._idProp])}else for(var d=0,p=i.length;d<p;d++){var v=i[d],y=this._data.get(v);null!=y&&r(y)&&o.push(y[this._idProp])}else if(n){for(var m=[],g=0,b=i.length;g<b;g++){var w=i[g];m.push(e.get(w))}this._sort(m,n);for(var x=0,_=m.length;x<_;x++)o.push(m[x][this._idProp])}else for(var S=0,k=i.length;S<k;S++){var L=i[S],A=e.get(L);null!=A&&o.push(A[this._idProp])}return o}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&Vn(e),n=this._data,i=To(as(n).call(n));if(e&&e.order)for(var o=this.get(e),a=0,s=o.length;a<s;a++){var l=o[a];t(l,l[this._idProp])}else for(var u=0,c=i.length;u<c;u++){var h=i[u],f=this._data.get(h);null==f||r&&!r(f)||t(f,h)}}},{key:"map",value:function(t,e){for(var r=e&&Vn(e),n=[],i=this._data,o=To(as(i).call(i)),a=0,s=o.length;a<s;a++){var l=o[a],u=this._data.get(l);null==u||r&&!r(u)||n.push(t(u,l))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?ul(r=te(e)?e:go(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;ai(t).call(t,(function(t,e){var n=t[r],i=e[r];return n>i?1:n<i?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");ai(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],i=te(t)?t:[t],o=0,a=i.length;o<a;o++){var s=this._remove(i[o]);if(s){var l=s[this._idProp];null!=l&&(r.push(l),n.push(s))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(Ol(t)?e=t:t&&"object"===ln(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=To(as(e=this._data).call(e)),n=[],i=0,o=r.length;i<o;i++)n.push(this._data.get(r[i]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,i=null,o=kl(Ln(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,s=a[t];"number"==typeof s&&(null==i||s>i)&&(n=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,i=null,o=kl(Ln(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,s=a[t];"number"==typeof s&&(null==i||s<i)&&(n=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=To(as(e).call(e)),n=[],i=0,o=0,a=r.length;o<a;o++){for(var s=r[o],l=e.get(s)[t],u=!1,c=0;c<i;c++)if(n[c]==l){u=!0;break}u||void 0===l||(n[i]=l,i++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=wl()),t}(t,this._idProp),r=e[this._idProp];if(this._data.has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return this._data.set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Oa(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,_l(_l({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new Pl(Fi({},Ns,Bs.mark((function r(){var n,i,o,a;return Bs.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=kl(t),r.prev=1,n.s();case 3:if((i=n.n()).done){r.next=11;break}if(o=i.value,null==(a=e.get(o))){r.next=9;break}return r.next=9,[o,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new Pl(Fi({},Ns,dl(r=rs(this._data)).call(r,this._data)))}},{key:"idProp",get:function(){return this._idProp}}]),r}(Tl),Dl=function(t){ys(r,t);var e=Sl(r);function r(t,n){var i,o;return Ea(this,r),(o=e.call(this)).length=0,o._ids=new js,o._options=n||{},o._listener=dl(i=o._onEvent).call(i,Ya(o)),o.setData(t),o}return Ma(r,[{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:Vn(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:Vn(this._options)}),i=0,o=n.length;i<o;i++){var a=n[i];this._ids.add(a)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new Ml;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:Vn(this._options)}),e=To(this._ids),r={},n=[],i=[],o=[],a=0,s=t.length;a<s;a++){var l=t[a];r[l]=!0,this._ids.has(l)||(n.push(l),this._ids.add(l))}for(var u=0,c=e.length;u<c;u++){var h=e[u],f=this._data.get(h);null==f?console.error("If you see this, report it please."):r[h]||(i.push(h),o.push(f),this._ids.delete(h))}this.length+=n.length-i.length,n.length&&this._trigger("add",{items:n}),i.length&&this._trigger("remove",{items:i,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;Ol(t)||te(t)?(n=t,r=e):r=t;var i=ct({},this._options,r),o=Vn(this._options),a=r&&Vn(r);return o&&a&&(i.filter=function(t){return o(t)&&a(t)}),null==n?this._data.get(i):this._data.get(n,i)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=Vn(this._options),n=null!=t?Vn(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,i=Vn(this._options),o=e&&Vn(e);n=o?i?function(t){return i(t)&&o(t)}:o:i,xn(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,i=Vn(this._options),o=e&&Vn(e);return n=o?i?function(t){return i(t)&&o(t)}:o:i,ko(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||Fi({},Ns,dl(e=as(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,n="This data view has already been disposed of.",i={get:function(){throw new Error(n)},set:function(){throw new Error(n)},configurable:!1},o=kl(Lo(r.prototype));try{for(o.s();!(e=o.n()).done;){var a=e.value;ui(this,a,i)}}catch(t){o.e(t)}finally{o.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,i=[],o=[],a=[],s=[],l=[],u=[];switch(t){case"add":for(var c=0,h=n.length;c<h;c++){var f=n[c];this.get(f)&&(this._ids.add(f),i.push(f))}break;case"update":for(var d=0,p=n.length;d<p;d++){var v=n[d];this.get(v)?this._ids.has(v)?(o.push(v),l.push(e.data[d]),s.push(e.oldData[d])):(this._ids.add(v),i.push(v)):this._ids.has(v)&&(this._ids.delete(v),a.push(v),u.push(e.oldData[d]))}break;case"remove":for(var y=0,m=n.length;y<m;y++){var g=n[y];this._ids.has(g)&&(this._ids.delete(g),a.push(g),u.push(e.oldData[y]))}}this.length+=i.length-a.length,i.length&&this._trigger("add",{items:i},r),o.length&&this._trigger("update",{items:o,oldData:s,data:l},r),a.length&&this._trigger("remove",{items:a,oldData:u},r)}}},{key:"idProp",get:function(){return this.getDataSet().idProp}}]),r}(Tl);function Rl(t,e){return"object"===ln(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof xn(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof ko(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}function Il(){this.min=void 0,this.max=void 0}Il.prototype.adjust=function(t){void 0!==t&&((void 0===this.min||this.min>t)&&(this.min=t),(void 0===this.max||this.max<t)&&(this.max=t))},Il.prototype.combine=function(t){this.add(t.min),this.add(t.max)},Il.prototype.expand=function(t){if(void 0!==t){var e=this.min-t,r=this.max+t;if(e>r)throw new Error("Passed expansion value makes range invalid");this.min=e,this.max=r}},Il.prototype.range=function(){return this.max-this.min},Il.prototype.center=function(){return(this.min+this.max)/2};var zl=Il;function jl(t,e,r){this.dataGroup=t,this.column=e,this.graph=r,this.index=void 0,this.value=void 0,this.values=t.getDistinctValues(this.column),Ln(this).length>0&&this.selectValue(0),this.dataPoints=[],this.loaded=!1,this.onLoadCallback=void 0,r.animationPreload?(this.loaded=!1,this.loadInBackground()):this.loaded=!0}function Fl(){this.dataTable=null}jl.prototype.isLoaded=function(){return this.loaded},jl.prototype.getLoadedProgress=function(){for(var t=Ln(this).length,e=0;this.dataPoints[e];)e++;return Math.round(e/t*100)},jl.prototype.getLabel=function(){return this.graph.filterLabel},jl.prototype.getColumn=function(){return this.column},jl.prototype.getSelectedValue=function(){if(void 0!==this.index)return Ln(this)[this.index]},jl.prototype.getValues=function(){return Ln(this)},jl.prototype.getValue=function(t){if(t>=Ln(this).length)throw new Error("Index out of range");return Ln(this)[t]},jl.prototype._getDataPoints=function(t){if(void 0===t&&(t=this.index),void 0===t)return[];var e;if(this.dataPoints[t])e=this.dataPoints[t];else{var r={};r.column=this.column,r.value=Ln(this)[t];var n=new Dl(this.dataGroup.getDataSet(),{filter:function(t){return t[r.column]==r.value}}).get();e=this.dataGroup._getDataPoints(n),this.dataPoints[t]=e}return e},jl.prototype.setOnLoadCallback=function(t){this.onLoadCallback=t},jl.prototype.selectValue=function(t){if(t>=Ln(this).length)throw new Error("Index out of range");this.index=t,this.value=Ln(this)[t]},jl.prototype.loadInBackground=function(t){void 0===t&&(t=0);var e=this.graph.frame;if(t<Ln(this).length){void 0===e.progress&&(e.progress=document.createElement("DIV"),e.progress.style.position="absolute",e.progress.style.color="gray",e.appendChild(e.progress));var r=this.getLoadedProgress();e.progress.innerHTML="Loading animation... "+r+"%",e.progress.style.bottom="60px",e.progress.style.left="10px";var n=this;bt((function(){n.loadInBackground(t+1)}),10),this.loaded=!1}else this.loaded=!0,void 0!==e.progress&&(e.removeChild(e.progress),e.progress=void 0),this.onLoadCallback&&this.onLoadCallback()},Fl.prototype.initializeData=function(t,e,r){if(void 0!==e){var n;if(te(e)&&(e=new Ml(e)),!(e instanceof Ml||e instanceof Dl))throw new Error("Array, DataSet, or DataView expected");if(0!=(n=e.get()).length){this.style=r,this.dataSet&&this.dataSet.off("*",this._onChange),this.dataSet=e,this.dataTable=n;var i=this;this._onChange=function(){t.setData(i.dataSet)},this.dataSet.on("*",this._onChange),this.colX="x",this.colY="y",this.colZ="z";var o=t.hasBars(r);if(o&&(void 0!==t.defaultXBarWidth?this.xBarWidth=t.defaultXBarWidth:this.xBarWidth=this.getSmallestDifference(n,this.colX)||1,void 0!==t.defaultYBarWidth?this.yBarWidth=t.defaultYBarWidth:this.yBarWidth=this.getSmallestDifference(n,this.colY)||1),this._initializeRange(n,this.colX,t,o),this._initializeRange(n,this.colY,t,o),this._initializeRange(n,this.colZ,t,!1),n[0].hasOwnProperty("style")){this.colValue="style";var a=this.getColumnRange(n,this.colValue);this._setRangeDefaults(a,t.defaultValueMin,t.defaultValueMax),this.valueRange=a}else this.colValue="z",this.valueRange=this.zRange;return this.getDataTable()[0].hasOwnProperty("filter")&&void 0===this.dataFilter&&(this.dataFilter=new jl(this,"filter",t),this.dataFilter.setOnLoadCallback((function(){t.redraw()}))),this.dataFilter?this.dataFilter._getDataPoints():this._getDataPoints(this.getDataTable())}}},Fl.prototype._collectRangeSettings=function(t,e){var r;if(-1==Kn(r=["x","y","z"]).call(r,t))throw new Error("Column '"+t+"' invalid");var n=t.toUpperCase();return{barWidth:this[t+"BarWidth"],min:e["default"+n+"Min"],max:e["default"+n+"Max"],step:e["default"+n+"Step"],range_label:t+"Range",step_label:t+"Step"}},Fl.prototype._initializeRange=function(t,e,r,n){var i=this._collectRangeSettings(e,r),o=this.getColumnRange(t,e);n&&"z"!=e&&o.expand(i.barWidth/2),this._setRangeDefaults(o,i.min,i.max),this[i.range_label]=o,this[i.step_label]=void 0!==i.step?i.step:o.range()/5},Fl.prototype.getDistinctValues=function(t,e){void 0===e&&(e=this.dataTable);for(var r=[],n=0;n<e.length;n++){var i=e[n][t]||0;-1===Kn(r).call(r,i)&&r.push(i)}return ai(r).call(r,(function(t,e){return t-e}))},Fl.prototype.getSmallestDifference=function(t,e){for(var r=this.getDistinctValues(t,e),n=null,i=1;i<r.length;i++){var o=r[i]-r[i-1];(null==n||n>o)&&(n=o)}return n},Fl.prototype.getColumnRange=function(t,e){for(var r=new zl,n=0;n<t.length;n++){var i=t[n][e];r.adjust(i)}return r},Fl.prototype.getNumberOfRows=function(){return this.dataTable.length},Fl.prototype._setRangeDefaults=function(t,e,r){void 0!==e&&(t.min=e),void 0!==r&&(t.max=r),t.max<=t.min&&(t.max=t.min+1)},Fl.prototype.getDataTable=function(){return this.dataTable},Fl.prototype.getDataSet=function(){return this.dataSet},Fl.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var n=new $o;n.x=t[r][this.colX]||0,n.y=t[r][this.colY]||0,n.z=t[r][this.colZ]||0,n.data=t[r],n.value=t[r][this.colValue]||0;var i={};i.point=n,i.bottom=new $o(n.x,n.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},Fl.prototype.initDataAsMatrix=function(t){var e,r,n,i,o=this.getDistinctValues(this.colX,t),a=this.getDistinctValues(this.colY,t),s=this.getDataPoints(t),l=[];for(n=0;n<s.length;n++){i=s[n];var u=Kn(o).call(o,i.point.x),c=Kn(a).call(a,i.point.y);void 0===l[u]&&(l[u]=[]),l[u][c]=i}for(e=0;e<l.length;e++)for(r=0;r<l[e].length;r++)l[e][r]&&(l[e][r].pointRight=e<l.length-1?l[e+1][r]:void 0,l[e][r].pointTop=r<l[e].length-1?l[e][r+1]:void 0,l[e][r].pointCross=e<l.length-1&&r<l[e].length-1?l[e+1][r+1]:void 0);return s},Fl.prototype.getInfo=function(){var t=this.dataFilter;if(t)return t.getLabel()+": "+t.getSelectedValue()},Fl.prototype.reload=function(){this.dataTable&&this.setData(this.dataTable)},Fl.prototype._getDataPoints=function(t){var e=[];if(this.style===ua.GRID||this.style===ua.SURFACE)e=this.initDataAsMatrix(t);else if(e=this.getDataPoints(t),this.style===ua.LINE)for(var r=0;r<e.length;r++)r>0&&(e[r-1].pointNext=e[r]);return e},Nl.STYLE=ua;var Bl=void 0;function Nl(t,e,r){if(!(this instanceof Nl))throw new SyntaxError("Constructor must be called with the new operator");this.containerElement=t,this.dataGroup=new Fl,this.dataPoints=null,this.create(),function(t,e){if(void 0===t||pa(t))throw new Error("No DEFAULTS passed");if(void 0===e)throw new Error("No dst passed");da=t,ya(t,e,ha),ya(t,e,fa,"default"),ga(t,e),e.margin=10,e.showTooltip=!1,e.onclick_callback=null,e.eye=new $o(0,0,-1)}(Nl.DEFAULTS,this),this.colX=void 0,this.colY=void 0,this.colZ=void 0,this.colValue=void 0,this.setOptions(r),this.setData(e)}function Gl(t){return"clientX"in t?t.clientX:t.targetTouches[0]&&t.targetTouches[0].clientX||0}function Wl(t){return"clientY"in t?t.clientY:t.targetTouches[0]&&t.targetTouches[0].clientY||0}Nl.DEFAULTS={width:"400px",height:"400px",filterLabel:"time",legendLabel:"value",xLabel:"x",yLabel:"y",zLabel:"z",xValueLabel:function(t){return t},yValueLabel:function(t){return t},zValueLabel:function(t){return t},showXAxis:!0,showYAxis:!0,showZAxis:!0,showGrayBottom:!1,showGrid:!0,showPerspective:!0,showShadow:!1,showSurfaceGrid:!0,keepAspectRatio:!0,rotateAxisLabels:!0,verticalRatio:.5,dotSizeRatio:.02,dotSizeMinFraction:.5,dotSizeMaxFraction:2.5,showAnimationControls:Bl,animationInterval:1e3,animationPreload:!1,animationAutoStart:Bl,axisFontSize:14,axisFontType:"arial",axisColor:"#4D4D4D",gridColor:"#D3D3D3",xCenter:"55%",yCenter:"50%",style:Nl.STYLE.DOT,tooltip:!1,tooltipDelay:300,tooltipStyle:{content:{padding:"10px",border:"1px solid #4d4d4d",color:"#1a1a1a",background:"rgba(255,255,255,0.7)",borderRadius:"2px",boxShadow:"5px 5px 10px rgba(128,128,128,0.5)"},line:{height:"40px",width:"0",borderLeft:"1px solid #4d4d4d",pointerEvents:"none"},dot:{height:"0",width:"0",border:"5px solid #4d4d4d",borderRadius:"5px",pointerEvents:"none"}},dataColor:{fill:"#7DC1FF",stroke:"#3267D2",strokeWidth:1},surfaceColors:Bl,colormap:Bl,cameraPosition:{horizontal:1,vertical:.5,distance:1.7},zoomable:!0,ctrlToZoom:!1,showLegend:Bl,backgroundColor:Bl,xBarWidth:Bl,yBarWidth:Bl,valueMin:Bl,valueMax:Bl,xMin:Bl,xMax:Bl,xStep:Bl,yMin:Bl,yMax:Bl,yStep:Bl,zMin:Bl,zMax:Bl,zStep:Bl},si(Nl.prototype),Nl.prototype._setScale=function(){this.scale=new $o(1/this.xRange.range(),1/this.yRange.range(),1/this.zRange.range()),this.keepAspectRatio&&(this.scale.x<this.scale.y?this.scale.y=this.scale.x:this.scale.x=this.scale.y),this.scale.z*=this.verticalRatio,void 0!==this.valueRange&&(this.scale.value=1/this.valueRange.range());var t=this.xRange.center()*this.scale.x,e=this.yRange.center()*this.scale.y,r=this.zRange.center()*this.scale.z;this.camera.setArmLocation(t,e,r)},Nl.prototype._convert3Dto2D=function(t){var e=this._convertPointToTranslation(t);return this._convertTranslationToScreen(e)},Nl.prototype._convertPointToTranslation=function(t){var e=this.camera.getCameraLocation(),r=this.camera.getCameraRotation(),n=t.x*this.scale.x,i=t.y*this.scale.y,o=t.z*this.scale.z,a=e.x,s=e.y,l=e.z,u=Math.sin(r.x),c=Math.cos(r.x),h=Math.sin(r.y),f=Math.cos(r.y),d=Math.sin(r.z),p=Math.cos(r.z);return new $o(f*(d*(i-s)+p*(n-a))-h*(o-l),u*(f*(o-l)+h*(d*(i-s)+p*(n-a)))+c*(p*(i-s)-d*(n-a)),c*(f*(o-l)+h*(d*(i-s)+p*(n-a)))-u*(p*(i-s)-d*(n-a)))},Nl.prototype._convertTranslationToScreen=function(t){var e,r,n=this.eye.x,i=this.eye.y,o=this.eye.z,a=t.x,s=t.y,l=t.z;return this.showPerspective?(e=o/l*(a-n),r=o/l*(s-i)):(e=a*(-o/this.camera.getArmLength()),r=s*(-o/this.camera.getArmLength())),new Jo(this.currentXCenter+e*this.frame.canvas.clientWidth,this.currentYCenter-r*this.frame.canvas.clientWidth)},Nl.prototype._calcTranslations=function(t){for(var e=0;e<t.length;e++){var r=t[e];r.trans=this._convertPointToTranslation(r.point),r.screen=this._convertTranslationToScreen(r.trans);var n=this._convertPointToTranslation(r.bottom);r.dist=this.showPerspective?n.length():-n.z}ai(t).call(t,(function(t,e){return e.dist-t.dist}))},Nl.prototype._initializeRanges=function(){var t=this.dataGroup;this.xRange=t.xRange,this.yRange=t.yRange,this.zRange=t.zRange,this.valueRange=t.valueRange,this.xStep=t.xStep,this.yStep=t.yStep,this.zStep=t.zStep,this.xBarWidth=t.xBarWidth,this.yBarWidth=t.yBarWidth,this.colX=t.colX,this.colY=t.colY,this.colZ=t.colZ,this.colValue=t.colValue,this._setScale()},Nl.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var n=new $o;n.x=t[r][this.colX]||0,n.y=t[r][this.colY]||0,n.z=t[r][this.colZ]||0,n.data=t[r],n.value=t[r][this.colValue]||0;var i={};i.point=n,i.bottom=new $o(n.x,n.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},Nl.prototype._getDataPoints=function(t){var e,r,n,i,o=[];if(this.style===Nl.STYLE.GRID||this.style===Nl.STYLE.SURFACE){var a=this.dataGroup.getDistinctValues(this.colX,t),s=this.dataGroup.getDistinctValues(this.colY,t);o=this.getDataPoints(t);var l=[];for(n=0;n<o.length;n++){i=o[n];var u=Kn(a).call(a,i.point.x),c=Kn(s).call(s,i.point.y);void 0===l[u]&&(l[u]=[]),l[u][c]=i}for(e=0;e<l.length;e++)for(r=0;r<l[e].length;r++)l[e][r]&&(l[e][r].pointRight=e<l.length-1?l[e+1][r]:void 0,l[e][r].pointTop=r<l[e].length-1?l[e][r+1]:void 0,l[e][r].pointCross=e<l.length-1&&r<l[e].length-1?l[e+1][r+1]:void 0)}else if(o=this.getDataPoints(t),this.style===Nl.STYLE.LINE)for(n=0;n<o.length;n++)n>0&&(o[n-1].pointNext=o[n]);return o},Nl.prototype.create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div"),this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas);var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t),this.frame.filter=document.createElement("div"),Vn(this.frame).style.position="absolute",Vn(this.frame).style.bottom="0px",Vn(this.frame).style.left="0px",Vn(this.frame).style.width="100%",this.frame.appendChild(Vn(this.frame));var e=this;Uo(this.frame.canvas,"mousedown",(function(t){e._onMouseDown(t)})),Uo(this.frame.canvas,"touchstart",(function(t){e._onTouchStart(t)})),Uo(this.frame.canvas,"mousewheel",(function(t){e._onWheel(t)})),Uo(this.frame.canvas,"mousemove",(function(t){e._onTooltip(t)})),Uo(this.frame.canvas,"click",(function(t){e._onClick(t)})),this.containerElement.appendChild(this.frame)},Nl.prototype._setSize=function(t,e){this.frame.style.width=t,this.frame.style.height=e,this._resizeCanvas()},Nl.prototype._resizeCanvas=function(){this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=this.frame.canvas.clientWidth,this.frame.canvas.height=this.frame.canvas.clientHeight,Vn(this.frame).style.width=this.frame.canvas.clientWidth-20+"px"},Nl.prototype.animationStart=function(){if(this.animationAutoStart&&this.dataGroup.dataFilter){if(!Vn(this.frame)||!Vn(this.frame).slider)throw new Error("No animation available");Vn(this.frame).slider.play()}},Nl.prototype.animationStop=function(){Vn(this.frame)&&Vn(this.frame).slider&&Vn(this.frame).slider.stop()},Nl.prototype._resizeCenter=function(){"%"===this.xCenter.charAt(this.xCenter.length-1)?this.currentXCenter=Fn(this.xCenter)/100*this.frame.canvas.clientWidth:this.currentXCenter=Fn(this.xCenter),"%"===this.yCenter.charAt(this.yCenter.length-1)?this.currentYCenter=Fn(this.yCenter)/100*(this.frame.canvas.clientHeight-Vn(this.frame).clientHeight):this.currentYCenter=Fn(this.yCenter)},Nl.prototype.getCameraPosition=function(){var t=this.camera.getArmRotation();return t.distance=this.camera.getArmLength(),t},Nl.prototype._readData=function(t){this.dataPoints=this.dataGroup.initializeData(this,t,this.style),this._initializeRanges(),this._redrawFilter()},Nl.prototype.setData=function(t){null!=t&&(this._readData(t),this.redraw(),this.animationStart())},Nl.prototype.setOptions=function(t){void 0!==t&&(!0===Ia.validate(t,Wa)&&console.log("%cErrors have been found in the supplied options object.",Ra),this.animationStop(),function(t,e){if(void 0!==t){if(void 0===e)throw new Error("No dst passed");if(void 0===da||pa(da))throw new Error("DEFAULTS not set for module Settings");ma(t,e,ha),ma(t,e,fa,"default"),ga(t,e)}}(t,this),this.setPointDrawingMethod(),this._setSize(this.width,this.height),this.setAxisLabelMethod(),this.setData(this.dataGroup.getDataTable()),this.animationStart())},Nl.prototype.setPointDrawingMethod=function(){var t=void 0;switch(this.style){case Nl.STYLE.BAR:t=this._redrawBarGraphPoint;break;case Nl.STYLE.BARCOLOR:t=this._redrawBarColorGraphPoint;break;case Nl.STYLE.BARSIZE:t=this._redrawBarSizeGraphPoint;break;case Nl.STYLE.DOT:t=this._redrawDotGraphPoint;break;case Nl.STYLE.DOTLINE:t=this._redrawDotLineGraphPoint;break;case Nl.STYLE.DOTCOLOR:t=this._redrawDotColorGraphPoint;break;case Nl.STYLE.DOTSIZE:t=this._redrawDotSizeGraphPoint;break;case Nl.STYLE.SURFACE:t=this._redrawSurfaceGraphPoint;break;case Nl.STYLE.GRID:t=this._redrawGridGraphPoint;break;case Nl.STYLE.LINE:t=this._redrawLineGraphPoint;break;default:throw new Error("Can not determine point drawing method for graph style '"+this.style+"'")}this._pointDrawingMethod=t},Nl.prototype.setAxisLabelMethod=function(){this.rotateAxisLabels?(this._drawAxisLabelX=this.drawAxisLabelXRotate,this._drawAxisLabelY=this.drawAxisLabelYRotate,this._drawAxisLabelZ=this.drawAxisLabelZRotate):(this._drawAxisLabelX=this.drawAxisLabelX,this._drawAxisLabelY=this.drawAxisLabelY,this._drawAxisLabelZ=this.drawAxisLabelZ)},Nl.prototype.redraw=function(){if(void 0===this.dataPoints)throw new Error("Graph data not initialized");this._resizeCanvas(),this._resizeCenter(),this._redrawSlider(),this._redrawClear(),this._redrawAxis(),this._redrawDataGraph(),this._redrawInfo(),this._redrawLegend()},Nl.prototype._getContext=function(){var t=this.frame.canvas.getContext("2d");return t.lineJoin="round",t.lineCap="round",t},Nl.prototype._redrawClear=function(){var t=this.frame.canvas;t.getContext("2d").clearRect(0,0,t.width,t.height)},Nl.prototype._dotSize=function(){return this.frame.clientWidth*this.dotSizeRatio},Nl.prototype._getLegendWidth=function(){var t;this.style===Nl.STYLE.DOTSIZE?t=this._dotSize()*this.dotSizeMaxFraction:t=this.style===Nl.STYLE.BARSIZE?this.xBarWidth:20;return t},Nl.prototype._redrawLegend=function(){if(!0===this.showLegend&&this.style!==Nl.STYLE.LINE&&this.style!==Nl.STYLE.BARSIZE){var t=this.style===Nl.STYLE.BARSIZE||this.style===Nl.STYLE.DOTSIZE,e=this.style===Nl.STYLE.DOTSIZE||this.style===Nl.STYLE.DOTCOLOR||this.style===Nl.STYLE.SURFACE||this.style===Nl.STYLE.BARCOLOR,r=Math.max(.25*this.frame.clientHeight,100),n=this.margin,i=this._getLegendWidth(),o=this.frame.clientWidth-this.margin,a=o-i,s=n+r,l=this._getContext();if(l.lineWidth=1,l.font="14px arial",!1===t){var u,c=r;for(u=0;u<c;u++){var h=1-(u-0)/(c-0),f=this._colormap(h,1);l.strokeStyle=f,l.beginPath(),l.moveTo(a,n+u),l.lineTo(o,n+u),l.stroke()}l.strokeStyle=this.axisColor,l.strokeRect(a,n,i,r)}else{var d;this.style===Nl.STYLE.DOTSIZE?d=i*(this.dotSizeMinFraction/this.dotSizeMaxFraction):(this.style,Nl.STYLE.BARSIZE),l.strokeStyle=this.axisColor,l.fillStyle=On(this.dataColor),l.beginPath(),l.moveTo(a,n),l.lineTo(o,n),l.lineTo(a+d,s),l.lineTo(a,s),l.closePath(),On(l).call(l),l.stroke()}var p,v,y=e?this.valueRange.min:this.zRange.min,m=e?this.valueRange.max:this.zRange.max,g=new ta(y,m,(m-y)/5,!0);for(g.start(!0);!g.end();)u=s-(g.getCurrent()-y)/(m-y)*r,p=new Jo(a-5,u),v=new Jo(a,u),this._line(l,p,v),l.textAlign="right",l.textBaseline="middle",l.fillStyle=this.axisColor,l.fillText(g.getCurrent(),a-10,u),g.next();l.textAlign="right",l.textBaseline="top";var b=this.legendLabel;l.fillText(b,o,s+this.margin)}},Nl.prototype._redrawFilter=function(){var t=this.dataGroup.dataFilter,e=Vn(this.frame);if(e.innerHTML="",t){var r=new Ko(e,{visible:this.showAnimationControls});e.slider=r,e.style.padding="10px",r.setValues(Ln(t)),r.setPlayInterval(this.animationInterval);var n=this;r.setOnChangeCallback((function(){var t=n.dataGroup.dataFilter,e=r.getIndex();t.selectValue(e),n.dataPoints=t._getDataPoints(),n.redraw()}))}else e.slider=void 0},Nl.prototype._redrawSlider=function(){void 0!==Vn(this.frame).slider&&Vn(this.frame).slider.redraw()},Nl.prototype._redrawInfo=function(){var t=this.dataGroup.getInfo();if(void 0!==t){var e=this._getContext();e.font="14px arial",e.lineStyle="gray",e.fillStyle="gray",e.textAlign="left",e.textBaseline="top";var r=this.margin,n=this.margin;e.fillText(t,r,n)}},Nl.prototype._line=function(t,e,r,n){void 0!==n&&(t.strokeStyle=n),t.beginPath(),t.moveTo(e.x,e.y),t.lineTo(r.x,r.y),t.stroke()},Nl.prototype.drawAxisLabelX=function(t,e,r,n,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*n)>0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*n)<0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},Nl.prototype.drawAxisLabelY=function(t,e,r,n,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*n)<0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*n)>0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},Nl.prototype.drawAxisLabelZ=function(t,e,r,n){void 0===n&&(n=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,i.x-n,i.y)},Nl.prototype.drawAxisLabelXRotate=function(t,e,r,n,i){var o=this._convert3Dto2D(e);Math.cos(2*n)>0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*n)<0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},Nl.prototype.drawAxisLabelYRotate=function(t,e,r,n,i){var o=this._convert3Dto2D(e);Math.cos(2*n)<0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*n)>0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},Nl.prototype.drawAxisLabelZRotate=function(t,e,r,n){void 0===n&&(n=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,i.x-n,i.y)},Nl.prototype._line3d=function(t,e,r,n){var i=this._convert3Dto2D(e),o=this._convert3Dto2D(r);this._line(t,i,o,n)},Nl.prototype._redrawAxis=function(){var t,e,r,n,i,o,a,s,l,u,c=this._getContext();c.font=this.axisFontSize/this.camera.getArmLength()+"px "+this.axisFontType;var h,f,d,p=.025/this.scale.x,v=.025/this.scale.y,y=5/this.camera.getArmLength(),m=this.camera.getArmRotation().horizontal,g=new Jo(Math.cos(m),Math.sin(m)),b=this.xRange,w=this.yRange,x=this.zRange;for(c.lineWidth=1,n=void 0===this.defaultXStep,(r=new ta(b.min,b.max,this.xStep,n)).start(!0);!r.end();){var _=r.getCurrent();if(this.showGrid?(t=new $o(_,w.min,x.min),e=new $o(_,w.max,x.min),this._line3d(c,t,e,this.gridColor)):this.showXAxis&&(t=new $o(_,w.min,x.min),e=new $o(_,w.min+p,x.min),this._line3d(c,t,e,this.axisColor),t=new $o(_,w.max,x.min),e=new $o(_,w.max-p,x.min),this._line3d(c,t,e,this.axisColor)),this.showXAxis){a=g.x>0?w.min:w.max,h=new $o(_,a,x.min);var S="  "+this.xValueLabel(_)+"  ";this._drawAxisLabelX.call(this,c,h,S,m,y)}r.next()}for(c.lineWidth=1,n=void 0===this.defaultYStep,(r=new ta(w.min,w.max,this.yStep,n)).start(!0);!r.end();){var k=r.getCurrent();if(this.showGrid?(t=new $o(b.min,k,x.min),e=new $o(b.max,k,x.min),this._line3d(c,t,e,this.gridColor)):this.showYAxis&&(t=new $o(b.min,k,x.min),e=new $o(b.min+v,k,x.min),this._line3d(c,t,e,this.axisColor),t=new $o(b.max,k,x.min),e=new $o(b.max-v,k,x.min),this._line3d(c,t,e,this.axisColor)),this.showYAxis){o=g.y>0?b.min:b.max,h=new $o(o,k,x.min);var L="  "+this.yValueLabel(k)+"  ";this._drawAxisLabelY.call(this,c,h,L,m,y)}r.next()}if(this.showZAxis){for(c.lineWidth=1,n=void 0===this.defaultZStep,(r=new ta(x.min,x.max,this.zStep,n)).start(!0),o=g.x>0?b.min:b.max,a=g.y<0?w.min:w.max;!r.end();){var A=r.getCurrent(),C=new $o(o,a,A),O=this._convert3Dto2D(C);e=new Jo(O.x-y,O.y),this._line(c,O,e,this.axisColor);var E=this.zValueLabel(A)+" ";this._drawAxisLabelZ.call(this,c,C,E,5),r.next()}c.lineWidth=1,t=new $o(o,a,x.min),e=new $o(o,a,x.max),this._line3d(c,t,e,this.axisColor)}this.showXAxis&&(c.lineWidth=1,f=new $o(b.min,w.min,x.min),d=new $o(b.max,w.min,x.min),this._line3d(c,f,d,this.axisColor),f=new $o(b.min,w.max,x.min),d=new $o(b.max,w.max,x.min),this._line3d(c,f,d,this.axisColor));this.showYAxis&&(c.lineWidth=1,t=new $o(b.min,w.min,x.min),e=new $o(b.min,w.max,x.min),this._line3d(c,t,e,this.axisColor),t=new $o(b.max,w.min,x.min),e=new $o(b.max,w.max,x.min),this._line3d(c,t,e,this.axisColor));var T=this.xLabel;T.length>0&&this.showXAxis&&(u=.1/this.scale.y,o=(b.max+3*b.min)/4,a=g.x>0?w.min-u:w.max+u,i=new $o(o,a,x.min),this.drawAxisLabelX(c,i,T,m));var P=this.yLabel;P.length>0&&this.showYAxis&&(l=.1/this.scale.x,o=g.y>0?b.min-l:b.max+l,a=(w.max+3*w.min)/4,i=new $o(o,a,x.min),this.drawAxisLabelY(c,i,P,m));var M=this.zLabel;M.length>0&&this.showZAxis&&(30,o=g.x>0?b.min:b.max,a=g.y<0?w.min:w.max,s=(x.max+3*x.min)/4,i=new $o(o,a,s),this.drawAxisLabelZ(c,i,M,30))},Nl.prototype._getStrokeWidth=function(t){return void 0!==t?this.showPerspective?1/-t.trans.z*this.dataColor.strokeWidth:-this.eye.z/this.camera.getArmLength()*this.dataColor.strokeWidth:this.dataColor.strokeWidth},Nl.prototype._redrawBar=function(t,e,r,n,i,o){var a,s=this,l=e.point,u=this.zRange.min,c=[{point:new $o(l.x-r,l.y-n,l.z)},{point:new $o(l.x+r,l.y-n,l.z)},{point:new $o(l.x+r,l.y+n,l.z)},{point:new $o(l.x-r,l.y+n,l.z)}],h=[{point:new $o(l.x-r,l.y-n,u)},{point:new $o(l.x+r,l.y-n,u)},{point:new $o(l.x+r,l.y+n,u)},{point:new $o(l.x-r,l.y+n,u)}];xn(c).call(c,(function(t){t.screen=s._convert3Dto2D(t.point)})),xn(h).call(h,(function(t){t.screen=s._convert3Dto2D(t.point)}));var f=[{corners:c,center:$o.avg(h[0].point,h[2].point)},{corners:[c[0],c[1],h[1],h[0]],center:$o.avg(h[1].point,h[0].point)},{corners:[c[1],c[2],h[2],h[1]],center:$o.avg(h[2].point,h[1].point)},{corners:[c[2],c[3],h[3],h[2]],center:$o.avg(h[3].point,h[2].point)},{corners:[c[3],c[0],h[0],h[3]],center:$o.avg(h[0].point,h[3].point)}];e.surfaces=f;for(var d=0;d<f.length;d++){a=f[d];var p=this._convertPointToTranslation(a.center);a.dist=this.showPerspective?p.length():-p.z}ai(f).call(f,(function(t,e){var r=e.dist-t.dist;return r||(t.corners===c?1:e.corners===c?-1:0)})),t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=o,t.fillStyle=i;for(var v=2;v<f.length;v++)a=f[v],this._polygon(t,a.corners)},Nl.prototype._polygon=function(t,e,r,n){if(!(e.length<2)){void 0!==r&&(t.fillStyle=r),void 0!==n&&(t.strokeStyle=n),t.beginPath(),t.moveTo(e[0].screen.x,e[0].screen.y);for(var i=1;i<e.length;++i){var o=e[i];t.lineTo(o.screen.x,o.screen.y)}t.closePath(),On(t).call(t),t.stroke()}},Nl.prototype._drawCircle=function(t,e,r,n,i){var o=this._calcRadius(e,i);t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=n,t.fillStyle=r,t.beginPath(),t.arc(e.screen.x,e.screen.y,o,0,2*Math.PI,!0),On(t).call(t),t.stroke()},Nl.prototype._getColorsRegular=function(t){var e=(t.point.value-this.valueRange.min)*this.scale.value;return{fill:this._colormap(e,1),border:this._colormap(e,.8)}},Nl.prototype._getColorsColor=function(t){var e,r,n;if(t&&t.point&&t.point.data&&t.point.data.style&&(n=t.point.data.style),n&&"object"===ln(n)&&On(n)&&n.stroke)return{fill:On(n),border:n.stroke};if("string"==typeof t.point.value)e=t.point.value,r=t.point.value;else{var i=(t.point.value-this.valueRange.min)*this.scale.value;e=this._colormap(i,1),r=this._colormap(i,.8)}return{fill:e,border:r}},Nl.prototype._getColorsSize=function(){return{fill:On(this.dataColor),border:this.dataColor.stroke}},Nl.prototype._colormap=function(t){var e,r,n,i,o,a,s,l,u,c=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,h=this.colormap;if(te(h)){var f=h.length-1,d=Math.max(Math.floor(t*f),0),p=Math.min(d+1,f),v=t*f-d,y=h[d],m=h[p];e=y.r+v*(m.r-y.r),r=y.g+v*(m.g-y.g),n=y.b+v*(m.b-y.b)}else if("function"==typeof h){var g=h(t);e=g.r,r=g.g,n=g.b,i=g.a}else{var b=240*(1-t),w=qo(b/360,1,1);e=w.r,r=w.g,n=w.b}return"number"!=typeof i||Kt(i)?Jt(o=Jt(a="RGB(".concat(Math.round(e*c),", ")).call(a,Math.round(r*c),", ")).call(o,Math.round(n*c),")"):Jt(s=Jt(l=Jt(u="RGBA(".concat(Math.round(e*c),", ")).call(u,Math.round(r*c),", ")).call(l,Math.round(n*c),", ")).call(s,i,")")},Nl.prototype._calcRadius=function(t,e){var r;return void 0===e&&(e=this._dotSize()),(r=this.showPerspective?e/-t.trans.z:e*(-this.eye.z/this.camera.getArmLength()))<0&&(r=0),r},Nl.prototype._redrawBarGraphPoint=function(t,e){var r=this.xBarWidth/2,n=this.yBarWidth/2,i=this._getColorsRegular(e);this._redrawBar(t,e,r,n,On(i),i.border)},Nl.prototype._redrawBarColorGraphPoint=function(t,e){var r=this.xBarWidth/2,n=this.yBarWidth/2,i=this._getColorsColor(e);this._redrawBar(t,e,r,n,On(i),i.border)},Nl.prototype._redrawBarSizeGraphPoint=function(t,e){var r=(e.point.value-this.valueRange.min)/this.valueRange.range(),n=this.xBarWidth/2*(.8*r+.2),i=this.yBarWidth/2*(.8*r+.2),o=this._getColorsSize();this._redrawBar(t,e,n,i,On(o),o.border)},Nl.prototype._redrawDotGraphPoint=function(t,e){var r=this._getColorsRegular(e);this._drawCircle(t,e,On(r),r.border)},Nl.prototype._redrawDotLineGraphPoint=function(t,e){var r=this._convert3Dto2D(e.bottom);t.lineWidth=1,this._line(t,r,e.screen,this.gridColor),this._redrawDotGraphPoint(t,e)},Nl.prototype._redrawDotColorGraphPoint=function(t,e){var r=this._getColorsColor(e);this._drawCircle(t,e,On(r),r.border)},Nl.prototype._redrawDotSizeGraphPoint=function(t,e){var r=this._dotSize(),n=(e.point.value-this.valueRange.min)/this.valueRange.range(),i=r*this.dotSizeMinFraction,o=i+(r*this.dotSizeMaxFraction-i)*n,a=this._getColorsSize();this._drawCircle(t,e,On(a),a.border,o)},Nl.prototype._redrawSurfaceGraphPoint=function(t,e){var r=e.pointRight,n=e.pointTop,i=e.pointCross;if(void 0!==e&&void 0!==r&&void 0!==n&&void 0!==i){var o,a,s,l=!0;if(this.showGrayBottom||this.showShadow){var u=$o.subtract(i.trans,e.trans),c=$o.subtract(n.trans,r.trans),h=$o.crossProduct(u,c);if(this.showPerspective){var f=$o.avg($o.avg(e.trans,i.trans),$o.avg(r.trans,n.trans));s=-$o.dotProduct(h.normalize(),f.normalize())}else s=h.z/h.length();l=s>0}if(l||!this.showGrayBottom){var d=((e.point.value+r.point.value+n.point.value+i.point.value)/4-this.valueRange.min)*this.scale.value,p=this.showShadow?(1+s)/2:1;o=this._colormap(d,p)}else o="gray";a=this.showSurfaceGrid?this.axisColor:o,t.lineWidth=this._getStrokeWidth(e);var v=[e,r,i,n];this._polygon(t,v,o,a)}},Nl.prototype._drawGridLine=function(t,e,r){if(void 0!==e&&void 0!==r){var n=((e.point.value+r.point.value)/2-this.valueRange.min)*this.scale.value;t.lineWidth=2*this._getStrokeWidth(e),t.strokeStyle=this._colormap(n,1),this._line(t,e.screen,r.screen)}},Nl.prototype._redrawGridGraphPoint=function(t,e){this._drawGridLine(t,e,e.pointRight),this._drawGridLine(t,e,e.pointTop)},Nl.prototype._redrawLineGraphPoint=function(t,e){void 0!==e.pointNext&&(t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=this.dataColor.stroke,this._line(t,e.screen,e.pointNext.screen))},Nl.prototype._redrawDataGraph=function(){var t,e=this._getContext();if(!(void 0===this.dataPoints||this.dataPoints.length<=0))for(this._calcTranslations(this.dataPoints),t=0;t<this.dataPoints.length;t++){var r=this.dataPoints[t];this._pointDrawingMethod.call(this,e,r)}},Nl.prototype._storeMousePosition=function(t){this.startMouseX=Gl(t),this.startMouseY=Wl(t),this._startCameraOffset=this.camera.getOffset()},Nl.prototype._onMouseDown=function(t){if(t=t||window.event,this.leftButtonDown&&this._onMouseUp(t),this.leftButtonDown=t.which?1===t.which:1===t.button,this.leftButtonDown||this.touchDown){this._storeMousePosition(t),this.startStart=new Date(this.start),this.startEnd=new Date(this.end),this.startArmRotation=this.camera.getArmRotation(),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},Uo(document,"mousemove",e.onmousemove),Uo(document,"mouseup",e.onmouseup),Zo(t)}},Nl.prototype._onMouseMove=function(t){this.moving=!0,t=t||window.event;var e=Fn(Gl(t))-this.startMouseX,r=Fn(Wl(t))-this.startMouseY;if(t&&!0===t.ctrlKey){var n=.5*this.frame.clientWidth,i=.5*this.frame.clientHeight,o=(this._startCameraOffset.x||0)-e/n*this.camera.armLength*.8,a=(this._startCameraOffset.y||0)+r/i*this.camera.armLength*.8;this.camera.setOffset(o,a),this._storeMousePosition(t)}else{var s=this.startArmRotation.horizontal+e/200,l=this.startArmRotation.vertical+r/200,u=Math.sin(4/360*2*Math.PI);Math.abs(Math.sin(s))<u&&(s=Math.round(s/Math.PI)*Math.PI-.001),Math.abs(Math.cos(s))<u&&(s=(Math.round(s/Math.PI-.5)+.5)*Math.PI-.001),Math.abs(Math.sin(l))<u&&(l=Math.round(l/Math.PI)*Math.PI),Math.abs(Math.cos(l))<u&&(l=(Math.round(l/Math.PI-.5)+.5)*Math.PI),this.camera.setArmRotation(s,l)}this.redraw();var c=this.getCameraPosition();this.emit("cameraPositionChange",c),Zo(t)},Nl.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",this.leftButtonDown=!1,Xo(document,"mousemove",this.onmousemove),Xo(document,"mouseup",this.onmouseup),Zo(t)},Nl.prototype._onClick=function(t){if(this.onclick_callback||this.hasListeners("click")){if(this.moving)this.moving=!1;else{var e=this.frame.getBoundingClientRect(),r=Gl(t)-e.left,n=Wl(t)-e.top,i=this._dataPointFromXY(r,n);i&&(this.onclick_callback&&this.onclick_callback(i.point.data),this.emit("click",i.point.data))}Zo(t)}},Nl.prototype._onTooltip=function(t){var e=this.tooltipDelay,r=this.frame.getBoundingClientRect(),n=Gl(t)-r.left,i=Wl(t)-r.top;if(this.showTooltip)if(this.tooltipTimeout&&clearTimeout(this.tooltipTimeout),this.leftButtonDown)this._hideTooltip();else if(this.tooltip&&this.tooltip.dataPoint){var o=this._dataPointFromXY(n,i);o!==this.tooltip.dataPoint&&(o?this._showTooltip(o):this._hideTooltip())}else{var a=this;this.tooltipTimeout=bt((function(){a.tooltipTimeout=null;var t=a._dataPointFromXY(n,i);t&&a._showTooltip(t)}),e)}},Nl.prototype._onTouchStart=function(t){this.touchDown=!0;var e=this;this.ontouchmove=function(t){e._onTouchMove(t)},this.ontouchend=function(t){e._onTouchEnd(t)},Uo(document,"touchmove",e.ontouchmove),Uo(document,"touchend",e.ontouchend),this._onMouseDown(t)},Nl.prototype._onTouchMove=function(t){this._onMouseMove(t)},Nl.prototype._onTouchEnd=function(t){this.touchDown=!1,Xo(document,"touchmove",this.ontouchmove),Xo(document,"touchend",this.ontouchend),this._onMouseUp(t)},Nl.prototype._onWheel=function(t){if(t||(t=window.event),this.zoomable&&(!this.ctrlToZoom||t.ctrlKey)){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail&&(e=-t.detail/3),e){var r=this.camera.getArmLength()*(1-e/10);this.camera.setArmLength(r),this.redraw(),this._hideTooltip()}var n=this.getCameraPosition();this.emit("cameraPositionChange",n),Zo(t)}},Nl.prototype._insideTriangle=function(t,e){var r=e[0],n=e[1],i=e[2];function o(t){return t>0?1:t<0?-1:0}var a=o((n.x-r.x)*(t.y-r.y)-(n.y-r.y)*(t.x-r.x)),s=o((i.x-n.x)*(t.y-n.y)-(i.y-n.y)*(t.x-n.x)),l=o((r.x-i.x)*(t.y-i.y)-(r.y-i.y)*(t.x-i.x));return!(0!=a&&0!=s&&a!=s||0!=s&&0!=l&&s!=l||0!=a&&0!=l&&a!=l)},Nl.prototype._dataPointFromXY=function(t,e){var r,n=null,i=null,o=null,a=new Jo(t,e);if(this.style===Nl.STYLE.BAR||this.style===Nl.STYLE.BARCOLOR||this.style===Nl.STYLE.BARSIZE)for(r=this.dataPoints.length-1;r>=0;r--){var s=(n=this.dataPoints[r]).surfaces;if(s)for(var l=s.length-1;l>=0;l--){var u=s[l].corners,c=[u[0].screen,u[1].screen,u[2].screen],h=[u[2].screen,u[3].screen,u[0].screen];if(this._insideTriangle(a,c)||this._insideTriangle(a,h))return n}}else for(r=0;r<this.dataPoints.length;r++){var f=(n=this.dataPoints[r]).screen;if(f){var d=Math.abs(t-f.x),p=Math.abs(e-f.y),v=Math.sqrt(d*d+p*p);(null===o||v<o)&&v<100&&(o=v,i=n)}}return i},Nl.prototype.hasBars=function(t){return t==Nl.STYLE.BAR||t==Nl.STYLE.BARCOLOR||t==Nl.STYLE.BARSIZE},Nl.prototype._showTooltip=function(t){var e,r,n;this.tooltip?(e=this.tooltip.dom.content,r=this.tooltip.dom.line,n=this.tooltip.dom.dot):(e=document.createElement("div"),ct(e.style,{},this.tooltipStyle.content),e.style.position="absolute",r=document.createElement("div"),ct(r.style,{},this.tooltipStyle.line),r.style.position="absolute",n=document.createElement("div"),ct(n.style,{},this.tooltipStyle.dot),n.style.position="absolute",this.tooltip={dataPoint:null,dom:{content:e,line:r,dot:n}}),this._hideTooltip(),this.tooltip.dataPoint=t,"function"==typeof this.showTooltip?e.innerHTML=this.showTooltip(t.point):e.innerHTML="<table><tr><td>"+this.xLabel+":</td><td>"+t.point.x+"</td></tr><tr><td>"+this.yLabel+":</td><td>"+t.point.y+"</td></tr><tr><td>"+this.zLabel+":</td><td>"+t.point.z+"</td></tr></table>",e.style.left="0",e.style.top="0",this.frame.appendChild(e),this.frame.appendChild(r),this.frame.appendChild(n);var i=e.offsetWidth,o=e.offsetHeight,a=r.offsetHeight,s=n.offsetWidth,l=n.offsetHeight,u=t.screen.x-i/2;u=Math.min(Math.max(u,10),this.frame.clientWidth-10-i),r.style.left=t.screen.x+"px",r.style.top=t.screen.y-a+"px",e.style.left=u+"px",e.style.top=t.screen.y-a-o+"px",n.style.left=t.screen.x-s/2+"px",n.style.top=t.screen.y-l/2+"px"},Nl.prototype._hideTooltip=function(){if(this.tooltip)for(var t in this.tooltip.dataPoint=null,this.tooltip.dom)if(this.tooltip.dom.hasOwnProperty(t)){var e=this.tooltip.dom[t];e&&e.parentNode&&e.parentNode.removeChild(e)}},Nl.prototype.setCameraPosition=function(t){xa(t,this),this.redraw()},Nl.prototype.setSize=function(t,e){this._setSize(t,e),this.redraw()},t.DELETE=Ro,t.DataSet=Ml,t.DataStream=Pl,t.DataView=Dl,t.Graph3d=Nl,t.Graph3dCamera=la,t.Graph3dFilter=jl,t.Graph3dPoint2d=Jo,t.Graph3dPoint3d=$o,t.Graph3dSlider=Ko,t.Graph3dStepNumber=ta,t.Queue=El,t.createNewDataPipeFrom=function(t){return new Cl(t)},t.isDataSetLike=Rl,t.isDataViewLike=function(t,e){return"object"===ln(e)&&null!==e&&t===e.idProp&&"function"==typeof xn(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof ko(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&Rl(t,e.getDataSet())},Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-graph3d.min.js.map
